#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "modulo1.h"

int leggiFile(char * nomefile, int dimensione, char * testo)
{ FILE *mail; int i;
i=0;
testo=malloc(dimensione*sizeof(char));
if ( (nomefile==NULL)||(dimensione==NULL) ) return NULL_POINTER;
if ( (mail=fopen(nomefile,"r"))==NULL) return FILE_MISSING;
if ( fgets(testo,dimensione,mail)==NULL) return FILE_EMPTY;
while ((!feof(mail))&&(i<=dimensione))
	{ testo[i]=fgetc(mail);
	  i++;
	  }
if (i>dimensione) return BUFFER_TOO_SMALL;
testo[i]='\0';
fclose(mail);
return RESULT_OK;
}

int estraiHeaders(char *email,char *headers,int dimh)
{ int i,j;
i=0;
j=0;
if ( (email==NULL)||(dimh==NULL) ) return NULL_POINTER;
if (email[0]=='\0') return EMPTY_STRING;
headers=malloc(dimh*sizeof(char));
while( (email[i]!='\0')&&(j<=dimh) )
{  while( (email[i]!='\n')&&(j<=dimh) )
	{ headers[j]=email[i];
	  i++;
	  j++;
	 }
      if (email[i+1]=='\n') break;
   headers[j++]='\n';      
   i++;
}
if (j>dimh) return BUFFER_TOO_SMALL;
headers[j]='\0';
return RESULT_OK;
}

int primoHeader(char *headers, char *primo_header, int dim)
{ int i,j;
i=0;
j=0;
if ( (headers==NULL)||(dim==NULL) ) return NULL_POINTER;
if (headers[0]=='\0') return EMPTY_STRING;
if (headers[0]=='\n') return HEADER_NOT_FOUND;
primo_header=malloc(dim*sizeof(char));
while( (headers[i]!='\0')&&(j<=dim) )
{  while( (headers[i]!='\n')&&(j<=dim) )
	{ primo_header[j]=headers[i];
	  i++;
	  j++;
	 }
   if  ((headers[i+1]!='\t')&&(headers[i+1]!=' '))  break;
   i++;
}
if (j>dim) return BUFFER_TOO_SMALL;
headers[j]='\0';
return RESULT_OK;
}

int parseheader(char* header, char *tipo, int dimt, char *valore, int dimv)
{ int i,j,k;
i=0; j=0; k=0;
if ( (header==NULL)||(dimt==NULL)||(dimv==NULL) ) return NULL_POINTER;
if (header[0]=='\0') return HEADER_NOT_FOUND;
tipo=malloc(dimt*sizeof(char));
valore=malloc(dimv*sizeof(char));
while( (header[i]!='\0')&&(header[i]!=' ')&&(j<=dimt) )
	{ tipo[j]=header[i];
	  i++; j++;
	 }
if (header[i]=='\0') return BAD_HEADER;
if (j>dimt) return BUFFER_TOO_SMALL;
i++;
while( (header[i]!='\0')&&(k<=dimv) )
	{ valore[k]=header[i];
	  i++; k++;
	 }
if (k>dimv) return BUFFER_TOO_SMALL;
tipo[j]='\0';
valore[k]='\0';
return RESULT_OK;
}

int primaParola(char* testo, char *parola, int dim)
{ int i,j;
j=0;
if ( (testo==NULL)||(dim==NULL) ) return NULL_POINTER;
if (testo[0]=='\0') return BODY_NOT_FOUND;
parola=malloc(dim*sizeof(char));
for(i=0;i<=dim;i++) {
if( (testo[i]>='a'&& testo[i]<='z')||(testo[i]>='A'&& testo[i]<='Z')||(testo[i]>='1'&& testo[i]<='9') ) break;
}
while( (testo[i]>='a'&& testo[i]<='z')||(testo[i]>='A'&& testo[i]<='Z')||(testo[i]>='1'&& testo[i]<='9')&&(j<=dim) )
	{ parola[j]=testo[i];
	  i++; j++;
	 }
if (j>dim) return BUFFER_TOO_SMALL;
parola[j]='\0';
return RESULT_OK;
}

int tokenizzaEmail(char *email, Token tokenArray[], int dimT)
{  char *app; int dim,dim1,i,t,x,j,h; char *header; char *primo; char *tipo,*valore;
dim=5000;
dim1=50;
i=0;  t=0; j=0;
if ( (estraiHeaders(email,header,dim))!=0) return UNKNOWN_ERROR;
app=header;
h=strlen(header);
while (header[i]!='\0')
	{ primoHeader(header,primo,dim);
	  parseHeader(primo,tipo,dim1,valore,dim1);
	  tokenArray[t].parola=tipo;
	  tokenArray[t].contesto=valore;
	  x=strlen(primo);
	  while(i<=x) header[i++];
	 }
while (j<=h) email[j++];
while (email[j]!='\0')
{ primaParola(email,valore,dim1);
  tokenArray[t].parola=NULL;
  tokenArray[t].contesto=valore;
  x=strlen(valore);
  while(i<=x) email[j++];
	 }
return RESULT_OK;
}

int printToken (Token tokenArray[], int dimT)
{ int i;
if ( (tokenArray==NULL)||(dimT==NULL) ) return NULL_POINTER;

for (i=0;i<=dimT;i++)
   {  if (tokenArray[i].parola!=NULL)	printf("%s*",tokenArray[i].parola);
      printf("%s\n",tokenArray[i].contesto);
    }
return RESULT_OK;
}
