#include <stdio.h>
#include "testModulo1.h"

int test_leggiFile ( int tipo_di_test, int argomento )
{ int dim; char *text; char *nome;
if (tipo_di_test==NULL) return NOT_VALID;
if (argomento<0 || argomento>2) return ARG_MISSING;

switch(tipo_di_test)
{	case UNKNOWN_ERROR: case FILE_UNWRITABLE: case FILE_UNREADABLE: case MEM_ALLOC_ERROR:
	return NOT_IMPLEMENTED;
	
	case NULL_POINTER:
	if (argomento==0) { nome=NULL; dim=5000;
			      if ( leggiFile(nome,dim,text)==tipo_di_test ) return TEST_PASSED;
			      else { printf("Test fallito: funzione testata: leggiFile\nrisultato atteso: %d\nrisultato ottenuto: %d",tipo_di_test,leggiFile(nome,dim,text));
			      	     return TEST_FAILED; }
			     }
	if (argomento==1) { nome="email1.txt"; dim=NULL;
			      if ( leggiFile(nome,dim,text)==tipo_di_test ) return TEST_PASSED;
			      else { printf("Test fallito: funzione testata: leggiFile\nrisultato atteso: %d\nrisultato ottenuto: %d",tipo_di_test,leggiFile(nome,dim,text));
			      	     return TEST_FAILED; }
			     }
	if (argomento==2) return NOT_VALID;
	
	case FILE_MISSING:
	if (argomento==0) { nome="pincopallo.txt"; dim=5000;
			      if ( leggiFile(nome,dim,text)==tipo_di_test ) return TEST_PASSED;
			      else { printf("Test fallito: funzione testata: leggiFile\nrisultato atteso: %d\nrisultato ottenuto: %d",tipo_di_test,leggiFile(nome,dim,text));
			      	     return TEST_FAILED; }
			     }
	else return NOT_VALID;
	
	case BUFFER_TOO_SMALL:
	if (argomento!=0) { nome="email1.txt"; dim=1;
			      if ( leggiFile(nome,dim,text)==tipo_di_test ) return TEST_PASSED;
			      else { printf("Test fallito: funzione testata: leggiFile\nrisultato atteso: %d\nrisultato ottenuto: %d",tipo_di_test,leggiFile(nome,dim,text));
			      	     return TEST_FAILED; }
			     }
	else return NOT_VALID;
	
	case RESULT_OK:
	nome="email1.txt"; dim=5000;
	if ( leggiFile(nome,dim,text)==tipo_di_test ) return TEST_PASSED;
	else { printf("Test fallito: funzione testata: leggiFile\nrisultato atteso: %d\nrisultato ottenuto: %d",tipo_di_test,leggiFile(nome,dim,text));
	       return TEST_FAILED; }
	
	default:
	return NOT_VALID;
}
}


int test_estraiHeader ( int tipo_di_test, int argomento )
{ int arg2; char *arg0; char *arg1;
if (tipo_di_test==NULL) return NOT_VALID;
if (argomento<0 || argomento>2) return ARG_MISSING;

switch(tipo_di_test)
{	case UNKNOWN_ERROR: case HEADER_NOT_FOUND: case BAD_HEADER: case MEM_ALLOC_ERROR:
	return NOT_IMPLEMENTED;
	
	case NULL_POINTER:
	if (argomento==0) { arg0=NULL; arg2=500;
			      if ( estraiHeaders(arg0,arg1,arg2)==tipo_di_test ) return TEST_PASSED;
			      else { printf("Test fallito: funzione testata: estraiHeader\nrisultato atteso: %d\nrisultato ottenuto: %d",tipo_di_test,estraiHeaders(arg0,arg1,arg2));
			      	     return TEST_FAILED; }
			     }
	if (argomento==2) { arg0="from: alex\nobject: ciao\n\nemail prova numero1\ncorpo della lettera\n"; arg2=NULL;
			      if ( estraiHeaders(arg0,arg1,arg2)==tipo_di_test ) return TEST_PASSED;
			      else { printf("Test fallito: funzione testata: estraiHeader\nrisultato atteso: %d\nrisultato ottenuto: %d",tipo_di_test,estraiHeaders(arg0,arg1,arg2));
			      	     return TEST_FAILED; }
			     }
	if (argomento==1) return NOT_VALID;
	
	case EMPTY_STRING:
	if (argomento==0) { arg0='\0'; arg2=500;
			      if ( estraiHeaders(arg0,arg1,arg2)==tipo_di_test ) return TEST_PASSED;
			      else { printf("Test fallito: funzione testata: estraiHeader\nrisultato atteso: %d\nrisultato ottenuto: %d",tipo_di_test,estraiHeaders(arg0,arg1,arg2));
			      	     return TEST_FAILED; }
			     }
	else return NOT_VALID;
	
	case BUFFER_TOO_SMALL:
	if (argomento!=0) { arg0="from: alex\nobject: ciao\n\nemail prova numero1\ncorpo della lettera\n"; arg2=1;
			      if ( estraiHeaders(arg0,arg1,arg2)==tipo_di_test ) return TEST_PASSED;
			      else { printf("Test fallito: funzione testata: estraiHeader\nrisultato atteso: %d\nrisultato ottenuto: %d",tipo_di_test,estraiHeaders(arg0,arg1,arg2));
			      	     return TEST_FAILED; }
			     }
	else return NOT_VALID;
	
	case RESULT_OK:
	arg0="from: alex\nobject: ciao\n\nemail prova numero1\ncorpo della lettera\n"; arg2=500;
	if ( estraiHeaders(arg0,arg1,arg2)==tipo_di_test ) return TEST_PASSED;
	else { printf("Test fallito: funzione testata: estraiHeader\nrisultato atteso: %d\nrisultato ottenuto: %d",tipo_di_test,estraiHeaders(arg0,arg1,arg2));
			      	     return TEST_FAILED; }
	
	default:
	return NOT_VALID;
}
}


int test_primoHeader(int tipo_di_test, int argomento)
{ char *arg0; char *arg1; int arg2;
if (tipo_di_test==NULL) return NOT_VALID;
if (argomento<0 || argomento>2) return ARG_MISSING;

switch(tipo_di_test)
{	case UNKNOWN_ERROR: case BAD_HEADER: case MEM_ALLOC_ERROR:
	return NOT_IMPLEMENTED;
	
	case NULL_POINTER:
	if (argomento==0) { arg0=NULL; arg2=500;
			      if ( primoHeader(arg0,arg1,arg2)==tipo_di_test ) return TEST_PASSED;
			      else { printf("Test fallito: funzione testata: primoHeader\nrisultato atteso: %d\nrisultato ottenuto: %d",tipo_di_test,primoHeader(arg0,arg1,arg2));
			      	     return TEST_FAILED; }
			     }
	if (argomento==2) { arg0="from: alex\nobject: ciao"; arg2=NULL;
			      if ( primoHeader(arg0,arg1,arg2)==tipo_di_test ) return TEST_PASSED;
			      else { printf("Test fallito: funzione testata: primoHeader\nrisultato atteso: %d\nrisultato ottenuto: %d",tipo_di_test,primoHeader(arg0,arg1,arg2));
			      	     return TEST_FAILED; }
			     }
	if (argomento==1) return NOT_VALID;
	
	case EMPTY_STRING:
	if (argomento==0) { arg0='\0'; arg2=500;
			      if ( primoHeader(arg0,arg1,arg2)==tipo_di_test ) return TEST_PASSED;
			      else { printf("Test fallito: funzione testata: primoHeader\nrisultato atteso: %d\nrisultato ottenuto: %d",tipo_di_test,primoHeader(arg0,arg1,arg2));
			      	     return TEST_FAILED; }
			     }
	else return NOT_VALID;
	
	case HEADER_NOT_FOUND:
	if (argomento==0) { arg0='\n'; arg2=500;
			      if ( primoHeader(arg0,arg1,arg2)==tipo_di_test ) return TEST_PASSED;
			      else { printf("Test fallito: funzione testata: primoHeader\nrisultato atteso: %d\nrisultato ottenuto: %d",tipo_di_test,primoHeader(arg0,arg1,arg2));
			      	     return TEST_FAILED; }
			     }
	else return NOT_VALID;
	
	case BUFFER_TOO_SMALL:
	if (argomento!=0) { arg0="from: alex\nobject: ciao"; arg2=1;
			      if ( primoHeader(arg0,arg1,arg2)==tipo_di_test ) return TEST_PASSED;
			      else { printf("Test fallito: funzione testata: primoHeader\nrisultato atteso: %d\nrisultato ottenuto: %d",tipo_di_test,primoHeader(arg0,arg1,arg2));
			      	     return TEST_FAILED; }
			     }
	else return NOT_VALID;
	
	case RESULT_OK:
	arg0="from: alex\nobject: ciao"; arg2=500;
	if ( primoHeader(arg0,arg1,arg2)==tipo_di_test ) return TEST_PASSED;
	else { printf("Test fallito: funzione testata: primoHeader\nrisultato atteso: %d\nrisultato ottenuto: %d",tipo_di_test,primoHeader(arg0,arg1,arg2));
		return TEST_FAILED; }
	
	default:
	return NOT_VALID;
}
}


int test_parseHeader(int tipo_di_test, int argomento)
{ char *arg0; char *arg1; int arg2; char *arg3; int arg4;
if (tipo_di_test==NULL) return NOT_VALID;
if (argomento<0 || argomento>4) return ARG_MISSING;

switch(tipo_di_test)
{	case UNKNOWN_ERROR: case MEM_ALLOC_ERROR:
	return NOT_IMPLEMENTED;
	
	case NULL_POINTER:
	if (argomento==0) { arg0=NULL; arg2=50; arg4=50;
			      if ( parseHeader(arg0,arg1,arg2,arg3,arg4)==tipo_di_test ) return TEST_PASSED;
			      else { printf("Test fallito: funzione testata: parseHeader\nrisultato atteso: %d\nrisultato ottenuto: %d",tipo_di_test,parseHeader(arg0,arg1,arg2,arg3,arg4));
			      	     return TEST_FAILED; }
			     }
	else {
	if (argomento==2) { arg0="from: andrea@sterbini.org"; arg2=NULL; arg4=50;
			      if ( parseHeader(arg0,arg1,arg2,arg3,arg4)==tipo_di_test ) return TEST_PASSED;
			      else { printf("Test fallito: funzione testata: parseHeader\nrisultato atteso: %d\nrisultato ottenuto: %d",tipo_di_test,parseHeader(arg0,arg1,arg2,arg3,arg4));
			      	     return TEST_FAILED; }
			    }
		else {
		if (argomento==4) { arg0="from: andrea@sterbini.org"; arg2=50; arg4=NULL;
			      if ( parseHeader(arg0,arg1,arg2,arg3,arg4)==tipo_di_test ) return TEST_PASSED;
			      else { printf("Test fallito: funzione testata: parseHeader\nrisultato atteso: %d\nrisultato ottenuto: %d",tipo_di_test,parseHeader(arg0,arg1,arg2,arg3,arg4));
			      	     return TEST_FAILED; }
			     }
			else return NOT_VALID;
			}
		}
				     
	case BAD_HEADER:
	if (argomento==0) { arg0="From: "; arg2=50; arg4=50;
			      if ( parseHeader(arg0,arg1,arg2,arg3,arg4)==tipo_di_test ) return TEST_PASSED;
			      else { printf("Test fallito: funzione testata: parseHeader\nrisultato atteso: %d\nrisultato ottenuto: %d",tipo_di_test,parseHeader(arg0,arg1,arg2,arg3,arg4));
			      	     return TEST_FAILED; }
			     }
	else return NOT_VALID;
	
	case HEADER_NOT_FOUND:
	if (argomento==0) { arg0='\0'; arg2=50; arg4=50;
			      if ( parseHeader(arg0,arg1,arg2,arg3,arg4)==tipo_di_test ) return TEST_PASSED;
			      else { printf("Test fallito: funzione testata: parseHeader\nrisultato atteso: %d\nrisultato ottenuto: %d",tipo_di_test,parseHeader(arg0,arg1,arg2,arg3,arg4));
			      	     return TEST_FAILED; }
			     }
	else return NOT_VALID;
	
	case BUFFER_TOO_SMALL:
	if (argomento!=0) { arg0="from: andrea@sterbini.org"; arg2=1; arg4=1;
			      if ( parseHeader(arg0,arg1,arg2,arg3,arg4)==tipo_di_test ) return TEST_PASSED;
			      else { printf("Test fallito: funzione testata: parseHeader\nrisultato atteso: %d\nrisultato ottenuto: %d",tipo_di_test,parseHeader(arg0,arg1,arg2,arg3,arg4));
			      	     return TEST_FAILED; }
			     }
	else return NOT_VALID;
	
	case RESULT_OK:
	arg0="from: andrea@sterbini.org"; arg2=50; arg4=50;
	if ( parseHeader(arg0,arg1,arg2,arg3,arg4)==tipo_di_test ) return TEST_PASSED;
	else { printf("Test fallito: funzione testata: parseHeader\nrisultato atteso: %d\nrisultato ottenuto: %d",tipo_di_test,parseHeader(arg0,arg1,arg2,arg3,arg4));
		return TEST_FAILED; }
	
	default:
	return NOT_VALID;
}
}


int test_primaParola(int tipo_di_test, int argomento)
{ char *arg0; char *arg1; int arg2;
if (tipo_di_test==NULL) return NOT_VALID;
if (argomento<0 || argomento>2) return ARG_MISSING;

switch(tipo_di_test)
{	case UNKNOWN_ERROR: case EMPTY_STRING: case MEM_ALLOC_ERROR:
	return NOT_IMPLEMENTED;
	
	case NULL_POINTER:
	if (argomento==0) { arg0=NULL; arg2=50;
			      if ( primaParola(arg0,arg1,arg2)==tipo_di_test ) return TEST_PASSED;
			      else { printf("Test fallito: funzione testata: primaParola\nrisultato atteso: %d\nrisultato ottenuto: %d",tipo_di_test,primaParola(arg0,arg1,arg2));
				     return TEST_FAILED; }
			     }
	if (argomento==2) { arg0="++++---Pippo96+++---"; arg2=NULL;
			      if ( primaParola(arg0,arg1,arg2)==tipo_di_test ) return TEST_PASSED;
			      else { printf("Test fallito: funzione testata: primaParola\nrisultato atteso: %d\nrisultato ottenuto: %d",tipo_di_test,primaParola(arg0,arg1,arg2));
				     return TEST_FAILED; }
			     }
	if (argomento==1) return NOT_VALID;
	
	case BODY_NOT_FOUND:
	if (argomento==0) { arg0='\0'; arg2=50;
			      if ( primaParola(arg0,arg1,arg2)==tipo_di_test ) return TEST_PASSED;
			      else { printf("Test fallito: funzione testata: primaParola\nrisultato atteso: %d\nrisultato ottenuto: %d",tipo_di_test,primaParola(arg0,arg1,arg2));
				     return TEST_FAILED; }
			     }
	else return NOT_VALID;
	
	case BUFFER_TOO_SMALL:
	if (argomento!=0) { arg0="++++---Pippo96+++---"; arg2=1;
			      if ( primaParola(arg0,arg1,arg2)==tipo_di_test ) return TEST_PASSED;
			      else { printf("Test fallito: funzione testata: primaParola\nrisultato atteso: %d\nrisultato ottenuto: %d",tipo_di_test,primaParola(arg0,arg1,arg2));
				     return TEST_FAILED; }
			     }
	else return NOT_VALID;
	
	case RESULT_OK:
	arg0="++++---Pippo96+++---"; arg2=50;
	if ( primaParola(arg0,arg1,arg2)==tipo_di_test ) return TEST_PASSED;
	else { printf("Test fallito: funzione testata: primaParola\nrisultato atteso: %d\nrisultato ottenuto: %d",tipo_di_test,primaParola(arg0,arg1,arg2));
		return TEST_FAILED; }
	
	default:
	return NOT_VALID;
}
}



int test_printTokens(int tipo_di_test, int argomento)
{ Token * arg0; int arg1;
if (tipo_di_test==NULL) return NOT_VALID;
if (argomento<0 || argomento>1) return ARG_MISSING;

switch(tipo_di_test)
{	case NULL_POINTER:
	if (argomento==0) {   arg1=5000;
			      if ( printTokens(arg0,arg1)==tipo_di_test ) return TEST_PASSED;
			      else { printf("Test fallito: funzione testata: printTokens\nrisultato atteso: %d\nrisultato ottenuto: %d",tipo_di_test,printTokens(arg0,arg1));
					return TEST_FAILED; }
			     }
	if (argomento==1) { arg1=NULL;
			      if ( printTokens(arg0,arg1)==tipo_di_test ) return TEST_PASSED;
			      else { printf("Test fallito: funzione testata: printTokens\nrisultato atteso: %d\nrisultato ottenuto: %d",tipo_di_test,printTokens(arg0,arg1));
					return TEST_FAILED; }
			     }
		
	case RESULT_OK:
	arg1=50;
	if ( printTokens(arg0,arg1)==tipo_di_test ) return TEST_PASSED;
	else { printf("Test fallito: funzione testata: printTokens\nrisultato atteso: %d\nrisultato ottenuto: %d",tipo_di_test,printTokens(arg0,arg1));
					return TEST_FAILED; }
	
	default:
	return NOT_VALID;
}
}
