#include "modulo1.h"
#include <stdio.h>
#include <sys/stat.h>
#include <sys/types.h>
#include <unistd.h>

int AleMaisalnumGrot(char c)
{
  int i;
  
  if(c >= 'a' && c <= 'z') return 1;
  if(c >= 'A' && c <= 'Z') return 1;
  if(c >= '0' && c <= '9') return 1;
  
  else return 0;

}
////////////////////////////////////////////////////////////
//  FUNZIONE LEGGI FILE
//////////////////////////////////////////////////////////// 
int leggiFile(char * nomefile, int dimensione, char * testo)
{
  int i=0, v;
  FILE *fp;
  struct stat file;

  ///////////////////////////////////////
  // Errore 2 - CONTROLLO PUNTATORI NULLI
  ///////////////////////////////////////
  if(nomefile == NULL) return NULL_POINTER;
  if(testo == NULL) return NULL_POINTER;
  
  //////////////////////////////////////////
  // Errore 3 - CONTROLLO STRINGA VUOTA
  //////////////////////////////////////////  
  if(nomefile[0] == '\0') return EMPTY_STRING;

  ///////////////////////////////////////////
  // Errore 4 - CONTROLLO SE IL FILE ESISTE
  ///////////////////////////////////////////
  v=stat(nomefile, &file);
  if(v == -1) return FILE_MISSING;
  if((file.st_mode & S_IFMT) != S_IFREG) return FILE_MISSING;

  ///////////////////////////////////////////
  // Errore 5 - CONTROLLO LETTURA
  ///////////////////////////////////////////

  ///////////////////////////////////////////
  // Errore 6 - CONTROLLO SCRITTURA
  ///////////////////////////////////////////

  ///////////////////////////////////////////
  // Errore 7 - CONTROLLO FILE VUOTO
  ///////////////////////////////////////////
  if(file.st_size == 0) return FILE_EMPTY;

  ///////////////////////////////////////////
  // Errore 8 - BUFFER TROPPO PICCOLO
  ///////////////////////////////////////////
  if(dimensione < 2) return BUFFER_TOO_SMALL;

  ////////////////////////
  // APRO FILE
  ////////////////////////
  fp=fopen(nomefile, "r");

  ////////////////////////////////////
  // DIVENTERA' UNKNOWN
  ////////////////////////////////////
  if(fp==NULL) return FILE_UNREADABLE;



  /////////////////
  // COPIO EMAIL
  /////////////////
  while(i != dimensione-1 && (EOF != (testo[i] = fgetc(fp)))) i++;

  testo[i]='\0';

  fclose(fp);


return RESULT_OK;
}

/////////////////////////////////////////////////////
//  PRIMA PAROLA
/////////////////////////////////////////////////////
int primaParola(char * testo, char * parola, int dim)
{
  int t=0, p=0;

  ///////////////////////////////////////
  // Errore 2 - CONTROLLO PUNTATORI NULLI
  ///////////////////////////////////////
  if(testo  == NULL) return NULL_POINTER;
  if(parola == NULL) return NULL_POINTER;

  ///////////////////////////////////////
  // Errore 3 - CONTROLLO STRINGA TESTO
  ///////////////////////////////////////
  if(testo[0] == '\0') return EMPTY_STRING;

  ///////////////////////////////////////
  // Errore 8 - CONTROLLO DIM BUFFER
  ///////////////////////////////////////
  if(dim < 2) return BUFFER_TOO_SMALL;

  //////////////////////////////////////////
  // SALTA MONNEZZA
  //////////////////////////////////////////
  while(!(AleMaisalnumGrot(testo[t])) && testo[t] != '\0') t++;

  //////////////////////
  //COPIA PAROLA
  //////////////////////
  while(p != dim-1 && testo[t] != '\0' && AleMaisalnumGrot(testo[t]))
    {
      parola[p]=testo[t];

      testo[t]='@';
      p++;
      t++;
    }

  ///////////////////////////////////////
  // ERRORE 8 - CONTROLLO FINE BUFFER
  ///////////////////////////////////////
  if(p == dim-1 && AleMaisalnumGrot(testo[t]) ) return BUFFER_TOO_SMALL;

  //////////////////////
  // FINE BUFFER PAROLA
  //////////////////////
  parola[p]='\0';

  //////////////////////////////////
  // MARCA FINE BUFFER TESTO
  //////////////////////////////////
  if(testo[t]=='\0') testo[t-1]='\0';

  /////////////////
  // TUTTO OK
  /////////////////
  return RESULT_OK;
}


/////////////////////////////////////////////////////////
//  ESTRAI HEADERS
/////////////////////////////////////////////////////////
int estraiHeaders(char * email, char * headers, int dimh)
{
  int i=0;

  ///////////////////////////////////////
  // Errore 2 - CONTROLLO PUNTATORI NULLI
  ///////////////////////////////////////
  if(email==NULL)    return NULL_POINTER;
  if(headers==NULL)  return NULL_POINTER;

  ///////////////////////////////////////
  // Errore 3 - CONTROLLO STRINGA EMAIL
  ///////////////////////////////////////
  if(email[0]=='\0') return EMPTY_STRING;

  ///////////////////////////////////////
  // Errore 8 - CONTROLLO DIM BUFFER
  ///////////////////////////////////////
  if(dimh < 4 ) return BUFFER_TOO_SMALL;

  /////////////////////////////////////////////////////////////////////
  // Errore 9 - CONTROLLO SUL PRIMO CARATTERE VALIDITA' HEADERS
  /////////////////////////////////////////////////////////////////////
  if(isspace(email[0]) ) return HEADER_NOT_FOUND;

  ///////////////////////
  //   ESTRAI HEADERS
  ///////////////////////

  while(i!=dimh-1)
    {

      //////////////////////////////////////////////////
      // Errore 9 - CONTROLLO FINE FILE PER VALIDITA' HEADERS
      //////////////////////////////////////////////////
      if(email[i+1]=='\0') return HEADER_NOT_FOUND;

      ////////////////////
      //   COPIA HEADERS
      ////////////////////
      headers[i]=email[i];

      //////////////////////////////////////////
      //   CONTROLLO FINE HEADERS
      //   FINO A DOPPIO " \n "
      //////////////////////////////////////////
      if(email[i] == '\n' && email[i+1] == '\n')
	{
	  headers[i+1]='\0';
	  return RESULT_OK;
	}
      
      i++;
    }
    
  //////////////////////////
  // Errore 8 - NON BASTA 
  // IL BUFFER
  //////////////////////////
  return BUFFER_TOO_SMALL;
}

/////////////////////////////////////////////////////////////
//   PRIMO HEADER
/////////////////////////////////////////////////////////////
int primoHeader(char * headers, char * primo_header, int dim)
{
  int i=0;

  ///////////////////////////////////////
  // Errore 2 - CONTROLLO PUNTATORI NULLI
  ///////////////////////////////////////
  if(headers == NULL) return NULL_POINTER;
  if(primo_header == NULL) return NULL_POINTER;

  ///////////////////////////////////////
  // Errore 3 - CONTROLLO STRINGA HEADERS
  ///////////////////////////////////////
  if(headers[0] == '\0') return EMPTY_STRING;

   ///////////////////////////////////////
  // Errore 8 - CONTROLLO DIM BUFFER
  ///////////////////////////////////////
  if(dim < 4) return BUFFER_TOO_SMALL;
  

  while(i!=dim-1)
    {
    
      /////////////////////////////////////////////
      // Errore 9 - CONTROLLO FINE STRINGA
      /////////////////////////////////////////////
      if(headers[i] == '\0') return HEADER_NOT_FOUND;

      ///////////////////////////
      // COPIA HEADER
      ///////////////////////////
      primo_header[i]=headers[i];

      if(headers[i] == '\n' && !(isspace(headers[i+1])))
	{
	  primo_header[i]='\0';
	  return RESULT_OK;
	}

      i++;
    }
    
  //////////////////////////
  // Errore 8 - NON BASTA 
  // IL BUFFER
  //////////////////////////
  return BUFFER_TOO_SMALL;
}


int parseHeader(char * header, char * tipo, int dimt, char * valore, int dimv)
{
  int i=0, j=0, tip=0;

  ///////////////////////////////////////
  // Errore 2 - CONTROLLO PUNTATORI NULLI
  ///////////////////////////////////////
  if(header == NULL) return NULL_POINTER;
  if(tipo == NULL) return NULL_POINTER;
  if(valore == NULL) return NULL_POINTER;
  
  ///////////////////////////////////////
  // Errore 3 - CONTROLLO STRINGA HEADER
  ///////////////////////////////////////
  if(header[0] == '\0') return EMPTY_STRING;

  ///////////////////////////////////////
  // Errore 8 - CONTROLLO DIM BUFFER
  ///////////////////////////////////////
  if(dimt < 1 || dimv < 1) return BUFFER_TOO_SMALL;
  
  /////////////////////////////////////////////////////////////////////
  // Errore 11 - CONTROLLO SUL PRIMO CARATTERE VALIDITA' HEADER
  /////////////////////////////////////////////////////////////////////
  if(header[i]==':' || isspace(header[i])) return BAD_HEADER;

  
  ///////////////
  // COPIA TIPO
  ///////////////
  while(i != dimt-1 && header[i] != ' ' && header[i] != '\t')
    {
      tipo[i]=header[i];
      i++;
      if(header[i+1] == '\0') return BAD_HEADER;
    }

  if(header[i] == ' ' || header[i] == '\t') tip=1;
  
  if( i+1 == dimt && (header[i+1] != ' ' || header[i+1] != '\t')) return BUFFER_TOO_SMALL;
  
  tipo[i]='\0';

  j=i+1;
  i=0;

  if(tip!=1 && header[j] == '\0') return BAD_HEADER;

  /////////////////
  // COPIA VALORE
  /////////////////
  while(i!=dimv-1 && header[j] != '\0')
    {
      valore[i]=header[j];

      if(header[j] == '\n' && header[j+1] != '\t' && header[j+1] != ' ') return BAD_HEADER;

      i++;
      j++;
    }

  if(header[j] != '\0') return BUFFER_TOO_SMALL;
  valore[i]='\0';
  

  return RESULT_OK;
}



/////////////////////////////////////////////////////////////
//   TOKENIZZA EMAIL
/////////////////////////////////////////////////////////////
int tokenizzaEmail(char * email, Token tokenArray[], int dimT)
{

  int i, k, dim, tok=0;
  char *headers, *headerS, *header, *valore, *tipo, *parola;

  ///////////////////////////////////////
  // Errore 2 - CONTROLLO PUNTATORI NULLI
  ///////////////////////////////////////
  if(email == NULL) return NULL_POINTER;
  if(tokenArray == NULL) return NULL_POINTER;
  
  ///////////////////////////////////////
  // Errore 3 - CONTROLLO STRINGA EMAIL
  ///////////////////////////////////////
  if(email[0] == '\0') return EMPTY_STRING;

  ///////////////////////////////////////
  // Errore 8 - CONTROLLO DIM BUFFER
  ///////////////////////////////////////
  if(dimT < 1 ) return BUFFER_TOO_SMALL; 


  //////////////////////////////
  // ALLOCAZIONE BUFFER HEADERS
  //////////////////////////////
  headers=(char*)calloc(sizeof(char), strlen(email)+1);
  if(headers == NULL) return MEM_ALLOC_ERROR;

  ////////////////////////////
  // ESTRAZIONE DEGLI HEADERS
  ////////////////////////////
  i=estraiHeaders(email, headers, strlen(email)+1);
  if(i!=RESULT_OK) return i;
  
  ////////////////////////////
  // CONTROLLO ESISTENZA BODY
  // ED ELIMINAZIONE HEADERS
  // DALL'EMAIL
  ////////////////////////////
  if(email[strlen(headers)+1] == '\0') return BODY_NOT_FOUND;  
  for(i=0; i<=strlen(headers); i++) email[i]='@';


  ///////////////////////
  // ALLOCAZIONE BUFFERS
  ///////////////////////
  headerS=(char*)calloc(sizeof(char), strlen(headers)+1);
  header=(char*)calloc(sizeof(char), strlen(headers)+1);
  if(header == NULL || headerS == NULL) return MEM_ALLOC_ERROR;
  
  
  while(strlen(headers)!=0)
    {

      /////////////////////////////
      // ESTRAZIONE SINGOLO HEADER
      /////////////////////////////
      i=primoHeader(headers, header, strlen(headers)+1);
      if(i!=RESULT_OK) return i;
      
      valore=(char*)calloc(sizeof(char), strlen(header)+1);
      tipo=(char*)calloc(sizeof(char), strlen(header)+1);
      if(valore == NULL || tipo == NULL) return MEM_ALLOC_ERROR;

      i=5;
      
      while(i!=0)
	{

	  ///////////////////////
	  // PARS SINGOLO HEADER
	  ///////////////////////
	  i=parseHeader(header, tipo, strlen(header)+1, valore, strlen(header)+1);
	  if(i!=RESULT_OK) return i;

	  dim=strlen(valore);
      
	  parola=(char*)calloc(sizeof(char), strlen(valore)+1);
	  if(parola == NULL) return MEM_ALLOC_ERROR;
	  
	  while(valore[dim-1]!='\0' && tok!=dimT-1)
	    {

	      /////////////////////////////////
	      // SPEZZETTAMENTO IN SINGOLE
	      // PAROLE DEL VALORE DELL'HEADER
	      /////////////////////////////////
	      i=primaParola(valore, parola, dim+1);
	      if(i!=RESULT_OK) return i;

	      ////////////////////////
	      // COPIO TIPO DI HEADER
	      ////////////////////////
	      tokenArray[tok].contesto=(char*)calloc(sizeof(char), strlen(tipo)+1);
	      if(tokenArray[tok].contesto == NULL) return MEM_ALLOC_ERROR;
	      strcpy(tokenArray[tok].contesto, tipo);

	      ///////////////////////////
	      // COPIO PAROLA DEL VALORE
	      ///////////////////////////
	      tokenArray[tok].parola=(char*)calloc(sizeof(char), strlen(parola)+1);
	      if(tokenArray[tok].parola == NULL) return MEM_ALLOC_ERROR;
	      strcpy(tokenArray[tok].parola, parola);
	      
	      if(strlen(tokenArray[tok].parola)>1) tok++;
	      
	      if(tok == dimT-1) return BUFFER_TOO_SMALL;
	      
	    }

	  if(valore[dim-1] != '\0') return BUFFER_TOO_SMALL;
	}

      /////////////////////////
      // ACCORCIAMENTO HEADERS
      /////////////////////////
      for(i=strlen(header)+1, k=0; headers[i]!='\0';i++, k++) headerS[k]=headers[i];
      headerS[k]='\0';
      strcpy(headers, headerS);
    }

  dim=strlen(email);

  parola=(char*)calloc(sizeof(char), strlen(email)+1);
  if(parola == NULL) return MEM_ALLOC_ERROR;

  while(email[dim-1]!='\0' && tok!=dimT-1)
    {
    
      ////////////////////////
      // CONTESTO INESISTENTE
      ////////////////////////
      tokenArray[tok].contesto=NULL;

      //////////////////////////
      // SPEZZETTAMENTO BODY
      // IN PAROLE SENZA RUMORE
      //////////////////////////
      i=primaParola(email, parola, strlen(email));
      if(i!=0) return i;

      tokenArray[tok].parola=(char*)calloc(sizeof(char), strlen(parola)+1);
      if(tokenArray[tok].parola == NULL) return MEM_ALLOC_ERROR;

      if(strlen(parola)>1)
	{
	  strcpy(tokenArray[tok].parola, parola);
	  tok++;
	}
    }

  if(email[dim-1] != '\0') return BUFFER_TOO_SMALL;

  /////////////////////
  // FINE ARRAY TOKENS
  /////////////////////
  tokenArray[tok].contesto=NULL;
  tokenArray[tok].parola=NULL;


  parola=NULL;
  header=NULL;
  headers=NULL;
  valore=NULL;
  tipo=NULL;
  free(parola);
  free(header);
  free(headers);
  free(headerS);
  free(valore);
  free(tipo);

  return RESULT_OK;
}


int printTokens(Token tokenArray[], int dimT)
{
  int i=0;
  if(tokenArray == NULL) return NULL_POINTER;
  
  if(dimT < 1) return BUFFER_TOO_SMALL;
  
  while(i!=dimT)
    {
      if(tokenArray[i].parola==NULL && tokenArray[i].contesto==NULL) return RESULT_OK;
      if(tokenArray[i].contesto!=NULL)
        {
   if(tokenArray[i].contesto == '\0') return EMPTY_STRING;
   printf("%s*", tokenArray[i].contesto);
 }
      printf("%s\n", tokenArray[i].parola);
      i++;
    }
  return BUFFER_TOO_SMALL;
}





