#include "testModulo1.h"
#include <stdio.h>
#include <sys/stat.h>
#include <sys/types.h>
#include <unistd.h>

//////////////////////////////////////////
// STAMPA ERRORI
//////////////////////////////////////////
int AlessaGrott_Err(int att, int i, char *funz_name)
{
  char *errore=(char*)calloc(sizeof(char), 35);
  if(errore == NULL) return 1;

  char *test=(char*)calloc(sizeof(char), 35);
  if(test == NULL) return 1;

  if(i ==  0) errore = "RESULT_OK";
  if(i ==  1) errore = "UNKNOWN_ERROR";
  if(i ==  2) errore = "NULL_POINTER";
  if(i ==  3) errore = "EMPTY_STRING";
  if(i ==  4) errore = "FILE_MISSING";
  if(i ==  5) errore = "FILE_UNREDABLE";
  if(i ==  6) errore = "FILE_UNWRITABLE";
  if(i ==  7) errore = "FILE_EMPTY";
  if(i ==  8) errore = "BUFFER_TOO_SMALL";
  if(i ==  9) errore = "HEADER_NOT_FOUND";
  if(i == 10) errore = "BODY_NOT_FOUND";
  if(i == 11) errore = "BAD_HEADER";
  if(i == 12) errore = "MEM_ALLOC_ERROR";

  if(att ==  0) test = "RESULT_OK";
  if(att ==  1) test = "UNKNOWN_ERROR";
  if(att ==  2) test = "NULL_POINTER";
  if(att ==  3) test = "EMPTY_STRING";
  if(att ==  4) test = "FILE_MISSING";
  if(att ==  5) test = "FILE_UNREDABLE";
  if(att ==  6) test = "FILE_UNWRITABLE";
  if(att ==  7) test = "FILE_EMPTY";
  if(att ==  8) test = "BUFFER_TOO_SMALL";
  if(att ==  9) test = "HEADER_NOT_FOUND";
  if(att == 10) test = "BODY_NOT_FOUND";
  if(att == 11) test = "BAD_HEADER";
  if(att == 12) test = "MEM_ALLOC_ERROR";

  printf("Test Fallito:\n");
  printf("\n\tFunzione Testata : %s\n\tTest Effettuato  : %s\n\tErrore Ritornato : %s\n", funz_name, test, errore);
  
  return 0;
}

///////////////////////////////////////////////////
//   TEST LEGGI FILE
/////////////////////////////////////////////////// 
int test_leggiFile(int tipo_di_test, int argomento)
{

  int i, err;

  FILE *fp;
 
  char *funz_name="leggiFile()\0";
  char *testo=(char*)calloc(sizeof(char), 100);
  char *Test_FILE_OK=(char*)calloc(sizeof(char), 100);
  if(testo == NULL)
    {
      printf("ERRORE INTERNO DELLA FUNZIONE DI TEST\nNON E' STATO POSSIBILE ALLOCARE MEMORIA\n");
      funz_name=NULL;
      Test_FILE_OK=NULL;
      testo=NULL;
      free(testo);
      free(funz_name);
      free(Test_FILE_OK);
      return;
    }

  if(funz_name == NULL)
    {
      printf("ERRORE INTERNO DELLA FUNZIONE DI TEST\nNON E' STATO POSSIBILE ALLOCARE MEMORIA\n");
      funz_name=NULL;
      Test_FILE_OK=NULL;
      testo=NULL;
      free(testo);
      free(funz_name);
      free(Test_FILE_OK);
      return;
    }

  if(Test_FILE_OK == NULL)
    {
      printf("ERRORE INTERNO DELLA FUNZIONE DI TEST\nNON E' STATO POSSIBILE ALLOCARE MEMORIA\n");
      funz_name=NULL;
      Test_FILE_OK=NULL;
      testo=NULL;
      free(testo);
      free(funz_name);
      free(Test_FILE_OK);
      return;
    }

  if(argomento > 2) return ARG_MISSING;
  
  switch(argomento)
    {

      /////////////////////////////////////////
      //   ARGOMENTO 0 - char *nomefile
      ////////////////////////////////////////
    
    case 0 :

      switch(tipo_di_test)
	{

	case RESULT_OK :

	  fp=fopen("TEST_File~", "w");
	  if(fp == NULL)
	    {
	      printf("ERRORE INTERNO DELLA FUNZIONE DI TEST\nNON E' STATO POSSIBILE CREARE UN FILE\n");
	      funz_name=NULL;
	      Test_FILE_OK=NULL;
	      testo=NULL;
	      free(testo);
	      free(funz_name);
	      free(Test_FILE_OK);
	      return;
	    }

	  Test_FILE_OK="\n\n\n\t\n \v\\:\n";

	  fwrite(Test_FILE_OK, sizeof(char), strlen(Test_FILE_OK), fp);
	  fclose(fp);

	  i=leggiFile("TEST_File~", strlen(Test_FILE_OK)+1 , testo);

	  if((i == RESULT_OK) && !(strcmp(testo, Test_FILE_OK)))
	    {
	      fp=fopen("TEST_File~", "w");
	      if(fp == NULL)
		{
		  printf("ERRORE INTERNO DELLA FUNZIONE DI TEST\nNON E' STATO POSSIBILE CREARE UN FILE\n");
		  funz_name=NULL;
		  Test_FILE_OK=NULL;
		  testo=NULL;
		  free(testo);
		  free(funz_name);
		  free(Test_FILE_OK);
		  return;
		}

	      Test_FILE_OK=(char*)calloc(sizeof(char), 300);
	      if(Test_FILE_OK == NULL)
		{
		  printf("ERRORE INTERNO DELLA FUNZIONE DI TEST\nNON E' STATO POSSIBILE ALLOCARE MEMORIA\n");
		  funz_name=NULL;
		  Test_FILE_OK=NULL;
		  testo=NULL;
		  free(testo);
		  free(funz_name);
		  free(Test_FILE_OK);
		  return;
		}

	      Test_FILE_OK="From: test_leggiFile()\nTo: leggiFile()\nSubject: Andr Bene?\n\nVediamo se andr tutto bene...\n\0";

	      fwrite(Test_FILE_OK, sizeof(char), strlen(Test_FILE_OK), fp);
	      fclose(fp);

	      i=leggiFile("Test_File~", strlen(Test_FILE_OK)+1, testo);

	      if((i == RESULT_OK) && !(strcmp(testo, Test_FILE_OK)))
	        {
		  funz_name=NULL;
		  Test_FILE_OK=NULL;
		  testo=NULL;
		  free(testo);
		  free(funz_name);
		  free(Test_FILE_OK);
		  return TEST_PASSED;
		}
	    }

	  ////////////////
	  // TEST FALLITO
	  ////////////////
	  err=AlessaGrott_Err(tipo_di_test, i, funz_name);
	  if(err != 0)
	    {
	      printf("ERRORE INTERNO DELLA FUNZIONE DI TEST\nNON E' STATO POSSIBILE ALLOCARE MEMORIA\n");
	      funz_name=NULL;
		  Test_FILE_OK=NULL;
		  testo=NULL;
		  free(testo);
		  free(funz_name);
		  free(Test_FILE_OK);
	      return;
	    }
	  
	  printf("Non viene copiato correttamente tutto il testo del file nel buffer.\n");
	  funz_name=NULL;
	  Test_FILE_OK=NULL;
		  testo=NULL;
		  free(testo);
		  free(funz_name);
		  free(Test_FILE_OK);
	  return TEST_FAILED;
    
	  break;

	case UNKNOWN_ERROR :

	  funz_name=NULL;
		  Test_FILE_OK=NULL;
		  testo=NULL;
		  free(testo);
		  free(funz_name);
		  free(Test_FILE_OK);
	  return NOT_IMPLEMENTED;
	  break;

	case NULL_POINTER :    
    
	  testo=(char*)calloc(sizeof(char), 350);
	  if(testo == NULL)
	    {
	      printf("ERRORE INTERNO DELLA FUNZIONE DI TEST\nNON E' STATO POSSIBILE ALLOCARE MEMORIA\n");
	      funz_name=NULL;
		  Test_FILE_OK=NULL;
		  testo=NULL;
		  free(testo);
		  free(funz_name);
		  free(Test_FILE_OK);
	      return;
	    }

	  i=leggiFile(NULL, 350, testo);

	  if(i == NULL_POINTER)
	    {
	      funz_name=NULL;
		  Test_FILE_OK=NULL;
		  testo=NULL;
		  free(testo);
		  free(funz_name);
		  free(Test_FILE_OK);
	      return TEST_PASSED;
	    }

	  ////////////////
	  // TEST FALLITO
	  ////////////////
	  err=AlessaGrott_Err(tipo_di_test, i, funz_name);
	  if(err != 0) 
	    {
	      printf("ERRORE INTERNO DELLA FUNZIONE DI TEST\nNON E' STATO POSSIBILE ALLOCARE MEMORIA\n");
	      funz_name=NULL;
	      Test_FILE_OK=NULL;
	      testo=NULL;
	      free(testo);
	      free(funz_name);
	      free(Test_FILE_OK);
	      return;
	    }
	  
	  printf("Non viene controllato se l'argomento \" %d \" sia un puntatore a NULL.\n", argomento);
	  funz_name=NULL;
	  Test_FILE_OK=NULL;
	  testo=NULL;
	  free(testo);
	  free(funz_name);
	  free(Test_FILE_OK);
	  return TEST_FAILED;

	  break;

	case EMPTY_STRING :

	  i=leggiFile("\0", 10 , testo);
	  if(i == EMPTY_STRING)
	    {
	      funz_name=NULL;
	      Test_FILE_OK=NULL;
	      testo=NULL;
	      free(testo);
	      free(funz_name);
	      free(Test_FILE_OK);
	      return TEST_PASSED;
	    }

	  ////////////////
	  // TEST FALLITO
	  ////////////////
	  err=AlessaGrott_Err(tipo_di_test, i, funz_name);
	  if(err != 0) 
	    {
	      printf("ERRORE INTERNO DELLA FUNZIONE DI TEST\nNON E' STATO POSSIBILE ALLOCARE MEMORIA\n");
	      funz_name=NULL;
	      Test_FILE_OK=NULL;
	      testo=NULL;
	      free(testo);
	      free(funz_name);
	      free(Test_FILE_OK);
	      return;
	    }
	  
	  printf("Non viene controllato se l'argomento \" %d \" sia una stringa vuota.\n", argomento);
	  funz_name=NULL;
	  Test_FILE_OK=NULL;
	  testo=NULL;
	  free(testo);
	  free(funz_name);
	  free(Test_FILE_OK);
	  return TEST_FAILED;

	  break;

	case FILE_MISSING :

	  testo=(char*)calloc(sizeof(char), 350);
	  if(testo == NULL)
	    {
	      printf("ERRORE INTERNO DELLA FUNZIONE DI TEST\nNON E' STATO POSSIBILE ALLOCARE MEMORIA\n");
	      funz_name=NULL;
	      Test_FILE_OK=NULL;
	      testo=NULL;
	      free(testo);
	      free(funz_name);
	      free(Test_FILE_OK);
	      return;
	    }

	  i=leggiFile("/root", 350, testo);
	  if(i == FILE_MISSING)
	    {
	      funz_name=NULL;
	      Test_FILE_OK=NULL;
	      testo=NULL;
	      free(testo);
	      free(funz_name);
	      free(Test_FILE_OK);
	      return TEST_PASSED;
	    }

	  ////////////////
	  // TEST FALLITO
	  ////////////////
	  err=AlessaGrott_Err(tipo_di_test, i, funz_name);
	  if(err != 0) 
	    {
	      printf("ERRORE INTERNO DELLA FUNZIONE DI TEST\nNON E' STATO POSSIBILE ALLOCARE MEMORIA\n");
	      funz_name=NULL;
	      Test_FILE_OK=NULL;
	      testo=NULL;
	      free(testo);
	      free(funz_name);
	      free(Test_FILE_OK);
	      return;
	    }
	  
	  printf("Non viene controllato se il file da aprire esiste\n", argomento);
	  funz_name=NULL;
	  Test_FILE_OK=NULL;
	  testo=NULL;
	  free(testo);
	  free(funz_name);
	  free(Test_FILE_OK);
	  return TEST_FAILED;

	  break;

	case FILE_UNREADABLE :

	  testo=(char*)calloc(sizeof(char), 350);
	  if(testo == NULL)
	    {
	      printf("ERRORE INTERNO DELLA FUNZIONE DI TEST\nNON E' STATO POSSIBILE ALLOCARE MEMORIA\n");
	      funz_name=NULL;
	      Test_FILE_OK=NULL;
	      testo=NULL;
	      free(testo);
	      free(funz_name);
	      free(Test_FILE_OK);
	      return;
	    }

	  i=leggiFile("file-unreadable", 350, testo);
	  if(i == FILE_UNREADABLE)
	    {
	      funz_name=NULL;
	      Test_FILE_OK=NULL;
	      testo=NULL;
	      free(testo);
	      free(funz_name);
	      free(Test_FILE_OK);
	      return TEST_PASSED;
	    }

	  ////////////////
	  // TEST FALLITO
	  ////////////////
	  err=AlessaGrott_Err(tipo_di_test, i, funz_name);
	  if(err != 0)
	    {
	      printf("ERRORE INTERNO DELLA FUNZIONE DI TEST\nNON E' STATO POSSIBILE ALLOCARE MEMORIA\n");
	      funz_name=NULL;
		  Test_FILE_OK=NULL;
		  testo=NULL;
		  free(testo);
		  free(funz_name);
		  free(Test_FILE_OK);
	      return;
	    }
	  
	  printf("Non Viene controllato se il file da aprire e' leggibile\n", argomento);
	  funz_name=NULL;
	  Test_FILE_OK=NULL;
	  testo=NULL;
	  free(testo);
	  free(funz_name);
	  free(Test_FILE_OK);
	  return TEST_FAILED;
	  
	  break;

	case FILE_UNWRITABLE:

	  funz_name=NULL;
	  Test_FILE_OK=NULL;
	  testo=NULL;
	  free(testo);
	  free(funz_name);
	  free(Test_FILE_OK);
	  return NOT_VALID;
	  break;

	case FILE_EMPTY :

	  if(fp == NULL)
	    {
	      printf("ERRORE INTERNO DELLA FUNZIONE DI TEST\nNON E' STATO POSSIBILE CREARE UN FILE\n");
	      funz_name=NULL;
	      Test_FILE_OK=NULL;
	      testo=NULL;
	      free(testo);
	      free(funz_name);
	      free(Test_FILE_OK);
	      return;
	    }

	  i=leggiFile("file-empty", 10 , testo);

	  if(i == FILE_EMPTY)
	    {
	      funz_name=NULL;
	      Test_FILE_OK=NULL;
	      testo=NULL;
	      free(testo);
	      free(funz_name);
	      free(Test_FILE_OK);
	      return TEST_PASSED;
	    }

	  ////////////////
	  // TEST FALLITO
	  ////////////////
	  err=AlessaGrott_Err(tipo_di_test, i, funz_name);
	  if(err != 0)
	    {
	      printf("ERRORE INTERNO DELLA FUNZIONE DI TEST\nNON E' STATO POSSIBILE ALLOCARE MEMORIA\n");
	      funz_name=NULL;
	      Test_FILE_OK=NULL;
	      testo=NULL;
	      free(testo);
	      free(funz_name);
	      free(Test_FILE_OK);
	      return;
	    }
	  
	  printf("Non viene controllato se il file da aprire sia vuoto\n", argomento);
	  funz_name=NULL;
	  Test_FILE_OK=NULL;
	  testo=NULL;
	  free(testo);
	  free(funz_name);
	  free(Test_FILE_OK);
	  return TEST_FAILED;

	  break;

	case BUFFER_TOO_SMALL:

	  funz_name=NULL;
	  Test_FILE_OK=NULL;
	  testo=NULL;
	  free(testo);
	  free(funz_name);
	  free(Test_FILE_OK);
	  return NOT_VALID;
	  break;

	case HEADER_NOT_FOUND:

	  funz_name=NULL;
	  Test_FILE_OK=NULL;
	  testo=NULL;
	  free(testo);
	  free(funz_name);
	  free(Test_FILE_OK);
	  return NOT_VALID;
	  break;

	case BODY_NOT_FOUND:

	  funz_name=NULL;
	  Test_FILE_OK=NULL;
	  testo=NULL;
	  free(testo);
	  free(funz_name);
	  free(Test_FILE_OK);
	  return NOT_VALID;
	  break;

	case BAD_HEADER:

	  funz_name=NULL;
	  Test_FILE_OK=NULL;
	  testo=NULL;
	  free(testo);
	  free(funz_name);
	  free(Test_FILE_OK);
	  return NOT_VALID;
	  break;

	case MEM_ALLOC_ERROR:

	  funz_name=NULL;
	  Test_FILE_OK=NULL;
	  testo=NULL;
	  free(testo);
	  free(funz_name);
	  free(Test_FILE_OK);
	  return NOT_IMPLEMENTED;
	  break;

	}

      /////////////////////////////////////////
      //   ARGOMENTO 1 - int dimensione
      /////////////////////////////////////////

    case 1 :

      switch(tipo_di_test)
	{

	case RESULT_OK :

	  funz_name=NULL;
	  Test_FILE_OK=NULL;
	  testo=NULL;
	  free(testo);
	  free(funz_name);
	  free(Test_FILE_OK);
	  return NOT_IMPLEMENTED;
	  break;

	case UNKNOWN_ERROR :

	  funz_name=NULL;
	  Test_FILE_OK=NULL;
	  testo=NULL;
	  free(testo);
	  free(funz_name);
	  free(Test_FILE_OK);
	  return NOT_IMPLEMENTED;
	  break;

	case NULL_POINTER :
    
	  funz_name=NULL;
	  Test_FILE_OK=NULL;
	  testo=NULL;
	  free(testo);
	  free(funz_name);
	  free(Test_FILE_OK);
	  return NOT_VALID;
	  break;

	case EMPTY_STRING:

	  funz_name=NULL;
	  Test_FILE_OK=NULL;
	  testo=NULL;
	  free(testo);
	  free(funz_name);
	  free(Test_FILE_OK);
	  return NOT_VALID;
	  break;

	case FILE_MISSING:

	  funz_name=NULL;
	  Test_FILE_OK=NULL;
	  testo=NULL;
	  free(testo);
	  free(funz_name);
	  free(Test_FILE_OK);
	  return NOT_VALID;
	  break;

	case FILE_UNREADABLE:

	  funz_name=NULL;
	  Test_FILE_OK=NULL;
	  testo=NULL;
	  free(testo);
	  free(funz_name);
	  free(Test_FILE_OK);
	  return NOT_VALID;
	  break;

	case FILE_UNWRITABLE:

	  funz_name=NULL;
	  Test_FILE_OK=NULL;
	  testo=NULL;
	  free(testo);
	  free(funz_name);
	  free(Test_FILE_OK);
	  return NOT_VALID;
	  break;

	case FILE_EMPTY:

	  funz_name=NULL;
	  Test_FILE_OK=NULL;
	  testo=NULL;
	  free(testo);
	  free(funz_name);
	  free(Test_FILE_OK);
	  return NOT_VALID;
	  break;

	case BUFFER_TOO_SMALL :

	  i=leggiFile("email1.txt", 1 , testo);
  
	  if(i == BUFFER_TOO_SMALL)
	    {
	      i=leggiFile("email1.txt", -9876, testo);

	      if(i == BUFFER_TOO_SMALL)
		{
		  funz_name=NULL;
		  Test_FILE_OK=NULL;
		  testo=NULL;
		  free(testo);
		  free(funz_name);
		  free(Test_FILE_OK);
		  return TEST_PASSED;
		}
	    }

	  ////////////////
	  // TEST FALLITO
	  ////////////////
	  err=AlessaGrott_Err(tipo_di_test, i, funz_name);
	  if(err != 0)
	    {
	      printf("ERRORE INTERNO DELLA FUNZIONE DI TEST\nNON E' STATO POSSIBILE ALLOCARE MEMORIA\n");
	      Test_FILE_OK=NULL;
	      testo=NULL;
	      free(testo);
	      free(funz_name);
	      free(Test_FILE_OK);
	      return;
	    }
	  
	  printf("Non viene controllato se la dimensione del buffer \" %d \" sia valida.\n", argomento);
	  Test_FILE_OK=NULL;
	  testo=NULL;
	  free(testo);
	  free(funz_name);
	  free(Test_FILE_OK);
	  return TEST_FAILED;

	  break;

	case HEADER_NOT_FOUND:

	  funz_name=NULL;
	  Test_FILE_OK=NULL;
	  testo=NULL;
	  free(testo);
	  free(funz_name);
	  free(Test_FILE_OK);
	  return NOT_VALID;
	  break;

	case BODY_NOT_FOUND:

	  funz_name=NULL;
	  Test_FILE_OK=NULL;
	  testo=NULL;
	  free(testo);
	  free(funz_name);
	  free(Test_FILE_OK);
	  return NOT_VALID;
	  break;

	case BAD_HEADER:

	  funz_name=NULL;
	  Test_FILE_OK=NULL;
	  testo=NULL;
	  free(testo);
	  free(funz_name);
	  free(Test_FILE_OK);
	  return NOT_VALID;
	  break;

	case MEM_ALLOC_ERROR:

	  funz_name=NULL;
	  Test_FILE_OK=NULL;
	  testo=NULL;
	  free(testo);
	  free(funz_name);
	  free(Test_FILE_OK);
	  return NOT_IMPLEMENTED;
	  break;

	}

      /////////////////////////////////////////
      //   ARGOMENTO 2 - char *testo
      /////////////////////////////////////////
  
    case 2 :
  
      switch(tipo_di_test)
	{

	case RESULT_OK :

	  funz_name=NULL;
	  Test_FILE_OK=NULL;
	  testo=NULL;
	  free(testo);
	  free(funz_name);
	  free(Test_FILE_OK);
	  return NOT_IMPLEMENTED;
	  break;

	case UNKNOWN_ERROR :

	  funz_name=NULL;
	  Test_FILE_OK=NULL;
	  testo=NULL;
	  free(testo);
	  free(funz_name);
	  free(Test_FILE_OK);
	  return NOT_IMPLEMENTED;
	  break;
	  
	case NULL_POINTER :
    
	  i=leggiFile("email1.txt", 100 , NULL);
	  if(i == NULL_POINTER)
	    {
	      Test_FILE_OK=NULL;
	      testo=NULL;
	      funz_name=NULL;
	      free(testo);
	      free(funz_name);
	      free(Test_FILE_OK);	      
	      return TEST_PASSED;
	    }

	  ////////////////
	  // TEST FALLITO
	  ////////////////
	  err=AlessaGrott_Err(tipo_di_test, i, funz_name);
	  if(err != 0) 
	    {
	      printf("ERRORE INTERNO DELLA FUNZIONE DI TEST\nNON E' STATO POSSIBILE ALLOCARE MEMORIA\n");
	      funz_name=NULL;
	      Test_FILE_OK=NULL;
	      testo=NULL;
	      free(testo);
	      free(funz_name);
	      free(Test_FILE_OK);
	      return;
	    }
	  
	  printf("Non viene controllato se l'argomento \" %d \" sia un puntatore a NULL.\n", argomento);
	  Test_FILE_OK=NULL;
	  testo=NULL;
	  funz_name=NULL;
	  free(testo);
	  free(funz_name);
	  free(Test_FILE_OK);
	  return TEST_FAILED;

	  break;

	case EMPTY_STRING:

	  funz_name=NULL;
	  Test_FILE_OK=NULL;
	  testo=NULL;
	  free(testo);
	  free(funz_name);
	  free(Test_FILE_OK);
	  return NOT_VALID;
	  break;

	case FILE_MISSING:

	  funz_name=NULL;
	  Test_FILE_OK=NULL;
	  testo=NULL;
	  free(testo);
	  free(funz_name);
	  free(Test_FILE_OK);
	  return NOT_VALID;
	  break;

	case FILE_UNREADABLE:

	  funz_name=NULL;
	  Test_FILE_OK=NULL;
	  testo=NULL;
	  free(testo);
	  free(funz_name);
	  free(Test_FILE_OK);
	  return NOT_VALID;
	  break;

	case FILE_UNWRITABLE:

	  funz_name=NULL;
	  Test_FILE_OK=NULL;
	  testo=NULL;
	  free(testo);
	  free(funz_name);
	  free(Test_FILE_OK);
	  return NOT_VALID;
	  break;

	case FILE_EMPTY:

	  funz_name=NULL;
	  Test_FILE_OK=NULL;
	  testo=NULL;
	  free(testo);
	  free(funz_name);
	  free(Test_FILE_OK);
	  return NOT_VALID;
	  break;

	case BUFFER_TOO_SMALL:

	  funz_name=NULL;
	  Test_FILE_OK=NULL;
	  testo=NULL;
	  free(testo);
	  free(funz_name);
	  free(Test_FILE_OK);
	  return NOT_VALID;
	  break;

	case HEADER_NOT_FOUND:

	  funz_name=NULL;
	  Test_FILE_OK=NULL;
	  testo=NULL;
	  free(testo);
	  free(funz_name);
	  free(Test_FILE_OK);
	  return NOT_VALID;
	  break;

	case BODY_NOT_FOUND:

	  funz_name=NULL;
	  Test_FILE_OK=NULL;
	  testo=NULL;
	  free(testo);
	  free(funz_name);
	  free(Test_FILE_OK);
	  return NOT_VALID;
	  break;

	case BAD_HEADER:

	  funz_name=NULL;
	  Test_FILE_OK=NULL;
	  testo=NULL;
	  free(testo);
	  free(funz_name);
	  free(Test_FILE_OK);
	  return NOT_VALID;
	  break;

	case MEM_ALLOC_ERROR:

	  funz_name=NULL;
	  Test_FILE_OK=NULL;
	  testo=NULL;
	  free(testo);
	  free(funz_name);
	  free(Test_FILE_OK);
	  return NOT_IMPLEMENTED;
	  break;

	}
    }
}

///////////////////////////////////////////////////
//   TEST PRIMA PAROLA	
/////////////////////////////////////////////////// 
int test_primaParola(int tipo_di_test, int argomento)
{

  int i, cont, err;
  char Test_Testo[100];
  char *funz_name="primaParola()\0";
  char *testo=(char*)calloc(sizeof(char), 100);

  if(testo == NULL)
    {
      printf("ERRORE INTERNO DELLA FUNZIONE DI TEST\nNON E' STATO POSSIBILE ALLOCARE MEMORIA\n");
      funz_name=NULL;
      testo=NULL;
      free(funz_name);
      free(testo);
      return;
    }

  if(funz_name == NULL)
    {
      printf("ERRORE INTERNO DELLA FUNZIONE DI TEST\nNON E' STATO POSSIBILE ALLOCARE MEMORIA\n");
      funz_name=NULL;
      testo=NULL;
      free(funz_name);
      free(testo);
      return;
    }
  
  if(argomento > 2) return ARG_MISSING;
  
  switch(argomento)
    {

      /////////////////////////////////////////
      //   ARGOMENTO 0 - char *testo
      ////////////////////////////////////////
    
    case 0 :

      switch(tipo_di_test)
	{

	case RESULT_OK :

	  strcpy(Test_Testo, "$$%&/()=?^@#parola");

	  i=primaParola(Test_Testo, testo, strlen(Test_Testo)+1);

	  if(i == RESULT_OK && !(strcmp(testo, "parola")))
	    {
	      strcpy(Test_Testo, "\n");

	      i=primaParola(Test_Testo, testo, strlen(Test_Testo)+1);

	      if(i == RESULT_OK && strlen(testo)==0)
	        {
		  strcpy(Test_Testo, " prima  seconda \"\"terza quarta\n\tquinta");
	  
	  	  i=primaParola(Test_Testo, testo, strlen(Test_Testo)+1);

		  if(i == RESULT_OK)
		    if(!strcmp("prima", testo))
		      {
			i=primaParola(Test_Testo, testo, strlen(Test_Testo)+1);		

			if(i == RESULT_OK) if(!strcmp("seconda", testo))
			  {
			    i=primaParola(Test_Testo, testo, strlen(Test_Testo)+1);

			    if(i == RESULT_OK)
			      if(!strcmp("terza", testo))
				{
				  i=primaParola(Test_Testo, testo, strlen(Test_Testo)+1);

				  if(i == RESULT_OK) if(!strcmp("quarta", testo))
				    {
				      i=primaParola(Test_Testo, testo, strlen(Test_Testo)+1);

				      if(i == RESULT_OK) if(!strcmp("quinta", testo))
				        {
					  funz_name=NULL;
					  testo=NULL;
					  free(funz_name);
					  free(testo);
					  return TEST_PASSED;
					}
				    }
				}
			  }
		      }
		}
	    }

	  ////////////////
	  // TEST FALLITO
	  ////////////////
	  err=AlessaGrott_Err(tipo_di_test, i, funz_name);
	  if(err != 0) 
	    {
	      printf("ERRORE INTERNO DELLA FUNZIONE DI TEST\nNON E' STATO POSSIBILE ALLOCARE MEMORIA\n");
	      funz_name=NULL;
	      testo=NULL;
	      free(testo);
	      free(funz_name);
	      return;
	    }

	  printf("Non viene controllato se i caratteri del buffer \" %d \" sono\neffettivamente alfanumerici\n", argomento);
	  funz_name=NULL;
	  testo=NULL;
	  free(funz_name);
	  free(testo);
	  return TEST_FAILED;
    
	  break;

	case UNKNOWN_ERROR :

	  funz_name=NULL;
	  testo=NULL;
	  free(funz_name);
	  free(testo);
	  return NOT_IMPLEMENTED;
	  break;

	case NULL_POINTER :    
    
	  i=primaParola(NULL, testo, 100);

	  if(i == NULL_POINTER)
	    {
	      funz_name=NULL;
	      testo=NULL;
	      free(funz_name);
	      free(testo);
	      return TEST_PASSED;
	    }
	  
	  ////////////////
	  // TEST FALLITO
	  ////////////////
	  err=AlessaGrott_Err(tipo_di_test, i, funz_name);
	  if(err != 0) 
	    {
	      printf("ERRORE INTERNO DELLA FUNZIONE DI TEST\nNON E' STATO POSSIBILE ALLOCARE MEMORIA\n");
	      funz_name=NULL;
	      testo=NULL;
	      free(testo);
	      free(funz_name);
	      return;
	    }

	  printf("Non viene controllato se l'argomento \" %d \" sia un puntatore a NULL.\n", argomento);
	  funz_name=NULL;
	  testo=NULL;
	  free(funz_name);
	  free(testo);
	  return TEST_FAILED;

	  break;

	case EMPTY_STRING :

	  i=primaParola("\0", testo, 10);

	  if(i == EMPTY_STRING)
	    {
	      funz_name=NULL;
	      testo=NULL;
	      free(funz_name);
	      free(testo);
	      return TEST_PASSED;
	    }
	  
	  ////////////////
	  // TEST FALLITO
	  ////////////////
	  err=AlessaGrott_Err(tipo_di_test, i, funz_name);
	  if(err != 0) 
	    {
	      printf("ERRORE INTERNO DELLA FUNZIONE DI TEST\nNON E' STATO POSSIBILE ALLOCARE MEMORIA\n");
	      funz_name=NULL;
	      testo=NULL;
	      free(testo);
	      free(funz_name);
	      return;
	    }

	  printf("Non viene controllato se l'argomento \" %d \" sia una stringa vuota.\n", argomento);
	  funz_name=NULL;
	  testo=NULL;
	  free(funz_name);
	  free(testo);
	  return TEST_FAILED;

	  break;

	case FILE_MISSING:

	  funz_name=NULL;
	  testo=NULL;
	  free(funz_name);
	  free(testo);
	  return NOT_VALID;
	  break;

        case FILE_UNREADABLE:

	  funz_name=NULL;
	  testo=NULL;
	  free(funz_name);
	  free(testo);
	  return NOT_VALID;
	  break;

        case FILE_UNWRITABLE:

	  funz_name=NULL;
	  testo=NULL;
	  free(funz_name);
	  free(testo);
	  return NOT_VALID;
	  break;

        case FILE_EMPTY:

	  funz_name=NULL;
	  testo=NULL;
	  free(funz_name);
	  free(testo);
	  return NOT_VALID;
	  break;

        case BUFFER_TOO_SMALL:

	  funz_name=NULL;
	  testo=NULL;
	  free(funz_name);
	  free(testo);
	  return NOT_VALID;
	  break;

	case HEADER_NOT_FOUND:

	  funz_name=NULL;
	  testo=NULL;
	  free(funz_name);
	  free(testo);
	  return NOT_VALID;
	  break;


        case BODY_NOT_FOUND:

	  funz_name=NULL;
	  testo=NULL;
	  free(funz_name);
	  free(testo);
	  return NOT_VALID;
	  break;


        case BAD_HEADER:

	  funz_name=NULL;
	  testo=NULL;
	  free(funz_name);
	  free(testo);
	  return NOT_VALID;
	  break;


        case MEM_ALLOC_ERROR:

	  funz_name=NULL;
	  testo=NULL;
	  free(funz_name);
	  free(testo);
	  return NOT_IMPLEMENTED;
	  break;

	}

      /////////////////////////////////////////
      //   ARGOMENTO 1 - char *parola
      /////////////////////////////////////////

    case 1 :

      switch(tipo_di_test)
	{

	case RESULT_OK :

	  funz_name=NULL;
	  testo=NULL;
	  free(funz_name);
	  free(testo);
	  return NOT_IMPLEMENTED;
	  break;

	case UNKNOWN_ERROR :

	  funz_name=NULL;
	  testo=NULL;
	  free(funz_name);
	  free(testo);
	  return NOT_IMPLEMENTED;
	  break;

	case NULL_POINTER :

	  testo="ciao";

	  i=primaParola(testo, NULL, 10);

	  if(i == NULL_POINTER)
	    {
	      funz_name=NULL;
	      testo=NULL;
	      free(funz_name);
	      free(testo);
	      return TEST_PASSED;
	    }

	  ////////////////
	  // TEST FALLITO
	  ////////////////
	  err=AlessaGrott_Err(tipo_di_test, i, funz_name);
	  if(err != 0) 
	    {
	      printf("ERRORE INTERNO DELLA FUNZIONE DI TEST\nNON E' STATO POSSIBILE ALLOCARE MEMORIA\n");
	      funz_name=NULL;
	      testo=NULL;
	      free(testo);
	      free(funz_name);
	      return;
	    }

	  printf("Non viene controllato se l'argomento \" %d \" sia un puntatore a NULL.\n", argomento);
	  funz_name=NULL;
	  testo=NULL;
	  free(funz_name);
	  free(testo);
	  return TEST_FAILED;
	  break;

	case EMPTY_STRING:

	  funz_name=NULL;
	  testo=NULL;
	  free(funz_name);
	  free(testo);
	  return NOT_VALID;
	  break;

	case FILE_MISSING:

	  funz_name=NULL;
	  testo=NULL;
	  free(funz_name);
	  free(testo);
	  return NOT_VALID;
	  break;

        case FILE_UNREADABLE:

	  funz_name=NULL;
	  testo=NULL;
	  free(funz_name);
	  free(testo);
	  return NOT_VALID;
	  break;

        case FILE_UNWRITABLE:

	  funz_name=NULL;
	  testo=NULL;
	  free(funz_name);
	  free(testo);
	  return NOT_VALID;
	  break;

        case FILE_EMPTY:

	  funz_name=NULL;
	  testo=NULL;
	  free(funz_name);
	  free(testo);
	  return NOT_VALID;
	  break;

	case BUFFER_TOO_SMALL :

	  strcpy(Test_Testo, "par");

	  i=primaParola(Test_Testo, testo, strlen(Test_Testo));

	  if(i == BUFFER_TOO_SMALL)
	    {
	      funz_name=NULL;
	      testo=NULL;
	      free(funz_name);
	      free(testo);
	      return TEST_PASSED;
	    }
	  
	  ////////////////
	  // TEST FALLITO
	  ////////////////
	  err=AlessaGrott_Err(tipo_di_test, i, funz_name);
	  if(err != 0) 
	    {
	      printf("ERRORE INTERNO DELLA FUNZIONE DI TEST\nNON E' STATO POSSIBILE ALLOCARE MEMORIA\n");
	      funz_name=NULL;
	      testo=NULL;
	      free(testo);
	      free(funz_name);
	      return;
	    }

	  printf("Non viene controllato se la stringa da copiare sia piu' lunga del buffer disponibile.\n");
	  funz_name=NULL;
	  testo=NULL;
	  free(funz_name);
	  free(testo);
	  return TEST_FAILED;
	  
	  break;

	case HEADER_NOT_FOUND:

	  funz_name=NULL;
	  testo=NULL;
	  free(funz_name);
	  free(testo);
	  return NOT_VALID;
	  break;


        case BODY_NOT_FOUND:

	  funz_name=NULL;
	  testo=NULL;
	  free(funz_name);
	  free(testo);
	  return NOT_VALID;
	  break;


        case BAD_HEADER:

	  funz_name=NULL;
	  testo=NULL;
	  free(funz_name);
	  free(testo);
	  return NOT_VALID;
	  break;


        case MEM_ALLOC_ERROR:

	  funz_name=NULL;
	  testo=NULL;
	  free(funz_name);
	  free(testo);
	  return NOT_IMPLEMENTED;
	  break;

	}

      /////////////////////////////////////////
      //   ARGOMENTO 2 - int dim
      /////////////////////////////////////////
  
    case 2 :
  
      switch(tipo_di_test)
	{

	case RESULT_OK :

	  funz_name=NULL;
	  testo=NULL;
	  free(funz_name);
	  free(testo);
	  return NOT_IMPLEMENTED;
	  break;

	case UNKNOWN_ERROR :

	  funz_name=NULL;
	  testo=NULL;
	  free(funz_name);
	  free(testo);
	  return NOT_IMPLEMENTED;
	  break;

        case NULL_POINTER:

	  funz_name=NULL;
	  testo=NULL;
	  free(funz_name);
	  free(testo);
	  return NOT_VALID;
	  break;

        case EMPTY_STRING:

	  funz_name=NULL;
	  testo=NULL;
	  free(funz_name);
	  free(testo);
	  return NOT_VALID;
	  break;

	case FILE_MISSING:

	  funz_name=NULL;
	  testo=NULL;
	  free(funz_name);
	  free(testo);
	  return NOT_VALID;
	  break;

        case FILE_UNREADABLE:

	  funz_name=NULL;
	  testo=NULL;
	  free(funz_name);
	  free(testo);
	  return NOT_VALID;
	  break;

        case FILE_UNWRITABLE:

	  funz_name=NULL;
	  testo=NULL;
	  free(funz_name);
	  free(testo);
	  return NOT_VALID;
	  break;

        case FILE_EMPTY:

	  funz_name=NULL;
	  testo=NULL;
	  free(funz_name);
	  free(testo);
	  return NOT_VALID;
	  break;

	case BUFFER_TOO_SMALL :

	  strcpy(Test_Testo, "parola");
	  
	  i=primaParola(Test_Testo, testo, 1);
  
	  if(i == BUFFER_TOO_SMALL)
	    {
	      i=primaParola("parola", testo, -9845);

	      if(i == BUFFER_TOO_SMALL)
	        {
		  strcpy(Test_Testo, "parolamoltolunga");

		  i=primaParola(Test_Testo, testo, 7);

		  if(i == BUFFER_TOO_SMALL)
		    {
		      funz_name=NULL;
		      testo=NULL;
		      free(funz_name);
		      free(testo);
		      return TEST_PASSED;
		    }

		}
	    }

	  ////////////////
	  // TEST FALLITO
	  ////////////////
	  err=AlessaGrott_Err(tipo_di_test, i, funz_name);
	  if(err != 0) 
	    {
	      printf("ERRORE INTERNO DELLA FUNZIONE DI TEST\nNON E' STATO POSSIBILE ALLOCARE MEMORIA\n");
	      funz_name=NULL;
	      testo=NULL;
	      free(testo);
	      free(funz_name);
	      return;
	    }

	  printf("Non viene controllato se la dimensione del buffer \" %d \" sia valida.\n", argomento);
	  funz_name=NULL;
	  testo=NULL;
	  free(funz_name);
	  free(testo);
	  return TEST_FAILED;
	  
	  break;

        case HEADER_NOT_FOUND:

	  funz_name=NULL;
	  testo=NULL;
	  free(funz_name);
	  free(testo);
	  return NOT_VALID;
	  break;


        case BODY_NOT_FOUND:

	  funz_name=NULL;
	  testo=NULL;
	  free(funz_name);
	  free(testo);
	  return NOT_VALID;
	  break;


        case BAD_HEADER:

	  funz_name=NULL;
	  testo=NULL;
	  free(funz_name);
	  free(testo);
	  return NOT_VALID;
	  break;


        case MEM_ALLOC_ERROR:

	  funz_name=NULL;
	  testo=NULL;
	  free(funz_name);
	  free(testo);
	  return NOT_IMPLEMENTED;
	  break;

	}
    }
}

///////////////////////////////////////////////////
//   TEST ESTRAI HEADERS
/////////////////////////////////////////////////// 
int test_estraiHeaders(int tipo_di_test, int argomento)
{
  int i, cont, err;
  char Test_Email[100];
  char *funz_name="estraiHeaders()\0";
  char *headers=(char*)calloc(sizeof(char), 100);
  if(headers == NULL)
    {
      printf("ERRORE INTERNO DELLA FUNZIONE DI TEST\nNON E' STATO POSSIBILE ALLOCARE MEMORIA\n");
      funz_name=NULL;
      headers=NULL;
      free(funz_name);
      free(headers);
      return;
    }

  if(funz_name == NULL)
    {
      printf("ERRORE INTERNO DELLA FUNZIONE DI TEST\nNON E' STATO POSSIBILE ALLOCARE MEMORIA\n");
      funz_name=NULL;
      headers=NULL;
      free(funz_name);
      free(headers);
      return;
    }
  
  if(argomento > 2) return ARG_MISSING;
  
  switch(argomento)
    {

      /////////////////////////////////////////
      //   ARGOMENTO 0 - char *email
      ////////////////////////////////////////
    
    case 0 :

      switch(tipo_di_test)
	{

	case RESULT_OK :

	  strcpy(Test_Email, "From: a@b.c\nFrom \tcasa.mia.it\n\t123.456.789.0\nTo: c@b.a\nSoggetto: Testami\n\nblablabla\t");

	  i=estraiHeaders(Test_Email, headers, strlen(Test_Email)+1);

	  if((i == RESULT_OK) && !(strcmp(headers, "From: a@b.c\nFrom \tcasa.mia.it\n\t123.456.789.0\nTo: c@b.a\nSoggetto: Testami\n")))
	    {
	      funz_name=NULL;
	      headers=NULL;
	      free(funz_name);
	      free(headers);
	      return TEST_PASSED;
	    }

	  ////////////////
	  // TEST FALLITO
	  ////////////////
	  err=AlessaGrott_Err(tipo_di_test, i, funz_name);
	  if(err != 0) 
	    {
	      printf("ERRORE INTERNO DELLA FUNZIONE DI TEST\nNON E' STATO POSSIBILE ALLOCARE MEMORIA\n");
	      funz_name=NULL;
	      headers=NULL;
	      free(headers);
	      free(funz_name);
	      return;
	    }

	  printf("Non viene copiato correttamente il blocco di headers.\n");
	  funz_name=NULL;
	  headers=NULL;
	  free(funz_name);
	  free(headers);
	  return TEST_FAILED;
    
	  break;

	case UNKNOWN_ERROR :

	  funz_name=NULL;
	  headers=NULL;
	  free(funz_name);
	  free(headers);
	  return NOT_IMPLEMENTED;
	  break;

	case NULL_POINTER :    
    
	  i=estraiHeaders(NULL, headers, 10);

	  if(i == NULL_POINTER)
	    {
	      funz_name=NULL;
	      headers=NULL;
	      free(funz_name);
	      free(headers);
	      return TEST_PASSED;
	    }
	  
	  ////////////////
	  // TEST FALLITO
	  ////////////////
	  err=AlessaGrott_Err(tipo_di_test, i, funz_name);
	  if(err != 0) 
	    {
	      printf("ERRORE INTERNO DELLA FUNZIONE DI TEST\nNON E' STATO POSSIBILE ALLOCARE MEMORIA\n");
	      funz_name=NULL;
	      headers=NULL;
	      free(headers);
	      free(funz_name);
	      return;
	    }

	  printf("Non viene controllato se l'argomento \" %d \" sia un puntatore a NULL.\n", argomento);
	  funz_name=NULL;
	  headers=NULL;
	  free(funz_name);
	  free(headers);
	  return TEST_FAILED;

	  break;

	case EMPTY_STRING :

	  i=estraiHeaders("\0", headers, 10);

	  if(i == EMPTY_STRING)
	    {
	      funz_name=NULL;
	      headers=NULL;
	      free(funz_name);
	      free(headers);
	      return TEST_PASSED;
	    }
	  
	  ////////////////
	  // TEST FALLITO
	  ////////////////
	  err=AlessaGrott_Err(tipo_di_test, i, funz_name);
	  if(err != 0) 
	    {
	      printf("ERRORE INTERNO DELLA FUNZIONE DI TEST\nNON E' STATO POSSIBILE ALLOCARE MEMORIA\n");
	      funz_name=NULL;
	      headers=NULL;
	      free(headers);
	      free(funz_name);
	      return;
	    }

	  printf("Non viene controllato se l'argomento \" %d \" sia una stringa vuota.\n", argomento);
	  funz_name=NULL;
	  headers=NULL;
	  free(funz_name);
	  free(headers);
	  return TEST_FAILED;

	  break;

	case FILE_MISSING:

	    funz_name=NULL;
	    headers=NULL;
	    free(funz_name);
	    free(headers);
	    return NOT_VALID;
	    break;

        case FILE_UNREADABLE:

	    funz_name=NULL;
	    headers=NULL;
	    free(funz_name);
	    free(headers);
	    return NOT_VALID;
	    break;

        case FILE_UNWRITABLE:

	    funz_name=NULL;
	    headers=NULL;
	    free(funz_name);
	    free(headers);
	    return NOT_VALID;
	    break;

        case FILE_EMPTY:

	    funz_name=NULL;
	    headers=NULL;
	    free(funz_name);
	    free(headers);
	    return NOT_VALID;
	    break;

        case BUFFER_TOO_SMALL:

	    funz_name=NULL;
	    headers=NULL;
	    free(funz_name);
	    free(headers);
	    return NOT_VALID;
	    break;

	case HEADER_NOT_FOUND :

	  strcpy(Test_Email, " From: a@b.c\n\n ");

	  i=estraiHeaders(Test_Email, headers, strlen(Test_Email)+1);

	  if(i == HEADER_NOT_FOUND)
	    {
	      strcpy(Test_Email, "\nFrom: a@b.c\n\n ");

	      i=estraiHeaders(Test_Email, headers, strlen(Test_Email)+1);

	      if(i == HEADER_NOT_FOUND)
	        {
		  strcpy(Test_Email, "\tFrom: a@b.c\n\n ");

		  i=estraiHeaders(Test_Email, headers, strlen(Test_Email)+1);

		  if(i == HEADER_NOT_FOUND)
		    {
		      funz_name=NULL;
		      headers=NULL;
		      free(funz_name);
		      free(headers);
		      return TEST_PASSED;
		    }
		}
	    }

	  ////////////////
	  // TEST FALLITO
	  ////////////////
	  err=AlessaGrott_Err(tipo_di_test, i, funz_name);
	  if(err != 0) 
	    {
	      printf("ERRORE INTERNO DELLA FUNZIONE DI TEST\nNON E' STATO POSSIBILE ALLOCARE MEMORIA\n");
	      funz_name=NULL;
	      headers=NULL;
	      free(headers);
	      free(funz_name);
	      return;
	    }

	  printf("Non viene controllato se sono presenti headers corretti nell'email.\n");
	  funz_name=NULL;
	  headers=NULL;
	  free(funz_name);
	  free(headers);
	  return TEST_FAILED;
	  
	  break;

        case BODY_NOT_FOUND:

	    funz_name=NULL;
	    headers=NULL;
	    free(funz_name);
	    free(headers);
	    return NOT_VALID;
	    break;

        case BAD_HEADER:

	    funz_name=NULL;
	    headers=NULL;
	    free(funz_name);
	    free(headers);
	    return NOT_VALID;
	    break;

        case MEM_ALLOC_ERROR:

	    funz_name=NULL;
	    headers=NULL;
	    free(funz_name);
	    free(headers);
	    return NOT_IMPLEMENTED;
	    break;

	}

      /////////////////////////////////////////
      //   ARGOMENTO 1 - char *headers
      /////////////////////////////////////////

    case 1 :

      switch(tipo_di_test)
	{

	case RESULT_OK :

	  funz_name=NULL;
	  headers=NULL;
	  free(funz_name);
	  free(headers);
	  return NOT_IMPLEMENTED;
	  break;

	case UNKNOWN_ERROR :

	  funz_name=NULL;
	  headers=NULL;
	  free(funz_name);
	  free(headers);
	  return NOT_IMPLEMENTED;
	  break;

	case NULL_POINTER :

	  i=estraiHeaders("From: a@b.c\n\n ", NULL, 10);

	  if(i == NULL_POINTER)
	    {
	      funz_name=NULL;
	      headers=NULL;
	      free(funz_name);
	      free(headers);
	      return TEST_PASSED;
	    }

	  ////////////////
	  // TEST FALLITO
	  ////////////////
	  err=AlessaGrott_Err(tipo_di_test, i, funz_name);
	  if(err != 0) 
	    {
	      printf("ERRORE INTERNO DELLA FUNZIONE DI TEST\nNON E' STATO POSSIBILE ALLOCARE MEMORIA\n");
	      funz_name=NULL;
	      headers=NULL;
	      free(headers);
	      free(funz_name);
	      return;
	    }

	  printf("Non viene controllato se l'argomento \" %d \" sia un puntatore a NULL.\n", argomento);
	  funz_name=NULL;
	  headers=NULL;
	  free(funz_name);
	  free(headers);
	  return TEST_FAILED;
	  
	  break;

        case EMPTY_STRING:

	    funz_name=NULL;
	    headers=NULL;
	    free(funz_name);
	    free(headers);
	    return NOT_VALID;
	    break;

	case FILE_MISSING:

	    funz_name=NULL;
	    headers=NULL;
	    free(funz_name);
	    free(headers);
	    return NOT_VALID;
	    break;

        case FILE_UNREADABLE:

	    funz_name=NULL;
	    headers=NULL;
	    free(funz_name);
	    free(headers);
	    return NOT_VALID;
	    break;

        case FILE_UNWRITABLE:

	    funz_name=NULL;
	    headers=NULL;
	    free(funz_name);
	    free(headers);
	    return NOT_VALID;
	    break;

        case FILE_EMPTY:

	    funz_name=NULL;
	    headers=NULL;
	    free(funz_name);
	    free(headers);
	    return NOT_VALID;
	    break;

	case BUFFER_TOO_SMALL :

	  strcpy(Test_Email, "headers: head\n\n ");

	  i=estraiHeaders(Test_Email, headers, strlen(Test_Email)-5);

	  if(i == BUFFER_TOO_SMALL)
	    {
	      funz_name=NULL;
	      headers=NULL;
	      free(funz_name);
	      free(headers);
	      return TEST_PASSED;
	    }
	  
	  ////////////////
	  // TEST FALLITO
	  ////////////////
	  err=AlessaGrott_Err(tipo_di_test, i, funz_name);
	  if(err != 0) 
	    {
	      printf("ERRORE INTERNO DELLA FUNZIONE DI TEST\nNON E' STATO POSSIBILE ALLOCARE MEMORIA\n");
	      funz_name=NULL;
	      headers=NULL;
	      free(headers);
	      free(funz_name);
	      return;
	    }

	  printf("Non viene controllato se la stringa da copiare sia piu' lunga del buffer disponibile.\n");
	  funz_name=NULL;
	  headers=NULL;
	  free(funz_name);
	  free(headers);
	  return TEST_FAILED;


        case HEADER_NOT_FOUND:

	    funz_name=NULL;
	    headers=NULL;
	    free(funz_name);
	    free(headers);
	    return NOT_VALID;
	    break;

        case BODY_NOT_FOUND:

	    funz_name=NULL;
	    headers=NULL;
	    free(funz_name);
	    free(headers);
	    return NOT_VALID;
	    break;

        case BAD_HEADER:

	    funz_name=NULL;
	    headers=NULL;
	    free(funz_name);
	    free(headers);
	    return NOT_VALID;
	    break;

        case MEM_ALLOC_ERROR:

	    funz_name=NULL;
	    headers=NULL;
	    free(funz_name);
	    free(headers);
	    return NOT_IMPLEMENTED;
	    break;

	}

      /////////////////////////////////////////
      //   ARGOMENTO 2 - int dimh
      /////////////////////////////////////////
  
    case 2 :
  
      switch(tipo_di_test)
	{

	case RESULT_OK :

	  funz_name=NULL;
	  headers=NULL;
	  free(funz_name);
	  free(headers);
	  return NOT_IMPLEMENTED;
	  break;

	case UNKNOWN_ERROR :

	  funz_name=NULL;
	  headers=NULL;
	  free(funz_name);
	  free(headers);
	  return NOT_IMPLEMENTED;
	  break;

        case NULL_POINTER:

	    funz_name=NULL;
	    headers=NULL;
	    free(funz_name);
	    free(headers);
	    return NOT_VALID;
	    break;

        case EMPTY_STRING:

	    funz_name=NULL;
	    headers=NULL;
	    free(funz_name);
	    free(headers);
	    return NOT_VALID;
	    break;

	case FILE_MISSING:

	    funz_name=NULL;
	    headers=NULL;
	    free(funz_name);
	    free(headers);
	    return NOT_VALID;
	    break;

        case FILE_UNREADABLE:

	    funz_name=NULL;
	    headers=NULL;
	    free(funz_name);
	    free(headers);
	    return NOT_VALID;
	    break;

        case FILE_UNWRITABLE:

	    funz_name=NULL;
	    headers=NULL;
	    free(funz_name);
	    free(headers);
	    return NOT_VALID;
	    break;

        case FILE_EMPTY:

	    funz_name=NULL;
	    headers=NULL;
	    free(funz_name);
	    free(headers);
	    return NOT_VALID;
	    break;

	case BUFFER_TOO_SMALL :

	  strcpy(Test_Email, "From: a@b.c\nTo: c@b.a\n\n ");
	  
	  i=estraiHeaders(Test_Email, headers, 3);
  
	  if(i == BUFFER_TOO_SMALL)
	    {
	      i=estraiHeaders(Test_Email, headers, -9845);

	      if(i == BUFFER_TOO_SMALL)
	        {
		  funz_name=NULL;
		  headers=NULL;
		  free(funz_name);
		  free(headers);
		  return TEST_PASSED;
		 }
	        
	    }

	  ////////////////
	  // TEST FALLITO
	  ////////////////
	  err=AlessaGrott_Err(tipo_di_test, i, funz_name);
	  if(err != 0) 
	    {
	      printf("ERRORE INTERNO DELLA FUNZIONE DI TEST\nNON E' STATO POSSIBILE ALLOCARE MEMORIA\n");
	      funz_name=NULL;
	      headers=NULL;
	      free(headers);
	      free(funz_name);
	      return;
	    }

	  printf("Non viene controllato se la dimensione del buffer \" %d \" sia valida.\n", argomento);
	  funz_name=NULL;
	  headers=NULL;
	  free(funz_name);
	  free(headers);
	  return TEST_FAILED;
	  
	  break;

        case HEADER_NOT_FOUND:

	    funz_name=NULL;
	    headers=NULL;
	    free(funz_name);
	    free(headers);
	    return NOT_VALID;
	    break;

        case BODY_NOT_FOUND:

	    funz_name=NULL;
	    headers=NULL;
	    free(funz_name);
	    free(headers);
	    return NOT_VALID;
	    break;

        case BAD_HEADER:

	    funz_name=NULL;
	    headers=NULL;
	    free(funz_name);
	    free(headers);
	    return NOT_VALID;
	    break;

        case MEM_ALLOC_ERROR:

	    funz_name=NULL;
	    headers=NULL;
	    free(funz_name);
	    free(headers);
	    return NOT_IMPLEMENTED;
	    break;

	}
    }
}

///////////////////////////////////////////////////
//   TEST PRIMO HEADER
/////////////////////////////////////////////////// 
int test_primoHeader(int tipo_di_test, int argomento)
{
  int i, cont, err, j;
  char Test_Headers[150];
  char Test_Headers_App[150];
  char *funz_name="primoHeader()\0";
  char *header=(char*)calloc(sizeof(char), 100);
    if(header == NULL)
    {
      printf("ERRORE INTERNO DELLA FUNZIONE DI TEST\nNON E' STATO POSSIBILE ALLOCARE MEMORIA\n");
      funz_name=NULL;
      header=NULL;
      free(funz_name);
      free(header);
      return;
    }

  if(funz_name == NULL)
    {
      printf("ERRORE INTERNO DELLA FUNZIONE DI TEST\nNON E' STATO POSSIBILE ALLOCARE MEMORIA\n");
      funz_name=NULL;
      header=NULL;
      free(funz_name);
      free(header);
      return;
    }
  
  if(argomento > 2) return ARG_MISSING;
  
  switch(argomento)
    {

      /////////////////////////////////////////
      //   ARGOMENTO 0 - char *headers
      ////////////////////////////////////////
    
    case 0 :

      switch(tipo_di_test)
	{

	case RESULT_OK :

	  strcpy(Test_Headers, "From: a@b.c\nFrom \tcasa.mia.it\n\t123.456.789.0\nTo: c@b.a\nSoggetto: Testami\n");

	  i=primoHeader(Test_Headers, header, strlen(Test_Headers)+1);

	  if((i == RESULT_OK) && !(strcmp(header, "From: a@b.c\0")))
	    {

	      for(i=strlen(header)+1, j=0; Test_Headers[i]!=EOF;i++, j++) Test_Headers_App[j]=Test_Headers[i];
	      Test_Headers_App[i]='\0';

	      strcpy(Test_Headers, Test_Headers_App);

	      i=primoHeader(Test_Headers, header, strlen(Test_Headers)+1);

	      if(i == RESULT_OK && !(strcmp(header, "From \tcasa.mia.it\n\t123.456.789.0\0")))
	        {
		  funz_name=NULL;
		  header=NULL;
		  free(funz_name);
		  free(header);
		  return TEST_PASSED;
		}
	    }


	  ////////////////
	  // TEST FALLITO
	  ////////////////
	  err=AlessaGrott_Err(tipo_di_test, i, funz_name);
	  if(err != 0) 
	    {
	      printf("ERRORE INTERNO DELLA FUNZIONE DI TEST\nNON E' STATO POSSIBILE ALLOCARE MEMORIA\n");
	      funz_name=NULL;
	      header=NULL;
	      free(header);
	      free(funz_name);
	      return;
	    }

	  printf("Non viene copiato correttamente un header\n");
	  funz_name=NULL;
	  header=NULL;
	  free(funz_name);
	  free(header);
	  return TEST_FAILED;
    
	  break;

	case UNKNOWN_ERROR :

	  funz_name=NULL;
	  header=NULL;
	  free(funz_name);
	  free(header);
	  return NOT_IMPLEMENTED;
	  break;

	case NULL_POINTER :    
    
	  i=primoHeader(NULL, header, 10);

	  if(i == NULL_POINTER)
	    {
	      funz_name=NULL;
	      header=NULL;
	      free(funz_name);
	      free(header);
	      return TEST_PASSED;
	    }

	  ////////////////
	  // TEST FALLITO
	  ////////////////
	  err=AlessaGrott_Err(tipo_di_test, i, funz_name);
	  if(err != 0) 
	    {
	      printf("ERRORE INTERNO DELLA FUNZIONE DI TEST\nNON E' STATO POSSIBILE ALLOCARE MEMORIA\n");
	      funz_name=NULL;
	      header=NULL;
	      free(header);
	      free(funz_name);
	      return;
	    }

	  printf("Non viene controllato se l'argomento \" %d \" sia un puntatore a NULL.\n", argomento);
	  funz_name=NULL;
	  header=NULL;
	  free(funz_name);
	  free(header);
	  return TEST_FAILED;
	  
	  break;

	case EMPTY_STRING :

	  i=primoHeader("\0", header, 10);

	  if(i == EMPTY_STRING)
	    {
	      funz_name=NULL;
	      header=NULL;
	      free(funz_name);
	      free(header);
	      return TEST_PASSED;
	    }
	  
	  ////////////////
	  // TEST FALLITO
	  ////////////////
	  err=AlessaGrott_Err(tipo_di_test, i, funz_name);
	  if(err != 0) 
	    {
	      printf("ERRORE INTERNO DELLA FUNZIONE DI TEST\nNON E' STATO POSSIBILE ALLOCARE MEMORIA\n");
	      funz_name=NULL;
	      header=NULL;
	      free(header);
	      free(funz_name);
	      return;
	    }

	  printf("Non viene controllato se l'argomento \" %d \" sia una stringa vuota.\n", argomento);
	  funz_name=NULL;
	  header=NULL;
	  free(funz_name);
	  free(header);
	  return TEST_FAILED;

	  break;

	case FILE_MISSING:

	  funz_name=NULL;
	  header=NULL;
	  free(funz_name);
	  free(header);
	  return NOT_VALID;
	  break;

	case FILE_UNREADABLE:

	  funz_name=NULL;
	  header=NULL;
	  free(funz_name);
	  free(header);
	  return NOT_VALID;
	  break;

	case FILE_UNWRITABLE:

	  funz_name=NULL;
	  header=NULL;
	  free(funz_name);
	  free(header);
	  return NOT_VALID;
	  break;

	case FILE_EMPTY:

	  funz_name=NULL;
	  header=NULL;
	  free(funz_name);
	  free(header);
	  return NOT_VALID;
	  break;

	case BUFFER_TOO_SMALL :

	  funz_name=NULL;
	  header=NULL;
	  free(funz_name);
	  free(header);
	  return NOT_VALID;
	  break;

	case HEADER_NOT_FOUND:

	  funz_name=NULL;
	  header=NULL;
	  free(funz_name);
	  free(header);
	  return NOT_VALID;
	  break;

	case BODY_NOT_FOUND:

	  funz_name=NULL;
	  header=NULL;
	  free(funz_name);
	  free(header);
	  return NOT_VALID;
	  break;

	case BAD_HEADER:

	  funz_name=NULL;
	  header=NULL;
	  free(funz_name);
	  free(header);
	  return NOT_VALID;
	  break;

	case MEM_ALLOC_ERROR:

	  funz_name=NULL;
	  header=NULL;
	  free(funz_name);
	  free(header);
	  return NOT_IMPLEMENTED;
	  break;

	}

      /////////////////////////////////////////
      //   ARGOMENTO 1 - char *headers
      /////////////////////////////////////////

    case 1 :

      switch(tipo_di_test)
	{

	case RESULT_OK :

	  funz_name=NULL;
	  header=NULL;
	  free(funz_name);
	  free(header);
	  return NOT_IMPLEMENTED;
	  break;

	case UNKNOWN_ERROR :

	  funz_name=NULL;
	  header=NULL;
	  free(funz_name);
	  free(header);
	  return NOT_IMPLEMENTED;
	  break;

	case NULL_POINTER :

	  i=primoHeader("From: a@b.c", NULL, 10);

	  if(i == NULL_POINTER)
	    {
	      funz_name=NULL;
	      header=NULL;
	      free(funz_name);
	      free(header);
	      return TEST_PASSED;
	    }

	  ////////////////
	  // TEST FALLITO
	  ////////////////
	  err=AlessaGrott_Err(tipo_di_test, i, funz_name);
	  if(err != 0) 
	    {
	      printf("ERRORE INTERNO DELLA FUNZIONE DI TEST\nNON E' STATO POSSIBILE ALLOCARE MEMORIA\n");
	      funz_name=NULL;
	      header=NULL;
	      free(header);
	      free(funz_name);
	      return;
	    }

	  printf("Non viene controllato se l'argomento \" %d \" sia un puntatore a NULL.\n", argomento);
	  funz_name=NULL;
	  header=NULL;
	  free(funz_name);
	  free(header);
	  return TEST_FAILED;
	  
	  break;

	case EMPTY_STRING:

	  funz_name=NULL;
	  header=NULL;
	  free(funz_name);
	  free(header);
	  return NOT_VALID;
	  break;

	case FILE_MISSING:

	  funz_name=NULL;
	  header=NULL;
	  free(funz_name);
	  free(header);
	  return NOT_VALID;
	  break;

	case FILE_UNREADABLE:

	  funz_name=NULL;
	  header=NULL;
	  free(funz_name);
	  free(header);
	  return NOT_VALID;
	  break;

	case FILE_UNWRITABLE:

	  funz_name=NULL;
	  header=NULL;
	  free(funz_name);
	  free(header);
	  return NOT_VALID;
	  break;

	case FILE_EMPTY:

	  funz_name=NULL;
	  header=NULL;
	  free(funz_name);
	  free(header);
	  return NOT_VALID;
	  break;

	case BUFFER_TOO_SMALL :

	  strcpy(Test_Headers, "From: a@b.c\nTo: c@b.a\n");
	  
	  i=primoHeader(Test_Headers, header, 10);
  
	  if(i == BUFFER_TOO_SMALL)
	    {
	      funz_name=NULL;
	      header=NULL;
	      free(funz_name);
	      free(header);
	      return TEST_PASSED;
	    }

	  ////////////////
	  // TEST FALLITO
	  ////////////////
	  err=AlessaGrott_Err(tipo_di_test, i, funz_name);
	  if(err != 0) 
	    {
	      printf("ERRORE INTERNO DELLA FUNZIONE DI TEST\nNON E' STATO POSSIBILE ALLOCARE MEMORIA\n");
	      funz_name=NULL;
	      header=NULL;
	      free(header);
	      free(funz_name);
	      return;
	    }

	  printf("Non viene controllato se la stringa da copiare sia piu' lunga del buffer disponibile.\n");
	  funz_name=NULL;
	  header=NULL;
	  free(funz_name);
	  free(header);
	  return TEST_FAILED;
	  
	  break;

	case HEADER_NOT_FOUND:

	  funz_name=NULL;
	  header=NULL;
	  free(funz_name);
	  free(header);
	  return NOT_VALID;
	  break;

	case BODY_NOT_FOUND:

	  funz_name=NULL;
	  header=NULL;
	  free(funz_name);
	  free(header);
	  return NOT_VALID;
	  break;

	case BAD_HEADER:

	  funz_name=NULL;
	  header=NULL;
	  free(funz_name);
	  free(header);
	  return NOT_VALID;
	  break;

	case MEM_ALLOC_ERROR:

	  funz_name=NULL;
	  header=NULL;
	  free(funz_name);
	  free(header);
	  return NOT_IMPLEMENTED;
	  break;

	}

      /////////////////////////////////////////
      //   ARGOMENTO 2 - int dim
      /////////////////////////////////////////
  
    case 2 :
  
      switch(tipo_di_test)
	{

	case RESULT_OK :

	  funz_name=NULL;
	  header=NULL;
	  free(funz_name);
	  free(header);
	  return NOT_IMPLEMENTED;
	  break;

	case UNKNOWN_ERROR :

	  funz_name=NULL;
	  header=NULL;
	  free(funz_name);
	  free(header);
	  return NOT_IMPLEMENTED;
	  break;

	case NULL_POINTER:

	  funz_name=NULL;
	  header=NULL;
	  free(funz_name);
	  free(header);
	  return NOT_VALID;
	  break;

	case EMPTY_STRING:

	  funz_name=NULL;
	  header=NULL;
	  free(funz_name);
	  free(header);
	  return NOT_VALID;
	  break;

	case FILE_MISSING:

	  funz_name=NULL;
	  header=NULL;
	  free(funz_name);
	  free(header);
	  return NOT_VALID;
	  break;

	case FILE_UNREADABLE:

	  funz_name=NULL;
	  header=NULL;
	  free(funz_name);
	  free(header);
	  return NOT_VALID;
	  break;

	case FILE_UNWRITABLE:

	  funz_name=NULL;
	  header=NULL;
	  free(funz_name);
	  free(header);
	  return NOT_VALID;
	  break;

	case FILE_EMPTY:

	  funz_name=NULL;
	  header=NULL;
	  free(funz_name);
	  free(header);
	  return NOT_VALID;
	  break;

	case BUFFER_TOO_SMALL :

	  strcpy(Test_Headers, "F: \n");
	  
	  i=primoHeader(Test_Headers, header, 2);
  
	  if(i == BUFFER_TOO_SMALL)
	    {
	      i=primoHeader(Test_Headers, header, -9845);

	      if(i == BUFFER_TOO_SMALL)
	        {
		  funz_name=NULL;
		  header=NULL;
		  free(funz_name);
		  free(header);
		  return TEST_PASSED;
		}
	        
	    }

	  ////////////////
	  // TEST FALLITO
	  ////////////////
	  err=AlessaGrott_Err(tipo_di_test, i, funz_name);
	  if(err != 0) 
	    {
	      printf("ERRORE INTERNO DELLA FUNZIONE DI TEST\nNON E' STATO POSSIBILE ALLOCARE MEMORIA\n");
	      funz_name=NULL;
	      header=NULL;
	      free(header);
	      free(funz_name);
	      return;
	    }

	  printf("Non viene controllato se la dimensione del buffer \" %d \" sia valida.\n", argomento);
	  funz_name=NULL;
	  header=NULL;
	  free(funz_name);
	  free(header);
	  return TEST_FAILED;
	  
	  break;

	case HEADER_NOT_FOUND:

	  funz_name=NULL;
	  header=NULL;
	  free(funz_name);
	  free(header);
	  return NOT_VALID;
	  break;

	case BODY_NOT_FOUND:

	  funz_name=NULL;
	  header=NULL;
	  free(funz_name);
	  free(header);
	  return NOT_VALID;
	  break;

	case BAD_HEADER:

	  funz_name=NULL;
	  header=NULL;
	  free(funz_name);
	  free(header);
	  return NOT_VALID;
	  break;

	case MEM_ALLOC_ERROR:

	  funz_name=NULL;
	  header=NULL;
	  free(funz_name);
	  free(header);
	  return NOT_IMPLEMENTED;
	  break;

	}
    }
}

///////////////////////////////////////////////////
//   TEST PARSE HEADER
/////////////////////////////////////////////////// 
int test_parseHeader(int tipo_di_test, int argomento)
{
  int i, cont, err;
  char Test_Header[100];
  char *funz_name="parseHeader()\0";
  char *tipo=(char*)calloc(sizeof(char), 100);
  char *valore=(char*)calloc(sizeof(char), 100);  
  if(tipo == NULL)
    {
      printf("ERRORE INTERNO DELLA FUNZIONE DI TEST\nNON E' STATO POSSIBILE ALLOCARE MEMORIA\n");
      funz_name=NULL;
      tipo=NULL;
      valore=NULL;
      free(funz_name);
      free(tipo);
      free(valore);
      return;
    }

  if(valore == NULL)
    {
      printf("ERRORE INTERNO DELLA FUNZIONE DI TEST\nNON E' STATO POSSIBILE ALLOCARE MEMORIA\n");
      funz_name=NULL;
      tipo=NULL;
      valore=NULL;
      free(funz_name);
      free(tipo);
      free(valore);
      return;
    }

  if(funz_name == NULL)
    {
      printf("ERRORE INTERNO DELLA FUNZIONE DI TEST\nNON E' STATO POSSIBILE ALLOCARE MEMORIA\n");
      funz_name=NULL;
      tipo=NULL;
      valore=NULL;
      free(funz_name);
      free(tipo);
      free(valore);
      return;
    }
  
  if(argomento > 4) return ARG_MISSING;
  
  switch(argomento)
    {

      /////////////////////////////////////////
      //   ARGOMENTO 0 - char *header
      ////////////////////////////////////////
    
    case 0 :

      switch(tipo_di_test)
	{

	case RESULT_OK :

	  strcpy(Test_Header, "From: <a@b.c> Alessandro G.");

	  i=parseHeader(Test_Header, tipo, strlen(Test_Header)+1, valore, strlen(Test_Header)+1);

	  if((i == RESULT_OK) && (!(strcmp(tipo, "From:")) && !(strcmp(valore, "<a@b.c> Alessandro G."))))
	    {

	      strcpy(Test_Header, "From \t<a@b.c>\n\tAlessandro G.\n\t10.11.12.13");

	      i=parseHeader(Test_Header, tipo, strlen(Test_Header)+1, valore, strlen(Test_Header)+1);

	      if(i == RESULT_OK)
	        if(!(strcmp(tipo, "From")) && !(strcmp(valore, "\t<a@b.c>\n\tAlessandro G.\n\t10.11.12.13")))
		  {
		    funz_name=NULL;
		    tipo=NULL;
		    valore=NULL;
		    free(funz_name);
		    free(tipo);
		    free(valore);
		    return TEST_PASSED;
		  }
	    }


	  ////////////////
	  // TEST FALLITO
	  ////////////////
	  err=AlessaGrott_Err(tipo_di_test, i, funz_name);
	  if(err != 0) 
	    {
	      printf("ERRORE INTERNO DELLA FUNZIONE DI TEST\nNON E' STATO POSSIBILE ALLOCARE MEMORIA\n");
	      funz_name=NULL;
	      tipo=NULL;
	      valore=NULL;
	      free(tipo);
	      free(valore);
	      free(funz_name);
	      return;
	    }

	  printf("Non viene parsato correttamente un header\n");
	  funz_name=NULL;
	  tipo=NULL;
	  valore=NULL;
	  free(funz_name);
	  free(tipo);
	  free(valore);
	  return TEST_FAILED;
    
	  break;

	case UNKNOWN_ERROR :

	  funz_name=NULL;
	  tipo=NULL;
	  valore=NULL;
	  free(funz_name);
	  free(tipo);
	  free(valore);
	  return NOT_IMPLEMENTED;
	  break;

	case NULL_POINTER :    
    
	  i=parseHeader(NULL, tipo, 10, valore, 10);

	  if(i == NULL_POINTER)
	  {
	    funz_name=NULL;
	    tipo=NULL;
	    valore=NULL;
	    free(funz_name);
	    free(tipo);
	    free(valore);
	    return TEST_PASSED;
	  }

	  ////////////////
	  // TEST FALLITO
	  ////////////////
	  err=AlessaGrott_Err(tipo_di_test, i, funz_name);
	  if(err != 0) 
	    {
	      printf("ERRORE INTERNO DELLA FUNZIONE DI TEST\nNON E' STATO POSSIBILE ALLOCARE MEMORIA\n");
	      funz_name=NULL;
	      tipo=NULL;
	      valore=NULL;
	      free(tipo);
	      free(valore);
	      free(funz_name);
	      return;
	    }

	  printf("Non viene controllato se l'argomento \" %d \" sia un puntatore a NULL.\n", argomento);
	  funz_name=NULL;
	  tipo=NULL;
	  valore=NULL;
	  free(funz_name);
	  free(tipo);
	  free(valore);
	  return TEST_FAILED;
	  
	  break;

	case EMPTY_STRING :

	  i=parseHeader("\0", tipo, 10, valore, 10);

	  if(i == EMPTY_STRING)
	  {
	    funz_name=NULL;
	    tipo=NULL;
	    valore=NULL;
	    free(funz_name);
	    free(tipo);
	    free(valore);
	    return TEST_PASSED;
	  }
	  
	  ////////////////
	  // TEST FALLITO
	  ////////////////
	  err=AlessaGrott_Err(tipo_di_test, i, funz_name);
	  if(err != 0) 
	    {
	      printf("ERRORE INTERNO DELLA FUNZIONE DI TEST\nNON E' STATO POSSIBILE ALLOCARE MEMORIA\n");
	      funz_name=NULL;
	      tipo=NULL;
	      valore=NULL;
	      free(tipo);
	      free(valore);
	      free(funz_name);
	      return;
	    }

	  printf("Non viene controllato se l'argomento \" %d \" sia una stringa vuota.\n", argomento);
	  funz_name=NULL;
	  tipo=NULL;
	  valore=NULL;
	  free(funz_name);
	  free(tipo);
	  free(valore);
	  return TEST_FAILED;

	  break;

	case FILE_MISSING :

	  funz_name=NULL;
	  tipo=NULL;
	  valore=NULL;
	  free(funz_name);
	  free(tipo);
	  free(valore);
	  return NOT_VALID;
	  break;

	case FILE_UNREADABLE :

	  funz_name=NULL;
	  tipo=NULL;
	  valore=NULL;
	  free(funz_name);
	  free(tipo);
	  free(valore);
	  return NOT_VALID;
	  break;

	case FILE_UNWRITABLE :

	  funz_name=NULL;
	  tipo=NULL;
	  valore=NULL;
	  free(funz_name);
	  free(tipo);
	  free(valore);
	  return NOT_VALID;
	  break;

	case FILE_EMPTY :

	  funz_name=NULL;
	  tipo=NULL;
	  valore=NULL;
	  free(funz_name);
	  free(tipo);
	  free(valore);
	  return NOT_VALID;
	  break;

	case BUFFER_TOO_SMALL :

	  funz_name=NULL;
	  tipo=NULL;
	  valore=NULL;
	  free(funz_name);
	  free(tipo);
	  free(valore);
	  return NOT_VALID;
	  break;

	case HEADER_NOT_FOUND :

	  funz_name=NULL;
	  tipo=NULL;
	  valore=NULL;
	  free(funz_name);
	  free(tipo);
	  free(valore);
	  return NOT_VALID;
	  break;

	case BODY_NOT_FOUND :
	  
	  funz_name=NULL;
	  tipo=NULL;
	  valore=NULL;
	  free(funz_name);
	  free(tipo);
	  free(valore);
	  return NOT_VALID;
	  break;

	case BAD_HEADER :

	  strcpy(Test_Header, "\nFrom: a@b.c");

	  i=parseHeader(Test_Header, tipo, strlen(Test_Header)+1, valore, strlen(Test_Header)+1);

	  if(i == BAD_HEADER)
	    {
	      strcpy(Test_Header, "From");

	      i=parseHeader(Test_Header, tipo, strlen(Test_Header)+1, valore, strlen(Test_Header)+1);

	      if(i == BAD_HEADER)
	        {
		  strcpy(Test_Header, "From:a@b.c");

		  i=parseHeader(Test_Header, tipo, strlen(Test_Header)+1, valore, strlen(Test_Header)+1);

		  if(i == BAD_HEADER)
		    {
		      strcpy(Test_Header, "From: a@b.c\n");

		      i=parseHeader(Test_Header, tipo, strlen(Test_Header)+1, valore, strlen(Test_Header)+1);

		      if(i == BAD_HEADER)
		        {
			  strcpy(Test_Header, "From: ");
 
			  i=parseHeader(Test_Header, tipo, strlen(Test_Header)+1, valore, strlen(Test_Header)+1);

			  if(i == BAD_HEADER)
			    {
			      funz_name=NULL;
			      tipo=NULL;
			      valore=NULL;
			      free(funz_name);
			      free(tipo);
			      free(valore);
			      return TEST_PASSED;
			    }
			}
		    }
		}
	    }
	  
	  ////////////////
	  // TEST FALLITO
	  ////////////////
	  err=AlessaGrott_Err(tipo_di_test, i, funz_name);
	  if(err != 0) 
	    {
	      printf("ERRORE INTERNO DELLA FUNZIONE DI TEST\nNON E' STATO POSSIBILE ALLOCARE MEMORIA\n");
	      funz_name=NULL;
	      tipo=NULL;
	      valore=NULL;
	      free(tipo);
	      free(valore);
	      free(funz_name);
	      return;
	    }

	  printf("Non viene controllato la sintassi corretta del tipo dell'header.\n");
	  funz_name=NULL;
	  tipo=NULL;
	  valore=NULL;
	  free(funz_name);
	  free(tipo);
	  free(valore);
	  return TEST_FAILED;

	  break;

	case MEM_ALLOC_ERROR :

	  funz_name=NULL;
	  tipo=NULL;
	  valore=NULL;
	  free(funz_name);
	  free(tipo);
	  free(valore);
	  return NOT_IMPLEMENTED;
	  break;

	}

      /////////////////////////////////////////
      //   ARGOMENTO 1 - char *tipo
      ////////////////////////////////////////
    
    case 1 :

      switch(tipo_di_test)
	{

	case RESULT_OK :
	  
	  funz_name=NULL;
	  tipo=NULL;
	  valore=NULL;
	  free(funz_name);
	  free(tipo);
	  free(valore);
	  return NOT_IMPLEMENTED;
	  break;

	case UNKNOWN_ERROR :

	  funz_name=NULL;
	  tipo=NULL;
	  valore=NULL;
	  free(funz_name);
	  free(tipo);
	  free(valore);
	  return NOT_IMPLEMENTED;
	  break;

	case NULL_POINTER :    
    
	  i=parseHeader(Test_Header, NULL, 10, valore, 10);

	  if(i == NULL_POINTER)
	    {
	      funz_name=NULL;
	      tipo=NULL;
	      valore=NULL;
	      free(funz_name);
	      free(tipo);
	      free(valore);
	      return TEST_PASSED;
	    }

	  ////////////////
	  // TEST FALLITO
	  ////////////////
	  err=AlessaGrott_Err(tipo_di_test, i, funz_name);
	  if(err != 0) 
	    {
	      printf("ERRORE INTERNO DELLA FUNZIONE DI TEST\nNON E' STATO POSSIBILE ALLOCARE MEMORIA\n");
	      funz_name=NULL;
	      tipo=NULL;
	      valore=NULL;
	      free(tipo);
	      free(valore);
	      free(funz_name);
	      return;
	    }

	  printf("Non viene controllato se l'argomento \" %d \" sia un puntatore a NULL.\n", argomento);
	  funz_name=NULL;
	  tipo=NULL;
	  valore=NULL;
	  free(funz_name);
	  free(tipo);
	  free(valore);
	  return TEST_FAILED;
	  
	  break;

	case EMPTY_STRING :

	  funz_name=NULL;
	  tipo=NULL;
	  valore=NULL;
	  free(funz_name);
	  free(tipo);
	  free(valore);
	  return NOT_VALID;
	  break;

	case FILE_MISSING :

	  funz_name=NULL;
	  tipo=NULL;
	  valore=NULL;
	  free(funz_name);
	  free(tipo);
	  free(valore);
	  return NOT_VALID;
	  break;

	case FILE_UNREADABLE :

	  funz_name=NULL;
	  tipo=NULL;
	  valore=NULL;
	  free(funz_name);
	  free(tipo);
	  free(valore);
	  return NOT_VALID;
	  break;

	case FILE_UNWRITABLE :

	  funz_name=NULL;
	  tipo=NULL;
	  valore=NULL;
	  free(funz_name);
	  free(tipo);
	  free(valore);
	  return NOT_VALID;
	  break;

	case FILE_EMPTY :

	  funz_name=NULL;
	  tipo=NULL;
	  valore=NULL;
	  free(funz_name);
	  free(tipo);
	  free(valore);
	  return NOT_VALID;
	  break;

	case BUFFER_TOO_SMALL :

	  i=parseHeader("From a@b.c", tipo, 3, valore, 30);
  
	  if(i == BUFFER_TOO_SMALL)
	    {
	      funz_name=NULL;
	      tipo=NULL;
	      valore=NULL;
	      free(funz_name);
	      free(tipo);
	      free(valore);
	      return TEST_PASSED;
	    }

	  ////////////////
	  // TEST FALLITO
	  ////////////////
	  err=AlessaGrott_Err(tipo_di_test, i, funz_name);
	  if(err != 0) 
	    {
	      printf("ERRORE INTERNO DELLA FUNZIONE DI TEST\nNON E' STATO POSSIBILE ALLOCARE MEMORIA\n");
	      funz_name=NULL;
	      tipo=NULL;
	      valore=NULL;
	      free(tipo);
	      free(valore);
	      free(funz_name);
	      return;
	    }

	  printf("Non viene controllato se la stringa da copiare sia piu' lunga del buffer disponibile.\n");
	  funz_name=NULL;
	  tipo=NULL;
	  valore=NULL;
	  free(funz_name);
	  free(tipo);
	  free(valore);
	  return TEST_FAILED;
	  
	  break;

	case HEADER_NOT_FOUND :

	  funz_name=NULL;
	  tipo=NULL;
	  valore=NULL;
	  free(funz_name);
	  free(tipo);
	  free(valore);
	  return NOT_VALID;
	  break;


	case BODY_NOT_FOUND :

	  funz_name=NULL;
	  tipo=NULL;
	  valore=NULL;
	  free(funz_name);
	  free(tipo);
	  free(valore);
	  return NOT_VALID;
	  break;


	case BAD_HEADER :

	  funz_name=NULL;
	  tipo=NULL;
	  valore=NULL;
	  free(funz_name);
	  free(tipo);
	  free(valore);
	  return NOT_VALID;
	  break;

	case MEM_ALLOC_ERROR :

	  funz_name=NULL;
	  tipo=NULL;
	  valore=NULL;
	  free(funz_name);
	  free(tipo);
	  free(valore);
	  return NOT_IMPLEMENTED;
	  break;

	}

      /////////////////////////////////////////
      //   ARGOMENTO 2 - int dimt
      ////////////////////////////////////////
    
    case 2 :

      switch(tipo_di_test)
	{

	case RESULT_OK :
	  
	  funz_name=NULL;
	  tipo=NULL;
	  valore=NULL;
	  free(funz_name);
	  free(tipo);
	  free(valore);
	  return NOT_IMPLEMENTED;
	  break;

	case UNKNOWN_ERROR :

	  funz_name=NULL;
	  tipo=NULL;
	  valore=NULL;
	  free(funz_name);
	  free(tipo);
	  free(valore);
	  return NOT_IMPLEMENTED;
	  break;

	case NULL_POINTER :    
    
	  funz_name=NULL;
	  tipo=NULL;
	  valore=NULL;
	  free(funz_name);
	  free(tipo);
	  free(valore);
	  return NOT_VALID;
	  break;


	case EMPTY_STRING :

	  funz_name=NULL;
	  tipo=NULL;
	  valore=NULL;
	  free(funz_name);
	  free(tipo);
	  free(valore);
	  return NOT_VALID;
	  break;

	case FILE_MISSING :

	  funz_name=NULL;
	  tipo=NULL;
	  valore=NULL;
	  free(funz_name);
	  free(tipo);
	  free(valore);
	  return NOT_VALID;
	  break;

	case FILE_UNREADABLE :

	  funz_name=NULL;
	  tipo=NULL;
	  valore=NULL;
	  free(funz_name);
	  free(tipo);
	  free(valore);
	  return NOT_VALID;
	  break;

	case FILE_UNWRITABLE :

	  funz_name=NULL;
	  tipo=NULL;
	  valore=NULL;
	  free(funz_name);
	  free(tipo);
	  free(valore);
	  return NOT_VALID;
	  break;

	case FILE_EMPTY :

	  funz_name=NULL;
	  tipo=NULL;
	  valore=NULL;
	  free(funz_name);
	  free(tipo);
	  free(valore);
	  return NOT_VALID;
	  break;

	case BUFFER_TOO_SMALL :

	  i=parseHeader("From a@b.c", tipo, 1, valore, 30);
  
	  if(i == BUFFER_TOO_SMALL)
	    {
	      i=parseHeader("From a@b.c", tipo, -871, valore, 30);

	      if(i == BUFFER_TOO_SMALL)
	        {
		  funz_name=NULL;
		  tipo=NULL;
		  valore=NULL;
		  free(funz_name);
		  free(tipo);
		  free(valore);
		  return TEST_PASSED;
		}
	    }

	  ////////////////
	  // TEST FALLITO
	  ////////////////
	  err=AlessaGrott_Err(tipo_di_test, i, funz_name);
	  if(err != 0) 
	    {
	      printf("ERRORE INTERNO DELLA FUNZIONE DI TEST\nNON E' STATO POSSIBILE ALLOCARE MEMORIA\n");
	      funz_name=NULL;
	      tipo=NULL;
	      valore=NULL;
	      free(tipo);
	      free(valore);
	      free(funz_name);
	      return;
	    }

	  printf("Non viene controllato se la stringa da copiare sia piu' lunga del buffer disponibile.\n");
	  funz_name=NULL;
	  tipo=NULL;
	  valore=NULL;
	  free(funz_name);
	  free(tipo);
	  free(valore);
	  return TEST_FAILED;
	  
	  break;

	case HEADER_NOT_FOUND :

	  funz_name=NULL;
	  tipo=NULL;
	  valore=NULL;
	  free(funz_name);
	  free(tipo);
	  free(valore);
	  return NOT_VALID;
	  break;


	case BODY_NOT_FOUND :

	  funz_name=NULL;
	  tipo=NULL;
	  valore=NULL;
	  free(funz_name);
	  free(tipo);
	  free(valore);
	  return NOT_VALID;
	  break;


	case BAD_HEADER :

	  funz_name=NULL;
	  tipo=NULL;
	  valore=NULL;
	  free(funz_name);
	  free(tipo);
	  free(valore);
	  return NOT_VALID;
	  break;

	case MEM_ALLOC_ERROR :

	  funz_name=NULL;
	  tipo=NULL;
	  valore=NULL;
	  free(funz_name);
	  free(tipo);
	  free(valore);
	  return NOT_IMPLEMENTED;
	  break;

	}

      /////////////////////////////////////////
      //   ARGOMENTO 3 - char *valore
      ////////////////////////////////////////
    
    case 3 :

      switch(tipo_di_test)
	{

	case RESULT_OK :
	  
	  funz_name=NULL;
	  tipo=NULL;
	  valore=NULL;
	  free(funz_name);
	  free(tipo);
	  free(valore);
	  return NOT_IMPLEMENTED;
	  break;

	case UNKNOWN_ERROR :

	  funz_name=NULL;
	  tipo=NULL;
	  valore=NULL;
	  free(funz_name);
	  free(tipo);
	  free(valore);
	  return NOT_IMPLEMENTED;
	  break;

	case NULL_POINTER :    
    
	  i=parseHeader(Test_Header, tipo, 10, NULL, 10);

	  if(i == NULL_POINTER)
	    {
	      funz_name=NULL;
	      tipo=NULL;
	      valore=NULL;
	      free(funz_name);
	      free(tipo);
	      free(valore);
	      return TEST_PASSED;
	    }

	  ////////////////
	  // TEST FALLITO
	  ////////////////
	  err=AlessaGrott_Err(tipo_di_test, i, funz_name);
	  if(err != 0) 
	    {
	      printf("ERRORE INTERNO DELLA FUNZIONE DI TEST\nNON E' STATO POSSIBILE ALLOCARE MEMORIA\n");
	      funz_name=NULL;
	      tipo=NULL;
	      valore=NULL;
	      free(tipo);
	      free(valore);
	      free(funz_name);
	      return;
	    }

	  printf("Non viene controllato se l'argomento \" %d \" sia un puntatore a NULL.\n", argomento);
	  funz_name=NULL;
	  tipo=NULL;
	  valore=NULL;
	  free(funz_name);
	  free(tipo);
	  free(valore);
	  return TEST_FAILED;
	  
	  break;

	case EMPTY_STRING :

	  funz_name=NULL;
	  tipo=NULL;
	  valore=NULL;
	  free(funz_name);
	  free(tipo);
	  free(valore);
	  return NOT_VALID;
	  break;

	case FILE_MISSING :

	  funz_name=NULL;
	  tipo=NULL;
	  valore=NULL;
	  free(funz_name);
	  free(tipo);
	  free(valore);
	  return NOT_VALID;
	  break;

	case FILE_UNREADABLE :

	  funz_name=NULL;
	  tipo=NULL;
	  valore=NULL;
	  free(funz_name);
	  free(tipo);
	  free(valore);
	  return NOT_VALID;
	  break;

	case FILE_UNWRITABLE :

	  funz_name=NULL;
	  tipo=NULL;
	  valore=NULL;
	  free(funz_name);
	  free(tipo);
	  free(valore);
	  return NOT_VALID;
	  break;

	case FILE_EMPTY :

	  funz_name=NULL;
	  tipo=NULL;
	  valore=NULL;
	  free(funz_name);
	  free(tipo);
	  free(valore);
	  return NOT_VALID;
	  break;

	case BUFFER_TOO_SMALL :

	  i=parseHeader("From a@b.c", tipo, 30, valore, 3);
  
	  if(i == BUFFER_TOO_SMALL)
	    {
	      funz_name=NULL;
	      tipo=NULL;
	      valore=NULL;
	      free(funz_name);
	      free(tipo);
	      free(valore);
	      return TEST_PASSED;
	    }

	  ////////////////
	  // TEST FALLITO
	  ////////////////
	  err=AlessaGrott_Err(tipo_di_test, i, funz_name);
	  if(err != 0) 
	    {
	      printf("ERRORE INTERNO DELLA FUNZIONE DI TEST\nNON E' STATO POSSIBILE ALLOCARE MEMORIA\n");
	      funz_name=NULL;
	      tipo=NULL;
	      valore=NULL;
	      free(tipo);
	      free(valore);
	      free(funz_name);
	      return;
	    }

	  printf("Non viene controllato se la stringa da copiare sia piu' lunga del buffer disponibile.\n");
	  funz_name=NULL;
	  tipo=NULL;
	  valore=NULL;
	  free(funz_name);
	  free(tipo);
	  free(valore);
	  return TEST_FAILED;
	  
	  break;

	case HEADER_NOT_FOUND :

	  funz_name=NULL;
	  tipo=NULL;
	  valore=NULL;
	  free(funz_name);
	  free(tipo);
	  free(valore);
	  return NOT_VALID;
	  break;


	case BODY_NOT_FOUND :

	  funz_name=NULL;
	  tipo=NULL;
	  valore=NULL;
	  free(funz_name);
	  free(tipo);
	  free(valore);
	  return NOT_VALID;
	  break;


	case BAD_HEADER :

	  strcpy(Test_Header, "From: a@b.c\n");

	  i=parseHeader(Test_Header, tipo, strlen(Test_Header)+1, valore, strlen(Test_Header)+1);

	  if(i == BAD_HEADER)
	    {
	      strcpy(Test_Header, "From: a@b.c\n\t21.22.23.24\n era\nERRORE!!!");

	      i=parseHeader(Test_Header, tipo, strlen(Test_Header)+1, valore, strlen(Test_Header)+1);

	      if(i == BAD_HEADER)
	        {
		  funz_name=NULL;
		  tipo=NULL;
		  valore=NULL;
		  free(funz_name);
		  free(tipo);
		  free(valore);
		  return TEST_PASSED;
		}
	    }
	  
	  ////////////////
	  // TEST FALLITO
	  ////////////////
	  err=AlessaGrott_Err(tipo_di_test, i, funz_name);
	  if(err != 0) 
	    {
	      printf("ERRORE INTERNO DELLA FUNZIONE DI TEST\nNON E' STATO POSSIBILE ALLOCARE MEMORIA\n");
	      funz_name=NULL;
	      tipo=NULL;
	      valore=NULL;
	      free(tipo);
	      free(valore);
	      free(funz_name);
	      return;
	    }

	  printf("Non viene controllato la sintassi corretta del valore dell'header.\n");
	  funz_name=NULL;
	  tipo=NULL;
	  valore=NULL;
	  free(funz_name);
	  free(tipo);
	  free(valore);
	  return TEST_FAILED;

	  break;

	case MEM_ALLOC_ERROR :

	  funz_name=NULL;
	  tipo=NULL;
	  valore=NULL;
	  free(funz_name);
	  free(tipo);
	  free(valore);
	  return NOT_IMPLEMENTED;
	  break;

	}

      /////////////////////////////////////////
      //   ARGOMENTO 4 - int dimt
      ////////////////////////////////////////
    
    case 4 :

      switch(tipo_di_test)
	{

	case RESULT_OK :
	  
	  funz_name=NULL;
	  tipo=NULL;
	  valore=NULL;
	  free(funz_name);
	  free(tipo);
	  free(valore);
	  return NOT_IMPLEMENTED;
	  break;

	case UNKNOWN_ERROR :

	  funz_name=NULL;
	  tipo=NULL;
	  valore=NULL;
	  free(funz_name);
	  free(tipo);
	  free(valore);
	  return NOT_IMPLEMENTED;
	  break;

	case NULL_POINTER :    
    
	  funz_name=NULL;
	  tipo=NULL;
	  valore=NULL;
	  free(funz_name);
	  free(tipo);
	  free(valore);
	  return NOT_VALID;
	  break;


	case EMPTY_STRING :

	  funz_name=NULL;
	  tipo=NULL;
	  valore=NULL;
	  free(funz_name);
	  free(tipo);
	  free(valore);
	  return NOT_VALID;
	  break;

	case FILE_MISSING :

	  funz_name=NULL;
	  tipo=NULL;
	  valore=NULL;
	  free(funz_name);
	  free(tipo);
	  free(valore);
	  return NOT_VALID;
	  break;

	case FILE_UNREADABLE :

	  funz_name=NULL;
	  tipo=NULL;
	  valore=NULL;
	  free(funz_name);
	  free(tipo);
	  free(valore);
	  return NOT_VALID;
	  break;

	case FILE_UNWRITABLE :

	  funz_name=NULL;
	  tipo=NULL;
	  valore=NULL;
	  free(funz_name);
	  free(tipo);
	  free(valore);
	  return NOT_VALID;
	  break;

	case FILE_EMPTY :

	  funz_name=NULL;
	  tipo=NULL;
	  valore=NULL;
	  free(funz_name);
	  free(tipo);
	  free(valore);
	  return NOT_VALID;
	  break;

	case BUFFER_TOO_SMALL :

	  i=parseHeader("From a@b.c", tipo, 30, valore, 1);
  
	  if(i == BUFFER_TOO_SMALL)
	    {
	      i=parseHeader("From a@b.c", tipo, 30, valore, -987);

	      if(i == BUFFER_TOO_SMALL)
	        {
		  funz_name=NULL;
		  tipo=NULL;
		  valore=NULL;
		  free(funz_name);
		  free(tipo);
		  free(valore);
		  return TEST_PASSED;
		}
	    }

	  ////////////////
	  // TEST FALLITO
	  ////////////////
	  err=AlessaGrott_Err(tipo_di_test, i, funz_name);
	  if(err != 0) 
	    {
	      printf("ERRORE INTERNO DELLA FUNZIONE DI TEST\nNON E' STATO POSSIBILE ALLOCARE MEMORIA\n");
	      funz_name=NULL;
	      tipo=NULL;
	      valore=NULL;
	      free(tipo);
	      free(valore);
	      free(funz_name);
	      return;
	    }

	  printf("Non viene controllato se la stringa da copiare sia piu' lunga del buffer disponibile.\n");
	  funz_name=NULL;
	  tipo=NULL;
	  valore=NULL;
	  free(funz_name);
	  free(tipo);
	  free(valore);
	  return TEST_FAILED;
	  
	  break;

	case HEADER_NOT_FOUND :

	  funz_name=NULL;
	  tipo=NULL;
	  valore=NULL;
	  free(funz_name);
	  free(tipo);
	  free(valore);
	  return NOT_VALID;
	  break;


	case BODY_NOT_FOUND :

	  funz_name=NULL;
	  tipo=NULL;
	  valore=NULL;
	  free(funz_name);
	  free(tipo);
	  free(valore);
	  return NOT_VALID;
	  break;


	case BAD_HEADER :

	  funz_name=NULL;
	  tipo=NULL;
	  valore=NULL;
	  free(funz_name);
	  free(tipo);
	  free(valore);
	  return NOT_VALID;
	  break;

	case MEM_ALLOC_ERROR :

	  funz_name=NULL;
	  tipo=NULL;
	  valore=NULL;
	  free(funz_name);
	  free(tipo);
	  free(valore);
	  return NOT_IMPLEMENTED;
	  break;

	}
    }
}

///////////////////////////////////////////////////
//   TEST TOKANIZZA EMAIL
/////////////////////////////////////////////////// 
int test_tokenizzaEmail(int tipo_di_test, int argomento)
{
  int i, err, t=0;
  char *funz_name="tokenizzaEmail()\0";
  char email[100];
  Token *tok=(Token*)calloc(sizeof(Token), 100);
  if(funz_name == NULL)
    {
      printf("ERRORE INTERNO DELLA FUNZIONE DI TEST\nNON E' STATO POSSIBILE ALLOCARE MEMORIA\n");
      funz_name=NULL;
      tok=NULL;
      free(funz_name);
      free(tok);
      return;
    }
  if(tok == NULL)
    {
      printf("ERRORE INTERNO DELLA FUNZIONE DI TEST\nNON E' STATO POSSIBILE ALLOCARE MEMORIA\n");
      funz_name=NULL;
      tok=NULL;
      free(funz_name);
      free(tok);
      return;
    }  
  
  if(argomento > 2) return ARG_MISSING;
  
  switch(argomento)
    {

      /////////////////////////////////////////
      //   ARGOMENTO 0 - char *email
      ////////////////////////////////////////
    
    case 0 :

      switch(tipo_di_test)
	{

	case RESULT_OK :

	  strcpy(email, "From: ale@ale.it\nTo: LabProg2\nSubject: <<<<Sicuramente mi fregate :(\n\n?=()/&\"Appunto -_-");

	  i=tokenizzaEmail(email, tok, 40);

	  if(i == RESULT_OK && tok[7].contesto == NULL && (!strcmp(tok[7].parola, "Appunto") ))
	    {
	      tok=NULL;
	      funz_name=NULL;
	      free(tok);
	      free(funz_name);
	      return TEST_PASSED;
	    }

	  ////////////////
	  // TEST FALLITO
	  ////////////////
	  err=AlessaGrott_Err(tipo_di_test, i, funz_name);
	  if(err != 0)
	    {
	      printf("ERRORE INTERNO DELLA FUNZIONE DI TEST\nNON E' STATO POSSIBILE ALLOCARE MEMORIA\n");
	      tok=NULL;
	      funz_name=NULL;
	      free(tok);
	      free(funz_name);
	      return;
	    }

	  printTokens(tok, 40);
	  printf("Non viene controllato se esiste un body.\n");
	  tok=NULL;
	  funz_name=NULL;
	  free(tok);
	  free(funz_name);
	  return NOT_VALID;
	  break;

	case UNKNOWN_ERROR :

	  tok=NULL;
	  funz_name=NULL;
	  free(tok);
	  free(funz_name);
	  return NOT_IMPLEMENTED;
	  break;

	case NULL_POINTER :    
    
	  i=tokenizzaEmail(NULL, tok, 20);

	  if(i == NULL_POINTER)
	    {
	      tok=NULL;
	      funz_name=NULL;
	      free(tok);
	      free(funz_name);
	      return TEST_PASSED;
	    }

	  ////////////////
	  // TEST FALLITO
	  ////////////////
	  err=AlessaGrott_Err(tipo_di_test, i, funz_name);
	  if(err != 0) 
	    {
	      printf("ERRORE INTERNO DELLA FUNZIONE DI TEST\nNON E' STATO POSSIBILE ALLOCARE MEMORIA\n");
	      tok=NULL;
	      funz_name=NULL;
	      free(tok);
	      free(funz_name);
	      return;
	    }

	  printf("Non viene controllato se l'argomento \" %d \" sia un puntatore a NULL.\n", argomento);
	  tok=NULL;
	  funz_name=NULL;
	  free(tok);
	  free(funz_name);
	  return NOT_VALID;
	  break;


	case EMPTY_STRING :

	  i=tokenizzaEmail("\0", tok, 20);

	  if(i == EMPTY_STRING)
	    {
	      tok=NULL;
	      funz_name=NULL;
	      free(tok);
	      free(funz_name);
	      return TEST_PASSED;
	    }

	  ////////////////
	  // TEST FALLITO
	  ////////////////
	  err=AlessaGrott_Err(tipo_di_test, i, funz_name);
	  if(err != 0) 
	    {
	      printf("ERRORE INTERNO DELLA FUNZIONE DI TEST\nNON E' STATO POSSIBILE ALLOCARE MEMORIA\n");
	      tok=NULL;
	      funz_name=NULL;
	      free(tok);
	      free(funz_name);
	      return;
	    }

	  printf("Non viene controllato se l'argomento \" %d \" sia una stringa vuota.\n", argomento);
	  tok=NULL;
	  funz_name=NULL;
	  free(tok);
	  free(funz_name);
	  return NOT_VALID;
	  break;

	case FILE_MISSING :

	  tok=NULL;
	  funz_name=NULL;
	  free(tok);
	  free(funz_name);
	  return NOT_VALID;
	  break;

	case FILE_UNREADABLE :

	  tok=NULL;
	  funz_name=NULL;
	  free(tok);
	  free(funz_name);
	  return NOT_VALID;
	  break;

	case FILE_UNWRITABLE :

	  tok=NULL;
	  funz_name=NULL;
	  free(tok);
	  free(funz_name);
	  return NOT_VALID;
	  break;

	case FILE_EMPTY :

	  tok=NULL;
	  funz_name=NULL;
	  free(tok);
	  free(funz_name);
	  return NOT_VALID;
	  break;

	case BUFFER_TOO_SMALL :

	  tok=NULL;
	  funz_name=NULL;
	  free(tok);
	  free(funz_name);
	  return NOT_VALID;
	  break;

	case HEADER_NOT_FOUND :

	  strcpy(email, "\n ciao: n@i.it\n\nBODY");

	  i=tokenizzaEmail(email, tok, 20);

	  if(i == HEADER_NOT_FOUND)
	    {
	      tok=NULL;
	      funz_name=NULL;
	      free(tok);
	      free(funz_name);
	      return TEST_PASSED;
	    }

	  ////////////////
	  // TEST FALLITO
	  ////////////////
	  err=AlessaGrott_Err(tipo_di_test, i, funz_name);
	  if(err != 0) 
	    {
	      printf("ERRORE INTERNO DELLA FUNZIONE DI TEST\nNON E' STATO POSSIBILE ALLOCARE MEMORIA\n");
	      tok=NULL;
	      funz_name=NULL;
	      free(tok);
	      free(funz_name);
	      return;
	    }

	  printf("Non viene controllato se esiste il blocco headers.\n");
	  tok=NULL;
	  funz_name=NULL;
	  free(tok);
	  free(funz_name);
	  return NOT_VALID;
	  break;


	case BODY_NOT_FOUND :

	  strcpy(email, "ciao: n@i.it\n\n");

	  i=tokenizzaEmail(email, tok, 20);

	  if(i == BODY_NOT_FOUND)
	    {
	      tok=NULL;
	      funz_name=NULL;
	      free(tok);
	      free(funz_name);
	      return TEST_PASSED;
	    }

	  ////////////////
	  // TEST FALLITO
	  ////////////////
	  err=AlessaGrott_Err(tipo_di_test, i, funz_name);
	  if(err != 0) 
	    {
	      printf("ERRORE INTERNO DELLA FUNZIONE DI TEST\nNON E' STATO POSSIBILE ALLOCARE MEMORIA\n");
	      tok=NULL;
	      funz_name=NULL;
	      free(tok);
	      free(funz_name);
	      return;
	    }

	  printf("Non viene controllato se esiste un body.\n");
	  tok=NULL;
	  funz_name=NULL;
	  free(tok);
	  free(funz_name);
	  return NOT_VALID;
	  break;

	case BAD_HEADER :

	  strcpy(email, "ciao:n@i.it\n\nBODY");

	  i=tokenizzaEmail(email, tok, 20);

	  if(i == BAD_HEADER)
	    {
	      tok=NULL;
	      funz_name=NULL;
	      free(tok);
	      free(funz_name);
	      return TEST_PASSED;
	    }

	  ////////////////
	  // TEST FALLITO
	  ////////////////
	  err=AlessaGrott_Err(tipo_di_test, i, funz_name);
	  if(err != 0) 
	    {
	      printf("ERRORE INTERNO DELLA FUNZIONE DI TEST\nNON E' STATO POSSIBILE ALLOCARE MEMORIA\n");
	      tok=NULL;
	      funz_name=NULL;
	      free(tok);
	      free(funz_name);
	      return;
	    }

	  printf("Non viene controllato la sintassi corretta dell'header.\n");
	  tok=NULL;
	  funz_name=NULL;
	  free(tok);
	  free(funz_name);
	  return NOT_VALID;
	  break;
	  
	case MEM_ALLOC_ERROR :

	  tok=NULL;
	  funz_name=NULL;
	  free(tok);
	  free(funz_name);
	  return NOT_IMPLEMENTED;
	  break;

	}

      /////////////////////////////////////////
      //   ARGOMENTO 1 - Token tokenArray[]
      ////////////////////////////////////////
    
    case 1 :

      switch(tipo_di_test)
	{

	case RESULT_OK :
	  
	  tok=NULL;
	  funz_name=NULL;
	  free(tok);
	  free(funz_name);
	  return NOT_IMPLEMENTED;
	  break;

	case UNKNOWN_ERROR :

	  tok=NULL;
	  funz_name=NULL;
	  free(tok);
	  free(funz_name);
	  return NOT_IMPLEMENTED;
	  break;

	case NULL_POINTER :    
    
	  i=tokenizzaEmail(email, NULL, 20);

	  if(i == NULL_POINTER)
	    {
	      tok=NULL;
	      funz_name=NULL;
	      free(tok);
	      free(funz_name);
	      return TEST_PASSED;
	    }

	  ////////////////
	  // TEST FALLITO
	  ////////////////
	  err=AlessaGrott_Err(tipo_di_test, i, funz_name);
	  if(err != 0) 
	    {
	      printf("ERRORE INTERNO DELLA FUNZIONE DI TEST\nNON E' STATO POSSIBILE ALLOCARE MEMORIA\n");
	      tok=NULL;
	      funz_name=NULL;
	      free(tok);
	      free(funz_name);
	      return;
	    }

	  printf("Non viene controllato se l'argomento \" %d \" sia un puntatore a NULL.\n", argomento);
	  tok=NULL;
	  funz_name=NULL;
	  free(tok);
	  free(funz_name);
	  return NOT_VALID;
	  break;


	case EMPTY_STRING :

	  tok=NULL;
	  funz_name=NULL;
	  free(tok);
	  free(funz_name);
	  return NOT_VALID;
	  break;

	case FILE_MISSING :

	  tok=NULL;
	  funz_name=NULL;
	  free(tok);
	  free(funz_name);
	  return NOT_VALID;
	  break;

	case FILE_UNREADABLE :

	  tok=NULL;
	  funz_name=NULL;
	  free(tok);
	  free(funz_name);
	  return NOT_VALID;
	  break;

	case FILE_UNWRITABLE :

	  tok=NULL;
	  funz_name=NULL;
	  free(tok);
	  free(funz_name);
	  return NOT_VALID;
	  break;

	case FILE_EMPTY :

	  tok=NULL;
	  funz_name=NULL;
	  free(tok);
	  free(funz_name);
	  return NOT_VALID;
	  break;

	case BUFFER_TOO_SMALL :

	  strcpy(email, "From ab@bc.de\n\nBody");

	  i=tokenizzaEmail(email, tok, 3);
  
	  if(i == BUFFER_TOO_SMALL)
	    {
	      tok=NULL;
	      funz_name=NULL;
	      free(tok);
	      free(funz_name);
	      return TEST_PASSED;
	    }

	  ////////////////
	  // TEST FALLITO
	  ////////////////
	  err=AlessaGrott_Err(tipo_di_test, i, funz_name);
	  if(err != 0) 
	    {
	      printf("ERRORE INTERNO DELLA FUNZIONE DI TEST\nNON E' STATO POSSIBILE ALLOCARE MEMORIA\n");
	      tok=NULL;
	      funz_name=NULL;
	      free(tok);
	      free(funz_name);
	      return;
	    }

	  printf("Non viene controllato se la dimensione dell'array dei tokens basti\na riempire l'array con tutti i valori.\n");
	  tok=NULL;
	  funz_name=NULL;
	  free(tok);
	  free(funz_name);
	  return TEST_FAILED;
	  
	  break;

	case HEADER_NOT_FOUND :

	  tok=NULL;
	  funz_name=NULL;
	  free(tok);
	  free(funz_name);
	  return NOT_VALID;
	  break;


	case BODY_NOT_FOUND :

	  tok=NULL;
	  funz_name=NULL;
	  free(tok);
	  free(funz_name);
	  return NOT_VALID;
	  break;

	case BAD_HEADER :

	  tok=NULL;
	  funz_name=NULL;
	  free(tok);
	  free(funz_name);
	  return NOT_VALID;
	  break;

	case MEM_ALLOC_ERROR :

	  tok=NULL;
	  funz_name=NULL;
	  free(tok);
	  free(funz_name);
	  return NOT_IMPLEMENTED;
	  break;

	}


      /////////////////////////////////////////
      //   ARGOMENTO 2 - int dimT
      ////////////////////////////////////////
    
    case 2 :

      switch(tipo_di_test)
	{

	case RESULT_OK :
	  
	  tok=NULL;
	  funz_name=NULL;
	  free(tok);
	  free(funz_name);
	  return NOT_IMPLEMENTED;
	  break;

	case UNKNOWN_ERROR :

	  tok=NULL;
	  funz_name=NULL;
	  free(tok);
	  free(funz_name);
	  return NOT_IMPLEMENTED;
	  break;

	case NULL_POINTER :    
    
	  tok=NULL;
	  funz_name=NULL;
	  free(tok);
	  free(funz_name);
	  return NOT_VALID;
	  break;


	case EMPTY_STRING :

	  tok=NULL;
	  funz_name=NULL;
	  free(tok);
	  free(funz_name);
	  return NOT_VALID;
	  break;

	case FILE_MISSING :

	  tok=NULL;
	  funz_name=NULL;
	  free(tok);
	  free(funz_name);
	  return NOT_VALID;
	  break;

	case FILE_UNREADABLE :

	  tok=NULL;
	  funz_name=NULL;
	  free(tok);
	  free(funz_name);
	  return NOT_VALID;
	  break;

	case FILE_UNWRITABLE :

	  tok=NULL;
	  funz_name=NULL;
	  free(tok);
	  free(funz_name);
	  return NOT_VALID;
	  break;

	case FILE_EMPTY :

	  tok=NULL;
	  funz_name=NULL;
	  free(tok);
	  free(funz_name);
	  return NOT_VALID;
	  break;

	case BUFFER_TOO_SMALL :

	  i=tokenizzaEmail("From a@b.c\n\nBody", tok, 0);
  
	  if(i == BUFFER_TOO_SMALL)
	    {
	      i=tokenizzaEmail("From a@b.c\n\nBody", tok, -656);

	      if(i == BUFFER_TOO_SMALL)
	        {
		  tok=NULL;
		  funz_name=NULL;
		  free(tok);
		  free(funz_name);
		  return TEST_PASSED;
		}
	    }

	  ////////////////
	  // TEST FALLITO
	  ////////////////
	  err=AlessaGrott_Err(tipo_di_test, i, funz_name);
	  if(err != 0) 
	    {
	      printf("ERRORE INTERNO DELLA FUNZIONE DI TEST\nNON E' STATO POSSIBILE ALLOCARE MEMORIA\n");
	      tok=NULL;
	      funz_name=NULL;
	      free(tok);
	      free(funz_name);
	      return;
	    }

	  printf("Non viene controllato se la dimensione dell'array dei tokens basti\na riempire l'array con tutti i valori.\n");
	  tok=NULL;
	  funz_name=NULL;
	  free(tok);
	  free(funz_name);
	  return TEST_FAILED;
	  
	  break;

	case HEADER_NOT_FOUND :

	  tok=NULL;
	  funz_name=NULL;
	  free(tok);
	  free(funz_name);
	  return NOT_VALID;
	  break;


	case BODY_NOT_FOUND :

	  tok=NULL;
	  funz_name=NULL;
	  free(tok);
	  free(funz_name);
	  return NOT_VALID;
	  break;

 case BAD_HEADER :

   tok=NULL;
   funz_name=NULL;
   free(tok);
   free(funz_name);
   return NOT_VALID;
   break;

 case MEM_ALLOC_ERROR :

   tok=NULL;
   funz_name=NULL;
   free(tok);
   free(funz_name);
   return NOT_IMPLEMENTED;
   break;

 }
    }
}

///////////////////////////////////////////////////
//   TEST PRINT TOKEN
/////////////////////////////////////////////////// 
int test_printTokens(int tipo_di_test, int argomento)
{
    if(argomento > 1) return ARG_MISSING;
    return NOT_IMPLEMENTED;
}



