#include <stdlib.h>
#include <stdio.h>
#include "modulo1.h"
#include "testModulo1.h"

int test_leggiFile(int tipo_di_test, int n_argomento)
{
	//alcune variabili di supporto ai test
	char buf[4096];
	int buflen = 4096;
	int ret;
 
	//tabella degli argomenti:
	// 0 - char *nomefile   (test NULL e EMPTY_STRING)
	// 1 - int   dimensione (test BUFFER_TOO_SMALL)
	// 2 - char *testo      (test NULL)
 
	//la funzione leggiFile ha solo 3 argomenti, in tutti gli altri
	//casi  sbagliato
	if (n_argomento < 0 || n_argomento > 2)
		return ARG_MISSING;
 
	if (tipo_di_test == RESULT_OK)
	{
		//dobbiamo testare il caso in cui tutto vada bene
		//passiamo dei parametri validi
		ret = leggiFile("email1.txt", 4096, buf);
 
		//controlliamo il valore di ritorno
		if (ret == RESULT_OK)
		{
			//il test  andato a buon fine
			return TEST_PASSED;
		}
		else
		{
			//il test  fallito, stampiamo
			//un messaggio di errore
			printf("Test Fallito: funzione testata:   leggiFile(\"email.txt\", 4096, buf)\r\n"
				   "              risultato atteso:   RESULT_OK\r\n");
			return TEST_FAILED;
		}
	}
 
	//ora vediamo i test per i parametri nulli
	if (tipo_di_test == NULL_POINTER)
	{
		if (n_argomento == 0)
		{
			//testiamo la possibilit che il primo argomento sia NULL
			ret = leggiFile(NULL, 4096, buf);
 
			if (ret == NULL_POINTER)
				return TEST_PASSED;
			else
			{
				printf("Test Fallito: funzione testata:   leggiFile(NULL, 4096, buf)\r\n"
					   "              risultato atteso:   NULL_POINTER\r\n");
			return TEST_FAILED;
			}
		}
		else if (n_argomento == 2)
		{
			//testiamo la possibilit che il terzo argomento sia NULL
			ret = leggiFile("email1.txt", 4096, NULL);
 
			if (ret == NULL_POINTER)
				return TEST_PASSED;
			else
			{
				printf("Test Fallito: funzione testata:   leggiFile(\"email1.txt\", 4096, NULL)\r\n"
					   "              risultato atteso:   NULL_POINTER\r\n");
			return TEST_FAILED;
			}
		}
	}
 
	//vediamo il test EMPTY_STRING sul primo parametri
	if (tipo_di_test == EMPTY_STRING && n_argomento == 0)
	{
		ret = leggiFile("\0", 4096, buf);
 
		if (ret == EMPTY_STRING)
			return TEST_PASSED;
		else
		{
			printf("Test Fallito: funzione testata:   leggiFile(\"\0\", 4096, buf)\r\n"
				   "              risultato atteso:   EMPTY_STRING\r\n");
		return TEST_FAILED;
		}
	}
 
	//infine testiamo l'ultimo caso, quando il buffer  troppo stretto
	if (tipo_di_test == BUFFER_TOO_SMALL && n_argomento == 1)
	{
		ret = leggiFile("email1.txt", 1, buf);
 
		if (ret == BUFFER_TOO_SMALL)
			return TEST_PASSED;
		else
		{
			printf("Test Fallito: funzione testata:   leggiFile(\"\email1.txt\", 1, buf)\r\n"
				   "              risultato atteso:   BUFFER_TOO_SMALL\r\n");
		return TEST_FAILED;
		}
	}
 
	//in tutti gli altri casi il test non ha senso
	return NOT_VALID;
}	
	
