
#include <stdio.h>
#include <string.h>
#include <math.h>
#include <sys/stat.h>
#include "modulo1.h"
#include <errno.h>

int leggiFile(char * nomefile, int dimensione, char * testo)
{
	FILE *fp;
	int ch;
	int i=0;
	struct stat statbuf;
	//gestione parametri
	if((nomefile==NULL)||(testo==NULL))
		return NULL_POINTER;
	if(stat(nomefile, &statbuf)!=-1)
	{
		if(statbuf.st_size>dimensione)
			return BUFFER_TOO_SMALL;
		if(statbuf.st_size<=0)
			return FILE_EMPTY;
		if((fp=fopen(nomefile, "r"))==NULL)
			return FILE_UNREADABLE;
		ch=getc(fp);
		while((ch!=EOF)&&(i<dimensione-1))
		{
			*testo=ch;
			i++;
			testo++;
			ch=getc(fp);
		}
		*testo='\0';
		fclose(fp);
	}
	else
		return FILE_MISSING;
	return RESULT_OK;
}

int estraiHeaders(char * email, char * headers, int dimh)
{
	int i=0;
	if((email==NULL)||(headers==NULL))
		return NULL_POINTER;
	if(*email=='\0')
		return EMPTY_STRING;
	if(dimh<=0)
		return BUFFER_TOO_SMALL;
	if(*email=='\n')		//maybe don't do what i want it do
		return HEADER_NOT_FOUND;
	while((*email!='\n')&&(*(email+1)!='\n'))
	{
		*headers=*email;
		printf("%c",*headers);
		headers++;
		email++;
		i++;
		if(i==dimh)
			return BUFFER_TOO_SMALL;
	}
	*headers=*email;
	headers++;
	*headers='\0';
	return RESULT_OK;
}

int primoHeader(char * headers, char * primo_header, int dim)
{
	int i=0, space=0;
	if((headers==NULL)||(primo_header==NULL))
		return NULL_POINTER;
	if(*headers=='\0')
		return EMPTY_STRING;
	if(dim<=0)
		return BUFFER_TOO_SMALL;
	while(!isalnum(*headers))
		return BAD_HEADER;
	while(*headers!='\0')
	{
		if((*headers=='\n')&&((*(headers+1)!='\t')||(*(headers+1)!=' ')))
			break;
		if((*headers==' ')&&(isalnum(*(headers+1))))
			space=1;
		*primo_header=*headers;
		i++;
		headers++;
		primo_header++;
		if(i==dim)
			return BUFFER_TOO_SMALL;
	}
	if(space!=1)
		return BAD_HEADER;
	return RESULT_OK;
}

int parseHeader(char * header, char * tipo, int dimt, char * valore, int dimv)
{
	int i=0, j=0, tipe=1;
	if((header==NULL)||(tipo==NULL)||(valore==NULL))
		return NULL_POINTER;
	if(*header=='\0')
		return EMPTY_STRING;
	if((dimt<=0)||(dimv<=0))
		return BUFFER_TOO_SMALL;
	while(*header!='\0')
	{	
		if(tipe==1)
		{
			if(*header==' ')
			{
				tipe=0;
				header++;
			}
			*tipo=*header;
			i++;
			header++;
			tipo++;
		}
		else
		{
			*valore=*header;
			header++;
			j++;
			valore++;
		}
		if((i==dimt)||(j==dimv))
			return BUFFER_TOO_SMALL;
	}
	*valore='\0';
	*tipo='\0';
	return RESULT_OK;
}

int primaParola(char * testo, char * parola, int dim)
{
	int i=0, word=0;
	if((testo==NULL)||(parola==NULL))
		return NULL_POINTER;
	if(*testo=='\0')
		return EMPTY_STRING;
	if(dim<=0)
		return BUFFER_TOO_SMALL;
	if(*testo=='\0')
		return BODY_NOT_FOUND;
	while((word<2)||(*testo!='\0'))
	{
		if(isalnum(*testo))
		{
			*parola=*testo;
			parola++;
			word++;
		}
		else
		{
			if(word<2)
			{
				parola=-word;
				word=0;
			}
		}
		i++;
		testo++;
		if(i==dim)
			return BUFFER_TOO_SMALL;
	}
	return RESULT_OK;
}


int tokenizzaEmail(char * email, Token tokenArray[], int dimT)
{
	int dimh, dimp, dimv, dimt,i=0, dimw=0;
	char *headers, *primo_header;
	headers=(char *)malloc(10*sizeof(char));
	primo_header=(char *)malloc(10*sizeof(char));
	dimp=1000;
	dimt=100;
	dimw=100;
	dimv=100;
	if(dimT<=0)
		return BUFFER_TOO_SMALL;
	if((!headers)||(!primo_header))
		return MEM_ALLOC_ERROR;
	dimh=1000;
	if(estraiHeaders(email, headers, dimh)!=RESULT_OK)
		return estraiHeaders(email, headers, dimh);
	email=email+strlen(headers)+2;
	while(*headers!='\0')
	{
		if(*headers=='\n')
			headers++;
		if(primoHeader(headers,primo_header,dimp)!=RESULT_OK)
			return primoHeader(headers,primo_header,dimp);
		headers=headers+strlen(primo_header);
		if(parseHeader(primo_header, tokenArray[i].contesto, dimt, tokenArray[i].parola, dimv)!=RESULT_OK);	//maybe don't do what i want it do
			return parseHeader(primo_header, tokenArray[i].contesto, dimt, tokenArray[i].parola, dimv);
		i++;
		if(i>dimT)
			return BUFFER_TOO_SMALL;
	}
	while(*email!='\0')
	{
		if(primaParola(email,tokenArray[i].parola,dimw)!=RESULT_OK)
			return primoHeader(email,tokenArray[i].parola,dimw);
		tokenArray[i].contesto=NULL;
		email=email+strlen(tokenArray[i].parola);
		i++;
		if(i>dimT)
			return BUFFER_TOO_SMALL;
	}
}

int printTokens(Token tokenArray[], int dimT)
{
	int i;
	for(i=0;i<dimT;i++)
	{
		if(tokenArray[i].contesto!=NULL)
		{
			printf("%s",*(tokenArray[i].contesto));
			printf("*");
		}
		printf("%s",*(tokenArray[i].parola));
		printf("\n");
		i++;
	}
}
