#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/stat.h>
#include <unistd.h>
#include <errno.h>
#include "modulo1.h"

int leggiFile(char* nomefile, int dimensione, char* testo)
{
  /*contatori*/
  int n;

  /*appoggio*/
  char c;

  struct stat stat_F;
  FILE* filePtr;

  /*Control block begins*/
  if(nomefile==NULL)return NULL_POINTER;
  if(testo==NULL)return NULL_POINTER;
  if(nomefile=='\0')return EMPTY_STRING;
  if(testo=='\0')return EMPTY_STRING;
  if(access(nomefile,R_OK)==-1)return FILE_UNREADABLE;
  if(access(nomefile,F_OK)==-1)return FILE_MISSING;
  stat(nomefile,&stat_F);
  if(stat_F.st_size<=0)return FILE_EMPTY;
  /*control block ends*/

  filePtr=fopen(nomefile,"r");
  /*Read file*/
  for(n=0;n<dimensione-2;n++)
    {
      fscanf(filePtr,"%c",&c);
      testo[n]=c;
      if(n==stat_F.st_size)break;
    }
  testo[strlen(testo)+1]='\0';
  return RESULT_OK;
}

int estraiHeaders(char* email, char* headers, int dimh)
{
  /*appoggio*/
  char c;
  char b;

  /*countaroti*/
  int n=0;
  int prossimo=0;

  /*flags*/
  int headerOk=0;
  //int controllo=0;


  /*blocco di controllo*/
  if(email==NULL)return NULL_POINTER;
  if(headers==NULL)return NULL_POINTER;
  if(*email=='\0')return EMPTY_STRING;
  if(dimh<=0)return BUFFER_TOO_SMALL;

  for(n=0;n<dimh-1;n++)
  {
    /*prendo l'intero blocco degli headers*/
    c=email[n];
    if(c=='\n')
	{
	  prossimo=n;
	  prossimo++;
	  b=email[prossimo];
	  if(b==c)
	    {
	      headerOk=1;//preso senza nessun errore
	      break;
	    }
	}
      headers[n]=c;
    }
  if(!headerOk)return BUFFER_TOO_SMALL;
  headers[n+1]='\0';
  return RESULT_OK;
}

int primoHeader(char * headers, char * primo_header, int dim)
{
  /*countatori*/
  int i;
  
  /*flags*/
  int prossimo=0;
  int headerOk=0;

  /*appoggio*/
  char c;
  char b;

  /*blocco di controllo*/
  if(headers==NULL)return NULL_POINTER;
  if(headers[0]=='\0')return EMPTY_STRING;
  if(dim<=1)return BUFFER_TOO_SMALL;
  
  if(!isalnum(headers[0]))return BAD_HEADER;

  for(i=0;i<dim-1;i++)
    {
      /*copio l'header corrente*/
      c=headers[i];
      if(c=='\n')
	{
	  prossimo=i;
	  prossimo++;
	  b=headers[prossimo];
	  if(!isspace(b))
	    {
	      headerOk=1;//nessun errore!
	      break;
	    }
	}
      primo_header[i]=c;
    }

  primo_header[i+1]='\0';
  if(!headerOk)return BAD_HEADER;
  return RESULT_OK;
}

int parseHeader(char * header, char * tipo, int dimt, char * valore, int dimv)
{
  /*countatori*/
  int i=0;
  int prossimo=0;

  /*appoggio*/
  char c;
  char b;

  /*flags*/
  int tipoOk=0;
  int valoreOk=0;
  
  /*blocco di controllo */
  if(tipo==NULL)return NULL_POINTER;
  if(valore==NULL)return NULL_POINTER;
  if(header==NULL)return NULL_POINTER;
  if(*header=='\0')return EMPTY_STRING;
  if(dimt<=0)return BUFFER_TOO_SMALL;
  if(dimv<=0)return BUFFER_TOO_SMALL;
  
  for(i=0;i<dimt-1;i++)
    {
      /*inizio del parsing dell'header corrente*/
      sscanf(header,"%c",&c);
      *header++;
      tipo[i]=c;
      if(isspace(c)||c==':')
	{
	  tipoOk=1;//Tipo incluso correttamente
	  break;
	}
    }
  if(!tipoOk)return BUFFER_TOO_SMALL;
  *header+=dimt;
  for(i=0;i<dimv-1;i++)
    {
      /*acquisisco il valore dell'header*/
      c=header[i];
      if(c=='\n')
	{
	  prossimo=i;
	  prossimo++;
	  b=header[prossimo];
	  if(!isspace(b))
	    {
	      valoreOk=1;//valore acquisito correttamente
	      break;
	    }
	}
      valore[i]=c;
    }
  valore[dimv]='\0';
  tipo[dimt]='\0';
  if(!valoreOk)
    return BUFFER_TOO_SMALL;
  return RESULT_OK;
}

int primaParola(char * testo, char * parola, int dim)
{
  //inserire controllo per parole minori di due caratteri
  int wordOk=0;
  
  int i=0;

  char c;

  /*blocco di controllo*/
  if(testo==NULL)return NULL_POINTER;
  if(testo[0]=='\0')return EMPTY_STRING;
  if(dim<=1)return BUFFER_TOO_SMALL;
  if(!isalnum(testo))return BODY_NOT_FOUND;

  while(!isalnum(*testo))*testo++;
    for(i=0;i<dim-1;i++)
      {
	/*prendo la prima parola pulendola dal rumore*/
	sscanf(testo,"%c",&c);
	*testo++;
	if(isalnum(c))parola[i]=c;
	else
	  {
	    wordOk=1;//il buffer  sufficente
	    break;
	  }
      }
    parola[i+1]='\n';
    if(!wordOk)return BUFFER_TOO_SMALL;
  return RESULT_OK;
}

int tokenizzaEmail(char * email, Token tokenArray[], int dimT)
{
  /*quantificatori*/
  int dimH=0;
  int dimP=0;
  int dimFH=0;
  int dimType=0;
  int dimValue=0;
  int dimTxt;

  /*contatori*/
  int n=0;
  int i=0;
  int b=0;
  int prossimo=0;
  int currentToken=0;

  /*buffers*/
  char* headers;
  char* currentHeader;
  char* currentWord;
  char* testo;
  char* tipo;
  char* value;
  char c;

  dimTxt=strlen(email);
  //calcolo la grandezza degli headers
  for(n=0;n<dimTxt-1;n++)
  {
    c=email[n];
    if(c=='\n')
	{
	  prossimo=n;
	  prossimo++;
	  dimH++;
	  b=email[prossimo];
	  if(b==c)
	    {
	      dimH++;
	      break;
	    }
	}
    }
  //alloco la memoria necessaria per contenere il blocco degli headers[evito buffer overflow]
  if((headers=(char*)malloc(dimH*sizeof(char)))==NULL) return MEM_ALLOC_ERROR;
  
  estraiHeaders(email,headers,dimH);
  
  /*alloco la memoria necessaria a contenere il primo header*/
  while(*headers!='\0')
    {
      *headers+=dimFH;
      for(i=0;i<dimH-1;i++)
	{
	  c=headers[i];
	  if(c=='\n')
	    {
	      prossimo=i;
	      prossimo++;
	      dimFH++;
	      b=headers[prossimo];
	      if(!isspace(b))
		{
		  dimFH++;
		  break;
		}
	    }
	}
      primoHeader(headers,currentHeader,dimFH);
      //allocazione della memoria per il buffer corrente
      if((currentHeader=malloc(dimFH*sizeof(char)))==NULL)return MEM_ALLOC_ERROR;
      parseHeader(currentHeader,tipo,dimType,value,dimValue);
      /*calcolo la grandezza della prima parola all'interno dell'header corrente*/
      while(*currentHeader!='\0')
	{
	  *currentHeader+strlen(tipo);
	  while(!isalnum(*testo))*testo++;
	  for(i=0;i<dimFH-1;i++)
	    {
	      dimP++;
	      *testo++;
	      if(isalnum(c))dimP++;
	      else
		{
		  dimP++;
		  break;
		}
	    }
	}
      if((currentWord=malloc(dimP*sizeof(char)))==NULL) return MEM_ALLOC_ERROR;
      primaParola(value,currentWord,dimP);
      *currentHeader+=dimP;//calcolo lo spiazzamento per la prossima parola
      tokenArray[currentToken].contesto=malloc(strlen(tipo)*sizeof(char));
      tokenArray[currentToken].contesto=tipo;
      tokenArray[currentToken].parola=value;
      currentToken++;
      if(currentToken+1<dimT)
	{
	  tokenArray[currentToken++].contesto=NULL;
	  tokenArray[currentToken++].parola=NULL;
	  return BUFFER_TOO_SMALL;
	}
    }

  //mi sposto nel body
  *testo+=dimH;
  while(*testo=='\0')
    {
      //calcolo la memoria necessaria a contenere la prima parola....
      *testo+=dimP;
      while(dimT!='\0')
	{
	  while(!isalnum(*testo))*testo++;
	  for(i=0;i<dimT-1;i++)
	    {
	      dimP++;
	      *testo++;
	      if(isalnum(c))dimP++;
	      else
		{
		  break;
		  dimP++;
		}
	    }
	  //....e la alloco
	  if((currentWord=malloc(dimP*sizeof(char)))==NULL)return MEM_ALLOC_ERROR;
	  primaParola(testo,currentWord,dimP);
	  tokenArray[currentToken].contesto=NULL;
	  tokenArray[currentToken].parola=currentWord;
	  currentToken++;
	  if(currentToken+1<dimT)
	    {
	      tokenArray[currentToken++].contesto=NULL;
	      tokenArray[currentToken++].parola=NULL;
	      return BUFFER_TOO_SMALL;
	    }
	}
    }
  tokenArray[currentToken++].contesto=NULL;
  tokenArray[currentToken++].parola=NULL;
  return RESULT_OK;
}

int printTokens(Token tokenArray[],int dim)
{
  int i;

  /*control block begins*/
  if(tokenArray==NULL) return NULL_POINTER;
  if(dim<=0)return EMPTY_STRING;
  /*control bloack ends*/

  for(i=0; i<dim; i++)
    if(tokenArray[i].contesto==NULL)
      printf("%s\n",tokenArray[i].parola);
    else
      printf("%s*%s\n",tokenArray[i].contesto,tokenArray[i].parola);
  return RESULT_OK;
}

