  #include <stdio.h>
  #include <stdlib.h>
  #include "testModulo1.h"
  #include "modulo1.h"

char* interpreta_risultati(int out);

// eseguo un test sulla funzione leggiFile
int test_leggiFile(int tipo_di_test, int argomento)
{
    /* variabili per il testing */
    char buffernormale[1000];
    char bufferpiccolo[10];

/* tests generici */

    if(argomento>=3) return ARG_MISSING;
    if(tipo_di_test==0){
                                          int a=leggiFile("email1.txt", 1000, buffernormale);
                                          if(!a) return TEST_PASSED;
                                          else {
                                          printf("Test fallito: funzione testata: leggiFile(\"email1.txt\", 1000, buffernormale)\n"
                                          "risultato atteso: RESULT_OK\n"
                                          "risultato ottenuto: %s\n"
                                          "spiegazione: probabilmente la funzione non  stata implementata correttamente.\n", interpreta_risultati(a));
                                          return TEST_FAILED;
                                          }
                                        }

/* tests argomento 0 (nomefile) */

    if((tipo_di_test==2)&&(argomento==0)){
                                          int b=leggiFile(NULL, 1000, buffernormale);
                                          if(b==2) return TEST_PASSED;
                                          else{
                                               printf("Test fallito: funzione testata: leggiFile(NULL, 1000, buffernormale)\n"
                                               "risultato atteso: NULL_POINTER\n"
                                               "risultato ottenuto: %s\n"
                                               "spiegazione: la funzione non controlla se il primo argomento  un puntatore nullo.\n", interpreta_risultati(b));
                                               return TEST_FAILED;}
                                        }

    if((tipo_di_test==3)&&(argomento==0)){
                                          int d=leggiFile("", 1000, buffernormale);
                                          if(d==3) return TEST_PASSED;
                                          else{
                                               printf("Test fallito: funzione testata: leggiFile("", 1000, buffernormale)\n"
                                               "risultato atteso: EMPTY_STRING\n"
                                               "risultato ottenuto: %s\n"
                                               "spiegazione: la funzione non controlla se viene passato un nome-file vuoto.\n", interpreta_risultati(d));
                                               return TEST_FAILED;}
                                        }

    if((tipo_di_test==4)&&(argomento==0)){
                                        int e=leggiFile("file-missing", 1000, buffernormale);
                                        if(e==4) return TEST_PASSED;
                                        else{
                                               printf("Test fallito: funzione testata: leggiFile(\"file-missing\", 1000, buffernormale)\n"
                                               "risultato atteso: FILE_MISSING\n"
                                               "risultato ottenuto: %s\n"
                                               "spiegazione: la funzione non controlla se viene passato un file inesistente.\n", interpreta_risultati(e));
                                               return TEST_FAILED;}
                                        }

    if((tipo_di_test==5)&&(argomento==0)){
                                        int m=leggiFile("file-unreadable", 1000, buffernormale);
                                        if(m==5) return TEST_PASSED;
                                        else{
                                               printf("Test fallito: funzione testata: leggiFile(\"file-unreadable\", 1000, buffernormale)\n"
                                               "risultato atteso: FILE_UNREADABLE\n"
                                               "risultato ottenuto: %s\n"
                                               "spiegazione: la funzione non controlla se il file  leggibile.\n", interpreta_risultati(m));
                                               return TEST_FAILED;}
                                        }

    if((tipo_di_test==6)&&(argomento==0)){
                                        int n=leggiFile("file-unwritable", 1000, buffernormale);
                                        if(n==5) return TEST_PASSED;
                                        else{
                                               printf("Test fallito: funzione testata: leggiFile(\"file-unwritable\", 1000, buffernormale)\n"
                                               "risultato atteso: FILE_UNWRITABLE\n"
                                               "risultato ottenuto: %s\n"
                                               "spiegazione: la funzione non controlla se il file  in sola lettura.\n", interpreta_risultati(n));
                                               return TEST_FAILED;}
                                        }

    if((tipo_di_test==7)&&(argomento==0)){
                                          int g=leggiFile("file-empty", 1000, buffernormale);
                                          if(g==7) return TEST_PASSED;
                                          else{
                                               printf("Test fallito: funzione testata: leggiFile(\"file-empty\", 1000, buffernormale)\n"
                                               "risultato atteso: FILE_EMPTY\n"
                                               "risultato ottenuto: %s\n"
                                               "spiegazione: la funzione non controlla se viene passato un file vuoto.\n", interpreta_risultati(g));
                                               return TEST_FAILED;}
                                        }

    if((tipo_di_test>=8)&&(argomento==0)){
                                        return NOT_VALID;
                                        }

/* tests argomento 1 (dimensione) */

    if(((tipo_di_test>=2)||(tipo_di_test<=7))&&(argomento==1)) {
                                        return NOT_VALID;
                                        }

    if((tipo_di_test==8)&&(argomento==1)){ //CORREGGERE!!
                                          int i=leggiFile("email1.txt", 10, buffernormale);
                                          if(i==8) return TEST_PASSED;
                                          else {
                                          printf("Test fallito: funzione testata: leggiFile(\"email1.txt\", 10, buffernormale)\n"
                                          "risultato atteso: BUFFER_TOO_SMALL\n"
                                          "risultato ottenuto: %s\n"
                                          "spiegazione: la funzione non controlla se le dimensioni del buffer sono troppo piccole a contenere l'e-mail.\n", interpreta_risultati(i));
                                          return TEST_FAILED;}
                                         }

    if((tipo_di_test>=9)&&(argomento==1)){
                                        return NOT_VALID;
                                        }
                                        
/* tests argomento 2 (testo) */
                                        
    if((tipo_di_test==2)&&(argomento==2)){
                                          int l=leggiFile("email1.txt", 1000, NULL);
                                          if(l==2) return TEST_PASSED;
                                          else{
                                               printf("Test fallito: funzione testata: leggiFile(\"email1.txt\", 1000, NULL)\n"
                                               "risultato atteso: NULL_POINTER\n"
                                               "risultato ottenuto: %s\n"
                                               "spiegazione: la funzione non controlla se \"testo\"  un puntatore nullo.\n", interpreta_risultati(l));
                                               return TEST_FAILED;}
                                        }

    if((tipo_di_test>=3)&&(argomento==2)){
                                        return NOT_VALID;
                                        }
return NOT_IMPLEMENTED;
}

// eseguo un test sulla funzione estraiHeaders
int test_estraiHeaders(int tipo_di_test, int argomento)
{
/* variabili per il testing */
char*email="From: ilmantox@tiscali.it\n"
"To: babbo_natale@northpole.org\n"
"Subject: Cosa vorrei per il 6 Aprile\n\n"
"Caro Babbo Natale, \n"
"spero proprio di riuscire a finire questo homework in tempo visto che ho iniziato un po' in ritardo.\n\n"
"Salutami la befana.\n\n"
"Ciao\n"
"Andrea\n";
char*emailsenzaheaders="\nCaro Babbo Natale, \n"
"spero proprio di riuscire a finire questo homework in tempo visto che ho iniziato un po' in ritardo.\n\n"
"Salutami la befana.\n\n"
"Ciao\n"
"Andrea\n";
char headers[1000];

/* tests preliminari */

    if(argomento>=3) return ARG_MISSING;
    if(tipo_di_test==1) return NOT_VALID;
    if(tipo_di_test>=10) return NOT_VALID;
    if(tipo_di_test==0){
                                          int a2=estraiHeaders(email, headers, 1000);
                                          if(!a2) return TEST_PASSED;
                                          else {
                                          printf("Test fallito: funzione testata: estraiHeaders(email, headers, 1000)\n"
                                          "risultato atteso: RESULT_OK\n"
                                          "risultato ottenuto: %s\n"
                                          "spiegazione: probabilmente la funzione non  stata implementata correttamente.\n", interpreta_risultati(a2));
                                          return TEST_FAILED;
                                          }
                                        }

/* tests argomento 0 (email) */
    if((tipo_di_test==2)&&(argomento==0)){
                                          int b2=estraiHeaders(NULL, headers, 1000);
                                          if(b2==2) return TEST_PASSED;
                                          else{
                                               printf("Test fallito: funzione testata: estraiHeaders(NULL, headers, 1000)\n"
                                               "risultato atteso: NULL_POINTER\n"
                                               "risultato ottenuto: %s\n"
                                               "spiegazione: la funzione non controlla se il primo argomento  un puntatore nullo.\n", interpreta_risultati(b2));
                                               return TEST_FAILED;}
                                        }
    if((tipo_di_test==3)&&(argomento==0)){
                                          int d2=estraiHeaders("", headers, 1000);
                                          if(d2==3) return TEST_PASSED;
                                          else{
                                               printf("Test fallito: funzione testata: leggiFile("", 1000, buffernormale)\n"
                                               "risultato atteso: EMPTY_STRING\n"
                                               "risultato ottenuto: %s\n"
                                               "spiegazione: la funzione non controlla se viene passata un'e-mail vuota.\n", interpreta_risultati(d2));
                                               return TEST_FAILED;}
                                        }
    if((tipo_di_test==9)&&(argomento==0)){
                                          int e2=estraiHeaders(emailsenzaheaders, headers, 1000);
                                          if(e2==9) return TEST_PASSED;
                                          else{
                                               printf("Test fallito: funzione testata: estraiHeaders(emailsenzaheaders, headers, 1000)\n"
                                               "risultato atteso: HEADER_NOT_FOUND\n"
                                               "risultato ottenuto: %s\n"
                                               "spiegazione: la funzione non controlla se viene passata un'e-mail priva di headers.\n", interpreta_risultati(e2));
                                               return TEST_FAILED;}
                                        }
    if((argomento==0)&&(tipo_di_test>=10)) return NOT_VALID;
    
/* tests argomento 1 (headers) */

if((tipo_di_test==2)&&(argomento==1)){
                                          int c2=estraiHeaders(email, NULL, 1000);
                                          if(c2==2) return TEST_PASSED;
                                          else{
                                               printf("Test fallito: funzione testata: estraiHeaders(email, NULL, 1000)\n"
                                               "risultato atteso: NULL_POINTER\n"
                                               "risultato ottenuto: %s\n"
                                               "spiegazione: la funzione non controlla se il secondo argomento  un puntatore nullo.\n", interpreta_risultati(c2));
                                               return TEST_FAILED;}
                                        }
if((argomento==1)&&(tipo_di_test!=2)) return NOT_VALID;

/* tests argomento 2 (dimh) */
if((tipo_di_test==8)&&(argomento==2)){
                                          int f2=estraiHeaders(email, headers, 10);
                                          if(f2==8) return TEST_PASSED;
                                          else{
                                               printf("Test fallito: funzione testata: estraiHeaders(email, NULL, 1000)\n"
                                               "risultato atteso: BUFFER_TOO_SMALL\n"
                                               "risultato ottenuto: %s\n"
                                               "spiegazione: la funzione non controlla se la dimensione della stringa \"headers\"  troppo piccola per contenere gli headers.\n", interpreta_risultati(f2));
                                               return TEST_FAILED;}
                                        }
if((argomento==2)&&(tipo_di_test!=8)) return NOT_VALID;
return NOT_VALID;
}

// eseguo un test sulla funzione primoHeader
int test_primoHeader(int tipo_di_test, int argomento)
{
    char*headers="From: ilmantox@tiscali.it\n"
"To: babbo_natale@northpole.org\n"
"Subject: Cosa vorrei per il 6 Aprile\n\n";
    char primo_header[1000];
    
    if(argomento>=3) return ARG_MISSING;
    if((tipo_di_test!=0)&&(tipo_di_test!=2)&&(tipo_di_test!=3)&&(tipo_di_test!=8)) return NOT_VALID;
    if(tipo_di_test==0){
                        int a3=primoHeader(headers, primo_header, 1000);
                        if(a3==0) return TEST_PASSED;
                                          else{
                                               printf("Test fallito: funzione testata: primoHeader(headers, primo_header, 1000)\n"
                                               "risultato atteso: RESULT_OK\n"
                                               "risultato ottenuto: %s\n"
                                               "spiegazione: probabilmente la funzione non  stata implementata correttamente.\n", interpreta_risultati(a3));
                                               return TEST_FAILED;}
                                        }
    if((argomento==0)&&(tipo_di_test==2)){
                                          int b3=primoHeader(NULL, primo_header, 1000);
                                          if(b3==2) return TEST_PASSED;
                                          else{
                                               printf("Test fallito: funzione testata: primoHeader(NULL, primo_header, 1000)\n"
                                               "risultato atteso: NULL_POINTER\n"
                                               "risultato ottenuto: %s\n"
                                               "spiegazione: la funzione non controlla se il primo argomento  un puntatore nullo.\n", interpreta_risultati(b3));
                                               return TEST_FAILED;}
                                        }
    if((argomento==0)&&(tipo_di_test==3)){
                                          int c3=primoHeader("", primo_header, 1000);
                                          if(c3==3) return TEST_PASSED;
                                          else{
                                               printf("Test fallito: funzione testata: primoHeader("", primo_header, 1000)\n"
                                               "risultato atteso: EMPTY_STRING\n"
                                               "risultato ottenuto: %s\n"
                                               "spiegazione: la funzione non controlla se il primo argomento  una stringa vuota.\n", interpreta_risultati(c3));
                                               return TEST_FAILED;}
                                        }
    if((argomento==1)&&(tipo_di_test==2)){
                                          int d3=primoHeader(headers, NULL, 1000);
                                          if(d3==2) return TEST_PASSED;
                                          else{
                                               printf("Test fallito: funzione testata: primoHeader(header, NULL, 1000)\n"
                                               "risultato atteso: NULL_POINTER\n"
                                               "risultato ottenuto: %s\n"
                                               "spiegazione: la funzione non controlla se il secondo argomento  un puntatore nullo.\n", interpreta_risultati(d3));
                                               return TEST_FAILED;}
                                        }
    if((argomento==2)&&(tipo_di_test==8)){
                                          int e3=primoHeader(headers, primo_header, 1);
                                          if(e3==8) return TEST_PASSED;
                                          else{
                                               printf("Test fallito: funzione testata: primoHeader(header, NULL, 1000)\n"
                                               "risultato atteso: BUFFER_TOO_SMALLn"
                                               "risultato ottenuto: %s\n"
                                               "spiegazione: la funzione non controlla se la dimensione del buffer  abbastanza grande.\n", interpreta_risultati(e3));
                                               return TEST_FAILED;}
                                        }
    return NOT_IMPLEMENTED;
}

// eseguo un test sulla funzione parseHeader
int test_parseHeader(int tipo_di_test, int argomento)
{
    return NOT_IMPLEMENTED;
}

// eseguo un test sulla funzione primaParola
int test_primaParola(int tipo_di_test, int argomento)
{
    return NOT_IMPLEMENTED;
}

// eseguo un test sulla funzione tokenizzaEmail
int test_tokenizzaEmail(int tipo_di_test, int argomento)
{
    return NOT_IMPLEMENTED;
}

// eseguo un test sulla funzione printAllEmailTokens
int test_printTokens(int tipo_di_test, int argomento)
{
    return NOT_IMPLEMENTED;
}

char* interpreta_risultati(int out)
{
    char *string;
    if(out==0){
                string="RESULT_OK";
                return string;
                }
    if(out==2){
                string="NULL_POINTER";
                return string;
                }
    if(out==3){
                string="EMPTY_STRING";
                return string;
                }    
    if(out==4){
                string="FILE_MISSING";
                return string;
                } 
    if(out==5){
                string="FILE_UNREADABLE";
                return string;
                }                 
    if(out==6){
                string="FILE_UNWRITABLE";
                return string;
                }
    if(out==7){
                string="FILE_EMPTY";
                return string;
                }
    if(out==8){
                string="BUFFER_TOO_SMALL";
                return string;
                }
    if(out==9){
                string="HEADER_NOT_FOUND";
                return string;
                }
    if(out==10){
                string="BODY_NOT_FOUND";
                return string;
                }
    if(out==11){
                string="BAD_HEADER";
                return string;
                }
    if(out==12){
                string="MEM_ALLOC_ERROR";
                return string;
                }
    string="UNKNOWN_ERROR";
    return string;
}

