#ifndef TEST_MODULO1_H
#define TEST_MODULO1_H

// includo il file "modulo1.h" che contiene i possibili codici di errore delle funzioni
#include "modulo1.h"

///////////////////////////////////////////////////////////////////////////////////////////////
// Codici dei risultati delle funzioni di test
///////////////////////////////////////////////////////////////////////////////////////////////

#define TEST_PASSED	0	// il test &#65533;andato bene, la funzione si comporta come mi aspettavo
#define TEST_FAILED	1	// il test &#65533;fallito, la funzione non si comporta come mi aspettavo
#define ARG_MISSING	2	// la funzione da testare non ha questo argomento
#define NOT_VALID		3	// questo tipo di test non ha senso per questo argomento
#define NOT_IMPLEMENTED	4	// questo test per questo argomento non &#65533;stato implementato 
#define LAST_TEST		5	// (non usato) numero di codici che sono stati definiti

///////////////////////////////////////////////////////////////////////////////////////////////
// funzioni di test per controllare le funzioni di modulo1.c
///////////////////////////////////////////////////////////////////////////////////////////////

// eseguo un test sulla funzione leggiFile
int test_leggiFile(int tipo_di_test, int argomento);

// eseguo un test sulla funzione estraiHeaders
int test_estraiHeaders(int tipo_di_test, int argomento);

// eseguo un test sulla funzione primoHeader
int test_primoHeader(int tipo_di_test, int argomento);

// eseguo un test sulla funzione parseHeader
int test_parseHeader(int tipo_di_test, int argomento);

// eseguo un test sulla funzione primaParola
int test_primaParola(int tipo_di_test, int argomento);

// eseguo un test sulla funzione tokenizzaEmail
int test_tokenizzaEmail(int tipo_di_test, int argomento);

// eseguo un test sulla funzione printAllEmailTokens
int test_printTokens(int tipo_di_test, int argomento);

#endif // TEST_MODULO1_H
