/* Antonino Muratore / 1046705 */

#include <stdio.h>
#include <stdlib.h>
#include <strings.h>
#include <string.h>
#include <sys/stat.h>
#include <errno.h>

#include "modulo1.h"
#include "testModulo1.h"

///////////////////////////////////////////////////////////////////////////////////////////////
// funzioni di test per controllare le funzioni di modulo1.c
///////////////////////////////////////////////////////////////////////////////////////////////

int show_error(char *funzionetestata, int argomento, int retatteso, int ret) {
	printf("Funzione testata: %s\n", funzionetestata);
	printf("Test Scelto:      %d\n", retatteso);
	printf("Argomento:        %d\n", argomento);

	switch (ret) {
		case -3:
			printf("Il tipo di test scelto non ha senso per questo argomento\n");
			break;
		case -2:
			printf("La funzione da testare non ha questo argomento\n");
			break;
		case -1:
			printf("Test Fallito!!! Errore sconosciuto!\n");
			break;
		case 0:
			printf("\nTest completato\n"); // never displayed
			break;
		case NULL_POINTER:
			printf("Valore di ritorno: NULL_POINTER\n");
			printf("\nLa funzione non controlla se il %d argomento e' un puntatore nullo\n", argomento);
			break;
		case EMPTY_STRING:
			printf("Valore di ritorno: EMPTY_STRING\n");
			printf("\nLa funzione non controlla se il %d argomento e' una stringa vuota\n", argomento);
			break;
		case FILE_MISSING:
			printf("Valore di ritorno: FILE_MISSING\n");
			printf("\nLa funzione non controlla se il file esiste\n");
			break;
		case FILE_EMPTY:
			printf("Valore di ritorno: FILE_EMPTY\n");
			printf("\nLa funzione non controlla se il file e' vuoto\n");
			break;
		case BUFFER_TOO_SMALL:
			printf("Valore di ritorno: BUFFER_TOO_SMALL\n");
			printf("\nLa funzione non controlla la dimensione dei buffer\n");
			break;

		default:
			printf("Errore nel trattamento del codice d'errore!\n");
			break;
	}
	return abs(ret);
}

// eseguo un test sulla funzione leggiFile
int test_leggiFile(int tipo_di_test, int argomento) {
	int	ret = 0;
	char	email[16384];

	switch (argomento) {
		case 0:
			switch (tipo_di_test) {
				case NULL_POINTER:
					ret = leggiFile(NULL, 16383, email);
					break;
				case EMPTY_STRING:
					ret = leggiFile("", 16383, email);
					break;
				case FILE_MISSING:
					ret = leggiFile("/wompwomp", 16383, email);
					break;
				case FILE_EMPTY:
					ret = leggiFile("/dev/null", 16383, email);
					break;
				case BUFFER_TOO_SMALL:
					ret = leggiFile("email1.txt", 128, email);
					break;
				case RESULT_OK:
					ret = leggiFile("email1.txt", 16383, email);
					break;
				default:
					ret = -3;
					break;
			}
			if (ret != RESULT_OK) show_error("leggiFile", argomento, tipo_di_test, ret);
			break;
		case 1:
			switch (tipo_di_test) {
				case NULL_POINTER:
					ret = leggiFile("email1.txt", 0, email);
					break;
				case BUFFER_TOO_SMALL:
					ret = leggiFile("email1.txt", 128, email);
					break;
				case RESULT_OK:
					ret = leggiFile("email1.txt", 16383, email);
					break;
				default:
					ret = -3;
					break;
			}
			if (ret != RESULT_OK) show_error("leggiFile", argomento, tipo_di_test, ret);
			break;
		case 2:
			switch (tipo_di_test) {
				case NULL_POINTER:
					ret = leggiFile("email1.txt", 16384, NULL);
					break;
				case EMPTY_STRING:
					ret = leggiFile("email1.txt", 0, "");
					break;
				case RESULT_OK:
					ret = leggiFile("email1.txt", 16383, email);
					break;
				default:
					ret = -3;
					break;
			}
			if (ret != RESULT_OK) show_error("leggiFile", argomento, tipo_di_test, ret);
			break;
		default:
			return show_error("leggiFile", 3, 0, -2);
			break;
	}
	return ret;
}

// eseguo un test sulla funzione estraiHeaders
int test_estraiHeaders(int tipo_di_test, int argomento) {
	return NOT_IMPLEMENTED;
}

// eseguo un test sulla funzione primoHeader
int test_primoHeader(int tipo_di_test, int argomento) {
	return NOT_IMPLEMENTED;
}

// eseguo un test sulla funzione parseHeader
int test_parseHeader(int tipo_di_test, int argomento) {
	return NOT_IMPLEMENTED;
}

// eseguo un test sulla funzione primaParola
int test_primaParola(int tipo_di_test, int argomento) {
	return NOT_IMPLEMENTED;
}

// eseguo un test sulla funzione tokenizzaEmail
int test_tokenizzaEmail(int tipo_di_test, int argomento) {
	char	testo[16385];
	Token	tArray[1024];
	int	ret = 0;

	bzero(testo, sizeof(testo));
	leggiFile("email.txt", 16384, testo);

	switch (argomento) {
		case 0:
			switch (tipo_di_test) {
				case NULL_POINTER:
					ret = tokenizzaEmail(NULL, tArray, 16384);
					break;
				case EMPTY_STRING:
					ret = tokenizzaEmail("", tArray, 16384);
					break;
				case RESULT_OK:
					ret = tokenizzaEmail(testo, tArray, 16384);
					break;
				default:
					ret = -3;
					break;
			}
			if (ret != RESULT_OK) show_error("tokenizzaEmail", argomento, tipo_di_test, ret);
			break;
		case 1:
			switch (tipo_di_test) {
				case NULL_POINTER:
					ret = tokenizzaEmail(testo, NULL, 16384);
					break;
				case RESULT_OK:
					ret = tokenizzaEmail(testo, tArray, 16384);
					break;
				default:
					ret = -3;
					break;
			}
			if (ret != RESULT_OK) show_error("tokenizzaEmail", argomento, tipo_di_test, ret);
			break;
		case 2:
			switch (tipo_di_test) {
				case NULL_POINTER:
					ret = tokenizzaEmail(testo, tArray, 0);
					break;
				case EMPTY_STRING:
					ret = tokenizzaEmail(testo, tArray, 0);
					break;
				case BUFFER_TOO_SMALL:
					ret = tokenizzaEmail(testo, tArray, 128);
					break;
				case RESULT_OK:
					ret = tokenizzaEmail(testo, tArray, 16384);
					break;
				default:
					ret = -3;
					break;
			}
			if (ret != RESULT_OK) show_error("tokenizzaEmail", argomento, tipo_di_test, ret);
			break;
		default:
			return show_error("tokenizzaEmail", 3, 0, -2);
			break;
	}
	return ret;
}

// eseguo un test sulla funzione printAllEmailTokens
int test_printTokens(int tipo_di_test, int argomento) {
	char	testo[16385];
	Token	tArray[2048];
	int	ret = 0;

	bzero(testo, sizeof(testo));
	leggiFile("email.txt", 16384, testo);

	tokenizzaEmail(testo, tArray, 2047);

	switch (argomento) {
		case 0:
			switch (tipo_di_test) {
				case NULL_POINTER:
					ret = printTokens(NULL, 16384);
					break;
				case RESULT_OK:
					ret = printTokens(tArray, 16384);
					break;
				default:
					ret = -3;
					break;
			}
			if (ret != RESULT_OK) show_error("printTokens", argomento, tipo_di_test, ret);
			break;
		case 2:
			switch (tipo_di_test) {
				case NULL_POINTER:
					ret = printTokens(tArray, 0);
					break;
				case EMPTY_STRING:
					ret = printTokens(tArray, 0);
					break;
				case BUFFER_TOO_SMALL:
					ret = printTokens(tArray, 128);
					break;
				case RESULT_OK:
					ret = printTokens(tArray, 16384);
					break;
				default:
					ret = -3;
					break;
			}
			if (ret != RESULT_OK) show_error("printTokens", argomento, tipo_di_test, ret);
			break;
		default:
			return show_error("printTokens", 3, 0, -2);
			break;
	}
	return ret;
}
