#include<stdio.h>
#include<stdlib.h>
#include "modulo1.h"


#define ALL                   0
#define ALPHA                 1
#define NUMERIC               2
#define ALPHA_NUMERIC         3
#define SYMBOL_ALPHA_NUMERIC  4

int isAlpha(char);
int isNumeric(char);
int filter(FILE *, char*, int, int);
int isHeaders(char*, int, int, int*);
int checkDim(int, int, int*);
int isHeader(char*, int, int*);
char *removeNotValidChars(char*);   //restituisce una stringa filtrata dai caratteri non validi ad un buffer

int printTokens(Token tokenArray[], int dimT){
   int i;
   if(dimT<1) return BUFFER_TOO_SMALL;
   for(i=0; tokenArray[i].parola!=NULL && i<dimT; i++){
       if(tokenArray[i].contesto!=NULL)
         printf("%s*%s\n", tokenArray[i].contesto, tokenArray[i].parola);
       else
         printf("%s\n", tokenArray[i].parola);
   }
}

int isAlphaNumeric(char c){
   if((c>=97&&c<=122)||(c>=65 && c<=90)||(c>=48&&c<=57)) return 1;
   return 0;
}

int tokenizzaEmail(char* email, Token tokenArray[], int dimT){
   char *headersBuffer, *bodyBuffer, *valore;   //Dichiaro il pointer per il blocco headers
   int i, j, error, strOffset, maxDim;
   char *vContesto[dimT], *vParola[dimT];
   dimT--;
   
   
   maxDim = strlen(email);
   i = j = strOffset = error = 0;
   
   if(email==NULL) return NULL_POINTER;
   if(!strcmp(email, "")) return EMPTY_STRING;
   
   headersBuffer = (char*)malloc((sizeof(char) * strlen(email)) + 1);
   
   if((error = estraiHeaders(email, headersBuffer, strlen(email) + 1)) != RESULT_OK) return error;   //ritorna il tipo di errore generato e esce
   
   bodyBuffer = (char*)malloc((sizeof(char) * (strlen(email) - strlen(headersBuffer) + 3)));
   
   bodyBuffer = removeNotValidChars(&email[i+strlen(headersBuffer)+1]);
   bodyBuffer[0] = '\0';
   
   if(strlen(bodyBuffer)<2) return BODY_NOT_FOUND;
   
   i=0;
   while(headersBuffer[0]!='\0' && i<dimT){
      char *header, *tipo, *primo_header;
      
      header = tipo = valore = primo_header = NULL;
      
      
      primo_header = (char*)malloc(sizeof(char)*(512));
      tipo = (char*)malloc(sizeof(char)*128);
      valore = (char*)malloc(sizeof(char)*(512));
      
      if((error = primoHeader(headersBuffer, primo_header, 512)) !=RESULT_OK) return error;
      if((error = parseHeader(primo_header, tipo, 128, valore, 512)) !=RESULT_OK) return error;
      
      
      valore = removeNotValidChars(valore);
    
      while(valore[0]!='\0'){
         char parola[128];
         int i_dest, i_source;
         i_dest = i_source = 0;

         if(!(i<dimT)) return BUFFER_TOO_SMALL;
         if((error = primaParola(valore, parola, 128)) !=RESULT_OK) return error;
         
         tokenArray[i].contesto = (char*)malloc(sizeof(char)*128);
         tokenArray[i].parola = (char*)malloc(sizeof(char)*128);
         
         if(strlen(parola)>1){
            strcpy(tokenArray[i].contesto, tipo);
            strcpy(tokenArray[i].parola, parola);
         }else{
            i--;
         }       
         
         for(i_source = 0; valore[i_dest]!='\0'; i_source++){
            i_dest = i_source + strlen(parola) + 1;
            valore[i_source] = valore[i_dest] ;
         }valore[i_source] = '\0';  
         i++;
      }
   }//ok!
   
   //Blocco body
   
   while(bodyBuffer[0]!='\0' && i<dimT){
      char parola[128];
      int i_dest, i_source;
      i_dest = i_source = 0;
      
      if((error = primaParola(bodyBuffer, parola, 128)) !=RESULT_OK) return error;
      
      tokenArray[i].contesto = NULL;
      tokenArray[i].parola = (char*)malloc(sizeof(char)*128);
      
      if(strlen(parola)>1){
         strcpy(tokenArray[i].parola, parola);
      }else{
         i--;
      }       
      
      for(i_source = 0; bodyBuffer[i_dest]!='\0'; i_source++){
         i_dest = i_source + strlen(parola) + 1;
         bodyBuffer[i_source] = bodyBuffer[i_dest] ;
      }bodyBuffer[i_source] = '\0';
      i++;
   }
   
   tokenArray[i].parola = tokenArray[i].contesto = NULL;
      
   return RESULT_OK;
}


int isAlpha(char c){
   if(((c<'a')||(c>'z'))&&((c<'A')||(c>'Z'))) return 0;
   return 1;
}

int isNumeric(char c){
   if((c<'0')||(c>'9')) return 0;
   return 1;
}

char *removeNotValidChars(char* sourceBuff){
   char* buff;
   int i, j, wCounter;   
   wCounter = i = j = 0;
   
   buff = (char*)malloc((strlen(sourceBuff)*sizeof(char))+1);

   for(i=0; sourceBuff[i]!='\0'; i++){
      if(isAlphaNumeric(sourceBuff[i])){
         buff[j] = sourceBuff[i];
         j++;
         wCounter++;
      }else{
         if(!isAlphaNumeric(sourceBuff[i]) && buff[j-1] == ' '){
            wCounter=0;
         }else if(!isAlphaNumeric(sourceBuff[i]) && buff[j-1] != ' '){
            if(wCounter<2 && j>2){
               j = (j-2);
            }
            buff[j] = ' ';
            j++;
            wCounter=0;
         }else{
            wCounter=0;
         }
      }
   }
   buff[++j] = '\0'; 
   if (buff[0]==' ') return buff + 1;
   return buff;
}

int primaParola(char* testo, char *parola, int dim){
   int i_source, i_dest, i;
   dim--;
   i_source = i_dest = 0;

   if(testo==NULL) return NULL_POINTER;
   if(!strcmp(testo, "")) return EMPTY_STRING;
   if(parola==NULL) return NULL_POINTER;
   if(dim<=0) return BUFFER_TOO_SMALL;
   
   testo = removeNotValidChars(testo); 
   
   for(i=0; testo[i]!=' ' && testo[i]!='\0'; i++){
      if(i>=dim) return BUFFER_TOO_SMALL;
      parola[i] = testo[i]; 
   }
   parola[i]='\0';
   
   return RESULT_OK;
}


int parseHeader(char* header, char* tipo, int dimt, char* valore, int dimv){
   int i, valoreOffset = 0;
   dimt--;
   dimv--;
   
   if(header==NULL) return NULL_POINTER;
   if(!strcmp(header, "")) return EMPTY_STRING;
   if(tipo==NULL) return NULL_POINTER;
   if(dimt<=0) return BUFFER_TOO_SMALL;
   if(valore==NULL) return NULL_POINTER;
   if(dimv<=0) return BUFFER_TOO_SMALL;
  
   for(i=0; (header[i] !=' ' && header[i] !='\t' && header[i] !='\n')  && i<dimt ; i++){ //Estraggo il primo header
      tipo[i] = header[i];
   }
   tipo[i] = '\0';
   if(strlen(tipo)<2) return BAD_HEADER;
   
   valoreOffset = strlen(tipo) + 1;  //mi calcola lo spostamento del valore rispetto al tipo nel vettore header
 
   for(i = 0; (header[i + valoreOffset] !='\0')  && i<dimv ; i++){ //Estraggo il primo header
      valore[i] = header[i + valoreOffset];
   }
   valore[i] = '\0';
   if(strlen(valore)<2) return BAD_HEADER;
   return RESULT_OK;

}

int checkFile(char *filename){
   if(!strcmp(filename, "")) return EMPTY_STRING;
   if(access(filename,0)!=0) return FILE_MISSING;  //Controllo se il file esiste 0
   if(access(filename,4)!=0) return FILE_UNREADABLE;  //Controllo se il file  leggibile
   return RESULT_OK;
}

int leggiFile(char *nomefile, int dimensione, char *testo){
   FILE *fpSource = NULL;   
   int error = 0;
   
   if((error = checkFile(nomefile)) != RESULT_OK){
      return error;
   }
   
   
   if(testo==NULL) return NULL_POINTER;
   //Controllo se testo  inizializzato
   
   if(dimensione<1) return BUFFER_TOO_SMALL;
   
   //Controllo se il file esiste
   
   
   //provo ad aprire il file    ********** errore nell'allocazione del file --- Chiedere al prof    !!!!!!
   if((fpSource = fopen(nomefile, "r")) == NULL){
      return MEM_ALLOC_ERROR;
   }
   
   //leggo il file e lo bufferizzo controllando che il file non sia vuoto
   if(filter(fpSource, testo, dimensione, ALL)<1){
      return FILE_EMPTY;
   }
   fclose(fpSource);
   
   return RESULT_OK;
}



int primoHeader(char* headers, char* primo_header, int dim){
   int i, error, i_source, i_dest;
   dim--;
   error = 0;
   
   i_source = i_dest = 0;
   
   if(headers==NULL) return NULL_POINTER;
   if(!strcmp(headers, "")) return EMPTY_STRING;
   if(dim<3) return BUFFER_TOO_SMALL;
   
   for(i=0; isHeader(headers, i, &error); i++){
      if(i>dim) return BUFFER_TOO_SMALL;
      primo_header[i] = headers[i]; 
   }
   primo_header[i] = '\0';
   
   for(i_source = 0; headers[i_dest]!='\0'; i_source++){
      i_dest = i_source + strlen(primo_header) + 1;
      headers[i_source] = headers[i_dest] ;
   }
   headers[i_source] = '\0';
   
   return error;

}

int isHeader(char* h, int i, int* error){
   if(h[i]=='\n'){
      if((h[i+1]=='\t') ||(h[i+1]==' ')){
         return 1;   
      }else{
         return 0;
      }  
   }
   return 1;
}

int filter(FILE *fp, char* buffer, int dim, int mode){
   char tmpChar;
   int i;
   dim--;
   i=0;
   while((tmpChar = fgetc(fp))!=EOF && i<dim){
      switch(mode){
         case ALL:
            buffer[i] = tmpChar;
            i++;
            break;
         case ALPHA:
            if(isalpha(tmpChar) || tmpChar=='\n'){
               buffer[i] = tmpChar;
               i++;
            }
            break;
         case NUMERIC:
            if(isdigit(tmpChar) || tmpChar=='\n'){ 
               buffer[i] = tmpChar;
               i++;
            }
            break;
         case ALPHA_NUMERIC:
            if(isAlpha(tmpChar) || isNumeric(tmpChar) || tmpChar=='\n' || tmpChar=='\t' || tmpChar==' '){
               if(isAlpha(tmpChar) || isNumeric(tmpChar)){
                  buffer[i] = tmpChar;
                  i++;
               }else if(buffer[i-1]==' ' && (tmpChar=='\n' || tmpChar=='\t' || tmpChar==' ')){
                  ;
               }else{
                  buffer[i] = ' ';
                  i++;
               }
            }
            break;
         case SYMBOL_ALPHA_NUMERIC:
            if(isalnum(tmpChar) || (!isblank(tmpChar))){
               buffer[i] = tmpChar;
               i++;
            }
            break;
      }
         
   }
   buffer[i] = '\0';
   return i;
}

int isHeaders(char* e, int i, int max,  int *error){
   
   if(i>=2 && !(e[i-2]=='\t' || e[i-2]==' ') && e[i-1]=='\n' && e[i]=='\n'){
      return 1;
   }else if(i<2 && (e[0]=='\t' || e[0]==' ' || e[0]=='\n')){
      *error = BAD_HEADER;
      return 0;
   }else if(i>max || max<3){
      *error = BUFFER_TOO_SMALL;
      return 1;
   }else{
      return 0;
   }
   
}

int estraiHeaders(char* email, char* headers, int dimh){
   char tmpChar;
   int i=0;
   int error = 0;
   dimh--;

   if(email==NULL) return NULL_POINTER;
   if(!strcmp(email, "")) return EMPTY_STRING;
   if(headers==NULL) return NULL_POINTER;

   for(i=0; i<strlen(email) && (!isHeaders(email, i, dimh, &error)); i++){
      if(i<dimh) headers[i] = email[i];
   }
   headers[i] = '\0';
   
   return error;
}

