int test_leggiFile(int tipo_di_test, int n_argomento){
	char *nomefile = "email.txt";;
	char *testo;
	int dimensione = 500;
	int risultato;
	if(tipo_di_test >= 0 && tipo_di_test <= 12){				
		if(tipo_di_test == RESULT_OK){
			if(n_argomento >= 0 && n_argomento <= 2){
				if(n_argomento == 0 || n_argomento == 1 || n_argomento == 2){
					testo = malloc(sizeof(char)*dimensione);
					risultato = leggiFile(nomefile, dimensione, testo);
					if(risultato == RESULT_OK){
						return TEST_PASSED;
					}
					else{
						printf("Test Fallito: Funzione testata:   leggiFile(nomefile, dimensione, testo)\n");
						printf("              Risultato atteso:   RESULT_OK\n");
						printf("              Risultato ottenuto:   %d\n", risultato);
						printf("              Spiegazione:   La funzione leggiFile nonostante riceva parametri ottimali per la sua esecuzione riscontra un errore.\n");
						return TEST_FAILED;
					}
				}
			}
		}
		if(tipo_di_test == UNKNOWN_ERROR){
			return NOT_IMPLEMENTED;
		}
		if(tipo_di_test == NULL_POINTER){				
			if(n_argomento >= 0 && n_argomento <= 2){	
				if(n_argomento == 0){	
					dimensione = 500;
					testo = malloc(sizeof(char)*dimensione);
					nomefile = NULL;
					risultato = leggiFile(NULL, dimensione, testo);
					if(risultato == NULL_POINTER){		
						return TEST_PASSED;			
					}
					else{
						printf("Test Fallito: Funzione testata:   leggiFile(NULL, dimensione, testo)\n");
						printf("              Risultato atteso:   NULL_POINTER\n");
						printf("              Risultato ottenuto:   %d\n", risultato);
						printf("              Spiegazione:   La funzione leggiFile non controlla se il primo argomento è un puntatore nullo.\n");
						return TEST_FAILED;
					}
				}
			
		
		if(tipo_di_test == NULL_POINTER && n_argomento == 1){
			return NOT_VALID;
		}
		if(tipo_di_test == NULL_POINTER && n_argomento == 2){
			risultato = leggiFile(nomefile, dimensione, NULL);
			if(risultato == NULL_POINTER){
				return TEST_PASSED;
			}
			else{
				printf("Test Fallito: Funzione testata:   leggiFile(nomefile, dimensione, NULL)\n");
				printf("              Risultato atteso:   NULL_POINTER\n");
				printf("              Risultato ottenuto:   %d\n", risultato);
				printf("              Spiegazione:   La funzione leggiFile non controlla se il terzo argomento è un puntatore nullo.\n");
				return TEST_FAILED;
			}
		}
		}
		else{
			return ARG_MISSING;
		}
		if(tipo_di_test == EMPTY_STRING){			
			if(n_argomento >= 0 && n_argomento <= 2){
				if(n_argomento == 0){				
					risultato = leggiFile('\0', dimensione, testo);
					if(risultato == EMPTY_STRING){
						return TEST_PASSED;
					}
					else{
						printf("Test Fallito: Funzione testata:   leggiFile(nomefile, dimensione, NULL)\n");
						printf("              Risultato atteso:   EMPTY_STRING\n");
						printf("              Risultato ottenuto:   %d\n", risultato);
						printf("              Spiegazione:   La funzione leggiFile non controlla se il primo argomento è una stringa vuota.\n");
						return TEST_FAILED;
					}
				}
				if(n_argomento == 1){
					return NOT_VALID;
				}
				if(n_argomento == 2){
					return NOT_VALID;
				}
			}
			else{
				return ARG_MISSING;
			}
		}
		if(tipo_di_test == FILE_MISSING){
			if(n_argomento >= 0 && n_argomento <= 2){
				if(n_argomento == 0){
					risultato = leggiFile("File-missing", dimensione, testo);
					if(risultato == FILE_MISSING){
						return TEST_PASSED;
					}
					else{
						printf("Test Fallito: Funzione testata:   leggiFile(prova.pro, dimensione, testo)\n");
						printf("              Risultato atteso:   FILE_MISSING\n");
						printf("              Risultato ottenuto:   %d\n", risultato);
						printf("              Spiegazione:   La funzione leggiFile non controlla se il file da elaborare esiste.\n");
						return TEST_FAILED;
					}
				}
				if(n_argomento == 1){
					return NOT_VALID;
				}
				if(n_argomento == 2){
					return NOT_VALID;
				}
			}
			else{
				return ARG_MISSING;
			}
		}
		if(tipo_di_test == FILE_UNREADABLE){
			if(n_argomento = 0){
				risultato = leggiFile("File-unreadable", dimensione, testo);
				if(risultato == FILE_UNREADABLE){
					return TEST_PASSED;
				}
				else{
					printf("Test Fallito: Funzione testata:   leggiFile(prova.pro, dimensione, testo)\n");
					printf("              Risultato atteso:   FILE_UNREADABLE\n");
					printf("              Risultato ottenuto:   %d\n", risultato);
					printf("              Spiegazione:   La funzione leggiFile non controlla se il file da elaborare e' leggibile.\n");
					return TEST_FAILED;
				}
			}
			else{
				return NOT_VALID;
			}
		}
		if(tipo_di_test == FILE_UNWRITABLE){
			return NOT_IMPLEMENTED;
		}
		if(tipo_di_test == FILE_EMPTY){
			if(n_argomento == 0){
				risultato = leggiFile("File-empty", dimensione, testo);
				if(risultato == FILE_EMPTY){
					return TEST_PASSED;
				}
				else{
					printf("Test Fallito: Funzione testata:   leggiFile(prova.pro, dimensione, testo)\n");
					printf("              Risultato atteso:   FILE_EMPTY\n");
					printf("              Risultato ottenuto:   %d\n", risultato);
					printf("              Spiegazione:   La funzione leggiFile non controlla se il file da elaborare e' vuoto.\n");
					return TEST_FAILED;
				}
			}
			else{
				return NOT_VALID;
			}
		}
		if(tipo_di_test == BUFFER_TOO_SMALL){
			if(n_argomento >= 0 && n_argomento <= 2){
				if(n_argomento == 0){
					return NOT_VALID;
				}
				if(n_argomento == 1){
					risultato = leggiFile(nomefile, 3, testo);
					if(risultato == BUFFER_TOO_SMALL){
						return TEST_PASSED;
					}
					else{
						printf("Test Fallito: Funzione testata:   leggiFile(nomefile, 3, testo)\n");
						printf("              Risultato atteso:   BUFFER_TOO_SMALL\n");
						printf("              Risultato ottenuto:   %d\n", risultato);
						printf("              Spiegazione:   La funzione leggiFile non controlla se il Buffer passato è sufficente a contenere tutti i dati.\n");
						return TEST_FAILED;
					}
				}
				if(n_argomento == 2){
					return NOT_VALID;
				}
			}
			else{
				return ARG_MISSING;
			}
		}
		if(tipo_di_test == HEADER_NOT_FOUND){
			return NOT_VALID;
		}
		if(tipo_di_test == BODY_NOT_FOUND){
			return NOT_VALID;
		}
		if(tipo_di_test == BAD_HEADER){
			return NOT_VALID;
		}
		if(tipo_di_test == MEM_ALLOC_ERROR){
			return NOT_IMPLEMENTED;
		}
	}
	else{
		return ARG_MISSING;
	}
}
}

int test_estraiHeaders(int tipo_di_test, int n_argomento){
	char *email;
	char *headers;
	int dimh;
	int risultato;
	if(tipo_di_test >= 0 && tipo_di_test <= 12){
		if(n_argomento >= 0 && n_argomento <= 2){
			if(tipo_di_test == RESULT_OK){
				if(n_argomento == 0 || n_argomento == 1 || n_argomento == 2){
					risultato = estraiHeaders(email, headers, dimh);
					if(risultato == RESULT_OK){
						return TEST_PASSED;
					}
					else{
						printf("Test Fallito: Funzione testata:   estraiHeaders(email, headers, dimh)\n");
						printf("              Risultato atteso:   RESULT_OK\n");
						printf("              Risultato ottenuto:   %d\n", risultato);
						printf("              Spiegazione:   La funzione estraiHeaders nonostante riceva parametri ottimali per la sua esecuzione riscontra un errore.\n");
						return TEST_FAILED;
					}
				}
			}
			if(tipo_di_test == UNKNOWN_ERROR){
				return NOT_IMPLEMENTED;
			}
			if(tipo_di_test == NULL_POINTER){
				if(n_argomento == 0){
					risultato = estraiHeaders(NULL, headers, dimh);
					if(risultato == NULL_POINTER){
						return TEST_PASSED;
					}
					else{
						printf("Test Fallito: Funzione testata:   estraiHeaders(NULL, headers, dimh)\n");
						printf("              Risultato atteso:   NULL_POINTER\n");
						printf("              Risultato ottenuto:   %d\n", risultato);
						printf("              Spiegazione:   La funzione estraiHeaders non controlla se il primo argomento è un puntatore nullo.\n");
						return TEST_FAILED;
					}
				}
				if(n_argomento == 1){
					risultato = estraiHeaders(email, NULL, dimh);
					if(risultato == NULL_POINTER){
						return TEST_PASSED;
					}
					else{
						printf("Test Fallito: Funzione testata:   estraiHeaders(email, NULL, dimh)\n");
						printf("              Risultato atteso:   NULL_POINTER\n");
						printf("              Risultato ottenuto:   %d\n", risultato);
						printf("              Spiegazione:   La funzione estraiHeaders non controlla se il secondo argomento è un puntatore nullo.\n");
						return TEST_FAILED;
					}
				}
				if(n_argomento == 2){
					return NOT_VALID;
				}
			}
			if(tipo_di_test == EMPTY_STRING){
				if(n_argomento == 0){
					risultato = estraiHeaders('\0', headers, dimh);
					if(risultato == EMPTY_STRING){
						return TEST_PASSED;
					}
					else{
						printf("Test Fallito: Funzione testata:   estraiHeaders('\0', headers, dimh)\n");
						printf("              Risultato atteso:   EMPTY_STRING\n");
						printf("              Risultato ottenuto:   %d\n", risultato);
						printf("              Spiegazione:   La funzione estraiHeaders non controlla se il primo argomento è una stringa vuota.\n");
						return TEST_FAILED;
					}
				}
				if(n_argomento == 1){
					risultato = estraiHeaders(email, '\0', dimh);
					if(risultato == EMPTY_STRING){
						return TEST_PASSED;
					}
					else{
						printf("Test Fallito: Funzione testata:   estraiHeaders(email, '\0', dimh)\n");
						printf("              Risultato atteso:   EMPTY_STRING\n");
						printf("              Risultato ottenuto:   %d\n", risultato);
						printf("              Spiegazione:   La funzione estraiHeaders non controlla se il secondo argomento è una stringa vuota.\n");
						return TEST_FAILED;
					}
				}
				if(n_argomento == 2){
					return NOT_VALID;
				}
			}
		}
		else{
			return ARG_MISSING;
		}
	}
}


