#include <stdio.h>
#include <sys/stat.h>
#include <string.h>
#include <stdlib.h>
#include <modulo1.h>

/*

#define RESULT_OK		0	// la funzione ha avuto successo
#define UNKNOWN_ERROR		1	// errore sconosciuto
#define NULL_POINTER		2	// uno degli argomenti della funzione era NULL
#define EMPTY_STRING		3	// uno degli argomenti era una stringa vuota
#define FILE_MISSING		4	// il file non esiste
#define FILE_UNREADABLE		5	// il file non  leggibile
#define FILE_UNWRITABLE		6	// il file non  scrivibile
#define FILE_EMPTY		7	// il file  vuoto
#define BUFFER_TOO_SMALL	8	// il blocco di memoria (o vettore) passato non  sufficiente a contenere i dati
#define HEADER_NOT_FOUND	9	// lo header del messaggio non esiste
#define BODY_NOT_FOUND		10	// il corpo del messaggio non esiste
#define BAD_HEADER		11	// una riga degli headers non segue la sintassi giusta
#define MEM_ALLOC_ERROR		12	// non si  potuto allocare un blocco di memoria
#define LAST_CODE		13	// (da non usare) numero di codici di errore definiti


typedef struct a_token {
    char *parola;
    char *contesto;
}Token;


int leggiFile(char *, int, char *);
int estraiHeaders(char *, char *, int);
int primoHeader(char *, char *, int);
int parseHeader(char *, char *, int, char *, int);
int primaParola(char *, char *, int);
int tokenizzaEmail(char *, Token *, int);
int printTokens(Token *, int);
*/

int leggiFile(char *nomefile, int dimensione, char *testo)
{
    int i; FILE *in;char a; struct stat stbuf;

    if (nomefile == NULL) return (2);
    if (nomefile[0] == '\0') return (3);
    if (stat(nomefile, &stbuf) != 0) return (4); //trova le informazioni della e-mail
    dimensione = (stbuf.st_size);        //memorizza la dimensione in una variabile

    if ((stbuf.st_mode) < 33000) return (5);  //se il file non  apribile in lettura

    if ((in = (fopen(nomefile, "r"))) == NULL) return (4);  //se non apre il file

    if ((a = getc(in)) == '\0')     //se il file  vuoto
        {
                return(7);	//torna errore
        }

    for (i = 0; i < dimensione; i++)    //cicla finch non  finito il file
    {
        if (a == EOF)     //se finisce il file prima di
        {                                     //arrivare a dimensione si mette il
                *(testo+i) = '\0';            //carattere di fine stringa e si
                fclose(in);                   //che  tutto ok
                return(0);
        }

        else *(testo+i) = a;                //altrimenti si copia il carattere
	a = getc(in);
    }
    *(testo+i) = '\0';         //mette il marcatore di chiusura a fine buffer
    return(0);               //torna il valore di funzione andata a buon fine
}


int estraiHeaders(char *email, char *headers, int dimh)
{
    int i = 0; int cont = 0;

    if (email == NULL) return (2);  //se non c' il testo della e-mail torna errore
    if (email[0] == ' ') return (11);
    if (email[0] == '\0') return (3);    //se la e-mail era vuota torna errore
    if ((email[0] == '\r') || (email[0] == '\n')) return (9);  //se non c' header
                                                              //torna errore
    while ((email[i] != '\0') && (i < dimh) && (cont == 0))   //finch non finisce la stringa o
    {                                          //si raggiunge dimh
	*(headers+i) = email[i];    //copia il carattere dell'header in headers[i]
        i++;

        if ((email[i] == '\r') || (email[i] == '\n'))  //se  finito l'header
                if ((email[i+1] == '\r') || (email[i+1] == '\n')) cont = 1; //esce
                                                                  //dal ciclo
    }

    *(headers+i) = '\0';   //si mette il carattere di fine stringa
    if (dimh <= i) return (8);   //se dimh era troppo piccolo torna errore
    return (0);    //altrimenti torna che  tutto andato a buon fine
}


int primoHeader(char *headers, char *primo_header, int dim)
{
    int cont = 0, esc = 0, i = 0;

    if (headers == NULL) return(2);
    if (headers[0] == '\0') return (3);

    while ((esc == 0) && (i < dim)) //finch non c' un errore o si supera la
    {                               //dimensione del buffer
	if ((cont == 0) && ((headers[i] == (' ')) || (headers[i] == '\t')))
        {                        //se la e-mail inizia con uno spazio o un tab
                esc = 11;        //segnala errore ed esci dal ciclo
        }

        else                //riga 59
        {
                if (cont == 0)        //se  il primo carattere della e-mail
                {
                                cont = 1;   //segnala che  stato trovato
                                *(primo_header+i) = headers[i]; //e copialo
                }

                else if ((headers[i] == '\r') || (headers[i] == '\n'))  //se torna a capo
                {
                                if ((headers[i+1] == '\r') || (headers[i+1] == '\n'))
                                {   //se non ci sono pi headers esce
                                          esc = 1;
                                }

                                else if ((headers[i+1] != (' ')) && (headers[i+1] != '\t'))
                                {   //se inizia un nuovo header esce
                                         esc = 1;
                                }

                                else
                                {
                                       primo_header[i] = headers[i];  //se l'header continua
                                }                   //nel rigo successivo continua a copiare
                }

                else if (headers[i] == '\0')
                {                //se finisce l'header esce
                                esc = 1;
                }

                else
                {                //se nessuno dei precedenti if continua a copiare
                                primo_header[i] = headers[i];
                }

                i++;                //incrementa il contatore
        }
    }
    if (i >= dim)         //se  uscito perch il buffer era troppo piccolo
    {                     //torna errore
        return (8);
    }

    else if (esc != 1)    //se  uscito per un qualsiasi altro errore torna l'errore
    {
        return (esc);
    }

    else                //se  uscito perch l'header  finito metti il carattere
    {                   //di fine header e torna che  andato tutto bene
        i--;
        primo_header[i] = '\0';
        return (0);
    }
}


int parseHeader(char *header, char *tipo, int dimt, char *valore, int dimv)
{
    int i = 0, cont = 0; int j = 0;

    if (header == NULL) return(2);
    while ((cont == 0) && (i < dimt))   //finch non  finito il contesto o finisce
    {                                   //il buffer

        if ((header[i] == (' ')) || (header[i] == ':') || (header[i] == '\0'))  //se  finito il
        {                                                     //contesto
                tipo[i] = header[i];        //lo copia in 'tipo'
                tipo[i+1] = '\0';           //mette il carattere di fine stringa
                cont = 1;                //avverte che  finito il contesto
        }

        else                             //altrimenti
        {
                *(tipo+i) = header[i];            //copia il contesto in 'tipo'
                i++;                            //incrementta il contatore
        }
    }

    if (i >= dimt) return (8);   //se il buffer  troppo piccolo torna errore

    if (header[i] == '\0')    //se c' solo il contesto memorizza che non c'
    {                         //valore e torna che  andato tutto bene
        valore[j] = '\0';
        return (0);
    }

    i++;        //incrementa il contatore solo se  presente anche la parola

    if (header[i] == '\0')    //se non c' neanche un elemento dopo il contesto
    {                         //memorizza l'assenza delle parole e torna ok
        valore[j] = '\0';
        return (0);
    }

    while ((header[i] != '\0') && (i < dimv))  //finch non finisce l'header o
    {                                          //il buffer
        valore[j] = header[i];    //copia il valore in 'valore'
        i++;                      //incrementa il contatore
        j++;
    }
    if (i >= dimv) return (8);     //se il buffer era troppo piccolo torna errore

    valore[j] = '\0';    //altrimenti mette il carattere di fine stringa
    return(0);            //e torna che  andato tutto ok
}


int primaParola(char *testo, char *parola, int dim)
{
    int i = 0, j = 0;

    if (testo == NULL) return(2);
    if (testo[0] == '\0') return(3);
    while ((isalnum(testo[i]) == 0) && (i < dim) && (testo[i] != '\0'))
    {    //finch non trovo una lettera od un numero vai avanti
        i++;
    }
    if (i >= dim)    return (8);    //se il buffer  troppo piccolo torna errore
    while ((isalnum(testo[i]) != 0) && (i < dim) && (testo[i] != '\0'))
    {                            //finch ci sono lettere o numeri
        parola[j] = testo[i];    //le copia in 'parola' e incrementa i contatori
        j++;
        i++;
    }

    if (i >= dim) return (8);       //se il buffer  troppo piccolo torna errore

    parola[j] = '\0';               //altrimenti mette il carattere di fine stringa
    return (0);                     //e torna che  andato tutto bene
}


int printTokens(Token tokenArray[], int dimT)
{
    int i;

    if (tokenArray == NULL) return(2);
    for (i = 0; i < dimT; i++)  //finch non sono finiti i tokens
    {
        if ((tokenArray[i].contesto) != NULL)    //se  una parola dell'header
        {
		printf("%s*", tokenArray[i].contesto); //stampa il contesto e l'*
        }

        if ((tokenArray[i].parola) != NULL) //se c' una parola
        {
		printf("%s\n", tokenArray[i].parola);  //stampa la parola e vai a capo
        }

        else printf("\n");  //se c' solo il contesto vai semplicemente a capo
    }

    return (0);  //torna che  andato tutto bene
}


int tokenizzaEmail(char *email, Token tokenArray[], int dimT)
{
    char headtot[500], primoh[100], word[50]; int cont, dimens, dimh = 1;
    int dim =1, dimt2 = 1, dimv = 1, tot = 0, dim2 = 1, tot2 = 0, tok = 0;
    char type[20]; char value[500];
    struct stat stbuf;
    int i = 0;
    Token prova;

    if (email == NULL) return(2);
    if (email[0] == '\0') return (3);
    tokenArray = (Token *)malloc(sizeof(Token)*dimT);  //alloco tokenArray

    do
    {                                    //incrementa le dimensioni del buffer
	if (cont == 8)  dimh = dimh + 1; //se  troppo piccolo
        cont = estraiHeaders(email, headtot, dimh); //estrae gli headers
    } while (cont == 8);        //cicla finch il buffer non  giusto

    if (cont != 0)    //se c' stato un errore torna l'errore
    {
        return (cont);
    }

    while (headtot[tot] != '\0')        //finch non finiscono gli headers
    {
	do        //fa questo finch 'riga 205'
        {                                    //incrementa le dimensioni del
                if (cont != 0) dim = dim +1; //buffer se  troppo piccolo
                cont = primoHeader(&headtot[tot], primoh, dim); //estrae il 1 header
        } while (cont == 8);                //il buffer non  giusto

        if (cont != 0)        //se c' stato un errore torna l'errore
        {
                return (cont);
        }

        dim--;                  //dato che dim  pi grande di 1, sottrailo
        tot = tot + dim;        //memorizza la dimensione di questo header
	if (headtot[tot-1] == '\0') tot--;
        dim = 1;                //reinizializza la variabile 'dim'

        do        //faa questo finch 'riga 225'
        {        //incrementa le dimensioni dei buffer se sono troppo piccoli
                if (cont != 0)
                {
                                dimt2 = dimt2 + 1;
                                dimv = dimv + 1;
                }

                cont = parseHeader(primoh, type, dimt2, value, dimv); //divide l'header
        } while (cont == 8);    //i buffer non sono giusti
        
        if (cont != 0)        //se c' stato un errore torna l'errore
        {
                return (cont);
        }

        dimt2 = 1;                //reinizializza le dimensioni dei buffer
        dimv = 1;
        
        i = 0;
        
        if (value[i] == '\0')        //se c' solo il contesto
        {
                prova.contesto = (char *)malloc(sizeof(char) *(strlen(type)+1));
                (void)strcpy((prova.contesto), type);  //copia il contesto
                prova.parola = NULL;                //mette parola a NULL
                tokenArray[tok] = prova;            //attacca tokenArray a prova
                tok++;                //incrementa il contatore dei tokens
        }

        while (value[i] != '\0')  //finch non sono finite le parole del contesto
        {                         //in esame
        do        //fa questo finch 'riga 242'
        {         //se il buffer  piccolo lo aumenta finch non riesce a
                if (cont != 0) dim2 = dim2 + 1; //copiare la prima
                cont = primaParola(&value[i], word, dim2); //parola
        } while (cont == 8);  //il buffer non  giusto

        if (cont != 0)        //se c' stato un errore torna l'errore
        {
                return (cont);
        }
                
        if (tok > dimT)   //se ci sono pi tokens del previsto torna errore
        {
                return (8);
        }

        prova.contesto = (char *)malloc(sizeof(char) *(strlen(type)+1));
        prova.parola = (char *)malloc(sizeof(char) *(strlen(word)+1));

        (void)strcpy((prova.contesto), type);  //copia il contesto
        (void)strcpy((prova.parola), word);    //copia la parola
        tokenArray[tok] = prova;               //attacca tokenArray a prova

        dim2--;               //dato che dim2  pi grande di 1, sottrailo
        i = i + dim2;         //memorizza la posizione attuale della nuova parola
        tok++;                //incrementa il numero del token
        dim2 = 1;             //reinizializza la dimensione del buffer
        }
    }

    tot++;        //incrementa la posizione in 'email' superando gli headers
    dim2 = 1;     //reinizializza 'dim2'

    if ((email[tot-1] == '\0') || (email[tot] == '\0')) return (10);
    while ((tot < dimens) && (email[tot] != '\0'))
    {
        do    //fa questo finch 'riga 265'
        {     //se il buffer  piccolo lo aumenta finch non riesce a copiare la
                if (cont != 0) dim2 = dim2 + 1;  //prima parola
                cont = primaParola(&email[tot], word, dim2);
        } while (cont == 8);                //il buffer non  giusto

        if (cont != 0)        //se c' stato un errore torna l'errore
        {
                return (cont);
        }

        if (tok > dimT)   //se i tokens sono pi del preventivato torna errore
        {
                return (8);
        }
        
        prova.contesto = (char *)malloc(sizeof(char) *(strlen(type)+1));
        prova.parola = (char *)malloc(sizeof(char) *(strlen(word)+1));

        prova.contesto = NULL;  //copia il contesto
        (void)strcpy((prova.parola), word);
        tokenArray[tok] = prova; //copia la parola
        dim2--;        //dato che dim2  pi grande di 1, sottrailo
        tot = tot + dim2;       //incrementa la posizione in 'corpo'
        dim2 = 1;    //reinizializza 'dim2'
        tok++;       //incrementa il numero dei token 
        tot = tot + dim2;       //incrementa la posizione in 'corpo'
    }

    dimT = tok;
    cont = printTokens(tokenArray, dimT);        //stampo i tokens
    if (cont != 0)        //se c' stato un errore torna l'errore
    {
                return (cont);
    }
    
    return (0);                //torno che  andato tutto a buon fine
}
