#ifndef MODULO1_C
#define MODULO1_C
#include<stdio.h>
#include<stdlib.h>
#include<string.h>
#include "modulo1.h"

/*__________________________________________________________________________________________*/
// funzione che copia da un file i primi 'dimensione' caratteri nel blocco di memoria 'testo'
// e mette nella variabile 'dimensione' il numero di caratteri letti
int leggiFile(char * nomefile, int dimensione, char * testo)
{
 int i=0;
 FILE *ifp;

 //CONTROLLO ERRORI
   //Controllo che il puntatore al 'nomefile' non punti a NULL
   if(nomefile==NULL)
      return(2);
   //Controllo che il puntatore alla zona di memoria 'testo' non punti a NULL
   if(testo==NULL)
      return(2);
   //Controllo che la variabile intera 'dimensione' non sia <= a zero
   if(dimensione<=0)
      return(8);
 // FINE CONTROLLO ERRORI

 // Copiatura del file nella zona di memoria testo fino a dimensione-1 caratteri
    //apertura file in lettura
    ifp = fopen(nomefile, "r");
    //condizione sufficiente per copiare dim-1 caratteri
    for(i=0;(i<dimensione-1)&&((*(testo+i)=getc(ifp))!= EOF);i++);
    //si termina il contenuto copiato con il carattere '\0'
    *(testo+i)='\0';
    //chiusura file
    fclose(ifp);
 // Fine

 //ritorna zero se tutto  andato bene
 return 0;
}

/*____________________________________________________________________________*/

// Funzione che individua le intestazioni della email e le copia
// nel blocco di memoria 'headers' di lunghezza 'dimh'
int estraiHeaders(char * email, char * headers, int dimh)
{
 int i,j;

 //CONTROLLO ERRORI
   if(email==NULL)
      return(2);
   if(headers==NULL)
      return(2);
   if(*(email+0)==' ')
      return(9);
   if(dimh<=0)
      return(8);
 //FINE CONTROLLO ERRORI

 //Copiatura del blocco intestazioni nella stringa headers
 for(i=0,j=0;j<1;j++)
    {
     //condizione di fine header
     for(;*(email+i)!='\n';i++)
        {
         //Controllo se la dimensione  sufficiente per contenere gli headers
         if(dimh-1<i)
            return(8);
         //copio il carattere i-esimo
         *(headers+i)=*(email+i);
        }
     //condizione di fine headers
     if(*(email+(i+1))!='\n')
       {
        *(headers+i)='\n';
        i++;
        j--;
       }
     //termine per la stringa headers
     *(headers+i)='\0';
    }
 //Fine

 /*
   // Controlla se headers  stato copiato correttamente;
   printf ("headers:\n%s\n\n",headers);
   scanf("%d",&i);
 */

 return(0);
}
/*_______________________________________________________________________________*/

// funzione che estrae il primo header dagli headers e lo copia in primo_header
int primoHeader(char * headers, char * primo_header, int dim)
{
 int i;

 //CONTROLLO ERRORI
   if (headers==NULL)
       return(2);
   if(primo_header==NULL)
      return(2);
   if(dim<=0)
      return(8);
 //FINE CONTROLLO ERRORI

 //Copiatura del primo header nella stringa primo_header
 for(i=0;*(headers+i)!='\n';i++)
    {
     //Controllo se la dimensione  sufficiente per contenere lo header
     if(dim-1<i)
        return(8);
     //copio il carattere i-esimo
     *(primo_header+i)=*(headers+i);
     if(*(headers+i+1)=='\n')
     {
      if(*(headers+i+2)==32||*(headers+i+2)==9)
      {
       i=i+1;
       *(primo_header+i)=*(headers+i);
      }
     }
    }
     //termine per la stringa primo_header
     *(primo_header+i)='\0';
  /*
   printf("\ni:%d\n",i);
   // Controlla se lo header  stato copiato correttamente
   printf ("primo_header:\n%s\n\n",primo_header);
  */
 //Fine

 return(0);
}
/*_______________________________________________________________________________*/

// funzione che estrae il tipo ed il valore di uno header
int parseHeader(char * header, char * tipo, int dimt, char * valore, int dimv)
{
 int i,j;

 //CONTROLLO ERRORI
   if (header==NULL)
       return(2);
   if(tipo==NULL)
      return(2);
   if(valore==NULL)
      return(2);
   if(dimt<=0)
      return(8);
   if(dimv<=0)
      return(8);
 //FINE CONTROLLO ERRORI

 //Copio il tipo dello header nella stringa tipo
 for(i=0;*(header+i)!=' ';i++)
    {
     //Controllo se la dimensione  sufficiente per contenere il tipo
     if(dimt-1<i)
        return(8);
     //copio il carattere i-esimo
     *(tipo+i)=*(header+i);
    }
     //termine per la stringa tipo
     *(tipo+i)='\0';
 //fine
 i=i+1;

 //Copio il valore dello header nella stringa valore
 for(j=0;*(header+i)!='\0';i++,j++)
    {
     //Controllo se la dimensione  sufficiente per contenere il valore
     if(dimv-1<j)
        return(8);
     //copio il carattere i-esimo nella posizione j-esima
     *(valore+j)=*(header+i);
    }
     //termine per la stringa valore
     *(valore+j)='\0';
 //fine


  /*
   //Controlla se il tipo e il valore sono stati copiati correttamente
   printf ("tipo: %s\nvalore: %s\n\n",tipo,valore);
   scanf("%d",&i);
  */

 return(0);
}
/*_______________________________________________________________________________*/

// funzione che estrae la prima parola da una stringa
int primaParola(char * testo, char * parola, int dimp)
{
 int i,j,dev;
 //CONTROLLO ERRORI
   if (testo==NULL)
       return(2);
   if(parola==NULL)
      return(2);
   if(dimp<=0)
      return(8);
 //FINE CONTROLLO ERRORI

 dev=0;
 //Copio nella stringa parola la prima parola del testo
 j=0;
 for(i=0;*(testo+i)!='\0';i++)
    {
     if(dimp-1<i)
        return(8);
     if((*(testo+i)>=48 && *(testo+i)<=58)||(*(testo+i)>=65 && *(testo+i)<=90)||(*(testo+i)>=97 && *(testo+i)<=122))
     {
      if (dev==2)
          break;
      else
          {
           dev=1;
           *(parola+j) = *(testo+i);
           j++;
          }
     }
     else if(dev==1)
            {
             *(parola+j) = '\0';
             dev=2;
            }

    }
 /*
 printf("\nparola: %s\n",parola);
 scanf("%d",&i);
 */
 return(0);
}
/*_______________________________________________________________________________*/

// funzione che estrae i primi dimT token dalla email
int tokenizzaEmail(char * email, Token tokenArray[], int dimT)
{
 int n,i,j,k,h,l,y;

 //variabili prima funzione
   char * testo;
 //variabili seconda funzione(email=testo  preso dal risultato della prima funzione)
   int dimh=500;
   //int dimh=0;
   char*headers;
 //variabili terza funzione(headers  preso dal risultato della seconda funzione)
   int dim=500;
   //int dim=0;
   char*primo_header;
 //variabili quarta funzione(header=primo_header  preso dal risultato della terza funzione)
   char * header;
   char * tipo;
   char * valore;
   int dimt=500;
   //int dim=0;
   int dimv=500;
   //int dim=0;
 //variabili quinta funzione(testo  preso dal risultato della prima funzione)
   char * parola;
 // fine


 //CONTROLLO ERRORI
   if (email==NULL)
       return(2);
   if(dimT<=0)
      return(8);
 //FINE CONTROLLO ERRORI

 //CARICO LE INTESTAZIONI NEL tokenArray
   headers = (char*)malloc(dimh*sizeof(char));
   n = estraiHeaders(email, headers, dimh);
   l = strlen(headers);
   email=(email+l+1);
   y=0;
   for(i=0;*(headers+i)!='\0';i++)
   {
    primo_header = (char*)malloc(dim*sizeof(char));
    n = primoHeader(headers, primo_header, dim);
    l=strlen(primo_header);
    headers=(headers+l+1);
    tipo = (char*)malloc(dimt*sizeof(char));
    valore = (char*)malloc(dimv*sizeof(char));
    n = parseHeader(primo_header, tipo, dimt, valore, dimv);
    //printf("primo_header: %s\n",primo_header);
    for(j=0;*(valore+j)!='\0';j++)
    {
     //alloco memoria per la parola grande dim caratteri(da vedere)
     parola = (char*)malloc(dim*sizeof(char));
     //chiamo la funzione che trova la prima parola del valore
     n = primaParola(valore+j, parola, dim);
     //controllo errori da fare
     //CARICO L'ARRAY;
     tokenArray[y].parola=(char*)malloc(strlen(parola)+1);
     tokenArray[y].contesto=(char*)malloc(strlen(tipo)+1);
     strcpy(tokenArray[y].parola,parola);
     strcpy(tokenArray[y].contesto,tipo);
     //printf("Parola:%s\nContesto: %s\n",tokenArray[y].parola,tokenArray[y].contesto);
     //scanf("%d",&n);
     y=y+1;
     //Controllo se sono sufficienti le dimensioni del vettore tokenArray
     if(dimT-1<y)
       return (8);
     k=0;
     for(h=0;*(valore+j)!='\0';h++,j++)
     {
      if(*(valore+j)==*(parola+h))
        {
         if(*(parola+h+1)=='\0')
             k=1;
        }
      else
          {
           if(k==1)
              {
               if((*(valore+j)>=48 && *(valore+j)<=58)||(*(valore+j)>=65 && *(valore+j)<=90)
                   ||(*(valore+j)>=97 && *(valore+j)<=122))
                 {
                  j--;
                  free(parola);
                  break;
                 }
              }
           else h--;
          }//else
     }//for
    }//for
   }//for
   free(headers);
   free(primo_header);
   free(tipo);
   free(valore);
   free(parola);

  if(*(email+i+1)=='\0')
     return(10);
 //CARICO IL CORPO NEL tokenArray
   for(i=0;*(email+i+1)!='\0';i++)
    {
     // alloco memoria per la parola grande dim caratteri(da vedere)
     parola = (char*)malloc(dim*sizeof(char));
     //chiamo la funzione che trova la prima parola
     n = primaParola(email+i, parola, dim);
     //controllo errori da fare
//CARICO L'ARRAY;
     tokenArray[y].parola=(char*)malloc(strlen(parola)+1);
     tokenArray[y].contesto=NULL;
     strcpy(tokenArray[y].parola,parola);
     //printf("Parola:%s\nContesto: %s\n",tokenArray[y].parola,tokenArray[y].contesto);
     //scanf("%d",&n);
     y=y+1;
     k=0;
     for(h=0;*(email+i)!='\0';h++,i++)
     {
      if(*(email+i)==*(parola+h))
        {
         if(*(parola+h+1)=='\0')
             k=1;
        }
      else
          {
           if(k==1)
              {
               if((*(email+i)>=48 && *(email+i)<=58)||(*(email+i)>=65 && *(email+i)<=90)
                   ||(*(email+i)>=97 && *(email+i)<=122))
                 {
                  i--;
                  free(parola);
                  break;
                 }
              }
           else h--;
          }//else
     }//for
    }//for
 free(parola);
 return(0);
}
/*______________________________________________________________________________*/

// funzione che stampa i token uno per riga nel formato 'contesto*parola' oppure 'parola'
int printTokens(Token tokenArray[], int dimT)
{
 int n,i;

 //CONTROLLO ERRORI
   if(tokenArray[0].parola==NULL)
     return(2);
   if(tokenArray[0].contesto==NULL)
      return(2);
   if(dimT<=0)
      return(8);
 //FINE CONTROLLO ERRORI


 for(i=0;tokenArray[i].parola!=NULL;i++)
    {
     if(dimT-1<i)
        return(8);
     if(tokenArray[i].contesto==NULL)
        printf("%s\n",tokenArray[i].parola);
     else
         printf("%s*%s\n",tokenArray[i].contesto,tokenArray[i].parola);
    }
 return(0);
}

#endif
