#include <stdio.h>
#include <stdlib.h>
#include <ctype.h>
#include <strings.h>
#include "modulo1.h"			//per i codici di errore e definizioni delle funzioni
#include <sys/stat.h>			//stat

// funzione che copia da un file i primi 'dimensione' caratteri nel blocco di memoria 'testo'
// e mette nella variabile 'dimensione' il numero di caratteri letti
int leggiFile(char* nomefile,int dimensione, char*testo){
	int fd=0;						//file descriptor	
	FILE *fp;						//file pointer
	struct stat buf;				//struttura di tipo stat per la stat
	int controllo_stat=0;			//variabile di controllo
	int n=0;						//numero di caratteri letti dalla fread
	int dim_char=1;				//dimensione di un char in byte	
	int dim_testo=0;				//dimensione del testo	
		
		//CONTROLLO DEGLI ARGOMENTI PASSATI
		if(nomefile==NULL)
			return(NULL_POINTER);		//argomento NULL passato alla funzione 
		if(dimensione<3)
			return(BUFFER_TOO_SMALL);	//vettore nn sufficiente a contenere i dati	
		if(testo==NULL)
			return(NULL_POINTER);		//argomento NULL passato alla funzione 
		
		//CONTROLLO SUL FILE PASSATO

		controllo_stat=stat(nomefile,&buf);
			if(controllo_stat==-1)
				return(FILE_MISSING);				//il file nn esiste
			else if(buf.st_mode & S_IRUSR){			//puo essere letto
					fp=fopen(nomefile,"r");			//apro il file in lettura
						if(fp==NULL)				//di nuovo un controllo forse inutile
							return(FILE_MISSING);	//il file nn esiste
				}else  
					return(FILE_UNREADABLE);			//file nn leggibile
	
		//LEGGO E COPIO CARATTERI NEL VETTORE TESTO
		dimensione=dimensione-1;	
		n=fread(testo,dim_char,dimensione,fp);			//copio n-1 caratteri
		if(n==0)
			return(FILE_EMPTY);					//file vuoto
		if(n<0)
			return(UNKNOWN_ERROR);				//errore sconosciuto

		testo[dimensione+1]='\0';			//n-esimo elemento di fine stringa
		fclose(fp);

	return(RESULT_OK);					//la funzione nn riporta errori

}// end leggiFile


// funzione che individua gli headers e li copia nel vettore headers di dimensione (dimh)
int estraiHeaders(char * email, char * headers, int dimh){
	int i=0; 					//variabile con cui scorro il vettore email
	int dim_email=0;		
			//CONTROLLO DEGLI ARGOMENTI PASSATI
			
			if(email==NULL)
				return(NULL_POINTER);
			if(email[i]=='\0')							//stringa vuota
				return(EMPTY_STRING);
			if((email[0]=='\n')&&(email[1]=='\n'))			//se i primi due elementi sono \n nn ci sono header
				return(HEADER_NOT_FOUND);
			if(headers==NULL)
				return(NULL_POINTER);
			if(dimh<3)
				return(BUFFER_TOO_SMALL);
			


		dim_email=strlen(email);					//grandezza della email	
											
			while((email[i]!='\n')||(email[i+1]!='\n')){			//se trovo i due '\n' esco
				if(i+2>dimh-1)								//se no la metti fuori dal while
					return(BUFFER_TOO_SMALL);	
				if(i==dim_email)
					return(HEADER_NOT_FOUND);
			i++;
			}//while	
		i=i+1;
		strncpy(headers,email,i);
	
		headers[i]='\0';					//i-1  \n
		
		return(RESULT_OK);		
}//end estraiHeaders


// funzione che estrae il primo header dagli headers e lo copia in primo_header
int primoHeader(char * headers, char * primo_header, int dim){
	int i=0;		
	int controllo=0;							
					
						
								//CONTROLLO ARGOMENTI
				
				if(headers==NULL)
					return(NULL_POINTER);		//argomento NULL passato alla funzione 
				if(headers[0]=='\0')
					return(EMPTY_STRING);		//stringa vuota 
				if((headers[0]==' ')||(headers[0]=='\t')||(headers[1]==' '))	//devo aggiungere anche il tab? o no ?
					return(HEADER_NOT_FOUND);			//l'header nn segue la sintassi giusta
				if(primo_header==NULL)
					return(NULL_POINTER);		//argomento NULL passato alla funzione 
				if(dim<3)
					return(BUFFER_TOO_SMALL);	//vettore nn sufficiente a contenere i dati	
				
					
											//CONTROLLO				
					
				while(controllo==0){	
					while(headers[i]!='\n'){
						if(headers[i+1]=='\0'){
							return(HEADER_NOT_FOUND);
						}
					i++;
					
					}//while
				
					if((headers[i+1]!=' ')&&(headers[i+1]!='\t')){
						controllo=1;			//quindi esce
					}else{
						controllo=0;
						i++;			//incremento solo se rimango nel ciclo
					}	
				}//while
				
				
				
				if(i>dim-1)
					return(BUFFER_TOO_SMALL);
				if(i<2)
					return(HEADER_NOT_FOUND);
				
				strncpy(primo_header,headers,i);
				primo_header[i]='\0';				//la stringa primo_header nn contiene caratteri \n
				
				return(RESULT_OK); 

			}//end primoHeader


// funzione che estrae il tipo ed il valore di uno header
int parseHeader(char * header, char * tipo, int dimt, char * valore, int dimv){

	int i=0;			//variabile di controllo per il testo
	int y=0;			//variabile di controllo per il valore	
	int x=0;
	int head=0;
								//CONTROLLO SUGLI ARGOMENTI PASSATI
				
				if(header==NULL)
					return(NULL_POINTER);
				if(header[0]=='\0')
					return(EMPTY_STRING);
				if((header[0]==' ')||(header[1]==' '))
					return(BAD_HEADER);
				if(tipo==NULL)
					return(NULL_POINTER);
				if(dimt<3)
					return(BUFFER_TOO_SMALL);	
				if(valore==NULL)	
					return(NULL_POINTER);
				if(dimv<3)	
					return(BUFFER_TOO_SMALL);	
					
										//CONTROLLO
					
					
				while((header[i]!=' ')&&(header[i]!='\t')){				//fino a quando nn trovo uno spazio(' ' o \t
					if(header[i+1]=='\0')				//se arrivi a fine stringa senza aver trovato uno spazio
						return(BAD_HEADER);
				i++;
				}//while testo
				
				if(i>dimt-1)
					return(BUFFER_TOO_SMALL);
								
				strncpy(tipo,header,i);	
				tipo[i]='\0';
				
				i++;
				head=i;
				while(header[i]!='\0'){

				i++;	
				y++;
				}//while valore	
			
				if(y<2)
						return(BAD_HEADER);	
				
				if(y>dimv-1)
						return(BUFFER_TOO_SMALL);
				
				for(x=0;x<=y;x++){
					valore[x]=header[head];
					head++;
				}
				
				
				
			
				valore[x]='\0';			
				
				return(RESULT_OK);	
										
}//end parseHeader


// funzione che estrae la prima parola da una stringa
int primaParola(char * testo, char * parola, int dim){
	int i=0;
	int controllo=0;	
	int var_controllo=0;						
	int dim_parola=0;
	int y=0;			//variabile per la stringa "parola"		
										//CONTROLLO ARGOMENTI
					
					if(testo==NULL)
						return(NULL_POINTER);
					if(testo[0]=='\0')
						return(EMPTY_STRING);
					if(parola==NULL)
						return(NULL_POINTER);
					if(dim<3)
						return(BUFFER_TOO_SMALL);
			
							//CONTROLLO

		while((controllo==0)&&(testo[i]!='\0')){	//continuo il ciclo fino a quando la variabile di controllo  = a 0
				
			
		
			if((isdigit(testo[i])!=0)||(isalpha(testo[i])!=0)){	//vedo se il carattere  alfanumerico
				if((testo[i]!='')&&(testo[i]!='')&&(testo[i]!='')&&(testo[i]!='')&&(testo[i]!='')&&(testo[i]!='')){
					
					if(y>dim-1)
						return(BUFFER_TOO_SMALL);
					parola[y]=testo[i];	//copio il carattere in parola
					var_controllo=1;	//ho incominciato una parola
					
					y++;				//aggiorno il contatore
					controllo=0;		//e continuo il ciclo
					
				}
			}//nn  un carattere alfanumerico
			else{  parola[y]='\0';			//ultimo carattere
			
					if(strlen(parola)<2)
						y=0;
						
					if(strlen(parola)>=2)	
						controllo=1;
			
			}
			
			i++;
		}//while	
		
		
		//parola[y]='\0';			//ultimo carattere
	if(strlen(parola)<=0)
		return(UNKNOWN_ERROR);		
		
	return(RESULT_OK);
}//end primaParola


// funzione che estrae i primi dimT token dalla email
int tokenizzaEmail(char * email, Token tokenArray[], int dimT){

								//DICHIARAZIONE DI VARIABILI
				
				int dim_email=0;
				int dimh=0;
				char*headers;
				int val_1=0;
				int val_2=0;		
				int dim_headers=0;
				int dim=0;
				char*primo_header;		
				int dim_primo_header=0;		
				int dimt=0;
				int dimv=0;
				char*tipo;
				char*valore;				
				int val_3=0;				
				int dim_tipo=0;
				int dim_valore=0;				
				char*parola1;		//rappresenta il tipo(contesto)
				int dim1=0;		//dimensione max per il contesto
				int val_4=0;
				int dim2=0;		//dimensione max per il valore
				char*parola2;		//rappresenta il valore(parola)
				int i=0;
				int y=0;	
				int controllo=0;		
				int TEST=0;
				int CONTROLLO_TOKEN=0;
				int dim_parola2=0;		
				char*body;	
				int dim_body=0;
				int DIM_headers=0;	
				int DIM_BODY=0;
				int dim_contesto;
				int dim_parola;				
								//CONTROLLO ARGOMENTI PASSATI ALLA FUZIONE
				
				if(email==NULL)
					return(NULL_POINTER);
				if(email[0]=='\0')
					return(EMPTY_STRING);
				if(tokenArray==NULL)
					return(NULL_POINTER);
				if(dimT<1)
					return(BUFFER_TOO_SMALL);

					
					
									//CONTROLLO	
				
				dim_email=strlen(email);		//in modo che sono sicuro che posso copiare al piu tutto
				dimh=dim_email+1;			//mi aveva dato un errore
				
					
				headers=(char*)malloc(sizeof(char)*dimh);	
					if(headers==NULL)	
						return(MEM_ALLOC_ERROR);
				
				val_1=estraiHeaders(email,headers,dimh);	
					if(val_1!=0)						//ovvero se la estraiHeaders trova un quache errore
						return(val_1);
						
				
				dim_headers=strlen(headers);		//dimensione headers
										
				DIM_headers=dim_headers;		

											
				dim=dim_headers+1;			//dim_headers +1 e so dove parte il body della email
				
				
				
								//MI TROVO NEL BLOCCO HEADERS		
										
	//	while(headers[dim_primo_header]!='\0'){				
		while(dim_headers>0){					//puoi usare tutti e due i modi
				
				primo_header=(char*)malloc(sizeof(char)*dim);
					if(primo_header==NULL)
						return(MEM_ALLOC_ERROR);
					
				val_2=primoHeader(headers,primo_header,dim);
					if(val_2!=0)			
						return(val_2);		//c stato un errore
						
				dim_primo_header=strlen(primo_header);		//calcolo la lunghezza del header		
						
				dimt=dim_primo_header+1;				//dimensione massima per il tipo
				dimv=dim_primo_header+1;				//dimensione massima per il valore
						
				tipo=(char*)malloc(sizeof(char)*dimt);
					if(tipo==NULL)
						return(MEM_ALLOC_ERROR);
				valore=(char*)malloc(sizeof(char)*dimv);		
					if(valore==NULL)
						return(MEM_ALLOC_ERROR);
						
				val_3=parseHeader(primo_header,tipo,dimt,valore,dimv);
					if(val_3!=0)
						return(val_3);
				
				dim_tipo=strlen(tipo);			//dimensione reale del tipo
				dim_valore=strlen(valore);		//dimensione reale del valore
						
									//TROVIAMO IL VALORE
				dim2=dim_valore+1;			//dimensione massima per la parola
										//devo controllare tutta la stringa valore	
	//------------------------------------------------------------------------------------------------------------				
				
				parola2=(char*)malloc(sizeof(char)*dim2);
					if(parola2==NULL)
						return(MEM_ALLOC_ERROR);
				
		
		while(valore[i]!='\0'){
			
			if((isdigit(valore[i])!=0)||(isalpha(valore[i])!=0)){	//vedo se il carattere  alfanumerico
				if((valore[i]!='')&&(valore[i]!='')&&(valore[i]!='')&&(valore[i]!='')&&(valore[i]!='')&&(valore[i]!='')){
					parola2[y]=valore[i];	//copio il carattere in parola
					TEST=1;
					
					y++;				//aggiorno il contatore
					
					
				}
			}//nn  un carattere alfanumerico
			else{		if(TEST==1){
								parola2[y]='\0';
								dim_parola2=strlen(parola2);
								
							if(dim_parola2>=2){	
								tokenArray->parola=(char*)malloc(sizeof(char)*dim_parola2+1);
									if(tokenArray->parola==NULL)
										return(MEM_ALLOC_ERROR);	
								
								strcpy(tokenArray->parola,parola2);
								dim_parola=strlen(tokenArray->parola);
								tokenArray->parola[dim_parola]='\0';
								tokenArray->contesto=(char*)malloc(sizeof(char)*dim_tipo+1);
									if(tokenArray->contesto==NULL)
									return(MEM_ALLOC_ERROR);								
				
								strcpy(tokenArray->contesto,parola1);
								dim_contesto=strlen(tokenArray->contesto);
								tokenArray->contesto[dim_contesto]='\0';
								//printf("%s*%s\n",tokenArray->contesto,tokenArray->parola);
								y=0;
								tokenArray++;
								CONTROLLO_TOKEN++;
							}else{
							parola2[0]='\0';
							y=0;
			}
			}
			}//else
				
				if(valore[i+1]=='\0'){
					parola2[y]='\0';
					dim_parola2=strlen(parola2);	
						
			if(dim_parola2>=2){				
				tokenArray->parola=(char*)malloc(sizeof(char)*dim_parola2+1);
									if(tokenArray->parola==NULL)
										return(MEM_ALLOC_ERROR);			
				strcpy(tokenArray->parola,parola2);
				dim_parola=strlen(tokenArray->parola);
				tokenArray->parola[dim_parola]='\0';
				
				tokenArray->contesto=(char*)malloc(sizeof(char)*dim_tipo+1);
							if(tokenArray->contesto==NULL)
								return(MEM_ALLOC_ERROR);								
				
				strcpy(tokenArray->contesto,parola1);
				dim_contesto=strlen(tokenArray->contesto);
				
				tokenArray->contesto[dim_contesto]='\0';
				y=0;
				//printf("%s*%s\n",tokenArray->contesto,tokenArray->parola);
				tokenArray++;		
				CONTROLLO_TOKEN++;		
			}else{
							parola2[0]='\0';
							y=0;
			}
			
			
			}
			
			if(CONTROLLO_TOKEN>dimT-1)
				return(BUFFER_TOO_SMALL);
			
			i++;											
		}	//while 										
													
										
		
			i=0;	
				
			
			dim_headers=dim_headers-(dim_primo_header+1);	
			headers=headers+(dim_primo_header+1);											
		}//while headers					
		
		tokenArray->parola=NULL;
		tokenArray->contesto=NULL;
		
		
										//body
//---------------------------------------------------------------									
			
			
			email=email+(DIM_headers+1);			//sposto il puntatore al body
			i=0;
			y=0;
			TEST=0;		
			dim_body=dim_email-dim_headers;
			
			if(dim_body<2)
				return(BODY_NOT_FOUND);
			
			
			body=(char*)malloc(sizeof(char)*dim_body+1);
					if(body==NULL)
						return(MEM_ALLOC_ERROR);
			
					
			while(email[i]!='\0'){
			
			if((isdigit(email[i])!=0)||(isalpha(email[i])!=0)){	//vedo se il carattere  alfanumerico
				if((email[i]!='')&&(email[i]!='')&&(email[i]!='')&&(email[i]!='')&&(email[i]!='')&&(email[i]!='')){
					body[y]=email[i];	//copio il carattere in parola
					TEST=1;
					
					y++;				//aggiorno il contatore
					
					
				}
			}//nn  un carattere alfanumerico
			else{		if(TEST==1){
								body[y]='\0';
								
								y=0;
										
								DIM_BODY=strlen(body);
							if(DIM_BODY>=2){
								tokenArray->parola=(char*)malloc(sizeof(char)*DIM_BODY+1);
									if(tokenArray->parola==NULL)
										return(MEM_ALLOC_ERROR);	
								strcpy(tokenArray->parola,body);
								
								tokenArray->contesto=NULL;
								//printf("%s*%s\n",tokenArray->contesto,tokenArray->parola);
							}else{
							body[0]='\0';	
							y=0;
			}
			}
			}//else
				
				if(email[i+1]=='\0'){
					body[y]='\0';
						
						y=0;
						
				DIM_BODY=strlen(body);
					if(DIM_BODY>=2){			
					tokenArray->parola=(char*)malloc(sizeof(char)*DIM_BODY+1);
						if(tokenArray->parola==NULL)
							return(MEM_ALLOC_ERROR);	
					strcpy(tokenArray->parola,body);		
				tokenArray->contesto=NULL;
				//printf("%s*%s\n",tokenArray->contesto,tokenArray->parola);
				}else{		
				body[0]='\0';		
				y=0;
			
			}
			}
			
			i++;											
		}	//while 					
							
							
						
						
		return(RESULT_OK);							
						
						
						
						
}//end tokenizza email



int printTokens(Token tokenArray[], int dimT){

	int var=0;	

		if(tokenArray==NULL)
			return(NULL_POINTER);
		if(dimT<1)
			return(BUFFER_TOO_SMALL);
		if((tokenArray->parola=='\0')&&(tokenArray->contesto=='\0'))
			return(EMPTY_STRING);

			
		while(tokenArray->contesto!=NULL){
			
			if(var>dimT-1)
				return(BUFFER_TOO_SMALL);
			
			if(tokenArray->parola==NULL)
				return(UNKNOWN_ERROR);
		
			printf("%s*%s\n",tokenArray->contesto,tokenArray->parola);
			tokenArray++;
			var++;
					
		}
			
		while(tokenArray->parola!=NULL){
		
			if(var>dimT-1)
				return(BUFFER_TOO_SMALL);
			printf("%s\n",tokenArray->parola);
			tokenArray++;
			var++;
		
		}	
			
	return(RESULT_OK);

}//end printTokens 


