//#define INOUT

#define FILE1 "file_tmp_1"	//per scrivere i caratteri saltati
#define FILE2 "file_tmp_2"	//per scrivere la dimenzione del token

/*Per "vivere" :p */
#include<stdio.h>
#include<stdlib.h>

/*Per le funz a basso livello*/
#include<sys/types.h>
#include<sys/stat.h>
#include<fcntl.h>

/*Per gli errori*/
#include<string.h>
#include<errno.h>

/*Per errori, prototipi &tc.*/
#include"modulo1.h"

#define DIM_EMAIL 4096
#define DIM_HEADERS 512
#define DIM_PRIMOHEADER 64
#define DIM_PAROLA 32

#define TOK_VET_DIM 1024

int car_alfa(char);
int sposta_fino_a_str(char* orig, char*);
void stampa(char*);

void scrivi_car_non_val(int val);
int leggi_car_non_val(void);

void scrivi_dim_token(int);
int leggi_dim_token(void);



int main(int argc, char *argv[])
{
char email[DIM_EMAIL];
Token tokvett[TOK_VET_DIM];
int leggi_file, tokenizza_mail, stampa_token;
int tokdim;
//chiamo la funzione
leggi_file=leggiFile(argv[1], DIM_EMAIL, email);


//se  stampo l'output
#ifdef INOUT
if(leggi_file == 0)
	printf("Lettura file Ok\n");
else
	printf("Errore %d", leggi_file);
#endif


//chiamo la funzione
tokenizza_mail=tokenizzaEmail(email,tokvett, TOK_VET_DIM);


//se  stampo l'output
#ifdef INOUT
if(tokenizza_mail == 0)
	printf("Lettura file Ok\n");
else
	printf("Valore di ritorno = %d\n", tokenizza_mail);
#endif


//chiamo la funzione
tokdim=leggi_dim_token();
stampa_token=printTokens(tokvett, tokdim);


//se  stampo l'output
#ifdef INOUT
if(stampa_token == 0)
	printf("Scrittura Tokens Ok\n");
else
	printf("Valore di ritorno = %d\n", tokenizza_mail);
#endif


//da gestire - per ora stampo sempre 0...
return 0;
}

int leggiFile(char *nomefile, int dimensione, char *testo)
{
int fdescr;
int letti;


/*Controllo errore su buffern & nomefile*/
if ((testo == NULL) || (nomefile == NULL))
	return NULL_POINTER;
if (dimensione < 1)
	return BUFFER_TOO_SMALL;
/*Se sono qui gli argomenti passati sono ok...*/


//apro il file
fdescr=open(nomefile, O_RDONLY);


/*Ne gestisco l'errore*/
if (fdescr == -1)
	{
	switch(errno)
		{
		case EACCES:
			return FILE_UNREADABLE;

		case ENOENT:
			 return FILE_MISSING;

		default:
			 return UNKNOWN_ERROR;
		}
	}

/*Altrimenti di errori non ce ne sono*/


/*Leggo la Mail fino a Dimensione*/
letti=read(fdescr, testo, dimensione);
//in realt leggo fino a letti


/*gestisco eventuale errore*/
if ((letti == dimensione) || (letti == (dimensione-1)))
	return BUFFER_TOO_SMALL;
if (letti == -1)
	return UNKNOWN_ERROR;
if((letti == 1) || (letti == 0))
	return FILE_EMPTY;
/*dannati errori*/


//metto il carattere di fine stringa
*(testo+letti)='\0';


//se sono qui tutto  andato ok!
return RESULT_OK;
}



int estraiHeaders(char* email, char*headers, int dimh)
{
char car_pri, car_act;
int i;

/*Controllo errore su buffer & nomefile*/
if ((email == NULL) || (headers == NULL))
	return NULL_POINTER;
if (dimh < 1)
	return BUFFER_TOO_SMALL;
if (email[0] == '\n') return HEADER_NOT_FOUND;
/*Se sono qui gli argomenti passati sono ok...*/


headers[0]=email[0];
//primo carattere copiato! :p


/*temporan stampo anche questo*/
//printf("-%c-\n", headers[0]);


/*per un carattere alla volta*/
for(i=1;i<dimh;i++)
	{


	//ne salvo il precedente per gestire l'header a pi righe
	car_pri=email[i-1];
	car_act=email[i];

		
	/*se ho due accapi consecutivi => fine headers*/
	if((car_pri=='\n') && (car_act == '\n'))
		{
		headers[i]='\0';
		return RESULT_OK;
		}
	
		
	/*altrimenti copio il carattere su heders*/
	headers[i]=car_act;


/*temporaneamente lo stampo*/
//	printf("-%c-\n", car_act);
	}
	
/*se sono qui il buffer  finito e non ho trovato doppi accapi consecutivi*/
return BUFFER_TOO_SMALL;
}


int primoHeader(char* headers, char* primo_header, int dim)
{
int spazio=0, i;
char car_pri, car_act;


/*lo usavo per controllare l'headers fosse effettivamente quello atteso*/
/*
printf("<<<");
stampa(headers);
printf(">>>");
*/


/*Controllo errore su buffern & nomefile*/
if ((headers == NULL) || (primo_header == NULL))
	return NULL_POINTER;
if (dim < 1)
	return BUFFER_TOO_SMALL;
if (headers[0] == '\0')
	return HEADER_NOT_FOUND;
/*se sono qui gli argomenti passati sono Ok...*/


/*copio il primo carattere*/
primo_header[0]=headers[0];


/*se qualcosa non va puo' essere utile stamparlo*/
//printf("-%c-", primo_header[0]);


/*Se inizia con uno spazio l'header non  valido*/
if(primo_header[0] == ' ')
	return BAD_HEADER;


for(i=1;i<dim;i++)
	{
	car_pri=headers[i-1];
	car_act=headers[i];

	primo_header[i]=car_act;

	if(car_pri == '\n' && (!((car_act == '\t') || (car_act == ' '))))
		{
		primo_header[i-1]='\0';
		return RESULT_OK;
		}

/*	if (car_act == ' ')
		{
		if (spazio ==0)
			{
			spazio=1;
			}
		else
			{
			return BAD_HEADER;
			}
		}
	mistero degli spazi...
*/


/*Di controllo - ma ora dovrebbe essere tutto ok DOVREBBE*/
//	printf("%c-", car_act);
	}

/*Se sono qui il buffer non  bastato :p*/
return BUFFER_TOO_SMALL;
}


int parseHeader(char* header, char* tipo, int dimt, char *valore, int dimv)
{
int i;


/*Soliti controlli...*/
if ((header == NULL) || (tipo == NULL) || (valore ==NULL))
	return NULL_POINTER;
if ((dimt < 1) || (dimv < 1))
	return BUFFER_TOO_SMALL;
/*noiosi... ma essenziali*/


/*leggi fino al primo spazio e copia*/
for(i=0;tipo[i] != ' ';i++)
	{
	tipo[i]=header[i];

/*per controllare ERR puo' essere utile stamparlo*/
//	printf("%c", tipo[i]);


/*e se supero le dimn*/
	if(i >= dimt-1) return BUFFER_TOO_SMALL;
	}


//chiudo la stringa
tipo[i]='\0';



for(i=0;valore[i] != '\0';i++)
	{
	valore[i]=header[i];
/*per controlli puo' essere utile stamparlo*/
//	printf("%c", valore[i]);
	if(i >= dimv-1) return BUFFER_TOO_SMALL;
	}

//chiudo la stringa
valore[i]='\0';


return RESULT_OK;
}



int primaParola(char* testo, char* parola, int dim)
{
int i=0, j=0, lavorato=0, nnval=0;
char car;

/*controlli...*/
if ((testo == NULL) || (parola == NULL))
	return NULL_POINTER;
if (dim < 1)
	return BUFFER_TOO_SMALL;
/*i soliti!!!!*/


while(1)
	{
	/*Ogni volta controllo se il buffer  finito*/
	if (j >= dim-1)
		return BUFFER_TOO_SMALL;


	/*salvo il car e incremento*/
	car=testo[i];
	i++;

	/*se  alfanumerico*/
	if(car_alfa(car))
		{
		parola[j]=car;
		j++;
		lavorato=1;
		}

	/*altrimenti se non lo ...*/
	else
		{
		nnval++;

		/*se ho gi lavorato basta non andare avanti*/
		if(lavorato==1)
			{
			parola[j]='\0';
			scrivi_car_non_val(nnval);
			return RESULT_OK;
			}
		}
	}
}


/*No Comment*/
int car_alfa(char car)
{
if(((car >= 48) && (car <=57)) || ((car >=65) && (car <=90)) || ((car >= 97) && (car <= 122)))
	return 1;
return 0;
}


/*No Comment*/
void stampa(char *str)
{
while(*str != '\0')
	{
	printf("%c", *str);
	str++;
	}
}


/*No Comment*/
int leggi_car_non_val()
{
int val;
FILE *fp=fopen(FILE1, "r");
fscanf(fp, "%d", &val);

fclose(fp);
return val;
}


/*No Comment*/
void scrivi_car_non_val(int val)
{
FILE *fp=fopen(FILE1, "w");

fprintf(fp, "%d", val);
fclose(fp);
}


/*No Comment*/
int leggi_dim_token()
{
int val;
FILE *fp=fopen(FILE2, "r");
fscanf(fp, "%d", &val);

fclose(fp);
return val;
}


/*No Comment*/
void scrivi_dim_token(int val)
{
FILE *fp=fopen(FILE2, "w");

fprintf(fp, "%d", val);
fclose(fp);
}



int tokenizzaEmail(char* email, Token tokenArray[], int dimT)
/*LA IGNORANTE CHE GESTISCE TUTTO*/
{
char headers[DIM_HEADERS];
char primo_header[DIM_PRIMOHEADER];
char parola[DIM_PAROLA];

int i, letti;
int indtok;
int htemp, hlen, btemp;
int ttt, carNNval;

char *contes;
char *par;
int count_tok=0;


/* Headers estratti & scritti in headers*/
ttt=estraiHeaders(email, headers, DIM_HEADERS);


/*
GESTIONE HEADERS SINGOLI
*/
hlen=strlen(headers);
for(i=0,letti=0;letti < hlen;i++)
	{
	ttt=primoHeader(&headers[letti], primo_header, DIM_PRIMOHEADER);

/*incremento la lunghezza letta del singolo header*/
	letti+=strlen(primo_header)+1;


/*SCRIVO I TOKEN PER L'HEADER - mi creo la var contesto*/
contes=(char*)malloc(sizeof(char)*DIM_PAROLA);

if(contes ==NULL)
	return MEM_ALLOC_ERROR;


/*Non uso la primaParola perch mi prenderebbe solo la prima parola...*/

i=0;
while(primo_header[i] != ' ')
	{
	contes[i]=primo_header[i];
	i++;
	}
contes[i]='\0';
/*Fine lettura*/


/*Singolo header sistemato ora lo devo tokenizzare...*/

htemp=strlen(contes);
for(indtok=0;htemp<strlen(primo_header);indtok++,count_tok++)
	{
	/*mi creo lo spazio per la PAROLA*/
	par=(char*)malloc(sizeof(char)*DIM_PAROLA);
	if(par ==NULL)
		return MEM_ALLOC_ERROR;

	/*vi scrivo dentro la parola*/
	primaParola(&primo_header[htemp], par, DIM_PAROLA);

	/*incremento il contatore dello spazio scritto*/
	carNNval=leggi_car_non_val();
	htemp+=strlen(par)+carNNval;

	/*lo scrivo finalmente sul token*/
	tokenArray[count_tok].contesto=contes;
	tokenArray[count_tok].parola=par;

	//scorro al successivo


/*Per sicurezza posso stamparlo*/
#ifdef INOUT
	printf("%d - %s\t\tHeadPtr %d - cNNval %d - StrLen %d\n",count_tok, tokenArray[count_tok].parola, htemp, carNNval, strlen(par));
#endif
	}
}
/*TOKEN HEADERS SCRITTO*/

/*
FINE GESTIONE HEADERS - INIZIO BODY
*/

btemp=1;
while(!((email[btemp] == '\n' )&&(email[btemp-1]=='\n')))
	btemp++;


for(i=0;btemp < strlen(email)-1;i++)
	{

	/*alloco nuovamente per ogni token nuovo spazio per la parola*/
	par=(char*)malloc(sizeof(char)*DIM_PAROLA);
	if(par ==NULL)
		return MEM_ALLOC_ERROR;

	/*vi scrivo dentro*/
	ttt=primaParola(&email[btemp], par, DIM_PAROLA);
	if(ttt != RESULT_OK)
		printf("ATTENZIONE ATTENZIONE ATTENZIONE - ERRORE IN PRIMA PAROLA %d", ttt);


	/*aggiorno il contatore mettendo anche i caratteri non validi*/
	carNNval=leggi_car_non_val();
	btemp+=strlen(par)+carNNval;


	/*scrivo finalmente il token vero e proprio*/
	tokenArray[count_tok].contesto=NULL;
	tokenArray[count_tok].parola=par;
	indtok++;
	count_tok++;

	/*TOK SCRITTO*/

#ifdef INOUT
	//stampa(tokenArray[indtok].parola);
	printf("%d ", count_tok);
	stampa(par);
	printf("\t\tBodyPtr%d - NNval %d- ReturnVal %d. \n", btemp, carNNval, ttt);
#endif
	}

scrivi_dim_token(count_tok);

return 0;
}





int printTokens(Token tokenArray[], int dimT)
{
int i;

for(i=0;i<dimT;i++)
	{
	if(tokenArray[i].contesto != NULL)
		{
		printf("%s*%s\n",tokenArray[i].contesto,tokenArray[i].parola);
		}
	else
		{
		printf("%s\n",tokenArray[i].parola);
		}
	}
return 0;
}

