#include "modulo1.h"
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <ctype.h>
//-----------------------------------------------------------------------------------------------------------------------


int leggiFile(char * nomefile, int dimensione, char * testo){

  int p=0;
  if(nomefile==NULL){
    return(NULL_POINTER);
  }//un argomento della funzione era nullo
  if(dimensione<3){
    return(BUFFER_TOO_SMALL);
  }//il Buffer  troppo piccolo

  if(testo==NULL){
    return(NULL_POINTER);
  }//un argomento dell funzione  nullo

  int info;
  struct stat buf;
  
  int fd=0;
  int cp=0;
  int cl;
  info=stat(nomefile,&buf);
 
  if(info==-1){
    return(FILE_MISSING);
  }
  else{
    if(buf.st_mode & S_IRUSR){
      
      fd=open(nomefile,O_RDONLY);
      cp=read(fd,testo,dimensione-1);
     
      
      if(cp==-1){
	return(UNKNOWN_ERROR);
      }
      if(cp!=0){
	testo[dimensione]='\0';
	close(fd);
	return(RESULT_OK);
      }else{
	return(FILE_EMPTY);
      
      }
      
      }
    else{
      return(FILE_UNREADABLE);
      }
    }
}//chiusura fuzione leggi file


//------------------------------------------------------------------------------

int estraiHeaders(char * email,char * headers,int dimh){

  //CONTROLLO SUI PARAMETRI PASSATI
  if(email==NULL){
    return(NULL_POINTER);
  }
  //CONTROLLO CHE LA STRINGA NN SIA VUOTA
  if(email[0]=='\0'){
    return(EMPTY_STRING);
  }
     
  if(headers==NULL){
    return(NULL_POINTER);
  }
  
  if(dimh<3){
    return(BUFFER_TOO_SMALL);
  }
  
  if((email[0]=='\n')&&(email[1]=='\n')){
    return(HEADER_NOT_FOUND);
  }
  
  int i=0;
  
  while((email[i]!='\n')||(email[i+1]!='\n')){
    if(email[i+1]=='\0'){
      return(HEADER_NOT_FOUND);
    }
    i++;
  }
  
 
  if(i+1>dimh-1){
    return(BUFFER_TOO_SMALL);
  }
  else{
    memcpy(headers,email,i+1);
    headers[i+2]='\0';
    return(RESULT_OK);
  }

}//chiusura funzione estrai headers


//-------------------------------------------------------------------------------------------------------------------------------------------


int primoHeader(char * headers, char * primo_header, int dim){
  
  //controllo sui parametri della funzione
  if ((headers==NULL)){
    return(NULL_POINTER);
  }
  
  if(headers[0]=='\0'){
    return(EMPTY_STRING);
  }

  if((headers[0]==' ')||(headers[0]=='\t')||
     (headers[1]==' ')){
    
    return(HEADER_NOT_FOUND);
  }
  
  if(primo_header==NULL){
    return(NULL_POINTER);
  }
  
  if(dim<3){
    return(BUFFER_TOO_SMALL);
  }
  
  
  //controllo che l'headers nn comici con uno dei seguenti caratteri
  
  
  //cerco il primo headers
  int numocc=strlen(headers);//numero di caratteri dell' headers
  //printf("%d\n",numocc);
  int i=0;
  //int contaocc=0;
  while(i<numocc){
    if((headers[i]=='\n')){
      if((headers[i+1]!=' ')&&(headers[i+1]!='\t')){
	
	if(i<dim-1){
	  if(i<2){
	   
	    return(HEADER_NOT_FOUND);
	    
	  }else
	    {
	      memcpy(primo_header,headers,i);
	      primo_header[i]='\0';
	      return(RESULT_OK);
	  }
	}else{
	  return(BUFFER_TOO_SMALL);
	}
      }
      
    }
    i++;
    //contaocc++;
  }
  return(HEADER_NOT_FOUND);
  
}//chiusura funzione primo Header

//----------------------------------------------------------------------------------------------------------------------------------

int parseHeader(char *header,char *tipo,int dimt,char *valore,int dimv){

  //CONTROLLO SUI PASSAGGI DEI PARAMETRI DELLA FUNZIONE

  if((header==NULL)){
    return(NULL_POINTER);
  }
  
  if(header[0]=='\0'){
    return(EMPTY_STRING);
  }

  if((header[0]==' ')||(header[1]==' ')){
    return(BAD_HEADER);
  }

  if(tipo==NULL){
    return(NULL_POINTER);
  }
  
  if(dimt<3){
    return(BUFFER_TOO_SMALL);
  }
  
  if(valore==NULL){
    return(NULL_POINTER);
  }

  if(dimv<3){
    return(BUFFER_TOO_SMALL);
  }
  char *header2;
  char *Ptr=NULL;
  char *Ptr2=NULL;
  int a=0;
  int b=0;
  char *contr;
  char car1=' ';
  char car2='\t';
  if((strchr(header,car1)==NULL)&&(strchr(header,car2)==NULL)){
    return(BAD_HEADER);
  }
  int i=0;
  int numcar=0;
  numcar=strlen(header);
  while(i<numcar){
    if((header[i]!=' ')&&(header[i]!='\t')){
      i++;
    }
    else{
      if(i<2){
	return(BAD_HEADER);
      }
      else{
	if(i>dimt-1){
	  return(BUFFER_TOO_SMALL);
	}
	else{
	  strncpy(tipo,header,i);
	  tipo[i]='\0';
	  int a=i+1;
	  int b=0;
	  b=strlen(header+a);
	  if(b<2){
	    return(BAD_HEADER);
	  }
	  else{
	    if(b>dimv-1){
	      return(BUFFER_TOO_SMALL);
	    }
	    else{
	      strcpy(valore,header+a);
	      valore[b]='\0';
	      return(RESULT_OK);
	    }
	  }
	}
    
      }
  
    }
  }
  return(BAD_HEADER);

}//chiusra funzione parseHeader


//----------------------------------------------------------------------------------------------------------------------------------------

int primaParola(char *testo,char *parola,int dim){

  if(testo==NULL){
    return(NULL_POINTER);
  }
  
  if(testo[0]=='\0'){
    return(EMPTY_STRING);
  }

  if(parola==NULL){
    return(NULL_POINTER);
  }
  
  if(dim<3){
    return(BUFFER_TOO_SMALL);
  }

  int occ=0;
  occ=strlen(testo);//ritorno la lunghezza del testo
  
  int i=0;//contatore del ciclo
  char app;//appoggio carattere i-esimo
  char app2;//appoggio carattere i-esimo+1
  int cp=0;
  int v=0;
  int lunPar=0;
  //int conf=0
  while(i<occ){
    app=testo[i];
    app2=testo[i+1];
    
    if((isalnum(app)!=0)&&
      (app!='')&&(app!='')&&(app!='')&&
	(app!='')&&(app!='')&&(app!='')){
      if((isalnum(app2)!=0)&&
	 (app2!='')&&(app2!='')&&(app2!='')&&
	 (app2!='')&&(app2!='')&&(app2!='')){
	if(v<dim-1){
	parola[v]=app;
	v++;
	}else{
	  return(BUFFER_TOO_SMALL);
	}
      }//chiusura secondo if
      else{
	if(v<dim-1){
	  parola[v]=app;
	  parola[v+1]='\0';
	}
	else{
	  return(BUFFER_TOO_SMALL);
	}
	lunPar=strlen(parola);
	//printf("%d\n",lunPar);
	if(lunPar<2){
	  v=0;
	}
	if((lunPar>=2)&&(parola[v+1]=='\0')){
	  return(RESULT_OK);
	}
	   
      }
    }//chisura primo if
    
    i++;
  }//chiusura while
  if(strlen(parola)>2){
    return(RESULT_OK);
  }else{
  return(UNKNOWN_ERROR);
  }

}//chiusura funzione prima parola


int tokenizzaEmail(char *email,Token tokenArray[],int dimT){
  
  if(email==NULL){
    return(NULL_POINTER);
  }

  if(email[0]=='\0'){
    return(EMPTY_STRING);
  }

  if(tokenArray==NULL){
    return(NULL_POINTER);
  }

  if(dimT<1){
    return(BUFFER_TOO_SMALL);
  }
  //CALCOLO LA LUNGHEZZA DELL'EMAIL
  int lunEmail=0;//VAR LUN EMAL
  lunEmail=strlen(email);
  //printf("%d\n",lunEmail);
  char *headers=NULL;
  headers=(char *)malloc(sizeof(char *)*lunEmail+1);
  if(headers==NULL){
    return(MEM_ALLOC_ERROR);
  }
  //ESARAGGO IL BLOCCO DEGLI HEADERS
  int EH=0;
  EH=estraiHeaders(email,headers,lunEmail+1);
  if(EH!=0){
    return(EH);
  }
  int lunHeader=0;//VARIABILE LUNGHEZZA HEADERS
  int lunHeader1=0;//VARIABILE COPIA LUNGHEZZA MAIL
  int contatore=0;//VARIABILE CONTATORE TOKEARRAY
  int lunDimt=0;//VARIABILE PER LA LUNGHEZZA DI PRIMO_HEADERS
  int PH=0;//VARIABILE PER IL RIS PRIMO HEADER
  int lunDimv=0;//LUNGHEZZA DI PRIMO_HEADER
  int PRH=0;//VARIABILE PER IL RISULTATO PARSE HEADER
  int dim=0;//LUNGHEZZA DI TIPO
  int PP=0;//VARIABILE RIS PRIMA PAROLA
  int app=0;
  int memtipo=0;
  int cont=0;//CONTATORE CICLO " "
  int occ1=0;//LUNGHEZZA TOKENPTR
  int lunTipo=0;//VARIABILE LUNGHEZZA TIPO
  int lunVal=0;//VARIBILE LUNGHEZZA VALORE
  
  
   lunHeader=strlen(headers);
   lunHeader1=lunHeader;
   lunHeader=lunHeader + 1;
   
   
   
   //CICLO WHILE
   while(lunHeader>1){
     char *primo_header;
     primo_header=(char *)malloc(sizeof(char)*lunHeader);
     PH=primoHeader(headers,primo_header,lunHeader);
     if(PH!=0){
       return(PH);
       }
     
     lunDimt=strlen(primo_header);
     
     lunDimv=lunDimt;
     char *tipo=NULL;
     char *valore=NULL;
     tipo=(char *)malloc(sizeof(char *)*lunDimt+1);
     if(tipo==NULL){
       return(MEM_ALLOC_ERROR);
     }
     valore=(char *)malloc(sizeof(char *)*lunDimv+1);
     if(valore==NULL){
       return(MEM_ALLOC_ERROR);
     }
     PRH=parseHeader(primo_header,tipo,lunDimt+1,valore,lunDimv+1);
     if(PRH!=0){
       return(PRH);
     }
    
     dim=strlen(tipo);
     
     /*char *parola=NULL;
     parola=(char *)malloc(sizeof(char)*dim+1);
     if(parola==NULL){
       return(MEM_ALLOC_ERROR);
       }*/
     
     /*PP=primaParola(tipo,parola,dim+1);
     
     if(PP!=0){
     return(PP);
     }*/
     
     lunVal=strlen(valore);
     while(cont<=lunVal){
       if(isalnum(valore[cont])==0){
	 valore[cont]=' ';
       }else{
	 if((valore[cont]=='')||(valore[cont]=='')||(valore[cont]=='')
	    ||(valore[cont]=='')||(valore[cont]=='')||(valore[cont]=='')){
	   valore[cont]=' ';
	 }
       }
       cont++;
     }
     cont=0;//rinizzializzo il contatore del ciclo per la prossima volta
     char *tokenPtr=NULL;
     tokenPtr=strtok(valore," ");
     while(tokenPtr!=NULL){
       if(contatore<dimT-1){
	
	 occ1=strlen(tokenPtr);
	 if(occ1>1){
	 tokenArray->parola=(char *)malloc(sizeof(char)*occ1);
	 if(tokenArray->parola==NULL){
	   return(MEM_ALLOC_ERROR);
	 }
	 lunTipo=strlen(tipo);
	 tokenArray->contesto=(char *)malloc(sizeof(char)*lunTipo+1);
	 if(tokenArray->contesto==NULL){
	   return(MEM_ALLOC_ERROR);
	 }
	 strcpy(tokenArray->contesto,tipo);
	 tokenArray->contesto[lunTipo]='\0';
	 //BISOGNA CHIEDERE CHE COSA TORNARE NEL CASO DI PAROLA TROPPO CORTA
	 strcpy(tokenArray->parola,tokenPtr);
	 tokenArray->parola[occ1]='\0';
	 // printf("%s*%s\n",tokenArray->contesto,tokenArray->parola);
	 tokenArray++;
	 contatore++;
	 }
	 tokenPtr=strtok(NULL," ");
	 //tokenArray++;
	 //contatore++;//mi serve per vedere quanti elementi ho letto
       }else{
	 return(BUFFER_TOO_SMALL);
       }
     }

     lunDimt=lunDimt+1;//incremento la lunghezza del primo header
     lunHeader=lunHeader-lunDimt;//decremento la lunghezza complessiva
     headers=headers+lunDimt;//il puntatore;
     
     free(tokenArray->parola);
     free(tokenArray->contesto);
   }//CHIUSURA CICLO CHE COPIA IL BLOCCO DEGLI HEADER
   int conta=contatore;
   /*  while(conta>0){
     tokenArray--;
     printf("%s*%s\n",tokenArray->contesto,tokenArray->parola);
     conta--;
     }*/
   //BLOCCO CHE COPIA IL CORPO NEL TOKENARRAY
     email=email+lunHeader1;//aggiorno il puntatore dell'email per punatre al corpo
   
      lunVal=strlen(email);
     while(cont<=lunVal){
       if(isalnum(email[cont])==0){
	 email[cont]=' ';
       }else{
	 if((email[cont]=='')||(email[cont]=='')||(email[cont]=='')
	    ||(email[cont]=='')||(email[cont]=='')||(email[cont]=='')){
	   email[cont]=' ';
	 }
       }
       cont++;
     }
     
     char *tokenPtr1=NULL;
     tokenPtr1=strtok(email," ");
     if(tokenPtr1==NULL){
       return(BODY_NOT_FOUND);
     }
     
     
        while(tokenPtr1!=NULL){
	  if(contatore<dimT-1){
	
	    occ1=strlen(tokenPtr1);
	    if(occ1>1){
	      tokenArray->parola=(char *)malloc(sizeof(char)*occ1);
	      if(tokenArray->parola==NULL){
		return(MEM_ALLOC_ERROR);
	      }
	      //tokenArray->contesto=(char *)malloc(sizeof(char)*0);
	      tokenArray->contesto=NULL;
	      //BISOGNA CHIEDERE CHE COSA TORNARE NEL CASO DI PAROLA TROPPO CORTA
	    
	      strcpy(tokenArray->parola,tokenPtr1);
	      tokenArray->parola[occ1]='\0';
	      //printf("%s\n",tokenArray->parola);
	      tokenArray++;
	      contatore++;
	    }
	    tokenPtr1=strtok(NULL," ");
	  }else{
	    return(BUFFER_TOO_SMALL);
	  }
	}
       
     
     
     
     
     tokenArray->parola=NULL;
     tokenArray->contesto=NULL;
     tokenArray=tokenArray-53;
     return(RESULT_OK);
    
     int conta2=0;
     
      
     // }
    
}//chisuara funzione tokenizza email



int printTokens(Token tokenArray[],int dimT){
  
  if(tokenArray==NULL){
    return(NULL_POINTER);
  }
  
  if((tokenArray->contesto=='\0')&&(tokenArray->parola=='\0')){
    return(EMPTY_STRING);
  }
  
  if(dimT<1){
    return(BUFFER_TOO_SMALL);
  }
  int confronto=0;
  
  
      while((tokenArray->contesto!=NULL)&&(tokenArray->parola!=NULL)){
	if(confronto<dimT-1){
	  if(tokenArray->contesto!=NULL){
	    printf("%s*%s\n",tokenArray->contesto,tokenArray->parola);
	  }
	  tokenArray++;
	  confronto++;
	}else{
	  return(BUFFER_TOO_SMALL);
	}
      }
	
    
      while(tokenArray->parola!=NULL){
	if(confronto<dimT-1){
	  printf("%s\n",tokenArray->parola);
	  tokenArray++;
	  confronto++;
	}else{
	  return(BUFFER_TOO_SMALL);
	}
      }
      return(RESULT_OK);
  
}//CHIUSRA FUNZIONE CHE STAMPA TUTTI I TOKEN


