/* Funzioni di test - by Massimiliano Natale matricola 697236 ***************************************************************/


#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <unistd.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include "modulo1.h"
#include "testModulo1.h"



void crea_bad_header(char buffer[]) { // Crea un buffer con bad header
  buffer[0] = '\t';
}

void crea_header_not_found(char buffer[]) { // Crea un buffer senza header
  buffer[0] = '\n';
}

void crea_body_not_found(char buffer[]) {
  strcpy(buffer, "From: PierSilvio@Berlusconi.com\n\n");
}

void stampa_errore(char funzione[], char atteso[], char ottenuto[]) { // Stampa dei messaggi di errore
  printf("TEST FALLITO\n");
  printf("funzione testata:\t%s\n", funzione);
  printf("risultato atteso:\t%s\n", atteso);
  printf("risultato ottenuto:\t%s\n", ottenuto);
  printf("\nSPIEGAZIONE: ");
}

void crea_file_empty(char name[]) { // Crea un file completamente vuoto
  FILE *fp;

  if((fp = fopen(name, "w"))==NULL) // Non si  potuto creare il file
    return;

  fprintf(fp, ""); 
}

void crea_file_unreadable(char name[]) { // Crea un file che non ha i permessi in lettura
  int fd;

  if((fd = creat(name, 00000))<0) // Crea un file senza alcun permesso
    return;

  if(write(fd, "Massy", 5)<0)
    return;
}

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

int test_tokenizzaEmail(int tipo_di_test, int n_argomento) {
  int dim=5000, ritorno, i;
  char email[dim];
  Token *tokenArray;


  if((tokenArray = (Token *)malloc(dim * sizeof(Token)))==NULL) // Alloca spazio per array di strutture
    return MEM_ALLOC_ERROR;


  if(n_argomento==0) { // Test sul buffer email
    if(tipo_di_test==RESULT_OK) { // La funzione  andata a buon termine
      if(leggiFile("Mail1.txt", dim, email)!=RESULT_OK) {
	stampa_errore("tokenizzaEmail()", "RESULT_OK", "*");
	printf("La funzione non  riuscita a leggere il file Mail1.txt\n\n");
	return TEST_FAILED;
      }
      ritorno = tokenizzaEmail(email, tokenArray, dim); // Lancia la funzione

      if(ritorno==RESULT_OK)
	return TEST_PASSED;

      else { // Non hai superato il test
	if(ritorno==NULL_POINTER) {
	  stampa_errore("tokenizzaEmail()", "RESTUL_OK", "NULL_POINTER");
	  printf("La funzione ha individuato un parametro pari a NULL\n\n");
	}
	else if(ritorno==EMPTY_STRING) {
	  stampa_errore("tokenizzaEmail()", "RESULT_OK", "EMPTY_STRING");
	  printf("La funzione ha individuato un parametro pari alla stringa vuota\n\n");
	}
	else if(ritorno==HEADER_NOT_FOUND) {
	  stampa_errore("tokenizzaEmail()", "RESULT_OK", "HEADER_NOT_FOUND");
	  printf("La funzione non ha individuato nessun header nell'email\n\n");
	}
	else if(ritorno==BAD_HEADER) {
	  stampa_errore("tokenizzaEmail()", "RESULT_OK", "BAD_HEADER");
	  printf("La funzione ha individuato un header non valido nell'email\n\n");
	}
	else if(ritorno==BUFFER_TOO_SMALL) {
	  stampa_errore("tokenizzaEmail()", "RESULT_OK", "BUFFER_TOO_SMALL");
	  printf("Buffer non sufficiente a contenere i dati\n\n");
	}
	else // Nessun altro ritorno previsto 
	  return NOT_IMPLEMENTED;
	
	return TEST_FAILED;
      }
    }
    else if(tipo_di_test==NULL_POINTER) { // Devi passare NULL come primo argomento
      if(leggiFile("Mail1.txt", dim, email)!=RESULT_OK) {
	stampa_errore("tokenizzaEmail()", "RESULT_OK", "*");
	printf("La funzione non  riuscita a leggere il file Mail1.txt\n\n");
	return TEST_FAILED;
      }
      ritorno = tokenizzaEmail(NULL, tokenArray, dim); // Passa NULL come primo argomento

      if(ritorno==tipo_di_test)
	return TEST_PASSED;
      else {
	stampa_errore("tokenizzaEmail()", "NULL_POINTER", "*");
	printf("La funzione non controlla se il primo parametro  NULL\n\n");
	return TEST_FAILED;
      }
    }
    else if(tipo_di_test==EMPTY_STRING) { // Devi passare "" come argo0
      if(leggiFile("Mail1.txt", dim, email)!=RESULT_OK) {
	stampa_errore("tokenizzaEmail()", "RESULT_OK", "*");
	printf("La funzione non  riuscita a leggere il file Mail1.txt\n\n");
	return TEST_FAILED;
      }
      ritorno = tokenizzaEmail("", tokenArray, dim); // La stringa vuota come primo argomento

      if(ritorno==tipo_di_test)
	return TEST_PASSED;
      else {
	stampa_errore("tokenizzaEmail()", "EMPTY_STRING", "*");
	printf("La funzione non controlla se il primo parametro  la stringa vuota\n\n");
	return TEST_FAILED;
      }
    }
    else if(tipo_di_test==HEADER_NOT_FOUND) {
      crea_header_not_found(email); // Crea un email senza header
      ritorno = tokenizzaEmail(email, tokenArray, dim);

      if(ritorno==tipo_di_test)
	return TEST_PASSED;
      else {
	stampa_errore("tokenizzaEmail()", "HEADER_NOT_FOUND", "*");
	printf("La funzione non controlla la presenza di un header\n\n");
	return TEST_FAILED;
      }
    }
    else if(tipo_di_test==BAD_HEADER) {
      crea_bad_header(email);
      ritorno = tokenizzaEmail(email, tokenArray, dim);

      if(ritorno==tipo_di_test)
	return TEST_PASSED;
      else {
	stampa_errore("tokenizzaEmail()", "BAD_HEADER", "*");
	printf("La funzione non controlla la presenza di bad header\n\n");
	return TEST_FAILED;
      }
    }
    else if(tipo_di_test==BODY_NOT_FOUND) {
      crea_body_not_found(email); // Crea un email senza corpo
      ritorno = tokenizzaEmail(email, tokenArray, dim);

      if(ritorno==tipo_di_test)
	return TEST_PASSED;
      else {
	stampa_errore("tokenizzaEmail()", "BODY_NOT_FOUND", "*");
	printf("La funzione non controlla la presenza del BODY\n\n");
	return TEST_FAILED;
      }
    }
    else // Nessun altro tipo di test possibile per questo argomento 
      return NOT_VALID;
  } // Fine arg0

  else if(n_argomento==1) { // Test sull'argomento tokenArray
    if(tipo_di_test==NULL_POINTER) { // Passa NULL come arg1
      if(leggiFile("Mail1.txt", dim, email)!=RESULT_OK) {
	stampa_errore("tokenizzaEmail()", "RESULT_OK", "*");
	printf("La funzione non  riuscita a leggere il file Mail1.txt\n\n");
	return TEST_FAILED;
      }
      ritorno = tokenizzaEmail(email, NULL, dim); // La stringa vuota come arg1 argomento
      
      if(ritorno==tipo_di_test)
	return TEST_PASSED;
      else {
	stampa_errore("tokenizzaEmail()", "NULL_POINTER", "*");
	printf("La funzione non controlla se il secondo elemento  NULL\n\n");
	return TEST_FAILED;
      }
    }
    else // Nessun altro tipo di test per quest'argomento
      return NOT_VALID;
  } // Fine arg1

  else if(n_argomento==2) { // Test sul parametro dim
    if(tipo_di_test==BUFFER_TOO_SMALL) { // Passa dimensione negativa a dim
      if(leggiFile("Mail1.txt", dim, email)!=RESULT_OK) {
	stampa_errore("tokenizzaEmail()", "RESULT_OK", "*");
	printf("La funzione non  riuscita a leggere il file Mail1.txt\n\n");
	return TEST_FAILED;
      }
      ritorno = tokenizzaEmail(email, tokenArray, -1); // La stringa vuota come primo argomento

      if(ritorno==tipo_di_test)
	return TEST_PASSED;
      else {
	stampa_errore("tokenizzaEmail()", "BUFFER_TOO_SMALL", "*");
	printf("La funzione non controlla se la dimensione del vettore di strutture  negativa\n\n");
	return TEST_FAILED;
      }
    }
    else 
      return NOT_VALID;
  }

  else
    return ARG_MISSING;
}


//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

int test_printTokens(int tipo_di_test, int n_argomento) {
  int ritorno, dim=5000;
  Token tokenArray[1];

  (tokenArray[0]).parola = (char *)malloc(dim * sizeof(char));
  (tokenArray[0]).contesto = (char *)malloc(dim * sizeof(char));
  

  strcpy((tokenArray[0]).parola, "");
  strcpy((tokenArray[0]).contesto, "NULL"); 

  if(n_argomento==0) { // Test sul vettore token contenente i token
    if(tipo_di_test==RESULT_OK) {
      ritorno = printTokens(tokenArray, 0);
      if(ritorno==tipo_di_test)
	return TEST_PASSED;
      else {
	stampa_errore("printTokens()", "RESULT_OK", "*");
	printf("Errore inaspettato\n\n");
      }
    } 
      
    else if(tipo_di_test==NULL_POINTER) { // Passa NULL come vettore token
      ritorno = printTokens(NULL, 1);
      if(ritorno==NULL_POINTER)
	return TEST_PASSED;
      else {
	stampa_errore("printTokens()", "NULL_POINTER", "*");
	printf("La funzione non controlla se il primo argomento  NULL\n\n");
	return TEST_FAILED;
      }
    }
    else
      return NOT_VALID; // Nessun altro test possibile
  }
  // fine arg0

  else if(n_argomento==1) {
    if(tipo_di_test==RESULT_OK) {
      ritorno = printTokens(tokenArray, 0);
      if(ritorno==tipo_di_test)
	return TEST_PASSED;
      else {
	stampa_errore("printTokens()", "RESULT_OK", "*");
	printf("La funzione ha riportato un errore inaspettato\n\n");
	return TEST_FAILED;
      }
    }
    else if(tipo_di_test==BUFFER_TOO_SMALL) { // Passa una dimensione negativa
      ritorno = printTokens(tokenArray, -3);
      if(ritorno==tipo_di_test)
	return TEST_PASSED;
      else {
	stampa_errore("printTokens", "BUFFER_TOO_SMALL", "*");
	printf("La funzione non controlla se il parametro dimensione  negativo\n\n");
	return TEST_FAILED;
      }
    }
    else // Nessun arto tipo di test ha senso per questo argomento
      return NOT_VALID;
  }

  else // Nessun altro argomento
    return ARG_MISSING;
}

///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

int test_primaParola(int tipo_di_test, int n_argomento) {
  char *testo, *parola;
  int ritorno, dim=5000;

  if((testo = (char *)malloc(sizeof(char) * dim))==NULL)
    return MEM_ALLOC_ERROR;
  if((parola = (char *)malloc(sizeof(char) * dim))==NULL)
    return MEM_ALLOC_ERROR;

  if(n_argomento==0) { // Test fatto sull'argomento testo
    if(tipo_di_test==RESULT_OK) { // La funzione deve andare a buon termine
      if(leggiFile("Mail1.txt", dim, testo)!=RESULT_OK) // Copia l'email nel buffer 
	return NOT_IMPLEMENTED;
      ritorno = primaParola(testo, parola, dim); // Cerca la prima parola nell'email

      if(ritorno==tipo_di_test)
	return TEST_PASSED;
      else { // Il test  fallito
	if(ritorno==BUFFER_TOO_SMALL) { // Il buffer non pu contenere il testo
	  stampa_errore("primaParola()", "RESULT_OK", "BUFFER_TOO_SMALL");
	  printf("Il buffer non  sufficiente a contenere il testo email\n\n");
	}
	else if(ritorno==UNKNOWN_ERROR) {
	  stampa_errore("primaParola()", "RESULT_OK", "UNKNOWN_ERROR");
	  printf("E' probabile che il testo estratto non contiene parole\n\n");
	}
	else // Nessun altra possibilit di errore implementata
	  return NOT_IMPLEMENTED;

	return TEST_FAILED;
      }
    }
    else if(tipo_di_test==NULL_POINTER) {
      if(leggiFile("Mail1.txt", dim, testo)!=RESULT_OK) // Copia l'email nel buffer 
	return NOT_IMPLEMENTED;
      ritorno = primaParola(NULL, parola, dim); // Passa NULL come primo argomento

      if(ritorno==tipo_di_test)
	return TEST_PASSED;
      else { // Il test  fallito
	stampa_errore("primaParola()", "NULL_POINTER", "*");
	printf("La funzione non controlla se il primo argomento passato  NULL\n\n");
	return TEST_FAILED;
      }
    }

    else if(tipo_di_test==EMPTY_STRING) {
      if(leggiFile("Mail1.txt", dim, testo)!=RESULT_OK) // Copia l'email nel buffer 
	return NOT_IMPLEMENTED;
      ritorno = primaParola("", parola, dim); // Passa stringa vuota come primo argomento
      
      if(ritorno==tipo_di_test)
	return TEST_PASSED;
      else {
	stampa_errore("primaParola()", "EMPTY_STRING", "*");
	printf("La funzione non controlla se il primo argomento passato  una stringa vuota\n\n");
	return TEST_FAILED;
      }
    }

    else // Nessun altro tipo di test  valido per questo argomento
      return NOT_VALID;
  } // Fine test per arg0

  else if(n_argomento==1) { // Test fatto sul secondo argomento
    if(tipo_di_test==RESULT_OK) {
      if(leggiFile("Mail1.txt", dim, testo)!=RESULT_OK) // Copia l'email nel buffer 
	return NOT_IMPLEMENTED;
      ritorno = primaParola(testo, parola, dim);

      if(ritorno==tipo_di_test) 
	return TEST_PASSED;
      else {
	stampa_errore("primaParola()", "RESULT_OK", "*");
	printf("Errore inaspettato nell'estrazione della prima parola\n\n");
	return TEST_FAILED;
      }
    }
    
    else if(tipo_di_test==NULL_POINTER) {
      if(leggiFile("Mail1.txt", dim, testo)!=RESULT_OK) // Copia l'email nel buffer 
	return NOT_IMPLEMENTED;
      ritorno = primaParola(testo, NULL, dim); // Passa NULL come arg1
      if(ritorno==tipo_di_test)
	return TEST_PASSED;
      else { // Non hai superato il test
	stampa_errore("primaParola()", "NULL_POINTER", "*");
	printf("La funzione non controlla se il secondo parametro passato  NULL\n\n");
	return TEST_FAILED;
      }
    }
    else // Nessun altro tipo di test  valido per questo argomento
      return NOT_VALID;
  }

  else if(n_argomento==2) { // Test fatto sull'argomento dimensione 
    if(tipo_di_test==RESULT_OK) {
      if(leggiFile("Mail1.txt", dim, testo)!=RESULT_OK) // Copia l'email nel buffer 
	return NOT_IMPLEMENTED;
      ritorno = primaParola(testo, parola, dim);

      if(ritorno==tipo_di_test) 
	return TEST_PASSED;
      else {
	stampa_errore("primaParola()", "RESULT_OK", "*");
	printf("Errore inaspettato nell'estrazione della prima parola\n\n");
	return TEST_FAILED;
      }
    }
    else if(tipo_di_test==BUFFER_TOO_SMALL) {
      if(leggiFile("Mail1.txt", dim, testo)!=RESULT_OK) // Copia l'email nel buffer 
	return NOT_IMPLEMENTED;
      ritorno = primaParola(testo, parola, -1);
      if(ritorno==tipo_di_test)
	return TEST_PASSED;
      else {
	stampa_errore("primaParola()", "BUFFER_TOO_SMALL", "*");
	printf("La funzione non controlla se la dimensione del buffer  positiva\n\n");
	return TEST_FAILED;
      }
    }
    else 
      return NOT_VALID;
  }

  else // Argomenti non presenti nella funzione
    return ARG_MISSING;
}
    

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
	
      
int test_parseHeader(int tipo_di_test, int n_argomento) { // Testa la funzione parseHeader()
  int ritorno, dim=5000;
  char *header, *tipo, *valore, *testo, *headers;

  if((header = (char *)malloc(dim * sizeof(char)))==NULL)
    return MEM_ALLOC_ERROR;
  if((tipo = (char *)malloc(dim * sizeof(char)))==NULL)
    return MEM_ALLOC_ERROR;
  if((valore = (char *)malloc(dim * sizeof(char)))==NULL)
     return MEM_ALLOC_ERROR;
  if((testo = (char *)malloc(dim * sizeof(char)))==NULL)
    return MEM_ALLOC_ERROR;
  if((headers = (char *)malloc(dim * sizeof(char)))==NULL)
    return MEM_ALLOC_ERROR;
     
  if(n_argomento==0) { // Test effettuato sul parametro header
    if(tipo_di_test==RESULT_OK) { // La funzione deve andare a buon termine
      if(leggiFile("Mail1.txt", dim, testo)!=RESULT_OK) // Non sei riuscito a leggere il file
	return UNKNOWN_ERROR;
      if(estraiHeaders(testo, headers, dim)!=RESULT_OK) // Non sei riuscito ad estrarre gli headers
	return UNKNOWN_ERROR;
      if(primoHeader(headers, header, dim)!=RESULT_OK) // Non sei riuscito ad estrarre il primo header
	return UNKNOWN_ERROR;
      ritorno = parseHeader(header, tipo, dim, valore, dim); // Lancia la funzione testata

      if(ritorno==tipo_di_test) // Hai superato il test
	return TEST_PASSED;
      else { // Il test  fallito
	if(ritorno==NULL_POINTER) {
	  stampa_errore("parseHeader()", "RESULT_OK", "NULL_POINTER");
	  printf("La funzione non controlla se uno dei buffer passati  NULL\n\n");
	}
	else if(ritorno==EMPTY_STRING) {
	  stampa_errore("parseHeader()", "RESULT_OK", "EMPTY_STRING");
	  printf("La funzione non controlla il primo parametro  la stringa vuota\n\n");
	}
	else if(ritorno==BAD_HEADER) {
	  stampa_errore("parseHeader()", "RESULT_OK", "BAD_HEADER");
	  printf("L'header passato alla funzione non  valido\n\n");
	}
	else if(ritorno==BUFFER_TOO_SMALL) {
	  stampa_errore("parseHeader()", "RESULT_OK", "BUFFER_TOO_SMALL");
	  printf("Buffer non sufficiente a contenere il dato\n\n");
	}
	else // Nessun'altra possibile soluzione
	  return UNKNOWN_ERROR;

	return TEST_FAILED;
      }
    } // Fine RESULT_OK

    else if(tipo_di_test==NULL_POINTER) { // Devi passare NULL come primo parametro
      ritorno = parseHeader(NULL, tipo, dim, valore, dim);
      if(ritorno==tipo_di_test) // Test superato
	return TEST_PASSED;
      else {
	stampa_errore("parseHeader()", "NULL_POINTER", "*");
	printf("La funzione non controlla se il primo parametro  NULL\n\n");
	return TEST_FAILED;
      }
    }

    else if(tipo_di_test==EMPTY_STRING) { // Devi passare "" come primo parametro
      ritorno = parseHeader("", tipo, dim, valore, dim);
      if(ritorno==tipo_di_test)
	return TEST_PASSED;
      else {
	stampa_errore("parseHeader()", "EMPTY_STRING", "*");
	printf("La funzione non controlla se il primo parametro  la stringa vuota\n\n");
	return TEST_FAILED;
      }
    }

    else if(tipo_di_test==BAD_HEADER) { // Crea un header bad e passalo come primo argomento
      crea_bad_header(header);
      ritorno = parseHeader(header, tipo, dim, valore, dim);
      if(ritorno==tipo_di_test)
	return TEST_PASSED;
      else { // Test fallito
	stampa_errore("parseHeader()", "BAD_HEADER", "*");
	printf("La funzione non controlla la correttezza dell'header\n\n");
	return TEST_FAILED;
      }
    }

    else // Nessun altro tipo di test valido
      return NOT_VALID;
  } // Fine test su argo0

  else if(n_argomento==1 || n_argomento==3) { // Test su tipo
    if(tipo_di_test==RESULT_OK) {
      if(leggiFile("Mail1.txt", dim, testo)!=RESULT_OK) // Non sei riuscito a leggere il file
	return UNKNOWN_ERROR;
      if(estraiHeaders(testo, headers, dim)!=RESULT_OK) // Non sei riuscito ad estrarre gli headers
	return UNKNOWN_ERROR;
      if(primoHeader(headers, header, dim)!=RESULT_OK) // Non sei riuscito ad estrarre il primo header
	return UNKNOWN_ERROR;
      ritorno = parseHeader(header, tipo, dim, valore, dim); // Lancia la funzione testata

      if(ritorno==tipo_di_test)
	return TEST_PASSED;
      else {
	stampa_errore("parseHeader()", "RESULT_OK", "*");
	printf("Errore inaspettato\n\n");
	return TEST_FAILED;
      }
    }
    else if(tipo_di_test==NULL_POINTER) { // Passa NULL come secondo argomento
      if(n_argomento==1)
	ritorno = parseHeader("generic string\n", NULL, dim, valore, dim);
      else // su arg3
	ritorno = parseHeader("generic string\n", tipo, dim, NULL, dim);

      if(ritorno==tipo_di_test)
	return TEST_PASSED;
      else {
	stampa_errore("parseHeader()", "NULL_POINTER", "*");
	printf("La funzione non controlla se un argomento  NULL\n\n");
	return TEST_FAILED;
      }
    }
    else
      return NOT_VALID;
  }
 

  else if(n_argomento==2 || n_argomento==4) { // Comportamento simile per le due dimensioni
    if(tipo_di_test==RESULT_OK) {
      if(leggiFile("Mail1.txt", dim, testo)!=RESULT_OK) // Non sei riuscito a leggere il file
	return UNKNOWN_ERROR;
      if(estraiHeaders(testo, headers, dim)!=RESULT_OK) // Non sei riuscito ad estrarre gli headers
	return UNKNOWN_ERROR;
      if(primoHeader(headers, header, dim)!=RESULT_OK) // Non sei riuscito ad estrarre il primo header
	return UNKNOWN_ERROR;
      ritorno = parseHeader(header, tipo, dim, valore, dim); // Lancia la funzione testata

      if(ritorno==tipo_di_test)
	return TEST_PASSED;
      else {
	stampa_errore("parseHeader()", "RESULT_OK", "*");
	printf("Errore inaspettato\n\n");
	return TEST_FAILED;
      }
    }	

    else if(tipo_di_test==BUFFER_TOO_SMALL) { // Passa un valore negativo come terzo e/o quinto argomento
      if(n_argomento==2)
	ritorno = parseHeader("generic string\n", tipo, -1, valore, dim);

      else // Su arg 4
	ritorno = parseHeader("generic string\n", tipo, dim, valore, -1);

      if(ritorno==tipo_di_test)
	return TEST_PASSED;
      else {
	stampa_errore("parseHeader", "BUFFER_TOO_SMALL", "*");
	printf("La funzione non controlla la capienza dei dati nei buffer\n\n");
	return TEST_FAILED;
      }
    }

    else
      return NOT_VALID;
  }
  else 
    return ARG_MISSING;
} 


///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////


int test_primoHeader(int tipo_di_test, int n_argomento) { // Testa la funzione primoHeader()
  int ritorno, dim=5000;
  char *primo, *headers, *testo;

 

  if((headers = (char *)malloc(dim * sizeof(char)))==NULL)
    return MEM_ALLOC_ERROR;
  if((primo = (char *)malloc(dim * sizeof(char)))==NULL)
    return MEM_ALLOC_ERROR;
  if((testo = (char *)malloc(dim * sizeof(char)))==NULL)
    return MEM_ALLOC_ERROR;

  if(n_argomento==0) { // Test effettuato sull'argomento headers da cui estrarre il primo header
    if(tipo_di_test==RESULT_OK) {
      if(leggiFile("Mail1.txt", dim, testo)!=RESULT_OK) // Estrai il testo dal file
	return NOT_IMPLEMENTED;
      if(estraiHeaders(testo, headers, dim)!=RESULT_OK) // Estrai gli headers dal testo
	return NOT_IMPLEMENTED;
      ritorno = primoHeader(headers, primo, dim); // Lancia la funzione

      if(ritorno==tipo_di_test) // Hai superato il test
	return TEST_PASSED;

      else { // Altrimenti non hai superato il test
	free(testo); // Libera la memoria

	if(ritorno==HEADER_NOT_FOUND) {
	  stampa_errore("primoHeader()", "RESULT_OK", "HEADER_NOT_FOUND");
	  printf("Il test elaborato dalla funzione non contiene header\n\n");
	}
	else if(ritorno==BAD_HEADER) {
	  stampa_errore("primoHeader()", "RESULT_OK", "BAD_HEADER");
	  printf("Il test elaborato dalla funzione  contiene un header che non rispetta il formato\n\n");
	}
	else if(ritorno==BUFFER_TOO_SMALL) {
	  stampa_errore("primoHeader()", "RESULT_OK", "BUFFER_TOO_SMALL");
	  printf("Il buffer passato alla funzione non  sufficiente a contenere i dati\n\n");
	}
	else 
	  return NOT_IMPLEMENTED;

	return TEST_FAILED;
      }
    }
    if(tipo_di_test==NULL_POINTER) { // La funzione deve trovare NULL POINTER
      if(leggiFile("Mail1.txt", dim, testo)!=RESULT_OK) // Estrai il testo dal file
	return NOT_IMPLEMENTED;
      if(estraiHeaders(testo, headers, dim)!=RESULT_OK) // Estrai gli headers dal testo
	return NOT_IMPLEMENTED;
      ritorno = primoHeader(NULL, primo, dim); // Lancia la funzione passando NULL come arg0

      if(ritorno==tipo_di_test) // Hai superato il testo
	return TEST_PASSED;
      else {
	stampa_errore("primoHeader()", "NULL_POINTER", "*");
	printf("La funzione non controlla se il primo argomento  NULL\n\n");
	return TEST_FAILED;
      }
    }
    if(tipo_di_test==EMPTY_STRING) { // La funzione deve tornare EMPTY_STRING
      if(leggiFile("Mail1.txt", dim, testo)!=RESULT_OK) // Estrai il testo dal file
	return NOT_IMPLEMENTED;
      if(estraiHeaders(testo, headers, dim)!=RESULT_OK) // Estrai gli headers dal testo
	return NOT_IMPLEMENTED;
      ritorno = primoHeader("", primo, dim); // Passa la stringa vuota come primo argomento

      if(ritorno==tipo_di_test) // Hai superato il test
	return TEST_PASSED;
      else {
	stampa_errore("primoHeader()", "EMPTY_STRING", "*");
	printf("La funzione non controlla se il primo argomento  la stringa vuota\n\n");
	return TEST_FAILED;
      }
    }
    if(tipo_di_test==HEADER_NOT_FOUND) { // La funzione deve tornare HEADER_NOT_FOUND
      crea_header_not_found(headers); // Crea il buffer senza header
      ritorno = primoHeader(headers, primo, dim); // Passa il buffer senza header alla funzione

      if(ritorno==tipo_di_test)
	return TEST_PASSED;
      else { // Il test  fallito
	stampa_errore("primoHeader()", "HEADER_NOT_FOUND", "*");
	printf("La funzione non controlla se il buffer inizia con una newline\n\n");
	return TEST_FAILED;
      }
    }
    else if(tipo_di_test==BAD_HEADER) {
      crea_bad_header(headers); // Crea un buffer contenente un header non valido
      ritorno = primoHeader(headers, primo, dim);

      if(ritorno==tipo_di_test)
	return TEST_PASSED;
      else { // Il test  fallito
	stampa_errore("primoHeader()", "BAD_HEADER", "*");
	printf("La funzione non controlla il corretto formato dell'header\n\n");
	return TEST_FAILED;
      }
    }
    else
      return NOT_VALID; // Nessun altro tipo di test  valido per questo argomento
  } // Fine test sull'argomento 0

  else if(n_argomento==1) { // Effettua il test sul secondo buffer
    if(tipo_di_test==NULL_POINTER) {
      if(leggiFile("Mail1.txt", dim, testo)!=RESULT_OK) // Estrai il testo dal file
	return NOT_IMPLEMENTED;
      if(estraiHeaders(testo, headers, dim)!=RESULT_OK) // Estrai gli headers dal testo
	return NOT_IMPLEMENTED;
      ritorno = primoHeader(headers, NULL, dim); // Lancia la funzione passando NULL come arg1
      if(ritorno==tipo_di_test)
	return TEST_PASSED;
      else { // Tes fallito
	stampa_errore("primoHeader()", "NULL_POINTER", "*");
	printf("La funzione non controlla se il secondo parametro passato  NULL\n\n");
	return TEST_FAILED;
      }
    }
    else 
      return NOT_VALID; // Nessun altro tipo di test  valido per questo argomento
  } // Fine test sull'argomento 0

  else if(n_argomento==2) { // Effettua il test sulla dimensione
    if(tipo_di_test==RESULT_OK) {
      if(leggiFile("Mail1.txt", dim, testo)!=RESULT_OK) // Estrai il testo dal file
	return NOT_IMPLEMENTED;
      if(estraiHeaders(testo, headers, dim)!=RESULT_OK) // Estrai gli headers dal testo
	return NOT_IMPLEMENTED;
      ritorno = primoHeader(headers, primo, dim); // Lancia sulla funzione 
      if(ritorno==tipo_di_test) 
	return TEST_PASSED;
      else { // test fallito
	stampa_errore("primoHeader()", "RESULT_OK", "*");
	printf("Errore inaspettato nell'estrazione del primo header\n\n");
	return TEST_FAILED;
      }
    }
    else if(tipo_di_test==BUFFER_TOO_SMALL) {
      if(leggiFile("Mail1.txt", dim, testo)!=RESULT_OK) // Estrai il testo dal file
	return NOT_IMPLEMENTED;
      if(estraiHeaders(testo, headers, dim)!=RESULT_OK) // Estrai gli headers dal testo
	return NOT_IMPLEMENTED;
      ritorno = primoHeader(headers, primo, 0); // Lancia sulla funzione passando come dimensione un valore insufficiente

      if(ritorno==tipo_di_test)
	return TEST_PASSED;
      else { // Test fallito
	stampa_errore("primoHeader()", "BUFFER_TOO_SMALL", "*");
	printf("La funzione non controlla se la dimensione del buffer  sufficientemente grande\n\n");
	return TEST_FAILED;
      }
    }
    else // Nessun altro tipo di test  valido per questo argomento
      return NOT_VALID;
  }

  else // Nessun altro argomento presente
    return ARG_MISSING;
}


/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////


int test_estraiHeaders(int tipo_di_test, int n_argomento) { // Testa la funzione estraiHeaders()
  int ritorno, dim=5000;
  char *headers, *testo, *xbadx;


  if((testo = (char *)malloc(dim * sizeof(char)))==NULL)
    return MEM_ALLOC_ERROR;
  if((headers = (char *)malloc(dim * sizeof(char)))==NULL)
    return MEM_ALLOC_ERROR;

  if(n_argomento==0) { // Test sul parametro email
    if(tipo_di_test==RESULT_OK) { // La funzione deve andare a buon termine
      if(leggiFile("Mail1.txt", dim, testo)!=RESULT_OK)
	return NOT_IMPLEMENTED;     

      ritorno = estraiHeaders(testo, headers, dim); // Lancia la funzione su questo buffer
      
      if(ritorno==tipo_di_test) { // Hai superato il test
	free(testo);
	free(headers);
	return TEST_PASSED;
      }

      else { // Non hai superato il test
	if(ritorno==NULL_POINTER) {
	  stampa_errore("estraiHeaders()", "RESULT_OK", "NULL_POINTER");
	  printf("Uno dei due buffer della funzione puntava a NULL\n\n");
	}
	else if(ritorno==EMPTY_STRING) {
	  stampa_errore("estraiHeaders()", "RESULT_OK", "EMPTY_STRING");
	  printf("L'argomento email della funzione era una stringa vuota\n\n");
	}     
	else if(ritorno==BAD_HEADER) {
	  stampa_errore("estraiHeaders()", "RESULT_OK", "BAD_HEADER");
	  printf("Il testo inizia con uno spazio o con un TAB\n\n");
	}
	else if(ritorno==HEADER_NOT_FOUND) {
	  stampa_errore("estraiHeaders()", "RESULT_OK", "HEADER_NOT_FOUND");
	  printf("Il testo inizia con una newline\n\n");
	}
	else if(ritorno==BODY_NOT_FOUND) {
	  stampa_errore("estraiHeaders()", "RESULT_OK", "BODY_NOT_FOUND");
	  printf("EOF dopo gli headers\n\n");
	}

	free(testo);
	free(headers);

	return TEST_FAILED;
      }
    } // Fine test per RESULT_OK

    else if(tipo_di_test==NULL_POINTER) {
      ritorno = estraiHeaders(NULL, headers, dim); // Passa la stringa NULL alla funzione
      if(ritorno==tipo_di_test)
	return TEST_PASSED;
      else {
	stampa_errore("estraiHeaders()", "NULL_POINTER", "*");
	printf("La funzione non controlla se il primo argomento della funzione  NULL\n\n");
	return TEST_FAILED;
      }
    } 

    else if(tipo_di_test==EMPTY_STRING) {
      ritorno = estraiHeaders("", headers, dim); // Passa la stringa vuota alla funzione
      if(ritorno==tipo_di_test)
	return TEST_PASSED;
      else {
	stampa_errore("estraiHeaders()", "EMPTY_STRING", "*");
	printf("La funzione non controlla se il primo argomento passato  la stringa vuota\n\n");
	return TEST_FAILED;
      }
    }

    else if(tipo_di_test==BAD_HEADER) { 
      if((xbadx = (char *)malloc(dim * sizeof(char)))==NULL) 
	return MEM_ALLOC_ERROR;

      crea_bad_header(xbadx); // Crea un header con un bad header
      ritorno = estraiHeaders(xbadx, headers, dim); // Lancia la funzione sul bad header
      free(xbadx); // Libera la memoria allocata e controlla i test
      if(ritorno==tipo_di_test)
	return TEST_PASSED;
      else {
	stampa_errore("estraiHeaders()", "BAD_HEADER", "*");
	printf("La funzione non controlla la correttezza del formato HEADER\n\n");
	return TEST_FAILED;
      }
    }

    else if(tipo_di_test==HEADER_NOT_FOUND) {
      if((xbadx = (char *)malloc(dim * sizeof(char)))==NULL)
	return MEM_ALLOC_ERROR;

      crea_header_not_found(xbadx); // Crea un buffer senza header
      ritorno = estraiHeaders(xbadx, headers, dim); // Lancia la funzione sul buffer senza header
      free(xbadx); // Libera la memoria allocata e controlla i test
      if(ritorno==tipo_di_test)
	return TEST_PASSED;
      else {
	stampa_errore("estraiHeaders()", "HEADER_NOT_FOUND", "*");
	printf("La funzione non controlla la presenza dell'header\n\n");
	return TEST_FAILED;
      }
    }

    else if(tipo_di_test==BODY_NOT_FOUND) {
      if((xbadx = (char *)malloc(dim * sizeof(char)))==NULL)
	return MEM_ALLOC_ERROR;

      crea_body_not_found(xbadx); // Crea un buffer senza corpo
      ritorno = estraiHeaders(xbadx, headers, dim); // Lancia la funzione su questo buffer
      free(xbadx); // Libera la memoria e controlla i test
      if(ritorno==tipo_di_test)
	return TEST_PASSED;
      else { 
	stampa_errore("estraiHeaders()", "BODY_NOT_FOUND", "*");
	printf("La funzione non controlla se il BODY  presente\n\n");
	return TEST_FAILED;
      }
    }

    else // Nessun altro tipo di test  valido per questo argomento
      return NOT_VALID;

    // Libera la memoria e ritorna il codice relativo al test fallito
    free(testo);
    free(headers);
    return TEST_FAILED;
  } // Fine del test sull'argomento 0

  else if(n_argomento==1) { // test effettuato sul parametro headers
    if(tipo_di_test==RESULT_OK) {
      if(leggiFile("Mail1.txt", dim, testo)!=RESULT_OK)
	return NOT_IMPLEMENTED;
      ritorno = estraiHeaders(testo, headers, dim);
      if(ritorno==tipo_di_test)
	return TEST_PASSED;
      else {
	stampa_errore("estraiHeaders", "RESULT_OK", "*");
	printf("Errore inaspettato nell'estrazione dedgli headers\n\n");
	return TEST_FAILED;
      }
    }
    else if(tipo_di_test==NULL_POINTER) { // Il test deve ritornare NULL 
      if(leggiFile("Mail1.txt", dim, testo)!=RESULT_OK)
	return NOT_IMPLEMENTED;
      ritorno = estraiHeaders(testo, NULL, dim); // Passa NULL come secondo argomento
      if(ritorno==tipo_di_test)
	return TEST_PASSED;
      else {
	stampa_errore("estraiHeaders()", "NULL_POINTER", "*");
	printf("La funzione non controlla se il secondo argomento  NULL\n\n");
	return TEST_FAILED;
      }
    }
    else // Nessun altro tipo di test valido per questo argomento
      return NOT_VALID;
  } // Fine test per l'argomento headers

  else if(n_argomento==2) { // Controlla se hai una dimensione negativa
    if(tipo_di_test==BUFFER_TOO_SMALL) { // Passa un parametro negativo alla funzione
      if(leggiFile("Mail1.txt", dim, testo)!=RESULT_OK)
	return NOT_IMPLEMENTED;
      ritorno = estraiHeaders(testo, headers, -1); // Passa alla dimensione un numero negativo
      if(ritorno==tipo_di_test)
	return TEST_PASSED;
      else {
	stampa_errore("estraiHeaders()", "BUFFER_TOO_SMALL", "*");
	printf("La funzione non controlla se la dimensione del buffer  positiva\n\n");
	return TEST_FAILED;
      }
    }
    else // Nessun altro test  valido per questo parametro
      return NOT_VALID;
  }

  else // Fine degli argomenti
    return ARG_MISSING;
}  
  


///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////



int test_leggiFile(int tipo_di_test, int n_argomento) { // Testa la funzione leggiFile()
  int ritorno, dim=5000;
  char *testo;

  if((n_argomento >= 3) || (n_argomento < 0)) // L'indice degli argomenti per questa funzione sono 0, 1, 2
    return ARG_MISSING; 

  if((testo = (char *)malloc(dim * sizeof(char)))==NULL)
    return MEM_ALLOC_ERROR;


  if(n_argomento==0) { // Test su nome_file   
    if(tipo_di_test==RESULT_OK) { // Se ti aspettavi di ricevere RESULT_OK    
      ritorno = leggiFile("Mail1.txt", dim, testo); // Registra il ritorno della funzione 
      
      if(ritorno==tipo_di_test) {// Hai superato il test
	free(testo);
	return TEST_PASSED;
      }

      else { // Altrimenti non hai superato il test
	free(testo); // Libera la memoria

	if(ritorno==FILE_MISSING) { // Il file che stai tentando di leggere non esiste
	  stampa_errore("leggiFile()", "RESULT_OK", "FILE_MISSING");
	  printf("La funzione ha tentato di aprire un file inesistente\n\n");
	}	 
	else if(ritorno==FILE_UNREADABLE) {
	  stampa_errore("leggiFile()", "RESULT_OK", "FILE_UNREADABLE");
	  printf("La funzione ha tentato di aprire un file di cui non ha i permessi per accedere in lettura\n\n");
	}
	else if(ritorno==UNKNOWN_ERROR) {
	  stampa_errore("leggiFile()", "RESULT_OK", "UNKNOWN_ERROR");
	  printf("Errore inaspettato nell'apertura del file\n\n");
	}
	else if(ritorno==FILE_EMPTY) {
	  stampa_errore("leggiFile()", "RESULT_OK", "FILE_EMPTY"); 
	  printf("La funzione ha tentato di leggere un file vuoto\n\n");
	}
	else // Non  stata gestita nessun'altra possibilit di errore 
	  return NOT_IMPLEMENTED;

	return TEST_FAILED;
      }
    } // Fine per tipo di test = TEST_OK
      
    else if(tipo_di_test==NULL_POINTER) {
      ritorno = leggiFile(NULL, dim, testo); // Passa la stringa NULL alla funzione
      if(ritorno==tipo_di_test) // Hai superato il test
	return TEST_PASSED;
      else {
	stampa_errore("leggiFile()", "NULL_POINTER", "*");
	printf("La funzione non controlla se il primo parametro passato  NULL\n\n");
	return TEST_FAILED;
      }	
    }
      
    else if(tipo_di_test==EMPTY_STRING) {
      ritorno = leggiFile("", dim, testo); // Passa la stringa vuota alla funzione
      if(ritorno==tipo_di_test)
	return TEST_PASSED;
      else {
	stampa_errore("leggiFile()", "EMPTY_STRING", "*");
	printf("La funzione non controlla se il primo parametro passato  la stringa vuota\n\n");
	return TEST_FAILED;
      }
    }
      
    else if(tipo_di_test==FILE_MISSING) {
      ritorno = leggiFile("xcEEfx94", dim, testo);
      if(ritorno==tipo_di_test)
	return TEST_PASSED;
      else {
	stampa_errore("leggiFile()", "FILE_MISSING", "*");
	printf("La funzione non controlla l'esistenza del file\n\n");
	return TEST_FAILED;
      }	
    }

    else if(tipo_di_test==FILE_UNREADABLE) {
      crea_file_unreadable("NM1984"); // Crea un file che non ha i permessi di lettura

      ritorno = leggiFile("NM1984", dim, testo); 
      if(ritorno==tipo_di_test)
	return TEST_PASSED;
      else {
	stampa_errore("leggiFile()", "FILE_UNREADABLE", "*");
	printf("La funzione non controlla i permessi di lettura\n\n");
	return TEST_FAILED;
      }
    }

    else if(tipo_di_test==FILE_EMPTY) {
      crea_file_empty("EMPTYnm1984");

      ritorno = leggiFile("EMPTYnm1984", dim, testo); // Test sul file vuoto 
      if(ritorno==tipo_di_test)
	return TEST_PASSED;
      else {
	stampa_errore("leggiFile()", "FILE_EMPTY", "*");
	printf("La funzione non controlla se il file da leggere  vuoto\n\n");
	return TEST_FAILED;
      }
    }

    else // Nessun altro tipo di test  valido per questo parametro
      return NOT_VALID;      
  } // Fine del test per l'argomento 0

  else if(n_argomento==1) {  // Test effettuato rispetto al parametro dimensione
    if(tipo_di_test==RESULT_OK) {
      ritorno = leggiFile("Mail1.txt", dim, testo);
      if(ritorno==tipo_di_test)
	return TEST_PASSED;    
      else { // Test non andato a buon fine
	stampa_errore("leggiFile()", "RESULT_OK", "*");
	printf("Errore inaspettato nell'apertura del file\n\n");
	return TEST_FAILED;
      }
    }

    else if(tipo_di_test==BUFFER_TOO_SMALL) {
      ritorno = leggiFile("Mail1.txt", -1, testo); // Passa una dimensione negativa
      if(ritorno==tipo_di_test)
	return TEST_PASSED;
      else {
	stampa_errore("leggiFile()", "BUFFER_TOO_SMALL", "*");
	printf("La funzione non controlla se la dimensione passata  positiva\n\n");
	return TEST_FAILED;
      }
    }
    else // Nessun altro tipo di test ha senso per il parametro dimensione
      return NOT_VALID;
  }

  else if(n_argomento==2) { // Test effettuato rispetto al parametro testo 
    if(tipo_di_test==NULL_POINTER) { 
      ritorno = leggiFile("Mail1.txt", dim, NULL);
      if(ritorno==tipo_di_test)
	return TEST_PASSED;
      else {
	stampa_errore("leggiFile()", "NULL_POINTER", "*");
	printf("La funzione non controlla se il secondo parametro passato  NULL\n\n");
	return TEST_FAILED;
      }	
    }
    else // Nessun altro tipo di test  valido per questo argomento
      return NOT_VALID;
  }

  else // Nessun altro parametro da controllare
    return ARG_MISSING;
}


/////////////////////***********************************************************************************////////////////////////////////
/////////////////////////////////**************************END FILE*************************///////////////////////////////////////////
/*************************************************************************************************************************************/


/* 6 Aprile 2005 h 19.37 */


