#include<stdlib.h>
#include<stdio.h>
#include<string.h>
#include"modulo1.h"	

////////////////////////////////
// Funzione che legge la mail //
////////////////////////////////

int leggiFile(char *nomefile, int dimensione, char *testo){
  
  FILE* aperto;				// variabile di tipo File che punta al file
  int n = 0;char app; 
  
  if(dimensione == 0)
    return BUFFER_TOO_SMALL; 
  
  if(nomefile == NULL)
    return EMPTY_STRING;
  
  if(testo == NULL)
    return NULL_POINTER;
  
  aperto = fopen(nomefile , "r");	  // funzione che torna la prima lettera del file
  
  if(aperto == NULL)
    return FILE_MISSING; 
  
  if(fgetc(aperto) == EOF)		// controllo se il file è vuoto
    return FILE_EMPTY;
  
  rewind(aperto); 			// riavvolgo aperto :)	
  
  while((app = fgetc(aperto)) != EOF)
    {						// appoggio ogni lettera in app			
      testo[n] = app;
      if(n == dimensione-1)
	return BUFFER_TOO_SMALL;
      n++;                      		 //incremento per andare avanti	
    }
  n--;
  while(testo[n]=='\t' || testo[n]==' ' || testo[n]=='\n' )
    n--;
  testo[n+1] = '\0';				// metto '\0' all'ultimo posto
  return RESULT_OK;				// torna che è tutto ok 
  
}

///////////////////////////////////////////////
//Funzione che estrae gli Headers se ci sono //
///////////////////////////////////////////////

int estraiHeaders(char *email, char *headers, int dimh)
{
  int n = 0; char app;
  if(email[0] == '\0') return EMPTY_STRING;
  if(headers == NULL || email == NULL) return NULL_POINTER; 
  if(email[0] == ' ') return BAD_HEADER;
  if(email[0] == '\n') return HEADER_NOT_FOUND;
  
  while(n < (dimh-1))
    {			
      if(email[n] != '\n'){
	headers[n] = email[n];
	n++;
      }
      else if(email[n+1] != '\n'){
	headers[n] = email[n];
	n++;
      }	
      else break; 
    }
  headers[n] = '\0';			// metto '\0' all'ultimo posto
  
  return RESULT_OK;			// torna che è tutto ok 
}

//////////////////////////////////////////////
// Funzione che estrae solo il PRIMO HEADER //
//////////////////////////////////////////////

int primoHeader(char *headers, char *primo_header, int dim)
{
  int n=0,l=0;
  
  if(headers == NULL || primo_header == NULL) return NULL_POINTER;
  if(headers[0] == '\0'){ 
    primo_header[l] = '\0'; return EMPTY_STRING;
  }
  
  while(headers[n] != '\0')
    {
      if(headers[n] != '\n')
	{
	  primo_header[l] = headers[n];
	  
	  n++;
	}
      else if(headers[n+1] == ' ' || headers[n+1] == '\t')
	{
	  primo_header[l] = headers[n];
	  
	  n++;
	}
      else break;	
      if(n == dim) return BUFFER_TOO_SMALL;
      l++;
    }
  primo_header[l] = '\0';
  return RESULT_OK;
}

////////////////////////////////////////////////////
// Funzione che divide TIPO e VALORE di un header //
////////////////////////////////////////////////////

int parseHeader(char *header, char *tipo, int dimt, char *valore, int dimv)
{
  int n=0,v=0;
  
  if(header[0] == '\0') return EMPTY_STRING;
  if(header == NULL || tipo == NULL || valore == NULL) return NULL_POINTER;
  while(header[n] != ' ')
    {
      tipo[n] = header[n];
      n++;
    } 

  tipo[n] = '\0';
  while(header[n] != '\0')
    {
      valore[v] = header[n];
      n++;v++;
    }
  valore[v] = '\0';    
  return RESULT_OK; 
}

////////////////////////////////////////////////////////
//Funzione che  estrae la prima parola di una stringa///
////////////////////////////////////////////////////////

int primaParola(char *testo, char *parola, int dim)
{
  int n=0,i=0;
  if(testo == NULL || parola == NULL) return NULL_POINTER;
  if(testo[0] == '\0')  
    return EMPTY_STRING;
  
  while(testo[n] != '\0')
    
    {
      if(i == dim) return BUFFER_TOO_SMALL;
      if(isalnum(testo[n]))
	{
	  parola[i] = testo[n];
	  n++;
	  i++;
	}
      else 
	{ 
	  if(i < 2)
	    {
	      i=0;
	      n++;
	    }
	  else if(i > 0) 
	    break;
	  else n++; 
	}
    }
  parola[i] = '\0';
  return RESULT_OK;
}

//////////////////////////////////////
// Funzione che tokenizza una Mail ///
//////////////////////////////////////

int tokenizzaEmail(char *email, Token tokenArray[], int dimT)
{
  int app2=0;int stampa=0; int flag=0;
  
  int n=0,torna,i=0,k=0,y=0,z=0,t=0,r=0,u=0,l=0,corpo=100,j,w=0,flug=0;
  char *headers=NULL,*pheader=NULL,*valore=NULL,*tipo=NULL,*parola=NULL;
  char app;
  
  int dim = 100;
  
  if(email == NULL) return NULL_POINTER;
  if(email[0] == '\0') return EMPTY_STRING;
  tokenArray = (Token*)malloc(sizeof(Token)*dimT);
  
  while(email[n] != '\0')
    {			
      if(email[n] != '\n'){
	n++;}
      else if(email[n+1] != '\n'){
	n=n+2;}	
      else break; 
    }		
  
  headers = (char*)malloc(sizeof(char)*n+1);
  torna = estraiHeaders(email, headers, n+1);
  
  while(headers[w] != '\0')  
    if(headers[w] == ' ' )
      w++;
    else
      {
	flug=1;
	break;
      }
  
  if (flug == 0) BODY_NOT_FOUND;
  
  while(headers[0] != '\0' && flag==0)
    {
      pheader = (char*)malloc(sizeof(char)*(n+1));
      torna = primoHeader(headers,pheader,(n+1));
      tipo = (char*)malloc(sizeof(char)*(n+1));
      valore = (char*)malloc(sizeof(char)*(n+1));
      z=strlen(pheader);
      app2=0;
      
      while(headers[app2]!='\n')
	{
	  if(headers[app2]=='\0')
	    break;
	  
	  app2++;
	}	
      if(headers[app2]=='\0')
	flag=1;  
      app2=0;
      torna = parseHeader(pheader,tipo,n,valore,(n+1));
      
      while(valore[0] != '\0' )
	{
	  
	  parola = (char*)malloc(sizeof(char)*dim);  
	  torna = primaParola(valore,parola,(n+1));
	  tokenArray[i].contesto = (char*)malloc(sizeof(char)*(n+1));
	  tokenArray[i].parola = (char*)malloc(sizeof(char)*(n+1));
	  strcpy(tokenArray[i].contesto,tipo);
	  strcpy(tokenArray[i].parola,parola);
	  
	  while(isalnum(valore[r]))
	    r++;
	  if(valore[r]=='\0')
	    break;
	  while(!isalnum(valore[y]))
	    {
	      y++;
	      k++;
	    }
	  while(isalnum(valore[y]))
	    {
	      y++;
	      k++;
	    }
	  while(!isalnum(valore[y]))
	    {
	      y++;
	      k++;
	    }
	  y=0;
	  while(valore[k] != '\0')
	    {
	      app = valore[k];
	      valore[y] = app;
	      y++; k++;
	    }
	  i++;
	  valore[y] = '\0';
	  y=0; k=0;
	  r=0;
	  
	}
      
      while(isalnum(headers[z]))
      	z++;
	  if(headers[z]=='\n')
		  z++;
      while(headers[z] != '\0')
	{
	  app = headers[z];
	  headers[y] = app;
	  y++; z++;
	}
      headers[y]= '\0';
      y=0; z=0;
      l=0;
      i++;
    }
  z=i;
  

  /////////////////////////
  // ciclo per il corpo ///
  /////////////////////////
  while(!isalnum(email[n])) n++;  
  y=0;  
  
  while(email[n] != '\0')
    {
      app = email[n];
      email[y] = app;
      y++; n++;
    }
  email[y] = '\0';
  
  
  n=0; 
  
  while(email[0]!='\0')
    { 
      
      torna = primaParola(email,parola,dim);
      tokenArray[i].parola=(char*)malloc(sizeof(char)*corpo);
      tokenArray[i].contesto=(char*)malloc(sizeof(char)*corpo);
      strcpy(tokenArray[i].parola,parola);
      
      
      tokenArray[z].contesto=NULL;
      
      i++;
      z++;
      u=strlen(parola);
      
      while(email[u]>='a' && email[u]<='z' || email[u]>='A' && email[u]<='Z' || email[u]>='0' && email[u]<='9')
        u++;
      j=0;
      while(email[u]!='\0')  
	{
	  app=email[u];
	  email[j]=app;
	  j++; u++; 
	}
      email[j]='\0';
      
    }
  tokenArray[i].contesto=NULL;
  tokenArray[i].parola=NULL;
  if(i >= (dimT-1)) return BUFFER_TOO_SMALL;
  torna = printTokens(tokenArray,dimT);   
  
  return RESULT_OK;
}

////////////////////////////////////
// Stampa i vari TOKEN della mail //
////////////////////////////////////

int printTokens(Token tokenArray[], int dimT)
{
  int i=0,stampa=0;
  if(tokenArray == NULL) return NULL_POINTER; 
  while(tokenArray[stampa].parola != NULL)
    {
      if(i == dimT) return BUFFER_TOO_SMALL;  
      if(tokenArray[stampa].contesto != NULL)
	printf("%s*%s\n",tokenArray[stampa].contesto, tokenArray[stampa].parola);
      else
	printf("%s\n",tokenArray[stampa].parola);
      stampa++;
    } 
  return RESULT_OK;
}


