#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include "modulo1.h"
#include "testModulo1.h"
#include "modulo1.c"

//////////////////////////////////////
// TEST DI LEGGI FILE ////////////////
//////////////////////////////////////
int test_leggiFile(int tipo_di_test, int n_argomento)
{
  int risultato = 0;
  int dimensione = 1000;
  char *pippo = {"email.txt"};
  char testo[1000]; 
  
  ///////////////////////////
  // prova pippo = NULL ///// 
  ///////////////////////////
  
  if(tipo_di_test == NULL_POINTER && n_argomento == 0)
    {
      risultato = leggiFile(NULL,dimensione,testo);
      if(risultato == EMPTY_STRING)
	return TEST_PASSED;
      else if (risultato == RESULT_OK)
	{
	  printf("Il test ha fallito:\nLa funzione LeggiFile ha ricevuto il primo argomento vuoto e non se ne  accorta!!!\n ");
	  return TEST_FAILED;
	}
    }
  ////////////////////////////
  // prova testo == NULL /////
  ////////////////////////////
  
  else if (tipo_di_test == NULL_POINTER && n_argomento == 2)
    {
      risultato = leggiFile(pippo,dimensione,NULL);
      if(risultato == NULL_POINTER)
	return TEST_PASSED;
      else if (risultato == RESULT_OK)
	{
	  printf("Il test ha fallito:\nLa funzione LeggiFile ha ricevuto il terzo agomento minore o uguale a 0\n");  
	return TEST_FAILED;
	}
    }
  
  ////////////////////////////
  // prova buffer too small //
  ////////////////////////////
  else if(tipo_di_test == BUFFER_TOO_SMALL  && n_argomento == 1)
    {
      risultato = leggiFile(pippo,0,testo);
      if(risultato == BUFFER_TOO_SMALL)
	return TEST_PASSED;
      else if(risultato == RESULT_OK)
	{
	  printf("Il test ha fallito:\nLa funzione LeggiFile ha ricevuto il secondo agomento minore o uguale a 0\n");
	  return TEST_FAILED;
	}
    }
  else return NOT_IMPLEMENTED;
}

//////////////////////////////////
// TEST DI ESTRAI HEADER ////////
/////////////////////////////////

int test_estraiHeaders(int tipo_di_test, int n_argomento)
{
  int risultato = 0;
  int dimensione = 1000;
  char *pippo = {"MannaggiaEva"};
  char testo[1000]; 
  
  ///////////////////////////
  // prova pippo = NULL ///// 
  ///////////////////////////
  
  if(tipo_di_test == NULL_POINTER && n_argomento == 0)
    {
      risultato = leggiFile(NULL,dimensione,testo);
      if(risultato == EMPTY_STRING)
	return TEST_PASSED;
      else if (risultato == RESULT_OK)
	{
	  printf("Il test ha fallito:\nLa funzione LeggiFile ha ricevuto il primo argomento vuoto e non se ne  accorta!!!\n ");
	  return TEST_FAILED;
	}
    }
  ////////////////////////////
  // prova testo == NULL /////
  ////////////////////////////
  
  else if (tipo_di_test == NULL_POINTER && n_argomento == 2)
    {
      risultato = leggiFile(pippo,dimensione,NULL);
      if(risultato == NULL_POINTER)
	return TEST_PASSED;
      else if (risultato == RESULT_OK)
	{
	  printf("Il test ha fallito:\nLa funzione LeggiFile ha ricevuto il terzo agomento minore o uguale a 0\n");  
	return TEST_FAILED;
	}
    }
  
  ////////////////////////////
  // prova buffer too small //
  ////////////////////////////
  else if(tipo_di_test == BUFFER_TOO_SMALL  && n_argomento == 1)
    {
      risultato = leggiFile(pippo,0,testo);
      if(risultato == BUFFER_TOO_SMALL)
	return TEST_PASSED;
      else if(risultato == RESULT_OK)
	{
	  printf("Il test ha fallito:\nLa funzione LeggiFile ha ricevuto il secondo agomento minore o uguale a 0\n");
	  return TEST_FAILED;
	}
    }
  else return NOT_IMPLEMENTED;
}

///////////////////////////
// test di primo header ///
///////////////////////////

int test_primoHeader(int tipo_di_test, int n_argomento)
{
  int risultato = 0;
  int dimensione = 1000;
  char *pippo = {"email.txt"};
  char testo[1000]; 
  
  ///////////////////////////
  // prova pippo = NULL ///// 
  ///////////////////////////
  
  if(tipo_di_test == NULL_POINTER && n_argomento == 0)
    {
      risultato = leggiFile(NULL,dimensione,testo);
      if(risultato == EMPTY_STRING)
	return TEST_PASSED;
      else if (risultato == RESULT_OK)
	{
	  printf("Il test ha fallito:\nLa funzione LeggiFile ha ricevuto il primo argomento vuoto e non se ne  accorta!!!\n ");
	  return TEST_FAILED;
	}
    }
  ////////////////////////////
  // prova testo == NULL /////
  ////////////////////////////
  
  else if (tipo_di_test == NULL_POINTER && n_argomento == 2)
    {
      risultato = leggiFile(pippo,dimensione,NULL);
      if(risultato == NULL_POINTER)
	return TEST_PASSED;
      else if (risultato == RESULT_OK)
	{
	  printf("Il test ha fallito:\nLa funzione LeggiFile ha ricevuto il terzo agomento minore o uguale a 0\n");  
	return TEST_FAILED;
	}
    }
  
  ////////////////////////////
  // prova buffer too small //
  ////////////////////////////
  else if(tipo_di_test == BUFFER_TOO_SMALL  && n_argomento == 1)
    {
      risultato = leggiFile(pippo,0,testo);
      if(risultato == BUFFER_TOO_SMALL)
	return TEST_PASSED;
      else if(risultato == RESULT_OK)
	{
	  printf("Il test ha fallito:\nLa funzione LeggiFile ha ricevuto il secondo agomento minore o uguale a 0\n");
	  return TEST_FAILED;
	}
    }
  else return NOT_IMPLEMENTED;
}

///////////////////////////////
// test di parse Header //////
//////////////////////////////

int test_parseHeader(int tipo_di_test, int n_argomento)
{
  int risultato = 0;
  int dimensione = 1000;
  char *pippo = {"email.txt"};
  char testo[1000]; 
  
  ///////////////////////////
  // prova pippo = NULL ///// 
  ///////////////////////////
  
  if(tipo_di_test == NULL_POINTER && n_argomento == 0)
    {
      risultato = leggiFile(NULL,dimensione,testo);
      if(risultato == EMPTY_STRING)
	return TEST_PASSED;
      else if (risultato == RESULT_OK)
	{
	  printf("Il test ha fallito:\nLa funzione LeggiFile ha ricevuto il primo argomento vuoto e non se ne  accorta!!!\n ");
	  return TEST_FAILED;
	}
    }
  ////////////////////////////
  // prova testo == NULL /////
  ////////////////////////////
  
  else if (tipo_di_test == NULL_POINTER && n_argomento == 2)
    {
      risultato = leggiFile(pippo,dimensione,NULL);
      if(risultato == NULL_POINTER)
	return TEST_PASSED;
      else if (risultato == RESULT_OK)
	{
	  printf("Il test ha fallito:\nLa funzione LeggiFile ha ricevuto il terzo agomento minore o uguale a 0\n");  
	return TEST_FAILED;
	}
    }
  
  ////////////////////////////
  // prova buffer too small //
  ////////////////////////////
  else if(tipo_di_test == BUFFER_TOO_SMALL  && n_argomento == 1)
    {
      risultato = leggiFile(pippo,0,testo);
      if(risultato == BUFFER_TOO_SMALL)
	return TEST_PASSED;
      else if(risultato == RESULT_OK)
	{
	  printf("Il test ha fallito:\nLa funzione LeggiFile ha ricevuto il secondo agomento minore o uguale a 0\n");
	  return TEST_FAILED;
	}
    }
  else return NOT_IMPLEMENTED;
}

/////////////////////////////

int test_primaParola(int tipo_di_test, int n_argomento)
{
  int risultato = 0;
  int dimensione = 1000;
  char *pippo = {"email.txt"};
  char testo[1000]; 
  
  ///////////////////////////
  // prova pippo = NULL ///// 
  ///////////////////////////
  
  if(tipo_di_test == NULL_POINTER && n_argomento == 0)
    {
      risultato = leggiFile(NULL,dimensione,testo);
      if(risultato == EMPTY_STRING)
	return TEST_PASSED;
      else if (risultato == RESULT_OK)
	{
	  printf("Il test ha fallito:\nLa funzione LeggiFile ha ricevuto il primo argomento vuoto e non se ne  accorta!!!\n ");
	  return TEST_FAILED;
	}
    }
  ////////////////////////////
  // prova testo == NULL /////
  ////////////////////////////
  
  else if (tipo_di_test == NULL_POINTER && n_argomento == 2)
    {
      risultato = leggiFile(pippo,dimensione,NULL);
      if(risultato == NULL_POINTER)
	return TEST_PASSED;
      else if (risultato == RESULT_OK)
	{
	  printf("Il test ha fallito:\nLa funzione LeggiFile ha ricevuto il terzo agomento minore o uguale a 0\n");  
	return TEST_FAILED;
	}
    }
  
  ////////////////////////////
  // prova buffer too small //
  ////////////////////////////
  else if(tipo_di_test == BUFFER_TOO_SMALL  && n_argomento == 1)
    {
      risultato = leggiFile(pippo,0,testo);
      if(risultato == BUFFER_TOO_SMALL)
	return TEST_PASSED;
      else if(risultato == RESULT_OK)
	{
	  printf("Il test ha fallito:\nLa funzione LeggiFile ha ricevuto il secondo agomento minore o uguale a 0\n");
	  return TEST_FAILED;
	}
    }
  else return NOT_IMPLEMENTED;
}

/////////////////////////////
// test di tokenizza mail ///
/////////////////////////////

int test_tokenizzaEmail(int tipo_di_test, int n_argomento)
{
  
  int risultato = 0;
  int dimensione = 1000;
  char *pippo = {"email.txt"};
  char testo[1000]; 
  
  ///////////////////////////
  // prova pippo = NULL ///// 
  ///////////////////////////
  
  if(tipo_di_test == NULL_POINTER && n_argomento == 0)
    {
      risultato = leggiFile(NULL,dimensione,testo);
      if(risultato == EMPTY_STRING)
	return TEST_PASSED;
      else if (risultato == RESULT_OK)
	{
	  printf("Il test ha fallito:\nLa funzione LeggiFile ha ricevuto il primo argomento vuoto e non se ne  accorta!!!\n ");
	  return TEST_FAILED;
	}
    }
  ////////////////////////////
  // prova testo == NULL /////
  ////////////////////////////
  
  else if (tipo_di_test == NULL_POINTER && n_argomento == 2)
    {
      risultato = leggiFile(pippo,dimensione,NULL);
      if(risultato == NULL_POINTER)
	return TEST_PASSED;
      else if (risultato == RESULT_OK)
	{
	  printf("Il test ha fallito:\nLa funzione LeggiFile ha ricevuto il terzo agomento minore o uguale a 0\n");  
	return TEST_FAILED;
	}
    }
  
  ////////////////////////////
  // prova buffer too small //
  ////////////////////////////
  else if(tipo_di_test == BUFFER_TOO_SMALL  && n_argomento == 1)
    {
      risultato = leggiFile(pippo,0,testo);
      if(risultato == BUFFER_TOO_SMALL)
	return TEST_PASSED;
      else if(risultato == RESULT_OK)
	{
	  printf("Il test ha fallito:\nLa funzione LeggiFile ha ricevuto il secondo agomento minore o uguale a 0\n");
	  return TEST_FAILED;
	}
    }
  else return NOT_IMPLEMENTED;
}


