#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <math.h>
#include <ctype.h>
#include "modulo1.h"

int leggiFile(char * nomefile, int dimensione, char * testo) {

    char * postesto = testo;
    char * emptychar = "\0";
   
    int buffcounter = 0;
    int fchar;
    FILE * readtext;
 	
    
    /*Verifica se i puntatori sono nulli*/
    if (nomefile == NULL || testo == NULL) return NULL_POINTER;
  
    /*controllo sulla comparazione*/
    if (strcmp(nomefile, emptychar) == 0) return EMPTY_STRING;

    /*verifica la correttezza del nome e del modo del file*/
    if ((readtext = fopen( nomefile, "r")) == NULL) return FILE_MISSING;
         
    else {
		          
          while (!feof(readtext)) 
          		{          	
                 fchar = fgetc(readtext);
                 /* controlla che il file non sia vuoto*/
                 if( fchar == -1 && buffcounter == 0)
                 	return FILE_EMPTY;
                 /*copia il carattere letto alla posizione puntata dal cursore postesto*/
                 memset(postesto, fchar, sizeof(char));
                 /*conta quanti caratteri ho inserito nel buffer*/
                 buffcounter++;
                 /*aggiorna la posizione del cursore*/
                 postesto = postesto + sizeof(char);
                 /*se il numero di caratteri inseriti supera dimensione inserisce il carattere 
                   ti terminazione nell'ultima cella di memoria del buffer */
                 if (buffcounter > dimensione)
                 	{
                 	 postesto = testo + (dimensione * sizeof(char));
                 	 postesto = strcpy (postesto, emptychar);
                 	 return BUFFER_TOO_SMALL;
                 	}               
                }
         }

  
  fclose(readtext);
  return RESULT_OK;
}



int estraiHeaders(char * email, char * headers, int dimh) 
{
 
 char * posemail = email;
 char * endemail;
 char * emptychar = "\0";
 char * newlinec = "\n";
 char * poshead;
 int dimheader = 0;
 
 /*verifica se i due puntatori passati sono NULL*/
 if( email == NULL || headers == NULL) return NULL_POINTER;
 
 /*verifica se email punta ad una stringa vuota*/
 if (strcmp(email, emptychar) == 0) return EMPTY_STRING;
 
 /*endemail punta all'ultimo carattere della stringa passata (quindi all'ultima locazione di memoria)*/
 endemail = strchr(email, *emptychar); 
 
 /*finche' il mio puntatore resta nel buffer...*/
 while (posemail < endemail)
 	 { 
 	  //...il cursore punta alla prima occorrenza di un \n...
 	  posemail = strchr(posemail, *newlinec);
 	  if ((posemail - email) == 0) return HEADER_NOT_FOUND;
 	  	//...se nella cella successiva a quella puntata dal mio cursore c' un altro \n...
 	  	if( * (posemail + sizeof(char)) == * newlinec) 
 	  		{
 	  		 //...ho trovato il blocco degli headers e calcolo la sua dimensione...
 	  		 dimheader = posemail - email + sizeof(char);
 	  	     //... se la dimensione dell'headers trovato  maggiore uguale della dimensione di quello 
 	  	     //    passato alla funzione....
 	  	     if (dimheader > dimh) 
 				{
 	 			 // ...copio dimh -1 caratteri dentro al buffer passato e faccio ritornare l'errore BTS	 			 
 	 			 headers = strncpy(headers, email, (dimh-1));
 	 			 poshead = headers + ((dimh) * sizeof(char));
 	 			 poshead = strcpy (poshead, emptychar);; 
 	 			 return BUFFER_TOO_SMALL;
 				}
 
			 else
 				{
 	 			 //...altrimenti copio tutti i caratteri dell'headers nel buffer passato 
 	 			 //aggiungo il carattere di terminazione e ritorno RO
 	 			 headers = strncpy(headers, email, (dimheader-1)); 	 			 
 	 			 poshead = headers + ((dimheader) * sizeof(char));
 	 			 poshead = strcpy (poshead, emptychar);; 
 	 			 return RESULT_OK;
 				}
 	  	    }
 	  	else 
 	  		// se non c' un altro \n sposto il cursore al carattere successivo al \n e ripeto il ciclo
 	  		posemail = posemail + sizeof(char); 
 	  		
 	 }
 
 /*Assumendo che il ciclo termini correttamente solo se non  stato trovato un blocco headers all'interno
 	della email, l'ultima istruzione far ritornare alla funzione l'errore HNF*/
 
 return HEADER_NOT_FOUND;
 
}



int primoHeader(char * headers, char * primo_header, int dim) {

char * posheaders = headers;
char * endheaders;
char * posprimh;
char * cspace = " ";
char * cnewline = "\n";
char * emptychar = "\0";
char * ctabul = "\t";
int dimfirsth = 0;

// controllo che i due puntatori identifichino una zona di memoria correttamente allocata
if( headers == NULL || primo_header == NULL)
	return NULL_POINTER;

//controllo che la stringa contenente il blocco degli headers non sia vuota

if (strcmp(headers, emptychar) == 0) 
	return EMPTY_STRING;

//endheaders punta alla fine della stringa headers passata alla funzione
endheaders = strchr( headers, *emptychar);

//controlla se il primo carattere dell'headers e' "corretto" 
if ( * posheaders == * cspace || * posheaders == * ctabul)
	return BAD_HEADER; 

//finch il mio "cursore" punta all'interno della memoria allocata in cui  memorizzata la stringa...
while (posheaders < endheaders )
	{
	 //...il cursore punta alla prima occorrenza di un \n...se per caso non ci sono altri \n ma \0...
	 if ( (posheaders = strchr(posheaders, *cnewline)) == NULL)
	 	{
	 	 dimfirsth = strlen(headers);
	 	 primo_header = strncpy(primo_header, headers, dimfirsth);
	 	 posprimh = primo_header + ((dimfirsth +1) * sizeof(char));
	 	 posprimh = strcpy(posprimh, emptychar);
	 	 return RESULT_OK;
	 	}
	 //...se il primo headers non e' composto da pi righe...
	 if (*(posheaders + sizeof(char)) != *cspace || *(posheaders + sizeof(char)) != *ctabul )
	 	{
	 	 //...allora ho trovato il primo headers e ne calcolo la dimensione...
	 	 dimfirsth = posheaders - headers + sizeof(char);
	 	 //...comparo la dimensione del primo header con la dimensione del buffer...
	 	 if (dimfirsth >= dim)
	 	 	{
	 	 	 //...se la stringa che ho trovato  pi grande della dimensione del buffer...
	 	 	 //...copio dim-1 caratteri dentro il buffer...
	 	 	 primo_header = strncpy (primo_header, headers, dim-1);
	 	 	 //...aggiungo il carattere di terminazione...
	 	 	 posprimh = primo_header + ((dim) * sizeof(char));
	 	 	 posprimh = strcpy(posprimh, emptychar);
	 	 	 //...e ritorno il codice di errore BTS
	 	 	 return BUFFER_TOO_SMALL;	 	 	 
	 	 	}
	 	
	 	 else
	 	 	{
	 	 	 //...altrimenti copio tutto l'headers trovato dentro primo_headers...
	 	 	 primo_header = strncpy (primo_header, headers, (dimfirsth-1));
	 	 	 //...inserisco il carattere di terminazione alla fine e faccio tornare RO
	 	 	 posprimh = primo_header + ((dimfirsth) * sizeof(char));
	 	 	 posprimh = strcpy(posprimh, emptychar);;
	 	 	 return RESULT_OK;	 	 	
	 	 	}	 	
	 	}
	
	 else
	 	//...altrimenti, essendo composto da pi righe, punta al prossimo \n e riesegui il ciclo
	 	posheaders = posheaders + sizeof(char);
	}

 //come nella funzione estrai headers se il programma eseguir la riga i codice sottostante,
 // vuol dire che non  stato trovato nessun primo header
 
 return HEADER_NOT_FOUND;

}


int parseHeader(char * header, char * tipo, int dimt, char * valore, int dimv) 
{
 char * posheader;
 char * postipo;
 char * posvalore;
 char * endheader;
 char * cspace = " ";
 char * cnewline = "\n";
 char * emptychar = "\0";
 char * startvalore; 
 int dimto = 0;
 int dimvo = 0;
 
 
 //controllo se i puntatori passati siano uguali a null
 if ( header == NULL || tipo == NULL || valore == NULL)
 	return NULL_POINTER;

 //controllo se l'header passato alla funzione non sia vuoto
 if (strcmp(header, emptychar) == 0)
 	return EMPTY_STRING;
 
 //identifico la posizione del carattere di terminazione, quindi della fine della stringa
 endheader = strchr( header, *emptychar);
 
 
 //TIPO
 //ricavo la lunghezza della prima parola dell'header che dovrebbe rappresentare il tipo
 posheader = strchr( header, *cspace);
 dimto = posheader - header; 
 
 //se la stringa tipo trovata nell'header  pi grande della 
 //dimensione di memoria allocata per contenerla...
 if (dimto > dimt) 	
 	{
 	 //...copio dimt-1 caratteri...
 	 tipo = strncpy(tipo, header, (dimt-1));
 	 postipo = tipo + (dimt * sizeof(char));
 	 postipo = strcpy (postipo, emptychar);; 	 
 	 // ritorna BTS 	 
 	 return BUFFER_TOO_SMALL;
 	}
 else
 	{
 	 //altrimenti, copia la stringa tipo trovata nel buffer ed inserisci il carattere di terminazione
 	 tipo = strncpy(tipo, header, (dimto)); 	 
 	 postipo = tipo + (dimto *sizeof(char));
 	 postipo = strcpy (postipo, emptychar);;
 	} 	
 
 
 //VALORE
 //punto startvalore alla prima parola dopo lo spazio
 startvalore = posheader + sizeof(char);
 posheader = posheader + sizeof(char);
 
 //mi ricavo la lunghezza della stringa valore
 posheader = strchr (startvalore, *emptychar);
 dimvo = posheader - startvalore;
 
 //se la stringa valore trovata nell'header  pi grande della
 //dimensione di memoria allocata per contenerla...
 if (dimvo > dimv)
 	{
 	 //...copio dimv-1 caratteri...
 	 valore = strncpy(valore, startvalore, (dimv-1));
 	 posvalore = valore + (dimv * sizeof(char));
 	 posvalore = strcpy (posvalore, emptychar);;
 	 // ritorna BTS
 	 return BUFFER_TOO_SMALL;
 	}  	
 else
 	{
 	 //altrimenti copio tutta la stringa valore trovata ed inserisci il carattere di terminazione
 	 valore = strncpy(valore, startvalore, (dimvo +1)); 	
 	 posvalore = valore + (dimvo * sizeof(char));
 	 posvalore = strcpy (posvalore, emptychar);;
 	 return RESULT_OK;
 	}

return UNKNOWN_ERROR;
}



int primaParola(char * testo, char * parola, int dim) 
{
 char * postesto = testo;
 char * posparola = parola;
 char * emptychar = "\0";
 char exchar;
 int flagtw = 0;
 int dimfw = 0;

 //controllo che i due puntatori non siano nulli
 if ( testo == NULL || parola == NULL)
 	return NULL_POINTER;
 
 //controllo che testo non sia una stringa vuota
 if (strcmp(testo, emptychar) == 0)	
 	return EMPTY_STRING;
 	
 //inizio a scorrermi il testo...
 while ( *postesto != *emptychar)
 	{
 	 //controllo che il carattere puntato sia una cifra od una lettera
 	 exchar = * postesto;   	 
 	 postesto = postesto + sizeof(char);
 	 if (isalnum((int)exchar) != 0)
 	 	{
 	 	 if(isalnum((int)(* postesto)) != 0 || flagtw == 1)
 	 	   {
 	 	 	//ho iniziato a leggere un carattere valido
 	 	 	flagtw = 1;
 	 	 	//la copio nella stringa parola
 	 	 	memset(posparola, exchar, sizeof(char));
 	 	 	//aggiorno il contatore dei caratteri da copiare
 	 	 	dimfw++;
 	 	 	//aggiorno la posizione del cursore parola
 	 	 	posparola = posparola + sizeof(char);
 	 	 	//controllo se il numero dei caratteri copiati  maggiore o uguale a dim
 	 	 	if (dimfw >= dim)
 	 	 		{
 	 	 	 	 posparola = parola + (dim * sizeof(char));
 	 	 	 	 posparola = strcpy(posparola, emptychar);
 	 	 	 	 return BUFFER_TOO_SMALL;
 	 	 		}
 	 	 	} 	 			 	 	 	
 	 	}	
	 
	 else
	 	if (flagtw == 1)
	 		{
	 	 	 posparola = parola + (dimfw * sizeof(char));
         	 posparola = strcpy(posparola, emptychar);
         	 return RESULT_OK;
	 		}		
	}

 if (dimfw == 0)
 	return UNKNOWN_ERROR;
 else
 	{
 	 posparola = parola + ((dimfw) * sizeof(char));
     posparola = strcpy(posparola, emptychar);
     return RESULT_OK;
 	}
}



int tokenizzaEmail(char * email, Token tokenArray[], int dimT) 
{
 char * bheaders;
 char * posbhead;
 char * endbhead;
 
 char * pheader;
  
 char * fvalore;
 char * posfval;
 char * endfval;
 
 char * ftipo;
 char * fparola;
 
 char * posemail;
 char * endemail;
 char * emptychar = "";
 char * startbody;
 
 char exchar;
 
 int lenght = 0;
 
 int dimbhead = 0;
 int dimphead = 0;
 int dimfparola = 0;
 int dimftipo = 0;
 int dimfvalore = 0;
 int dimarrayT = 0;
 
 int funresult = 8;
 int dimcontrol = 0;
 
 //controllo che email non sia un puntatore NULL
 if (email == NULL)
 	return NULL_POINTER;
 
 //controllo che email non sia una stringa vuota
 if (strcmp (email, emptychar) == 0)
 	return EMPTY_STRING;
 
 //alloco memoria per contenere l'header
 do 
 	{
 	 dimbhead = dimbhead + 500;
 	 bheaders = (char*)calloc(dimbhead, sizeof(char));
 	 if (bheaders == NULL)
 	 	return MEM_ALLOC_ERROR;
 	 funresult = estraiHeaders(email, bheaders, dimbhead);
 	 //la funzione pu tornare solo due codici adeguati, o RESULT_OK o BUFFER_TOO_SMALL
 	 //in caso di altri errori, la funzione ritorna l'errore trovato
 	 switch (funresult)
 	 	{
 	 	 case 1:
 	 	 	free(bheaders);
 	 	 	return UNKNOWN_ERROR;
 	 	 case 2: 
 	 	 	free(bheaders);
 	 	 	return NULL_POINTER;
 	 	 case 3:
 	 	 	free(bheaders);
 	 	 	return EMPTY_STRING;
 	 	 case 9: 
 	 	 	free(bheaders);
 	 	 	return HEADER_NOT_FOUND;
 	 	}
 	 //se la funzione mi ritorna BUFFER_TOO_SMALL, ripeti il ciclo aumentando la dimensione del buffer
 	} while (funresult == 8);
 
 //startbody memorizza l'inizio del corpo del messaggio (bloccoheaders + i due \n)

 startbody = email + ((strlen(bheaders) + 2)*sizeof(char));
 endemail = strchr( email, *emptychar);
 
 //controllo che esista il corpo della email
 if(startbody == endemail)
 	{
 	 free(bheaders);
 	 return BODY_NOT_FOUND;
 	}
  
 //ANALIZZO IL BLOCCO HEADERS
 funresult = 8;
 posbhead = bheaders;
 endbhead = strchr( bheaders, *emptychar);
 
 while (posbhead < endbhead)
 	{
 	 do //alloca la memoria per contenere primoheader
 	 	{
 	 	 dimphead = dimphead + 200;
 	 	 pheader = (char*)calloc(dimphead, sizeof(char));
 	 	 //se non riesce ad allocare memoria torna MAE
 	 	 if (pheader == NULL)
 	 	 	{
 	 	 	 free(bheaders);
 	 	 	 return MEM_ALLOC_ERROR;
 	 	 	}
 	 	 //prendi il primo header
 	 	 funresult = primoHeader(posbhead, pheader, dimphead);
 	 	 //controlla il risultato di funresult, gli unici due valori per cui pu continuare il
 	 	 //programma sono RESULT_OK e BUFFER_TOO_SMALL
 	 	 switch (funresult)
 	 	 	{
 	 	 	 case 1:
 	 	 	 	free(pheader);
 	 	 	 	free(bheaders);
 	 	 	 	return UNKNOWN_ERROR;
 	 	 	 case 2:
 	 	 	 	free(pheader);
 	 	 	 	free(bheaders);
 	 	 	 	return NULL_POINTER;
 	 	 	 case 3:
 	 	 	 	free(pheader);
 	 	 	 	free(bheaders);
 	 	 	 	return EMPTY_STRING;
 	 	 	 case 9:
 	 	 	 	free(pheader);
 	 	 	 	free(bheaders);
 	 	 	 	return HEADER_NOT_FOUND;
 	 	 	 case 11:
 	 	 	 	free(pheader);
 	 	 	 	free(bheaders);
 	 	 	 	return BAD_HEADER;
 	 	 	}
 	 	 //se la funzione mi ritorna BUFFER_TOO_SMALL, ripeti il ciclo aumentando la dimensione del buffer 	 	
 	 	} while (funresult == 8);
 	 
 	 //ANALIZZO IL PRIMOHEADER	
 	 	
 	 //alloco la memoria per i buffer tipo e valore
 	 dimftipo = dimphead +1;
 	 dimfvalore = dimphead + 1;	 
 	 fvalore = (char*)calloc(dimfvalore, sizeof(char));	 
 	 ftipo = (char*)calloc(dimftipo, sizeof(char));
 	 //se non riesce ad allocare memoria, libera la memoria allocata in precendenza e torna MAE
 	 if (fvalore == NULL || ftipo == NULL)
 	 	{
 	 	 free(bheaders);
 	 	 free(pheader);
 	 	 return MEM_ALLOC_ERROR;
 	 	}
 	 funresult = parseHeader(pheader, ftipo, dimftipo, fvalore, dimfvalore);
 	 switch (funresult)
 	 	{
 	 	 case 1:
 	 	 	free(fvalore);
 	 	 	free(ftipo);
 	 	 	free(pheader);
 	 	 	free(bheaders);
 	 	 	return UNKNOWN_ERROR;
 	 	 case 2:
 	 	 	free(fvalore);
 	 	 	free(ftipo);
 	 	 	free(pheader);
 	 	 	free(bheaders);
 	 	 	return NULL_POINTER;
 	 	 case 3:
 	 	 	free(fvalore);
 	 	 	free(ftipo);
 	 	 	free(pheader);
 	 	 	free(bheaders);
 	 	 	return EMPTY_STRING;
 	 	 case 11: 
 	 	 	free(fvalore);
 	 	 	free(ftipo);
 	 	 	free(pheader);
 	 	 	free(bheaders);
 	 	 	return BAD_HEADER;
 	 	}
 	 
 	 // ANALIZZO VALORE
 	 	 
 	 fparola = (char*)calloc(dimfvalore, sizeof(char));
 	 //se non riesce ad allocare memoria, libera la memoria allocata in precendenza e torna MAE
 	 if ( fparola == NULL)
 	 	{
 	 	 free(fvalore);
 	 	 free(ftipo);
 	 	 free(pheader);
 	 	 free(bheaders);
 	 	 return MEM_ALLOC_ERROR;
 	 	}
 	 posfval = fvalore;
 	 endfval = strchr( fvalore, *emptychar);
 	 	 
 	 do
 	 	{
 	 	 exchar = *posfval;	 	 	 
 	 	 if (isalnum((int)exchar) != 0)
 	 	 	{
 	 	 	 if (isalnum((int)(*(posfval + sizeof(char)))) != 0)
 	 	 	 	{
 	 	 	 	 funresult = primaParola(posfval, fparola, dimfvalore);
 	 	 	 	 switch (funresult)
 	 	 	 		 {
 	 	 	 	 	  case 1: 
 	 	 	 	 	  	free(fparola);
 	 	 	 	 	  	free(fvalore);
 	 	 			  	free(ftipo);
 	 	 	 	 	  	free(pheader);
 	 	 	 	 	  	free(bheaders);
 	 	 	 	 	  	return UNKNOWN_ERROR;
 	 	 	 	 	  case 2:
 	 	 	 	 		free(fparola);
 	 	 	 	 		free(fvalore);
 	 	 				free(ftipo);
 	 	 	 	 		free(pheader);
 	 	 	 	 		free(bheaders);
 	 	 	 	 		return NULL_POINTER;
 	 	 	 	 	  case 3:
 	 	 	 	 		free(fparola);
 	 	 	 	 		free(fvalore);
 	 	 				free(ftipo);
 	 	 	 	 		free(pheader);
 	 	 	 	 		free(bheaders);
 	 	 	 	 		return EMPTY_STRING;
 	 	 	 		 }
 	 	 	 
 	 	 	 	if(dimarrayT > dimT)
 	 	 	 		return BUFFER_TOO_SMALL;
 	 	 	  
 	 	 	 	//inserisco tipo e valore dentro i campi contesto e valore di un elemento dell'array
 	 	 	 	
 	 	 	 	tokenArray[dimarrayT].contesto =(char*)calloc(strlen(ftipo) + 1, sizeof(char));  	 	 	
 	 	 	 	tokenArray[dimarrayT].contesto = strcpy (tokenArray[dimarrayT].contesto, ftipo);
 	 	 	 	tokenArray[dimarrayT].parola = (char*)calloc(strlen(fparola)  + 1, sizeof(char));
 	 	 	 	tokenArray[dimarrayT].parola = strcpy (tokenArray[dimarrayT].parola, fparola);
 	 	 	 	dimarrayT++;  
 	 	 	  	 	 	 
 	 	 	 	posfval = posfval + ((strlen(fparola) + 1) * sizeof(char));
 	 	 	 	
 	 	 	 	} //end isalnum secondchar 	 	  
 	 	 	  else
 	 	 	  	posfval = posfval + sizeof(char);
 	 	 	 } //end if isalnum primochar
 	 	 
 	 	 else
 	 	 	posfval = posfval + sizeof(char);
 	 	 
 	 	 } while (posfval <= endfval);	 	 	
 	
 	posbhead = posbhead + ((strlen(pheader) + 1) * sizeof(char));
 	} //chiusura while blocco headers
 	
 //libero la memoria usata per analizzare il blocco degli headers
 free(fparola);
 free(fvalore);
 free(ftipo);
 free(pheader);
 free(bheaders);
 
 //ANALIZZO IL CORPO DEL MESSAGGIO
 posemail = startbody;
 	
 fparola = (char*)calloc(100, sizeof(char));
 //se non riesce ad allocare memoria torna MAE
 if (fparola == NULL)
 	return MEM_ALLOC_ERROR;
 	
 do
 	{
 	 exchar = *posemail;
 	 if(isalnum((int)exchar) != 0)
 	 	{
 	 	 if(isalnum((int)(*(posemail + sizeof(char)))) != 0)
 	 	 	{
 	 	 	 funresult = primaParola(posemail, fparola, 100);
 	 	 	 switch (funresult)
 	 	 		 {
 	 	 	 	  case 1:
 	 	 	 		free(fparola);
 	 	 	 		return UNKNOWN_ERROR;
 	 	 	 	  case 2:
 	 	 	 		free(fparola);
 	 	 	 		return NULL_POINTER;
 	 	 	 	  case 3:
 	 	 	 		free(fparola);
 	 	 	 	 	return EMPTY_STRING;
 	 	 	 	  case 8:
 	 	 	 		free(fparola);
 	 	 	 		return BUFFER_TOO_SMALL; 	 	 
 	 	 		 }
 	 	
 	 	 	 if(dimarrayT > dimT)
 	 	 	 	  {
 	 	 	 	  free(fparola);
 	 	 	 	  return BUFFER_TOO_SMALL;
 	 	 	 	  }
 	 	 	 //inserisco tipo e valore dentro i campi contesto e valore di un elemento dell'array
 	 	 	 tokenArray[dimarrayT].contesto = NULL; 
 	 	 	 tokenArray[dimarrayT].parola = (char*)calloc(strlen(fparola)  + 1, sizeof(char));
 	 	 	 tokenArray[dimarrayT].parola = strcpy (tokenArray[dimarrayT].parola, fparola);
 	 	 	 dimarrayT++;
 	 	 
 	 	 	 posemail = posemail + ((strlen(fparola) + 1) * sizeof(char));
 	 	 
 	 		} //end secondisalnum
 	 	 else
 	 	 	posemail = posemail + sizeof(char);
 	 	} //end if primoisalnum
 	 
 	 else
 	 	posemail = posemail + sizeof(char);
 	} while (posemail < endemail);
 	
tokenArray[dimarrayT].contesto = NULL;
tokenArray[dimarrayT].parola = NULL;

free(fparola);
return RESULT_OK; 
 
} //end tokenizzaEmail




int printTokens(Token tokenArray[], int dimT) 
{
 int i = 0;
 
 if (tokenArray[i].contesto == NULL && tokenArray[i].parola == NULL)
 	 	return UNKNOWN_ERROR;
 
 for (i = 0; i <= dimT; i++)
 	{ 
 	 if (tokenArray[i].contesto == NULL && tokenArray[i].parola == NULL)
 	 	return RESULT_OK;
 	 
 	 else
 	 	
 	 	if (tokenArray[i].contesto == NULL)
 	 		{
 	 	 	 printf("%s\n", tokenArray[i].parola);
 	 		}
 	 	else
 	 		printf("%s*%s\n", tokenArray[i].contesto, tokenArray[i].parola);
 	}
}






