#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <math.h>
#include "modulo1.h"
#include "testModulo1.h"

char * determinamesserror (char * message, int tipotest, int result);
char * nametest(char * tname,int test);



/* Funzione che determina il messaggio di errore da stampare in caso di TEST_FAILED 

Assumo che se viene chiamata questa funzione, tipo_di_test e tresult non saranno MAI uguali. 
Quindi, in caso abbia un RESULT_OK ed  stata chiamata questa funzione vuol dire che il test
 fallito e di conseguenza cerco la causa vedendo che tipo di test ho effettuato.
Invece, per qualsiasi altro tipo di test, il messaggio di errore sar sempre dipendente solo
dal risultato ottenuto */  

char * determinamesserror (char * message, int tipotest, int result)	
{
 switch (result) 
 	{
 	 case RESULT_OK:
 	 	
 	 	switch (tipotest)
 	 		{
 	 		 case NULL_POINTER:
 	 		 	message = "la funzione non controlla se i puntatori passati sono NULL ";
 	 		 	break;
 	 		 case EMPTY_STRING:
 	 		 	message = "la funzione non controlla se una stringa passata e' vuota ";
 	 		 	break;
 	 		 case FILE_MISSING:
 	 		 	message = "La funzione non controlla se il file e' inesistente";
 	 		 	break;
 	 		 case FILE_UNREADABLE:
 	 		 	message = "la funzione non controlla se il file aperto non e' leggibile ";
 	 		 	break;
 	 		 case FILE_UNWRITABLE:
 	 		 	message = "la funzione non controlla se il file aperto non e' scrivibile ";
 	 		 	break;
 	 		 case FILE_EMPTY:
 	 		 	message = "la funzione non controlla se il file aperto e' vuoto ";
 	 		 	break;
 	 		 case BUFFER_TOO_SMALL:
 	 		 	message = "la funzione non controlla se il buffer e' minore rispetto al numero di bytes necessari ";
 	 		 	break;
 	 		 case HEADER_NOT_FOUND:
 	 		 	message = "La funziona non controlla se l'headers esiste";
 	 		 	break;
 	 		 case BODY_NOT_FOUND:
 	 		 	message = "La funzione non controlla se il corpo dell'email esista";
 	 		 	break;
 	 		 case BAD_HEADER:
 	 		 	message = "La funzione non controlla se la sintassi dell'headers e' corretta";
 	            break; 		 
 	 		 case MEM_ALLOC_ERROR:
 	 		 	message = "La funzione non controlla se e' stata allocata correttamente memoria";
 	 		 	break;
 	 		 default:
 	 		 	message = "tipo di errore sconosciuto";
 	 		 	break;	  	
 	 		}
 		
 		break;
 	 
 	 case UNKNOWN_ERROR:
 	 	message = "tipo di errore sconosciuto";
 	 	break;
 	 case NULL_POINTER:
 	 	message = "uno dei due parametri passati e' un puntatore NULL";
 	 	break;
 	 case EMPTY_STRING:
 	 	message = "uno dei puntatori ad una stringa passati puntava ad una stringa vuota";
 	 	break;
 	 case FILE_MISSING:
 	 	message = "il nome del file passato alla funzione non esiste";
 	 	break;
 	 case FILE_UNREADABLE:
 	 	message = "non  possibile leggere il file associato al nome passato alla funzione";
 	 	break;
 	 case FILE_UNWRITABLE:
 	 	message = "il file associato al nome passato alla funzione non e' modificabile";
 	 	break;
 	 case FILE_EMPTY:
 	 	message = "il file associato al nome passato alla funzione e' vuoto";
 	 	break;
 	 case BUFFER_TOO_SMALL:
 	 	message = "la dimensione del buffer  minore del numero di bytes necessari per l'intera memorizzazione della stringa";
 	 	break;
 	 case HEADER_NOT_FOUND:
 	 	message = "non  stato trovato nessun headers";
 	 	break;
 	 case BODY_NOT_FOUND:
 	 	message = "non  stato trovato il corpo dell'email";
        break; 	 		 
 	 case BAD_HEADER:
 	 	message = "una riga di un headers non segue la sintassi giusta";
 	 	break;
 	 case MEM_ALLOC_ERROR:
 	 	message = "il programma non  riuscito ad allocare un blocco di memoria";
 	 	break;
 	 		
 	}

return message;
}

char * nametest(char * tname, int test)
{
 switch (test)
   {	
 	case 0:
 		tname = "RESULT_OK";
 		break;
 	case 1:
 		tname = "UNKNOWN_ERROR";
 		break;
 	case 2:
 		tname = "NULL_POINTER";
 		break;
 	case 3:
 		tname = "EMPTY_STRING";
 		break;
 	case 4:
 		tname = "FILE_MISSING";
 		break;
 	case 5:
 		tname = "FILE_UNREADABLE";
 		break;
 	case 6:
 		tname = "FILE_UNWRITABLE";
 		break;
 	case 7:
 		tname = "FILE_EMPTY";
 		break;
 	case 8:
 		tname = "BUFFER_TOO_SMALL";
 		break;
 	case 9:
 		tname = "HEADER_NOT_FOUND";
 		break;
 	case 10:
 		tname = "BODY_NOT_FOUND";
 		break;
 	case 11:
 		tname = "BAD_HEADER";
 		break; 
 	case 12:
 		tname = "MEM_ALLOC_ERROR";
 		break;
   }
   
return tname;
}	
 







// eseguo un test sulla funzione leggiFile - i casi corretti verranno eseguiti su email1.txt
int test_leggiFile(int tipo_di_test, int argomento) {

char * tnomefile = "";
char * ttesto = ""; 
char * errormessage = "";
char * testname = "";

int tdimensione = 0;
int tresult = 0;

	switch (argomento) {
	
		case 0: // test sul puntatore a char nomefile
									
			// impongo che gli altri due paramentri siano corretti rispetto ad email1.txt
			ttesto = (char*)calloc(351, sizeof(char));
		    tdimensione = 351;
			
			switch(tipo_di_test) // seleziono il tipo di test per il parametro
				{
								
				 case RESULT_OK: // passo il nome corretto del file
								
					tnomefile = "email1.txt";
					break;
								
				 case NULL_POINTER: //passo un puntatore nullo come nome del file
								
					tnomefile = (void *)0;
					break;
								
				 case EMPTY_STRING: //passo una stringa vuota come nome del file
							
					tnomefile = "";
					break;
							
				 case FILE_MISSING: //passo un nome di un file inesistente
							
					tnomefile = "file-missing";
					break;
								
				 case FILE_UNREADABLE: //non implementata
						    
					return NOT_IMPLEMENTED;
						    
				 case FILE_UNWRITABLE: //non implementata
						    
					return NOT_IMPLEMENTED;
						    	
				 case FILE_EMPTY: //creo un file vuoto e resistuisco il nome
						    						    						
					tnomefile = "file-empty";					
					break;
					
				 default: // un tipo di test non sopraelencato non ha senso per questo argomento
				 	
				 	free(ttesto);
				 	return NOT_VALID;															
							
				} //end switch su tipo_di_test per arg 0
							
			// eseguo la funzione con i paramentri imposti
			tresult = leggiFile(tnomefile, tdimensione, ttesto);
								
			// libero la memoria che ho allocato per il test
			free(ttesto);
			
			switch (tresult) //confronto il risultato della funzione con le varie tipologie di test
							 //in caso tipo_di_test e tresult siano uguali il test  passato
							 //altrimenti lo switch termina correttamente  
				{
								
				 case RESULT_OK: 
					if (tipo_di_test == RESULT_OK) 
						return TEST_PASSED;						
					break;				
				 case NULL_POINTER: 
					if (tipo_di_test == NULL_POINTER)
						return TEST_PASSED;
					break;	
			     case EMPTY_STRING:
			    	if (tipo_di_test == EMPTY_STRING)
			    		return TEST_PASSED;
			    	break;	
			     case FILE_MISSING: 
			    	if (tipo_di_test == FILE_MISSING)
			    		return TEST_PASSED;
			    	break;	
			     case FILE_UNREADABLE: 
			    	if (tipo_di_test == FILE_UNREADABLE)
			    		return TEST_PASSED;
			    	break;	
			     case FILE_UNWRITABLE: 
			    	if (tipo_di_test == FILE_UNWRITABLE)
			    		return TEST_PASSED;
			    	break;	
			     case FILE_EMPTY:
			    	if (tipo_di_test == FILE_EMPTY)
			    		return TEST_PASSED; 
				    break;
				 
									     
			    } //end switch tresult per arg 0
			
	
            // visto che lo switch  terminato correttamente vuol dire che il test  fallito
            // determino il possibile messaggio di errore e stampo su stdout i relativi messaggi 
			errormessage = determinamesserror(errormessage, tipo_di_test, tresult);
			printf("Test Fallito:Funzione testata:  leggiFile(%s, %d, %s)\n", tnomefile, tdimensione, ttesto);
			testname = nametest(testname, tipo_di_test);
			printf("	     risultato Atteso:  %s\n", testname);
			testname = nametest(testname, tresult);
			printf("	     risultato ottenuto:%s\n", testname);
			printf("	     spiegazione: %s\n", errormessage );
			return TEST_FAILED;	
	
	    case 1: // test sul secondo argomento, la dimensione del buffer
	    	
	    	//impongo come validi gli altri due argomenti
	    	tnomefile = "email1.txt";
	    	ttesto = (char*)calloc(351, sizeof(char));
	    	
	    	switch (tipo_di_test)
	    		{
                                
                 case BUFFER_TOO_SMALL: //dimensione ha un valore pi piccolo di quello di cui si necessita
                 
                 	tdimensione = 200;
                 	break;
                 		
                 default: //altre tipologie di test su questo argomento non hanno senso
                 
                 	free(ttesto);
                 	return NOT_VALID;
                                  			    			    		
	    		} //end switch tipo_di_test per arg 1
	
	        tresult = leggiFile(tnomefile, tdimensione, ttesto);
	        
	        free(ttesto);
	        
	        switch (tresult)
	        
	        	{
	        	 case BUFFER_TOO_SMALL:
	        	 
	        	    if(tipo_di_test == BUFFER_TOO_SMALL)
	        	    	return TEST_PASSED;
	        	    break;	
	        	
	        	} //end switch tresult per arg 1 
	        	     
	        errormessage = determinamesserror(errormessage, tipo_di_test, tresult);
			printf("Test Fallito:Funzione testata:  leggiFile(%s, %d, %s)\n", tnomefile, tdimensione, ttesto);
			testname = nametest(testname, tipo_di_test);
			printf("	     risultato Atteso:  %s\n", testname);
			testname = nametest(testname, tresult);
			printf("	     risultato ottenuto:%s\n", testname);
			printf("	     spiegazione: %s\n", errormessage );
			return TEST_FAILED;
                	                     
	        	
	
	
	    case 2: //test sul terzo argomento, il buffer in cui copiare il testo
	    
	    	// impongo gli altri due argomenti come corretti
	    	tnomefile = "email1.txt";
	    	tdimensione = 351;
	    	
	    	switch (tipo_di_test)
	    		{    		 	
	    		 case NULL_POINTER: //il puntatore  NULL
	    		 
	    		 	ttesto = (void *)0;
	    		 	break;
	    		 case BUFFER_TOO_SMALL: //la memoria allocata non basta per copiare tutto il contenuto del file
	    		 
	    		 	ttesto = (char*)calloc(200,sizeof(char));
	    		 	tdimensione = 200;
	    		 	break;
	    		 	
	    		 default: //qualsiasi altro test su questo argomento non ha senso
	    		 	
	    		 	
	    		 	return NOT_VALID;	    		 
	    		 
	    		} //end switch tipo_di_test per arg 2	    	
	    	
	    	tresult = leggiFile(tnomefile, tdimensione, ttesto);
	    	
	    	free(ttesto);
	    	
	    	switch(tresult)
	    		{	    		 
	    		 case NULL_POINTER:
	    		 	if(tipo_di_test == NULL_POINTER)
	    		 		return TEST_PASSED;
					break;	    		 
	    		 case BUFFER_TOO_SMALL:
	    		 	if(tipo_di_test == BUFFER_TOO_SMALL)
	    		 		return TEST_PASSED; 
	    		 	break;	
	    		 	    		 
	    		 } // end switch tresult per arg 2 	
	    		 	
	    	errormessage = determinamesserror(errormessage, tipo_di_test, tresult);
			printf("Test Fallito:Funzione testata:  leggiFile(%s, %d, %s)\n", tnomefile, tdimensione, ttesto);
			testname = nametest(testname, tipo_di_test);
			printf("	     risultato Atteso:  %s\n", testname);
			testname = nametest(testname, tresult);
			printf("	     risultato ottenuto:%s\n", testname);
			printf("	     spiegazione: %s\n", errormessage );
			return TEST_FAILED;
	    		
	
	
	    default:
	    
	    	return ARG_MISSING;
	}    

}


// eseguo un test sulla funzione estraiHeaders
int test_estraiHeaders(int tipo_di_test, int argomento) 
{
 char * temail;
 char * theader = "";
 char * errormessage = "";
 char * testname = "";
 int tdimh = 0;
 int tresult = 0;

	switch (argomento) {
	
		case 0: // test sul primo argomento, il puntatore al testo della email
									
			theader = (char*)calloc(90, sizeof(char));
		    tdimh = 90;
			
			switch(tipo_di_test) 
				{
								
				 case RESULT_OK: // il testo dell'email ha un blocco header corretto 
								
					temail = "From: andrea@sterbini.org\nTo: babbo_natale@northpole.org\nSubject: Cosa vorrei per natale\n\nCaro Babbo Natale, \nblablablablablablabla\nblablablalbvlalalakoedkf\naofsjoasjf\n\nsadofjsdpojfs\n\0";
					break;
								
				 case NULL_POINTER: //il puntatore al testo dell'email e' NULL
								
					temail = (void *)0;
					break;
								
				 case EMPTY_STRING: //il testo dell'email e' vuoto
				 
				 	temail = "";
					break;				 
				 
				 case HEADER_NOT_FOUND: //il testo dell'email non ha un blocco header
							
					temail = "\nblablala\nblsidhiofanfioashfioashifoa\nsfisidfnhosidnfo\nspodjfsopdf\n\0";
					break;
											 
				 
				 default:  //qualsiasi altro test per questo argomento non ha senso
				 	
				 	free(theader);
				 	return NOT_VALID;															
							
				} //end switch su tipo_di_test per arg 0
							
			tresult = estraiHeaders(temail, theader, tdimh);
								
			free(theader);
			
			switch (tresult) 
				{
								
				 case RESULT_OK: 
					if (tipo_di_test == RESULT_OK)
						return TEST_PASSED;						
					break;				
				 case NULL_POINTER: 
					if (tipo_di_test == NULL_POINTER)
						return TEST_PASSED;
					break;	
			     case EMPTY_STRING:
			    	if (tipo_di_test == EMPTY_STRING)
			    		return TEST_PASSED;
			    	break;				   			     
			     case HEADER_NOT_FOUND:
			    	if (tipo_di_test == HEADER_NOT_FOUND)
			    		return TEST_PASSED; 
				    break;
				 
									     
			    } //end switch tresult per arg 0
			             
			errormessage = determinamesserror(errormessage, tipo_di_test, tresult);
			printf("Test Fallito:Funzione testata:  estraiHeaders(%s, %s, %d)\n", temail, theader, tdimh);
			testname = nametest(testname, tipo_di_test);
			printf("	     risultato Atteso:  %s\n", testname);
			testname = nametest(testname, tresult);
			printf("	     risultato ottenuto:%s\n", testname);
			printf("	     spiegazione: %s\n", errormessage );
			return TEST_FAILED;	
	
	    case 1: // test al secondo argomento, il puntatore alla zona di memoria dove dovr essere copiato il blocco degli headers
	    	
	    	temail = "From: andrea@sterbini.org\nTo: babbo_natale@northpole.org\nSubject: Cosa vorrei per natale\n\nCaro Babbo Natale, \nblablablablablablabla\nblablablalbvlalalakoedkf\naofsjoasjf\n\nsadofjsdpojfs\n\0";
	    	tdimh = 90;
	    	
	    	switch (tipo_di_test)
	    		{                 		
                 case NULL_POINTER: //il puntatore alla zona di memoria e' NULL
                 
                 	theader = (void*)0;
                 	break;
                 	
                 case BUFFER_TOO_SMALL: //la memoria allocata non e' sufficente
                 
                 	tdimh = 50; 
                 	theader = (char*)calloc(tdimh, sizeof(char));
                 	break;
                 
                 default: //qualsiasi altro test per questo argomento non ha senso
                 
                 	
                 	return NOT_VALID;
                                  			    			    		
	    		} //end switch tipo_di_test per arg 1
	
	        tresult =  estraiHeaders(temail, theader, tdimh);
	        
	        free(theader);
	        
	        switch (tresult)
	        
	        	{	        	 
	        	 case NULL_POINTER:
	        	 
	        	 	if(tipo_di_test == NULL_POINTER)
	        	 		return TEST_PASSED;
	        	 	break;
	        	 case BUFFER_TOO_SMALL:
	        	 
	        	    if(tipo_di_test == BUFFER_TOO_SMALL)
	        	    	return TEST_PASSED;
	        	    break;	
	        	 
	        	} //end switch tresult per arg 1
	        	     
	        errormessage = determinamesserror(errormessage, tipo_di_test, tresult);
			printf("Test Fallito:Funzione testata:  estraiHeaders(%s, %s, %d)\n", temail, theader, tdimh);
			testname = nametest(testname, tipo_di_test);
			printf("	     risultato Atteso:  %s\n", testname);
			testname = nametest(testname, tresult);
			printf("	     risultato ottenuto:%s\n", testname);
			printf("	     spiegazione: %s\n", errormessage );
			return TEST_FAILED;
                	                     
	        	
	
	
	    case 2: //test sul terzo argomento, la dimensione del buffer headers
	    
	    	temail = "From: andrea@sterbini.org\nTo: babbo_natale@northpole.org\nSubject: Cosa vorrei per natale\n\nCaro Babbo Natale, \nblablablablablablabla\nblablablalbvlalalakoedkf\naofsjoasjf\n\nsadofjsdpojfs\n\0";
	    	theader = (char*)calloc(90, sizeof(char));
	    	
	    	switch (tipo_di_test)
	    		{	    			    		 		    		 
	    		 case BUFFER_TOO_SMALL: //dimensione del blocco degli headers dell'email troppo piccola
	    		 	    		 	
	    		 	tdimh = 50;
	    		 	break;
	    		 	
	    		 default: //ogni altro tipo di test su questo argomento non ha senso
	    		 	
	    		 	free(theader);
	    		 	return NOT_VALID;	    		 
	    		 
	    		} //end switch tipo_di_test per arg 2	    	
	    	
	    	tresult =  estraiHeaders(temail, theader, tdimh);
	    	
	    	
	    	
	    	switch(tresult)
	    		{	    		 
	    		 case BUFFER_TOO_SMALL:
	    		 	if(tipo_di_test == BUFFER_TOO_SMALL)
	    		 		return TEST_PASSED; 
	    		 	break;	
	    		 
	    		 } //end switch tresult per arg 2
	    		 	
	    	errormessage = determinamesserror(errormessage, tipo_di_test, tresult);
			printf("Test Fallito:Funzione testata:  estraiHeaders(%s, %s, %d)\n", temail, theader, tdimh);
			testname = nametest(testname, tipo_di_test);
			printf("	     risultato Atteso:  %s\n", testname);
			testname = nametest(testname, tresult);
			printf("	     risultato ottenuto:%s\n", testname);
			printf("	     spiegazione: %s\n", errormessage );
			return TEST_FAILED;
	    		
	
	
	    default: //la funzione da testare non ha quest'argomento
	    
	    	return ARG_MISSING;
	}
    
    
}


// eseguo un test sulla funzione primoHeader
int test_primoHeader(int tipo_di_test, int argomento) 
{
 char * theaders;
 char * tprimohead = "";
 char * errormessage = "";
 char * testname = "";
 int tdim = 0;
 int tresult = 0;

	switch (argomento) {
	
		case 0: // test sul primo argomento, il puntatore al testo del blocco headers
									
			tprimohead = (char*)calloc(90, sizeof(char));
		    tdim = 90;
			
			switch(tipo_di_test) 
				{
								
				 case RESULT_OK: // il testo dell'email ha un blocco header corretto 
								
					theaders = "From: andrea@sterbini.org\nTo: babbo_natale@northpole.org\nSubject: Cosa vorrei per natale\0";
					break;
								
				 case NULL_POINTER: //il puntatore al blocco degli headers e' NULL
								
					theaders = (void *)0;
					break;
								
				 case EMPTY_STRING: //il testo del blocco headers e' vuoto
				 
				 	theaders = "";
					break;				 
				 
				 case BAD_HEADER: //il primo headers non segue la sintassi corretta
							
					theaders = " From: andrea@sterbini.org\nTo: babbo_natale@northpole.org\n\0";
					break;
											 
				 
				 default:  //qualsiasi altro test per questo argomento non ha senso
				 	
				 	free(tprimohead);
				 	return NOT_VALID;															
							
				} //end switch su tipo_di_test per arg 0
							
			tresult = primoHeader(theaders, tprimohead, tdim);
								
			free(tprimohead);
			
			switch (tresult) 
				{
								
				 case RESULT_OK: 
					if (tipo_di_test == RESULT_OK)
						return TEST_PASSED;						
					break;				
				 case NULL_POINTER: 
					if (tipo_di_test == NULL_POINTER)
						return TEST_PASSED;
					break;	
			     case EMPTY_STRING:
			    	if (tipo_di_test == EMPTY_STRING)
			    		return TEST_PASSED;
			    	break;				   			     
			     case BAD_HEADER:
			    	if (tipo_di_test == BAD_HEADER)
			    		return TEST_PASSED; 
				    break;
				 
									     
			    } //end switch tresult per arg 0
			             
			errormessage = determinamesserror(errormessage, tipo_di_test, tresult);
			printf("Test Fallito:Funzione testata:  primoHeader(%s, %s, %d)\n", theaders, tprimohead, tdim);
			testname = nametest(testname, tipo_di_test);
			printf("	     risultato Atteso:  %s\n", testname);
			testname = nametest(testname, tresult);
			printf("	     risultato ottenuto:%s\n", testname);
			printf("	     spiegazione: %s\n", errormessage );
			return TEST_FAILED;	
	
	    case 1: // test al secondo argomento, il puntatore alla zona di memoria dove dovr essere copiato il primo header
	    	
	    	theaders = "From: andrea@sterbini.org\nTo: babbo_natale@northpole.org\nSubject: Cosa vorrei per natale\0";
	    	tdim = 90;
	    	
	    	switch (tipo_di_test)
	    		{                
                 case NULL_POINTER: //il puntatore alla zona di memoria e' NULL
                 
                 	tprimohead = (void*)0;
                 	break;
                 	
                 case BUFFER_TOO_SMALL: //la memoria allocata non e' sufficente
                 
                 	tdim = 2; 
                 	tprimohead = (char*)calloc(tdim, sizeof(char));
                 	break;
                 
                 default: //qualsiasi altro test per questo argomento non ha senso
                 
                 	
                 	return NOT_VALID;
                                  			    			    		
	    		} //end switch tipo_di_test per arg 1
	
	        tresult =  primoHeader(theaders, tprimohead, tdim);
	        
	        free(tprimohead);
	        
	        switch (tresult)
	        
	        	{	        	 
	        	 case NULL_POINTER:
	        	 
	        	 	if(tipo_di_test == NULL_POINTER)
	        	 		return TEST_PASSED;
	        	 	break;
	        	 case BUFFER_TOO_SMALL:
	        	 
	        	    if(tipo_di_test == BUFFER_TOO_SMALL)
	        	    	return TEST_PASSED;
	        	    break;	
	        	 
	        	} //end switch tresult per arg 1
	        	     
	        errormessage = determinamesserror(errormessage, tipo_di_test, tresult);
			printf("Test Fallito:Funzione testata:  primoHeader(%s, %s, %d)\n", theaders, tprimohead, tdim);
			testname = nametest(testname, tipo_di_test);
			printf("	     risultato Atteso:  %s\n", testname);
			testname = nametest(testname, tresult);
			printf("	     risultato ottenuto:%s\n", testname);
			printf("	     spiegazione: %s\n", errormessage );
			return TEST_FAILED;
                	                     
	        	
	
	    case 2: //test sul terzo argomento, la dimensione del buffer 
	    
	    	theaders = "From: andrea@sterbini.org\nTo: babbo_natale@northpole.org\nSubject: Cosa vorrei per natale\0";
	    	tprimohead = (char*)calloc(90, sizeof(char));
	    	
	    	switch (tipo_di_test)
	    		{	    		 	 
	    		 case BUFFER_TOO_SMALL: //dimensione del primoheader dell'email troppo piccola
	    		 	    		 	
	    		 	tdim = 2;
	    		 	break;
	    		 	
	    		 default: //ogni altro tipo di test su questo argomento non ha senso
	    		 	
	    		 	free(tprimohead);
	    		 	return NOT_VALID;	    		 
	    		 
	    		} //end switch tipo_di_test per arg 2	    	
	    	
	    	tresult =  primoHeader(theaders, tprimohead, tdim);    		    	
	    	
	    	switch(tresult)
	    		{	    		
	    		 case BUFFER_TOO_SMALL:
	    		 	if(tipo_di_test == BUFFER_TOO_SMALL)
	    		 		return TEST_PASSED; 
	    		 	break;	
	    		 
	    		 } //end switch tresult per arg 2
	    		 	
	    	errormessage = determinamesserror(errormessage, tipo_di_test, tresult);
			printf("Test Fallito:Funzione testata:  primoHeader(%s, %s, %d)\n", theaders, tprimohead, tdim);
			testname = nametest(testname, tipo_di_test);
			printf("	     risultato Atteso:  %s\n", testname);
			testname = nametest(testname, tresult);
			printf("	     risultato ottenuto:%s\n", testname);
			printf("	     spiegazione: %s\n", errormessage );
			return TEST_FAILED;
	    		
	
	
	    default: //la funzione da testare non ha quest'argomento
	    
	    	return ARG_MISSING;
	}
}


// eseguo un test sulla funzione parseHeader
int test_parseHeader(int tipo_di_test, int argomento) 
{
 char * theader;
 char * ttipo = "";
 char * tvalore = "";
 char * errormessage = "";
 char * testname = "";
 int tdimt = 0;
 int tdimv = 0;
 int tresult = 0;

 switch (argomento)
 	{
 	 case 0: // testo sull'argomento char * header
 	 	
 	 	ttipo = (char*)calloc(90, sizeof(char));
		tvalore = (char*)calloc(90, sizeof(char));
		tdimt = 90;
		tdimv = 90;
			
			switch(tipo_di_test) 
				{
								
				 case RESULT_OK: // l'header passato  corretto
								
					theader = "From: andrea@sterbini.org\0";
					break;
								
				 case NULL_POINTER: //il puntatore alla stringa header e' NULL
								
					theader = (void *)0;
					break;
								
				 case EMPTY_STRING: //il testo della stringa header e' vuoto
				 
				 	theader = "";
					break;				 	 
				 
				 default:  //qualsiasi altro test per questo argomento non ha senso
				 	
				 	free(ttipo);
				 	free(tvalore);
				 	return NOT_VALID;															
							
				} //end switch su tipo_di_test per arg 0
							
			tresult = parseHeader(theader, ttipo, tdimt, tvalore, tdimv);
								
			free(ttipo);
			free(tvalore);
			
			switch (tresult) 
				{
								
				 case RESULT_OK: 
					if (tipo_di_test == RESULT_OK)
						return TEST_PASSED;						
					break;				
				 case NULL_POINTER: 
					if (tipo_di_test == NULL_POINTER)
						return TEST_PASSED;
					break;	
			     case EMPTY_STRING:
			    	if (tipo_di_test == EMPTY_STRING)
			    		return TEST_PASSED;
			    	break;				   			     	 
									     
			    } //end switch tresult per arg 0 
 	    
 	    	errormessage = determinamesserror(errormessage, tipo_di_test, tresult);
			printf("Test Fallito:Funzione testata:  parseHeader(%s, %s, %d, %s, %d)\n", theader, ttipo, tdimt, tvalore, tdimv);
			testname = nametest(testname, tipo_di_test);
			printf("	     risultato Atteso:  %s\n", testname);
			testname = nametest(testname, tresult);
			printf("	     risultato ottenuto:%s\n", testname);
			printf("	     spiegazione: %s\n", errormessage );
			return TEST_FAILED;	
 	 
 	 case 1: //test sull'argomento char * tipo
 	 
 	 	theader = "From: andrea@sterbini.org\0"; 	
		tvalore = (char*)calloc(90, sizeof(char));
		tdimt = 90;
		tdimv = 90;
			
			switch(tipo_di_test) 
				{												 
				 case NULL_POINTER: //il puntatore alla memoria per tipo e' NULL
								
					ttipo = (void *)0;
					break;	 	 
				 
				 default:  //qualsiasi altro test per questo argomento non ha senso
				 	
				 	
				 	free(tvalore);
				 	return NOT_VALID;															
							
				} //end switch su tipo_di_test per arg 1
							
			tresult = parseHeader(theader, ttipo, tdimt, tvalore, tdimv);
								
			free(ttipo);
			free(tvalore);
			
			switch (tresult) 
				{											
				 case NULL_POINTER: 
					if (tipo_di_test == NULL_POINTER)
						return TEST_PASSED;
					break;		     	 
									     
			    } //end switch tresult per arg 1
 	    
 	    	errormessage = determinamesserror(errormessage, tipo_di_test, tresult);
			printf("Test Fallito:Funzione testata:  parseHeader(%s, %s, %d, %s, %d)\n", theader, ttipo, tdimt, tvalore, tdimv);
			testname = nametest(testname, tipo_di_test);
			printf("	     risultato Atteso:  %s\n", testname);
			testname = nametest(testname, tresult);
			printf("	     risultato ottenuto:%s\n", testname);
			printf("	     spiegazione: %s\n", errormessage );
			return TEST_FAILED;	
 	 
 	 case 2: // test sull'argomento dimt
 	 
 	 	theader = "From: andrea@sterbini.org\0"; 	
		tvalore = (char*)calloc(90, sizeof(char));
		ttipo = (char*)calloc(90, sizeof(char));		
		tdimv = 90;
			
			switch(tipo_di_test) 
				{												
				 case BUFFER_TOO_SMALL: //la dimensione di tipo  troppo piccola per contenere la stringa
								
					tdimt = 2;
					break;	 	 
				 
				 default:  //qualsiasi altro test per questo argomento non ha senso
				 	
				 	free(ttipo);
				 	free(tvalore);
				 	return NOT_VALID;															
							
				} //end switch su tipo_di_test per arg 2
							
			tresult = parseHeader(theader, ttipo, tdimt, tvalore, tdimv);
								
			free(ttipo);
			free(tvalore);
			
			switch (tresult) 
				{												
				 case BUFFER_TOO_SMALL: 
					if (tipo_di_test == BUFFER_TOO_SMALL)
						return TEST_PASSED;
					break;		     	 
									     
			    } //end switch tresult per arg 2
 	    
 	    	errormessage = determinamesserror(errormessage, tipo_di_test, tresult);
			printf("Test Fallito:Funzione testata:  parseHeader(%s, %s, %d, %s, %d)\n", theader, ttipo, tdimt, tvalore, tdimv);
			testname = nametest(testname, tipo_di_test);
			printf("	     risultato Atteso:  %s\n", testname);
			testname = nametest(testname, tresult);
			printf("	     risultato ottenuto:%s\n", testname);
			printf("	     spiegazione: %s\n", errormessage );
			return TEST_FAILED;	
 	 
 	 
 	 case 3: //test sull'argomento char * valore
 	 
 	 	theader = "From: andrea@sterbini.org\0"; 	
		ttipo = (char*)calloc(90, sizeof(char));
		tdimt = 90;
		tdimv = 90;
			
			switch(tipo_di_test) 
				{
				 case NULL_POINTER: //il puntatore alla memoria per tipo e' NULL
								
					tvalore = (void *)0;
					break;	 	 
				 
				 default:  //qualsiasi altro test per questo argomento non ha senso
				 	
				 	free(ttipo);				 	
				 	return NOT_VALID;															
							
				} //end switch su tipo_di_test per arg 3
							
			tresult = parseHeader(theader, ttipo, tdimt, tvalore, tdimv);
								
			free(ttipo);
			free(tvalore);
			
			switch (tresult) 
				{
				 case NULL_POINTER: 
					if (tipo_di_test == NULL_POINTER)
						return TEST_PASSED;
					break;		     	 
									     
			    } //end switch tresult per arg 3
 	    
 	    	errormessage = determinamesserror(errormessage, tipo_di_test, tresult);
			printf("Test Fallito:Funzione testata:  parseHeader(%s, %s, %d, %s, %d)\n", theader, ttipo, tdimt, tvalore, tdimv);
			testname = nametest(testname, tipo_di_test);
			printf("	     risultato Atteso:  %s\n", testname);
			testname = nametest(testname, tresult);
			printf("	     risultato ottenuto:%s\n", testname);
			printf("	     spiegazione: %s\n", errormessage );
			return TEST_FAILED;	
 	 
 	 
 	 case 4: //test sull'argomento dimv
 	 
 	 	theader = "From: andrea@sterbini.org\0"; 	
		tvalore = (char*)calloc(90, sizeof(char));
		ttipo = (char*)calloc(90, sizeof(char));		
		tdimt = 90;
			
			switch(tipo_di_test) 
				{								
				 case BUFFER_TOO_SMALL: //la dimensione di tipo  troppo piccola per contenere la stringa
								
					tdimv = 2;
					break;	 	 
				 
				 default:  //qualsiasi altro test per questo argomento non ha senso
				 	
				 	free(ttipo);
				 	free(tvalore);
				 	return NOT_VALID;															
							
				} //end switch su tipo_di_test per arg 4
							
			tresult = parseHeader(theader, ttipo, tdimt, tvalore, tdimv);
								
			free(ttipo);
			free(tvalore);
			
			switch (tresult) 
				{
				 case BUFFER_TOO_SMALL: 
					if (tipo_di_test == BUFFER_TOO_SMALL)
						return TEST_PASSED;
					break;		     	 
									     
			    } //end switch tresult per arg 4
 	    
 	    	errormessage = determinamesserror(errormessage, tipo_di_test, tresult);
			printf("Test Fallito:Funzione testata:  parseHeader(%s, %s, %d, %s, %d)\n", theader, ttipo, tdimt, tvalore, tdimv);
			testname = nametest(testname, tipo_di_test);
			printf("	     risultato Atteso:  %s\n", testname);
			testname = nametest(testname, tresult);
			printf("	     risultato ottenuto:%s\n", testname);
			printf("	     spiegazione: %s\n", errormessage );
			return TEST_FAILED;	
 	 
 	 default:
 	 	return ARG_MISSING;
 	
 	
 	} //end switch argomento

}


// eseguo un test sulla funzione primaParola
int test_primaParola(int tipo_di_test, int argomento) 
{
 char * ttesto;
 char * tparola = "";
 int tdim = 0;
 char * errormessage = "";
 char * testname = "";
 int tresult = 0;
 
 switch (argomento)
 	{
 	 case 0: //test sull'argomento char * testo
 	 
 	 	tparola = (char*)calloc(90, sizeof(char));
		tdim = 90;
			
			switch(tipo_di_test) 
				{
								
				 case RESULT_OK: // il testo passato  corretto
								
					ttesto = "@$&<ciao&bello\0";
					break;
								
				 case NULL_POINTER: //il puntatore al blocco degli headers e' NULL
								
					ttesto = (void *)0;
					break;
								
				 case EMPTY_STRING: //il testo del blocco headers e' vuoto
				 
				 	ttesto = "";
					break;				 											 
				 
				 default:  //qualsiasi altro test per questo argomento non ha senso
				 	
				 	free(tparola);
				 	return NOT_VALID;															
							
				} //end switch su tipo_di_test per arg 0
							
			tresult = primaParola(ttesto, tparola, tdim);
								
			free(tparola);
			
			switch (tresult) 
				{
								
				 case RESULT_OK: 
					if (tipo_di_test == RESULT_OK)
						return TEST_PASSED;						
					break;				
				 case NULL_POINTER: 
					if (tipo_di_test == NULL_POINTER)
						return TEST_PASSED;
					break;	
			     case EMPTY_STRING:
			    	if (tipo_di_test == EMPTY_STRING)
			    		return TEST_PASSED;
			    	break;				   			     
									     
			    } //end switch tresult per arg 0
			             
			errormessage = determinamesserror(errormessage, tipo_di_test, tresult);
			printf("Test Fallito:Funzione testata:  primaParola(%s, %s, %d)\n", ttesto, tparola, tdim);
			testname = nametest(testname, tipo_di_test);
			printf("	     risultato Atteso:  %s\n", testname);
			testname = nametest(testname, tresult);
			printf("	     risultato ottenuto:%s\n", testname);
			printf("	     spiegazione: %s\n", errormessage );
			return TEST_FAILED;	
 	 
 	 case 1: // test sull'argomento char * parola
 	 
 	 	ttesto = "@$&<ciao&bello\0"; 		
		tdim = 90;
				
			switch(tipo_di_test) 
				{
				 case NULL_POINTER: //il puntatore alla memoria per parola e' NULL
								
					tparola = (void *)0;
					break;	 	 
				 
				 default:  //qualsiasi altro test per questo argomento non ha senso
				 				 					 	
				 	return NOT_VALID;															
							
				} //end switch su tipo_di_test per arg 3
							
			tresult = primaParola(ttesto, tparola, tdim);
								
			free(tparola);
			
			switch (tresult) 
				{		
				 case NULL_POINTER: 
					if (tipo_di_test == NULL_POINTER)
						return TEST_PASSED;
					break;		     	 
									     
			    } //end switch tresult per arg 3
 	    
 	    	errormessage = determinamesserror(errormessage, tipo_di_test, tresult);
			printf("Test Fallito:Funzione testata:  primaParola(%s, %s, %d)\n", ttesto, tparola, tdim);
			testname = nametest(testname, tipo_di_test);
			printf("	     risultato Atteso:  %s\n", testname);
			testname = nametest(testname, tresult);
			printf("	     risultato ottenuto:%s\n", testname);
			printf("	     spiegazione: %s\n", errormessage );
			return TEST_FAILED;	
 	 	
 	 case 2: //test sull'argomento int dim
 	 
 	 	ttesto = "@$&<ciao&bello\0";
	    tparola = (char*)calloc(90, sizeof(char));
	    	
	    	switch (tipo_di_test)
	    		{	    		 
	    		 case BUFFER_TOO_SMALL: //dimensione della memoria allocata per parola troppo piccola	    		 	    		 	
	    		 	
	    		 	tdim = 2;
	    		 	break;
	    		 	
	    		 default: //ogni altro tipo di test su questo argomento non ha senso
	    		 	
	    		 	free(tparola);
	    		 	return NOT_VALID;	    		 
	    		 
	    		} //end switch tipo_di_test per arg 2	    	
	    	
	    	tresult =  primaParola(ttesto, tparola, tdim);    		    	
	    	
	    	switch(tresult)
	    		{	    		
	   		 	 case BUFFER_TOO_SMALL:
	    		 	if(tipo_di_test == BUFFER_TOO_SMALL)
	    		 		return TEST_PASSED; 
	    		 	break;	
	    		 
	    		 } //end switch tresult per arg 2
	    		 	
	    	errormessage = determinamesserror(errormessage, tipo_di_test, tresult);
			printf("Test Fallito:Funzione testata:  primaParola(%s, %s, %d)\n", ttesto, tparola, tdim);
			testname = nametest(testname, tipo_di_test);
			printf("	     risultato Atteso:  %s\n", testname);
			testname = nametest(testname, tresult);
			printf("	     risultato ottenuto:%s\n", testname);
			printf("	     spiegazione: %s\n", errormessage );
			return TEST_FAILED;	 
 	 
 	 default:
 	 	return ARG_MISSING;
 	
 	
 	}

}


// eseguo un test sulla funzione tokenizzaEmail
int test_tokenizzaEmail(int tipo_di_test, int argomento) {

return NOT_IMPLEMENTED;
}


// eseguo un test sulla funzione printAllEmailTokens
int test_printTokens(int tipo_di_test, int argomento) {

return NOT_IMPLEMENTED;
}

