#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <errno.h>
#include "modulo1.h"
#include <sys/stat.h>


int printTokens(Token tokenArray[], int dimT){
int i;
   if(dimT==0) return BUFFER_TOO_SMALL;
   
   for(i=0;i<dimT;i++){
   if (i>dimT-1) return BUFFER_TOO_SMALL;
      if(tokenArray[i].contesto==NULL){
          if(tokenArray[i].parola==NULL) return EMPTY_STRING;
           printf("%s\n",tokenArray[i].parola);
	   }
      else{
          printf("%s*%s\n",tokenArray[i].contesto,tokenArray[i].parola);
      }
   
   
   }
return RESULT_OK;
}


//____

int primaParola(char *testo, char *parola, int dim){
   int i=0,j=0;
   char c;
   if (testo==NULL) return NULL_POINTER;
   if(testo[0]=='\0') return EMPTY_STRING;
   if (dim ==0) return BUFFER_TOO_SMALL;
   for(i=0;;i++){
       c=testo[i];
       if(isalnum(c)) break;
   }
   
   for(;;i++){
      if (j>dim-1) return BUFFER_TOO_SMALL;
      c=testo[i];
      if (!(isalnum(c))) break;
      parola[j]=c;
      j++;
   }
   
   parola[j]='\0';
   
   return RESULT_OK;
}

//_______

int parseHeader(char *header, char *tipo, int dimt, char *valore, int dimv){
   int i,j;
   char c;
   if (header==NULL) return NULL_POINTER;
   if (header[0]=='\0') return EMPTY_STRING;
   if(dimt==0 || dimv==0) return BUFFER_TOO_SMALL;

   for (i=0;;i++)
   {
      if (i>dimt-1) return BUFFER_TOO_SMALL;
      c=header[i];
      if (c==':'||isspace(c)) break;  
      tipo[i]=c;
   }
   tipo[i]='\0';
   
   j=i;				//Per andare al primo carattere dopo lo spazio o i due punti
   do{
      j++;
      c=header[j];
   }while (!(isalnum(c)));
   
   i=j;
   
   for(j=0;;i++)
   {
      if (j>dimv-1) return BUFFER_TOO_SMALL;
      c=header[i];
      if (c=='\0') break;
      valore[j]=c;
      j++;
      
   } 
  

   valore[j]='\0';

   return RESULT_OK;
}

//__________

int primoHeader (char *headers, char *primo_header, int dim){
   int i,j,trovato=0;
   char c;
   if(headers==NULL) return NULL_POINTER;
   c=headers[0];
   if (c=='\0') return EMPTY_STRING;   //Se email  vuota 
   if(dim==0) return BUFFER_TOO_SMALL; 
   if(!isalnum (c)) return BAD_HEADER;   //Se la prima lettera non  un carattere
   for(i=0;c!=EOF;i++){
      if (i>dim-1) return BUFFER_TOO_SMALL;   //Se la dimensione di headers non  sufficiente
      c=headers[i];
      if(c=='\n'){
         j=i;
	 j++;
	 
	 if (!(isspace(headers[j]))){
	 trovato=1;
	 break;
	 }
      }
      primo_header[i]=c;
   }
   if(i<3) return BAD_HEADER;
   if (trovato==0) return HEADER_NOT_FOUND;   //L'header non esiste
   primo_header[i++]='\0';
   
   return RESULT_OK;
}

//_______



int estraiHeaders(char *email, char *headers, int dimh){
   if (email==NULL) return NULL_POINTER;
   if (email[0]=='\0') return EMPTY_STRING;   //Se email  vuota 
   if (dimh==0) return BUFFER_TOO_SMALL; 
   int i,j,trovato=0;
   char c,d;
   c=(email[0]);

   if(!isalnum (c)) return BAD_HEADER;   //Se la prima lettera non  un carattere
   for(i=0;c!=EOF;i++)
   {
       if (i>dimh-1) return BUFFER_TOO_SMALL;   //Se la dimensione di headers non  sufficiente
       c=email[i];
       if (c=='\n'){
          j=i;
	  j++;
	  d=email[j];
	  if (c==d){
	    trovato=1;
	    break; 
	  }
       }
        headers[i]=c;
	
   }
   if (trovato==0) return HEADER_NOT_FOUND;   //L'header non esiste
   headers[i++]='\0';
   
   return RESULT_OK;

}

//----
int leggiFile(char *nomefile, int dimensione, char *testo){
   int i=0;
   char carattere;
   FILE *fp=NULL;
   struct stat controlFile;
   int controllo;
   fp= fopen(nomefile,"r");
   if(fp==NULL) return FILE_UNREADABLE;
   
   if (stat(nomefile, &controlFile)!=0){
      if(errno == ENOENT) return FILE_MISSING;
      else return UNKNOWN_ERROR;
   }
   
   if (nomefile==NULL) return NULL_POINTER;
   if (dimensione==0) return BUFFER_TOO_SMALL; 
    
  do{
      carattere=fgetc(fp);
      if (i>dimensione-1) return BUFFER_TOO_SMALL;
      if(carattere == EOF) break;
      else 
      testo[i]=carattere;
      i++;
      
      }while(carattere!=EOF);
      
   if (i==0) return FILE_EMPTY;
   
   testo[i]='\0';
  fclose(fp);
   return RESULT_OK;
}



/*//////////////////////////////////////////////////////////////////////////////////////////*/

int tokenizzaEmail(char *email, Token tokenArray[], int dimT){
   int i=0,j=0,k=0;
   char c,d;
   int dimh,dim=0;
   int contT=0; 
   if (email==NULL) return NULL_POINTER;
   if (email[0]=='\0') return EMPTY_STRING;   //Se email  vuota 
   if(dimT==0)return BUFFER_TOO_SMALL; 
        
   if((tokenArray= (Token*)malloc((sizeof(Token))*dimT)) == NULL) return MEM_ALLOC_ERROR;
   
   
   
   while(c!=EOF){   //Mi trovo la dimensione da dare a headers per passarla ad estraiHeaders
      c=email[i];
      if (c=='\n')
       {
          j=i;
	  j++;
	  d=email[j];
	  if (c==d)break; 
       }
      i++;
    }
    
    dimh=i+1;
   
    char headers[dimh];
    
    estraiHeaders(email, headers, dimh);    
    j=0;
    i=0;
    char tempHeaders[dimh];
    strcpy(tempHeaders,headers);
    
    for(;i<dimh;){ //Estraggo gli header uno alla volta
  
             for(;c!=EOF;){	//Esegui il ciclo finch non trovi la fine dell'header e quindi la dimensione
                c=headers[j];
                if(c=='\n'){
                    k=j;
	            k++;
	            if (!(isspace(headers[k])))break;
		    
	        }
		j++;
	     }
	     
	     j++;
             dim=j-i;  //Dimensione dell'header preso in considerazione
       
   
             char primo_header[dim];
	    
	     primoHeader(tempHeaders,primo_header,dim);
	      
	     int p=0;
             for(k=j;k<dimh;k++){
	         c=headers[k];
		 tempHeaders[p]=c;
	         p++;
	     }
	     tempHeaders[p]='\0';
	     
	     
	     
             
             for(k=0;;k++){   //Devo trovare la dimensione del tipo 
                      c=primo_header[k];
                      if (c==':'||isspace(c)) break;
             }
	     int dimt=k+1;   
	     int temp=0;
	     for(;c!='\0';k++){
	        c=primo_header[k];
		temp++;
	     }
             
             int dimv=temp+1;   //alla dimensione tot dell'header tolgo quella del tipo e ottengo quella del valore
             dimv++;
             char tipo[dimt];
             char valore[dimv];
             
             parseHeader(primo_header,tipo,dimt,valore,dimv);
	         
	     k=0;
	     char c;
	     char tempPrimo[dim];
	   
	     strcpy(tempPrimo,primo_header); 
	     dim=strlen(tempPrimo);
	     while(k<dim){
                  
                      for(;;k++){
                            c=primo_header[k];
			    if(isalnum(c)) break;
                      }
                      temp=k;  //posizione attuale da cui parte la parola
	         
                      for(;;k++){
                            c=primo_header[k];
			    if (!(isalnum(c))) break;
                      }   //k indica ora dove finisce la parola
                      k++;
                      int dimParola=k-temp;
	              
		      
                      char parola[dimParola];
                      primaParola(tempPrimo,parola,dimParola);
		      temp=k;
		      p=0;
		      
		      
                      for(;temp<dim;temp++){
	                    c=primo_header[temp];
		            tempPrimo[p]=c;
	                     p++;
	              }
	              tempPrimo[p]='\0';	    
		      
		      
		      
		      
		      
       
             tokenArray[contT].parola = (char*)malloc( (sizeof(char) * strlen(parola) ) );
	     tokenArray[contT].contesto = (char*)malloc( (sizeof(char) * strlen(tipo) ) );
             strcpy(tokenArray[contT].parola,parola);
	     strcpy(tokenArray[contT].contesto,tipo);
             
            
             contT++;
          }
         
            i=i+dim; 
      }
      int z=dimh;
      int p=0;
      int dimB=strlen(email);
     
      dimB=dimB-dimh;
      char body[dimB];
      
      while(!isalnum(c)){
          c=body[z];
          z++;
      }
      
      for(;c!='\0';z++){
	         c=email[z];
		 body[p]=c;
	         p++;
	     }
	     body[p]='\0';
      z=0;
      p=0;
      
      while(z<dimB){
                  char tempPar[100];
                      for(;;z++){
                            c=body[z];
			    if(isalnum(c)) break;
                      }
                      int temp=z;  //posizione attuale da cui parte la parola
	              p=0;
                      for(;;z++){
                            c=body[z];
			    if (!(isalnum(c))) break;
			    tempPar[p]=c;
			    p++;
                      }   //k indica ora dove finisce la parola
		      tempPar[p]='\0';
		      
		      
             tokenArray[contT].parola = (char*)malloc( (sizeof(char) * strlen(tempPar) ) );
             strcpy(tokenArray[contT].parola,tempPar);
             tokenArray[contT].contesto=NULL;
             contT++;
	     
         }
	 
	 printTokens(tokenArray, dimT);
	 
	 
    return RESULT_OK;
}

