/* Progetto di laboratorio 2004/2005 modulo 1... */

# include "testModulo1.h"
# include "modulo1.h"
# include <sys/stat.h>
# include <stdio.h>
# include <string.h>
# include <stdlib.h>

# define DEF_DIMH 20480
# define DEF_DIM_HEADER 20480
# define DEF_DIM_PAROLA 60
# define DEF_DIMT 200
# define DEF_DIMV 500

int leggiFile ( char* nomefile, int dimensione, char* testo) {
FILE* lettera;
struct stat* buf;
int i = 0;
if ((nomefile == NULL) || (testo == NULL))
   return NULL_POINTER;
if (!strlen (nomefile) || !strlen (testo))
   return EMPTY_STRING;
if (stat (nomefile, buf))
   return FILE_MISSING;
lettera = fopen (nomefile, "r");
if (lettera == NULL)
   return FILE_UNREADABLE;
for (i = 0; (feof (lettera)) || (i <= dimensione); i++)
/* while (!feof (lettera) || (i < dimensione)) */ {
   testo [i] = fgetc (lettera); }
testo [i+1] = '\0';
if (strlen (testo) == 0)
   return FILE_EMPTY;
else return RESULT_OK; }

int estraiHeaders (char* email, char* headers, int dimh) {
int i;
if ((email == NULL) || (headers == NULL))
   return NULL_POINTER;
if (!strlen (email) || !strlen (headers))
   return EMPTY_STRING;
if (strlen (email) < dimh)
   return BUFFER_TOO_SMALL;
// quindi fino a 2 capo di seguito
for (i = 0; i < dimh - 1; i++)
   if (!(email [i-1] == '\n' && email [i] == '\n'))
      headers [i] = email [i];
headers [i+1] = '\0';
return RESULT_OK; }

int primoHeader (char* headers, char* primo_header, int dim) {
if ((headers == NULL) || (primo_header == NULL))
   return NULL_POINTER;
if (!strlen (headers) || !strlen (primo_header))
   return EMPTY_STRING;
int i;
// '\n' + non ' ' o non 'tab' termina lo header
for (i = 0; i <= dim - 1; i++) {
   if (!(headers [i - 1] == '\n' && (headers [i] == ' ' || headers [i] == '\t')))
      primo_header [i] = headers [i]; }
primo_header [i+1] = '\0';
// ogni header deve finire con un a capo
if (headers [i] != '\n')
   return BUFFER_TOO_SMALL;   // ce ne possiamo accorgere solo da qui
else return RESULT_OK; }

int parseHeader (char* header, char* tipo, int dimt, char* valore, int dimv) {
if ( (header == NULL) || (tipo == NULL) || (valore == NULL))
   return NULL_POINTER;
if (!strlen (header))
   return EMPTY_STRING;
int c = 0;
int i = 0;
while (!isalnum (header [c]))
   c++;
while (isalnum (header [c]) || c < dimt - 1) {
   tipo [c] = header [c];
   c++; }
tipo [c+1] = '\0';   // per sicurezza meglio che la termino prima pure se non &#65533;buona perch&#65533;&#65533;troppo corta
if (isalnum (header [c+1]))
   return BUFFER_TOO_SMALL;   // se il carattere appresso era buono
while ((header [c+i] != '\0') || (c +i < dimv)) {  // c &#65533;il valore a cui &#65533;arrivato l'indice prima, pi i che 
// riparte da capo perch&#65533;valore parte da 0
   valore [i] = header [c+i]; }
valore [i+1] = '\0';     // terminiamo la stringa
if (strlen (tipo) + strlen (valore) < strlen (header))   // tipo + valore deve rifare header, &#65533;il metodo pi semplice invece di
// chiederci che razza di carattere ci sar&#65533;dopo se l'header non era finito
   return BUFFER_TOO_SMALL;
else return RESULT_OK; }

int primaParola (char* testo, char* parola, int dim) {
if ((testo == NULL) || (parola == NULL))
   return NULL_POINTER;
if (!strlen (testo))
   return EMPTY_STRING;
int c = 0;
int i = 0;
parola = "";    // la inizializziamo come stringa vuota perch significher che se ci resta non pesca parole buone
while (!isalnum (testo [i]))
   i++;           // indice che conta eventuali caratteri da scartare precedenti
while (isalnum (testo [c+i]) && c < dim-1 && isalnum (testo [c+i-1])) {   // l'indice del testo &#65533;l'indice di parola + il numero di caratteri da scartare
// precedenti
// deve pure essere alfanumerico il carattere precedente se no la scartiamo perch  troppo corta
   parola [c] = testo [c];
   c++; }
parola [c+1] = '\0';
if (isalnum (testo [c+i+1]))
   return BUFFER_TOO_SMALL;     // se c'era ancora un carattere valido appresso la stringa era troppo corta
else return RESULT_OK; }

int tokenizzaEmail (char* email, Token tokenArray [], int dimT) {
if ((email == NULL) || (tokenArray == NULL))
   return NULL_POINTER;
int result, dimh = DEF_DIMH, dim_header = DEF_DIM_HEADER, dim_parola = DEF_DIM_PAROLA, offset_header = 0, offset_parola = 0, offset_tipo = 0, dimt = DEF_DIMT, dimv = DEF_DIMV, i;
char* headers = calloc (dimh, sizeof (char));
char* primo_Header = calloc (dim_header, sizeof (char));
char* tipo = calloc (dimt, sizeof (char));
char* valore = calloc (dimv, sizeof (char));
char* parola = calloc (dim_parola, sizeof (char));
if ((headers ==NULL) || (primo_Header == NULL) || (tipo == NULL) || (valore == NULL) || (parola == NULL))
   return MEM_ALLOC_ERROR;
// annulliamo tutta la tabella dei tokens
for (i = 0; i <= dimT - 1; i++) {
   tokenArray [i]. contesto = NULL;
   tokenArray [i]. parola = NULL; }
result = estraiHeaders (email, headers, dimh);
if (result)
   return result;
while (offset_header < strlen (headers)) {    // spero, non me lo ricordo  // finch non raggiungiamo la lunghezza di tutti gli headers
   result = primoHeader (headers + strlen (primo_Header), primo_Header, dim_header);  // a partire dall'header precedente se no trova sempre quello
   if (result)
      return result;
   while (offset_header < strlen (primo_Header) ) {  // finch non raggiungiamo la lunghezza di UNO header
      result = parseHeader (primo_Header + offset_header, tipo, dimt, valore, dimv);
      if (result)
         return result;
      for (i = 0; (offset_header < offset_parola) || (i <= dimT - 1) ; i++) 
   /*    while ( (primo_Header + offset_header < offset_parola) && (i < dimT) ) */   {
         result = primaParola (primo_Header + offset_parola, parola, dim_parola);
         offset_parola += strlen (parola);
         if (result)
            return result;
         strcpy (tokenArray [i]. contesto, tipo);
         strcpy (tokenArray [i]. parola, parola); }
      offset_tipo += strlen (tipo) + strlen (valore);
      offset_header += strlen (primo_Header); } }
result = primaParola (primo_Header + offset_parola, parola, dim_parola);
if (result)
   return result;
if ((strlen (parola)) && (i < dimT - 1))
   return BUFFER_TOO_SMALL;    // primaParola ha trovato un'altra parola ma la tabella token  finita
// finiti gli headers, contesto = NULL
// vediamo prima se c' il corpo dell'email per dopo le righe vuote, se ne occupa primaParola
result = primaParola (email + strlen (headers), parola, dim_parola);
if (result)
   return result;
if (strlen (parola) == 0)
   return BODY_NOT_FOUND;  // modifichiamo primaParola
tipo = NULL;
// non dobbiamo reinizzializzare i se no sono guai, sovrascriviamo la tabella di tokens
// lunghezza di tutti gli headers + tutte la parole finadesso + questa
for ( ; strlen (email) < strlen (headers) + offset_parola; i++) {
   // estraiamo le parole
   result = primaParola (email + strlen (headers), parola, dim_parola);
   offset_parola += strlen (parola);
   if (result)
      return result;
   strcpy (tokenArray [i]. contesto, tipo);
   strcpy (tokenArray [i]. parola, parola); 
   offset_parola += strlen (parola); } }   // CREDO che sia finita

 int printTokens (Token tokenArray [], int dimT) {
 if (tokenArray == NULL)
   return NULL_POINTER;
int i;
for (i = 0; i <= dimT; i++) {
   if (tokenArray [i]. contesto != NULL)
      printf ("%s*", tokenArray [i]. contesto);    // stampa contesto se c'
   printf ("%s\n", tokenArray [i]. parola); } }     // stampa parola comunque 

