/* Progetto di laboratorio 2004/2005 modulo 1 tests */

# include "testModulo1.h"
# include "modulo1.h"
# include <sys/stat.h>
# include <stdio.h>
# include <string.h>
# include <stdlib.h>

/* char* tests [5] = {"TEST_PASSED", "TEST_FAILED", "ARG_MISSING", "NOT_VALID",
"NOT_IMPLEMENTED"}; */

int test_leggiFile (int tipo_di_test, int argomento) {
char* errori [13] = {"RESULT_OK", "UNKNOWN_ERROR", "NULL_POINTER", "EMPTY_STRING", "FILE_MISSING", "FILE_UNREADABLE", 
"FILE_UNWRITABLE", "FILE_EMPTY", "BUFFER_TOO_SMALL", "HEADER_NOT_FOUND", "BODY_NOT_FOUND", "BAD_HEADER", "MEM_ALLOC_ERROR"};
int result;
char* nomefile;
int dimensione;
char* testo;
if (argomento >= 3)
   return ARG_MISSING;
// test insensati per l'argomento 0, stringa
else if ((argomento == 0) && ((tipo_di_test != 2) || (tipo_di_test != 3)))
   return NOT_VALID;
// test insensati per l'argomento 1, lunghezza
else if ((argomento == 1) && (tipo_di_test != 8))
   return NOT_VALID;
// test insensati per l'argomento 2, stringa di destinazione
else if ((argomento == 2) && (tipo_di_test != 2))
   return NOT_VALID;
//test veri e propri
if (tipo_di_test == 0) {
   // RESULT_OK
   nomefile = "email1.txt";
   dimensione = 20480; // sempre 20 Kb
   testo = calloc (dimensione, sizeof (char));
   result = leggiFile(nomefile, dimensione, testo);
   if (result == tipo_di_test)
      return TEST_PASSED;
   else { printf ("Funzione leggiFile\nrisultato atteso: %s\nrisultato ottenuto: %s\nspiegazione: %s\n", errori [tipo_di_test], 
   errori [result], errori [result]);
      return TEST_FAILED; } }
else if ((argomento == 0) && (tipo_di_test == 2)) {
   // nomefile == NULL
   nomefile = NULL;
   dimensione = 20480;
   testo = calloc (dimensione, sizeof (char));
   result = leggiFile(nomefile, dimensione, testo);
   if (result == tipo_di_test)
      return TEST_PASSED;
   else { printf ("Funzione leggiFile\nrisultato atteso: %s\nrisultato ottenuto: %s\nspiegazione: fallito il test del puntatore " 
   "nullo nomefile\n", errori [tipo_di_test], errori [result]);
      return TEST_FAILED; } }
else if ((argomento == 2) && (tipo_di_test == 2)) {
   // testo = NULL
   testo = NULL;
   nomefile = "email1.txt";
   dimensione = 20480;
   testo = calloc (dimensione, sizeof (char));
   result = leggiFile(nomefile, dimensione, testo);
   if (result == tipo_di_test)
      return TEST_PASSED;
   else { printf ("Funzione leggiFile\nrisultato atteso: %s\nrisultato ottenuto: %s\nspiegazione: fallito il test del puntatore "
   "nullo testo\n", errori [tipo_di_test], errori [result]);
      return TEST_FAILED; } }
else if ((argomento == 0) && (tipo_di_test == 3)) {
   // nomefile = ""
   nomefile = "";
   dimensione = 20480;
   testo = calloc (dimensione, sizeof (char));
   result = leggiFile(nomefile, dimensione, testo);
   if (result == tipo_di_test)
      return TEST_PASSED;
   else { printf ("Funzione leggiFile\nrisultato atteso: %s\nrisultato ottenuto: %s\nspiegazione: fallito il test della stringa "
   "vuota nomefile\n", errori [tipo_di_test], errori [result]);
      return TEST_FAILED; } }
else if ((argomento == 0) && (tipo_di_test == 4)) {
   // file missing
   nomefile = "file_missing";
   dimensione = 20480;
   testo = calloc (dimensione, sizeof (char));
   result = leggiFile(nomefile, dimensione, testo);
   if (result == tipo_di_test)
      return TEST_PASSED;
   else { printf ("Funzione leggiFile\nrisultato atteso: %s\nrisultato ottenuto: %s\nspiegazione: fallito il test del file "
   "mancante\n", errori [tipo_di_test], errori [result]);
      return TEST_FAILED; } }
else if ((argomento == 0) && (tipo_di_test == 5)) {
   // file unreadable
   nomefile = "file_unreadable";
   dimensione = 20480;
   testo = calloc (dimensione, sizeof (char));
   result = leggiFile(nomefile, dimensione, testo);
   if (result == tipo_di_test)
      return TEST_PASSED;
   else { printf ("Funzione leggiFile\nrisultato atteso: %s\nrisultato ottenuto: %s\nspiegazione: fallito il test del file illegibile\n", errori
[tipo_di_test], errori [result]);
      return TEST_FAILED; } }
if ((argomento == 0) && (tipo_di_test == 7)) {
   // file vuoto
   nomefile = "file_empty";
   dimensione = 20480;
   testo = calloc (dimensione, sizeof (char));
   result = leggiFile(nomefile, dimensione, testo);
   if (result == tipo_di_test)
      return TEST_PASSED;
   else { printf ("Funzione leggiFile\nrisultato atteso: %s\nrisultato ottenuto: %s\nspiegazione: fallito il test del file vuoto\n", 
   errori [tipo_di_test], errori [result]);
      return TEST_FAILED; } }
else if ((argomento == 1) && (tipo_di_test == 8)) {
   // buffer insufficiente
   dimensione = 25;
   testo = calloc (dimensione, sizeof (char));
   nomefile = "email1.txt";
   result = leggiFile(nomefile, dimensione, testo);
   if (result == tipo_di_test)
      return TEST_PASSED;
   else { printf ("Funzione leggiFile\nrisultato atteso: %s\nrisultato ottenuto: %s\nspiegazione: fallito il test del buffer "
   "insufficiente su dimensione\n", errori [tipo_di_test], errori [result]);
      return TEST_FAILED; } }
else return NOT_IMPLEMENTED; }

int test_estraiHeaders (int tipo_di_test, int argomento) {
char* errori [13] = {"RESULT_OK", "UNKNOWN_ERROR", "NULL_POINTER", "EMPTY_STRING", "FILE_MISSING", "FILE_UNREADABLE", 
"FILE_UNWRITABLE", "FILE_EMPTY", "BUFFER_TOO_SMALL", "HEADER_NOT_FOUND", "BODY_NOT_FOUND", "BAD_HEADER", "MEM_ALLOC_ERROR"};
int result;
char* email;
char* headers;
int dimh;
if (argomento >= 3)
   return ARG_MISSING;
// test insensati
// argomento 0, stringa sorgente
if ((argomento == 0) && ((tipo_di_test != 2) || (tipo_di_test != 3)))
   return NOT_VALID;
// argomento 1, stringa destinazione
if ((argomento == 1) && (tipo_di_test != 2))
   return NOT_VALID;
// argomento 2, lunghezza
if ((argomento == 2) && (tipo_di_test != BUFFER_TOO_SMALL))
   return NOT_VALID;
// tests veri e propri
if (tipo_di_test == RESULT_OK) {
   email = "From: andrea@sterbini.org\nTo: babbo_natale@northpole.org\nSubject: Cosa vorrei per Natale\n\nCaro Babbo Natale, "
   "\nquest'anno ho cercato di essere molto buono e di non bocciare nessuno, ma talvolta ho dovuto farlo.\n\nTi prego di portarmi in "
   "regalo un Lego Mindstorms per poter insegnare ai ragazzi del corso a programmare in microcodice Lego.\n\nCiao\nAndrea\n";
   dimh = 20480; // sono 20 Kb
   headers = calloc (dimh, sizeof (char));
   result = estraiHeaders (email, headers, dimh);
   if (result == tipo_di_test)
      return TEST_PASSED;
   else { printf ("Funzione estraiHeaders\nrisultato atteso: %s\nrisultato ottenuto: %s\nspiegazione: %s\n", errori [tipo_di_test], 
   errori [result], errori [result]);
      return TEST_FAILED; } }
else if ((argomento == 0) && (tipo_di_test == NULL_POINTER)) {
   email = NULL;
   dimh = 20480; // sono 20 Kb
   headers = calloc (dimh, sizeof (char));
   result = estraiHeaders(email, headers, dimh);
   if (result == tipo_di_test)
      return TEST_PASSED;
   else printf ("Funzione estraiHeaders\nrisultato atteso: %s\nrisultato ottenuto: %s\nspiegazione: fallito il test del puntatore "
   "nullo su email%s\n", errori [tipo_di_test], errori [result], errori [result]);
      return TEST_FAILED; }
else if ((argomento == 1) && (tipo_di_test == NULL_POINTER)) {
   email = "From: andrea@sterbini.org\nTo: babbo_natale@northpole.org\nSubject: Cosa vorrei per Natale\n\nCaro Babbo Natale, "
   "\nquest'anno ho cercato di essere molto buono e di non bocciare nessuno, ma talvolta ho dovuto farlo.\n\nTi prego di portarmi in "
   "regalo un Lego Mindstorms per poter insegnare ai ragazzi del corso a programmare in microcodice Lego.\n\nCiao\nAndrea\n";
   dimh = 20480;
   headers = NULL;
   result = estraiHeaders(email, headers, dimh);
   if (result == tipo_di_test)
      return TEST_PASSED;
   else { printf ("Funzione estraiHeaders\nrisultato atteso: %s\nrisultato ottenuto: %s\nspiegazione: fallito il test del puntatore "
   "nullo su headers%s\n", errori [tipo_di_test], errori [result], errori [result]);
      return TEST_FAILED; } }
else if ((argomento == 0) && (tipo_di_test == EMPTY_STRING)) {
   email = "";
   dimh = 20480;
   headers = calloc (dimh, sizeof (char));
   result = estraiHeaders(email, headers, dimh);
   if (result == tipo_di_test)
      return TEST_PASSED;
   else { printf ("Funzione estraiHeaders\nrisultato atteso: %s\nrisultato ottenuto: %s\nspiegazione: fallito il test della stringa "
   "vuota su email%s\n", errori [tipo_di_test], errori [result], errori [result]);
      return TEST_FAILED; } }
else if ((argomento == 2) && (tipo_di_test == BUFFER_TOO_SMALL)) {
   email = "From: andrea@sterbini.org\nTo: babbo_natale@northpole.org\nSubject: Cosa vorrei per Natale\n\nCaro Babbo Natale, "
   "\nquest'anno ho cercato di essere molto buono e di non bocciare nessuno, ma talvolta ho dovuto farlo.\n\nTi prego di portarmi in "
   "regalo un Lego Mindstorms per poter insegnare ai ragazzi del corso a programmare in microcodice Lego.\n\nCiao\nAndrea\n";
   dimh = 20;
   headers = calloc (dimh, sizeof (char));
   result = estraiHeaders(email, headers, dimh);
   if (result == tipo_di_test)
      return TEST_PASSED;
   else { printf ("Funzione estraiHeaders\nrisultato atteso: %s\nrisultato ottenuto: %s\nspiegazione: fallito il test del buffer "
   "insufficiente su dimh%s\n", errori [tipo_di_test], errori [result], errori [result]);
      return TEST_FAILED; } }
else return NOT_IMPLEMENTED; }

int test_primoHeader (int tipo_di_test, int argomento) {
char* errori [13] = {"RESULT_OK", "UNKNOWN_ERROR", "NULL_POINTER", "EMPTY_STRING", "FILE_MISSING", "FILE_UNREADABLE", 
"FILE_UNWRITABLE", "FILE_EMPTY", "BUFFER_TOO_SMALL", "HEADER_NOT_FOUND", "BODY_NOT_FOUND", "BAD_HEADER", "MEM_ALLOC_ERROR"};
int result;
char* headers;
char* primo_header;
int dim;
if (argomento >= 3)
   return ARG_MISSING;
// tests insensati
// argomento 0, stringa sorgente
if ((argomento == 0) && ((tipo_di_test != NULL_POINTER) || (tipo_di_test != EMPTY_STRING)))
   return NOT_VALID;
// argomento 1, stringa destinazione
if ((argomento == 1) && (tipo_di_test != NULL_POINTER))
   return NOT_VALID;
// argomento 2, lunghezza
if ((argomento == 2) && (tipo_di_test != BUFFER_TOO_SMALL))
   return NOT_VALID;
// tests veri e propri
if ((argomento == 0) && (tipo_di_test == NULL_POINTER)) {
   headers = NULL;
   dim = 20480;
   primo_header = calloc (dim, sizeof (char));
   result = primoHeader (headers, primo_header, dim);
if (result == tipo_di_test)
   return TEST_PASSED;
else { printf ("Funzione primo_Header\nrisultato atteso: %s\nrisultato ottenuto: %s\nspiegazione:fallito il test del puntatore nullo "
"su headers\n", errori [tipo_di_test], errori [result]);
   return TEST_FAILED;  } }
else if ((argomento == 0) && (tipo_di_test == EMPTY_STRING)) {
   headers = "";
   dim = 20480;
   primo_header = calloc (dim, sizeof (char));
   result = primoHeader (headers, primo_header, dim);
if (result == tipo_di_test)
   return TEST_PASSED;
else { printf ("Funzione primo_Header\nrisultato atteso: %s\nrisultato ottenuto: %s\nspiegazione:fallito il test della stringa vuota "
"su headers\n", errori [tipo_di_test], errori [result]);
   return TEST_FAILED; } }
else if ((argomento == 1) && (tipo_di_test == NULL_POINTER)) {
   dim = 20480;
   primo_header = NULL;
   result = primoHeader (headers, primo_header, dim);
if (result == tipo_di_test)
   return TEST_PASSED;
else { printf ("Funzione primo_Header\nrisultato atteso: %s\nrisultato ottenuto: %s\nspiegazione:fallito il test del puntatore nullo "
"su primo_header\n", errori [tipo_di_test], errori [result]);
   return TEST_FAILED; } }
else if ((argomento == 2) && (tipo_di_test == BUFFER_TOO_SMALL)) {
   dim = 30;
   primo_header = calloc (dim, sizeof (char));
   result = primoHeader (headers, primo_header, dim);
if (result == tipo_di_test)
   return TEST_PASSED;
else { printf ("Funzione primo_Header\nrisultato atteso: %s\nrisultato ottenuto: %s\nspiegazione:fallito il test del buffer "
"insufficiente su dim\n", errori [tipo_di_test], errori [result]);
   return TEST_FAILED; } }
else if (tipo_di_test == 0) {
   headers = "From: andrea@sterbini.org\nTo: babbo_natale@northpole.org\nSubject: Cosa vorrei per Natale\n\n";
   dim = 20480;
   primo_header = calloc (dim, sizeof (char));
   result = primoHeader (headers, primo_header, dim);
if (result == tipo_di_test)
   return TEST_PASSED;
else { printf ("Funzione primo_Header\nrisultato atteso: %s\nrisultato ottenuto: %s\nspiegazione: %s\n", errori [tipo_di_test], 
errori [result], errori [result]);
   return TEST_FAILED; } }
else return NOT_IMPLEMENTED; }

int test_parseHeader (int tipo_di_test, int argomento) {
char* errori [13] = {"RESULT_OK", "UNKNOWN_ERROR", "NULL_POINTER", "EMPTY_STRING", "FILE_MISSING", "FILE_UNREADABLE", 
"FILE_UNWRITABLE", "FILE_EMPTY", "BUFFER_TOO_SMALL", "HEADER_NOT_FOUND", "BODY_NOT_FOUND", "BAD_HEADER", "MEM_ALLOC_ERROR"};
int result;
char* header;
char* tipo;
int dimt;
char* valore;
int dimv;
if (argomento >= 5)
   return ARG_MISSING;
// tests insensati
// argomento 0, stringa sorgente
if ((argomento == 0) && ((tipo_di_test != NULL_POINTER) || (tipo_di_test != EMPTY_STRING)))
   return NOT_VALID;
// argomento 1, stringa destinazione
else if ((argomento == 1) && (tipo_di_test != NULL_POINTER))
        return NOT_VALID;
// argomento 2, lunghezza
     else if ((argomento == 2) && (tipo_di_test != BUFFER_TOO_SMALL))
             return NOT_VALID;
// argomento 3, stringa destinazione
          else if ((argomento == 3) && (tipo_di_test != NULL_POINTER))
	          return NOT_VALID;
// argomento 4, lunghezza
               else if ((argomento == 4) && (tipo_di_test != BUFFER_TOO_SMALL))
	               return NOT_VALID;
		    else return NOT_IMPLEMENTED;
// tests veri e propri
if (tipo_di_test == RESULT_OK) {
   header = "From: andrea@sterbini.org\nTo: babbo_natale@northpole.org\nSubject: Cosa vorrei per Natale\n\n";
   dimt = 200;
   tipo = calloc (dimt, sizeof (char));
   dimv = 500;
   valore = calloc (dimv, sizeof (char));
   result = parseHeader(header, tipo, dimt, valore, dimv);
if (result == tipo_di_test)
   return TEST_PASSED;
else { printf ("Funzione parseHeader\nrisultato atteso: %s\nrisultato ottenuto: %s\nspiegazione:%s\n", errori [tipo_di_test], 
errori [result], errori [result]);
   return TEST_FAILED; } }
else if ((argomento == 0) && (tipo_di_test == NULL_POINTER)) {
   header = NULL;
   dimt = 200;
   tipo = calloc (dimt, sizeof (char));
   dimv = 500;
   valore = calloc (dimv, sizeof (char));
   result = parseHeader(header, tipo, dimt, valore, dimv);
if (result == tipo_di_test)
   return TEST_PASSED;
else { printf ("Funzione parseHeader\nrisultato atteso: %s\nrisultato ottenuto: %s\nspiegazione: fallito il test del puntatore nullo "
"su header\n", errori [tipo_di_test], errori [result]);
   return TEST_FAILED; } }
else if ((argomento == 0) && (tipo_di_test == EMPTY_STRING)) {
   header = "";
   dimt = 200;
   dimv = 500;
   valore = calloc (dimv, sizeof (char));
   result = parseHeader(header, tipo, dimt, valore, dimv);
if (result == tipo_di_test)
   return TEST_PASSED;
else { printf ("Funzione parseHeader\nrisultato atteso: %s\nrisultato ottenuto: %s\nspiegazione: fallito il test della stringa vuota "
"su header\n", errori [tipo_di_test], errori [result]);
   return TEST_FAILED; } }
else if ((argomento == 1) && (tipo_di_test == NULL_POINTER)) {
   header = "From: andrea@sterbini.org\nTo: babbo_natale@northpole.org\nSubject: Cosa vorrei per Natale\n\n";
   tipo = NULL;
   dimt = 200;
   valore = calloc (dimv, sizeof (char));
   dimv = 500;
   result = parseHeader(header, tipo, dimt, valore, dimv);
if (result == tipo_di_test)
   return TEST_PASSED;
else { printf ("Funzione parseHeader\nrisultato atteso: %s\nrisultato ottenuto: %s\nspiegazione: fallito il test del puntatore nullo "
"su tipo\n", errori [tipo_di_test], errori [result]);
   return TEST_FAILED; } }
else if ((argomento == 2) && (tipo_di_test == BUFFER_TOO_SMALL)) {
   header = "From: andrea@sterbini.org\nTo: babbo_natale@northpole.org\nSubject: Cosa vorrei per Natale\n\n";
   dimt = 1;
   tipo = calloc (dimt, sizeof (char));
   dimv = 500;
   valore = calloc (dimv, sizeof (char));
   result = parseHeader(header, tipo, dimt, valore, dimv);
if (result == tipo_di_test)
   return TEST_PASSED;
else { printf ("Funzione parseHeader\nrisultato atteso: %s\nrisultato ottenuto: %s\nspiegazione: fallito il test del buffer "
"insufficiente su dimt\n", errori [tipo_di_test], errori [result]);
   return TEST_FAILED; } }
else if ((argomento == 3) && (tipo_di_test == NULL_POINTER)) {
   header = "From: andrea@sterbini.org\nTo: babbo_natale@northpole.org\nSubject: Cosa vorrei per Natale\n\n";
   dimt = 200;
   tipo = calloc (dimt, sizeof (char));
   dimv = 500;
   valore = NULL;
   result = parseHeader(header, tipo, dimt, valore, dimv);
if (result == tipo_di_test)
   return TEST_PASSED;
else { printf ("Funzione parseHeader\nrisultato atteso: %s\nrisultato ottenuto: %s\nspiegazione: fallito il test del puntatore nullo "
"su valore\n", errori [tipo_di_test], errori [result]);
   return TEST_FAILED; } }
else if ((argomento == 4) && (tipo_di_test == BUFFER_TOO_SMALL)) {
   header = "From: andrea@sterbini.org\nTo: babbo_natale@northpole.org\nSubject: Cosa vorrei per Natale\n\n";
   dimt = 200;
   tipo = calloc (dimt, sizeof (char));
   dimv = 1;
   valore = calloc (dimv, sizeof (char));
   result = parseHeader(header, tipo, dimt, valore, dimv);
if (result == tipo_di_test)
   return TEST_PASSED;
else printf ("Funzione parseHeader\nrisultato atteso: %s\nrisultato ottenuto: %s\nspiegazione: fallito il test del buffer "
"insufficiente su dimv\n", errori [tipo_di_test], errori [result]);
   return TEST_FAILED; }
else return NOT_IMPLEMENTED;}

int test_primaParola (int tipo_di_test, int argomento) {
char* errori [13] = {"RESULT_OK", "UNKNOWN_ERROR", "NULL_POINTER", "EMPTY_STRING", "FILE_MISSING", "FILE_UNREADABLE", 
"FILE_UNWRITABLE", "FILE_EMPTY", "BUFFER_TOO_SMALL", "HEADER_NOT_FOUND", "BODY_NOT_FOUND", "BAD_HEADER", "MEM_ALLOC_ERROR"};
int result;
char* testo;
char* parola;
int dim;
if (argomento >= 3)
   return ARG_MISSING;
// tests insensati
// argomento 0, stringa sorgente
else if ((argomento == 0) && ((tipo_di_test != NULL_POINTER) || (tipo_di_test != EMPTY_STRING)))
   return NOT_VALID;
// argomento 1, stringa destinazione
else if ((argomento == 1) && (tipo_di_test != NULL_POINTER))
   return NOT_VALID;
// argomento 2, lunghezza
else if ((argomento == 2) && (tipo_di_test != BUFFER_TOO_SMALL))
   return NOT_VALID;
// tests veri e propri
if (tipo_di_test == RESULT_OK) {
   testo = "Caro Babbo Natale,\nquest'anno ho cercato di essere molto buono e di non bocciare nessuno, ma talvolta ho dovuto farlo.\n"
"Ti prego di portarmi in regalo un Lego Mindstorms per poter insegnare ai ragazzi del corso a programmare in microcodice Lego.\n\nCiao "
"Andrea\n";
   dim = 60;
   parola = calloc (dim, sizeof (char));
   result = primaParola(testo, parola, dim);
if (result == tipo_di_test)
   return TEST_PASSED;
else { printf ("Funzione primaParola\nrisultato atteso: %s\nrisultato ottenuto: %s\nspiegazione:%s\n", errori [tipo_di_test], 
errori [result], errori [result]);
   return TEST_FAILED; } }
else if ((argomento == 0) && (tipo_di_test == NULL_POINTER)) {
   testo = NULL;
   dim = 60;
   parola = calloc (dim, sizeof (char));
   result = primaParola (testo, parola, dim);
if (result == tipo_di_test)
   return TEST_PASSED;
else { printf ("Funzione primaParola\nrisultato atteso: %s\nrisultato ottenuto: %s\nspiegazione: fallito il test del puntatore nullo "
"su testo\n", errori [tipo_di_test], errori [result]);
   return TEST_FAILED; } }
else if ((argomento == 0) && (tipo_di_test == EMPTY_STRING)) {
   testo = "";
   dim = 60;
   parola = calloc (dim, sizeof (char));
   result = primaParola (testo, parola, dim);
if (result == tipo_di_test)
   return TEST_PASSED;
else { printf ("Funzione primaParola\nrisultato atteso: %s\nrisultato ottenuto: %s\nspiegazione: fallito il test della stringa vuota "
"su testo\n", errori [tipo_di_test], errori [result]);
   return TEST_FAILED; } }
else if ((argomento == 1) && (tipo_di_test == NULL_POINTER)) {
   testo = "Caro Babbo Natale,\nquest'anno ho cercato di essere molto buono e di non bocciare nessuno, ma talvolta ho dovuto farlo.\n"
"Ti prego di portarmi in regalo un Lego Mindstorms per poter insegnare ai ragazzi del corso a programmare in microcodice Lego.\n\nCiao "
"Andrea\n";
   dim = 60;
   parola = NULL;
   result = primaParola (testo, parola, dim);
if (result == tipo_di_test)
   return TEST_PASSED;
else { printf ("Funzione primaParola\nrisultato atteso: %s\nrisultato ottenuto: %s\nspiegazione: fallito il test del puntatore nullo "
"su parola\n", errori [tipo_di_test], errori [result]);
   return TEST_FAILED; } }
else if ((argomento == 2) && (tipo_di_test == BUFFER_TOO_SMALL)) {
   testo = "Caro Babbo Natale,\nquest'anno ho cercato di essere molto buono e di non bocciare nessuno, ma talvolta ho dovuto farlo.\n"
"Ti prego di portarmi in regalo un Lego Mindstorms per poter insegnare ai ragazzi del corso a programmare in microcodice Lego.\n\nCiao "
"Andrea\n";
   dim = 2;
   parola = calloc (dim, sizeof (char));
   result = primaParola(testo, parola, dim);
if (result == tipo_di_test)
   return TEST_PASSED;
else { printf ("Funzione primaParola\nrisultato atteso: %s\nrisultato ottenuto: %s\nspiegazione: fallito il test del buffer "
"insufficiente su dim\n", errori [tipo_di_test], errori [result]);
   return TEST_FAILED; } }
else return NOT_IMPLEMENTED; }

int test_tokenizzaEmail (int tipo_di_test, int argomento) {
char* errori [13] = {"RESULT_OK", "UNKNOWN_ERROR", "NULL_POINTER", "EMPTY_STRING", "FILE_MISSING", "FILE_UNREADABLE", 
"FILE_UNWRITABLE", "FILE_EMPTY", "BUFFER_TOO_SMALL", "HEADER_NOT_FOUND", "BODY_NOT_FOUND", "BAD_HEADER", "MEM_ALLOC_ERROR"};
int result;
char* email;
Token* tokenArray;
int dimT;
if (argomento >= 3)
   return ARG_MISSING;
// tests insensati
// argomento 0, stringa sorgente
if ((argomento == 0) && ((tipo_di_test != NULL_POINTER) || (tipo_di_test != EMPTY_STRING) || (tipo_di_test != BODY_NOT_FOUND)))
   return NOT_VALID;
// argomento 1, tabella dei tokens (puntatore)
if ((argomento == 1) && (tipo_di_test != NULL_POINTER))
   return NOT_VALID;
// argomento 2, lunghezza
if ((argomento == 2) && (tipo_di_test != BUFFER_TOO_SMALL))
   return NOT_VALID;
// TESTS VERI E propri
if (tipo_di_test == 0) {
   email = "From: andrea@sterbini.org\nTo: babbo_natale@northpole.org\nSubject: Cosa vorrei per Natale\n\nCaro Babbo Natale,"
   "\nquest'anno ho cercato di essere molto buono e di non bocciare nessuno, ma talvolta ho dovuto farlo.\n\nTi prego di portarmi in "
   "regalo un Lego Mindstorms per poter insegnare ai ragazzi del corso a programmare in microcodice Lego.\n\nCiao\nAndrea\n";
   dimT = 300;
   tokenArray = calloc (dimT, sizeof (Token));
   result= tokenizzaEmail(email, tokenArray, dimT);
if (result == tipo_di_test)
   return TEST_PASSED;
else { printf ("Funzione tokenizzaEmail\nrisultato atteso: %s\nrisultato ottenuto: %s\nspiegazione: %s\n", errori [tipo_di_test], 
errori [result], errori [result]);
   return TEST_FAILED; } }
else if ((argomento == 0) && (tipo_di_test == NULL_POINTER)) {
   email = NULL;
   dimT = 300;
   tokenArray = calloc (dimT, sizeof (Token));
   result= tokenizzaEmail (email, tokenArray, dimT);
if (result == tipo_di_test)
   return TEST_PASSED;
else { printf ("Funzione tokenizzaEmail\nrisultato atteso: %s\nrisultato ottenuto: %s\nspiegazione: fallito il test del puntatore "
" nullo su email\n", errori [tipo_di_test], errori [result]);
   return TEST_FAILED; } }
else if ((argomento == 0) && (tipo_di_test == EMPTY_STRING) ) {
   email = "";
   dimT = 300;
   tokenArray = calloc (dimT, sizeof (Token));
   result= tokenizzaEmail (email, tokenArray, dimT);
if (result == tipo_di_test)
   return TEST_PASSED;
else { printf ("Funzione tokenizzaEmail\nrisultato atteso: %s\nrisultato ottenuto: %s\nspiegazione: fallito il test della stringa "
"vuota su email\n", errori [tipo_di_test], errori [result]);
   return TEST_FAILED; } }
else if ((argomento == 2 ) && (tipo_di_test == BUFFER_TOO_SMALL) ) {
   email = "From: andrea@sterbini.org\nTo: babbo_natale@northpole.org\nSubject: Cosa vorrei per Natale\n\nCaro Babbo Natale,"
   "\nquest'anno ho cercato di essere molto buono e di non bocciare nessuno, ma talvolta ho dovuto farlo.\n\nTi prego di portarmi in "
   "regalo un Lego Mindstorms per poter insegnare ai ragazzi del corso a programmare in microcodice Lego.\n\nCiao\nAndrea\n";
   dimT = 2;
   tokenArray = calloc (dimT, sizeof (Token));
   result= tokenizzaEmail (email, tokenArray, dimT);
if (result == tipo_di_test)
   return TEST_PASSED;
else { printf ("Funzione tokenizzaEmail\nrisultato atteso: %s\nrisultato ottenuto: %s\nspiegazione: FALLITO il test del buffer "
"insufficiente su dimT\n", errori [tipo_di_test], errori [result]);
   return TEST_FAILED; } }
else if ((argomento == 1) && (tipo_di_test == NULL_POINTER)) {
   email = "From: andrea@sterbini.org\nTo: babbo_natale@northpole.org\nSubject: Cosa vorrei per Natale\n\nCaro Babbo Natale,"
   "\nquest'anno ho cercato di essere molto buono e di non bocciare nessuno, ma talvolta ho dovuto farlo.\n\nTi prego di portarmi in "
   "regalo un Lego Mindstorms per poter insegnare ai ragazzi del corso a programmare in microcodice Lego.\n\nCiao\nAndrea\n";
   dimT = 300;
   tokenArray = NULL;
   result= tokenizzaEmail(email, tokenArray, dimT);
if (result == tipo_di_test)
   return TEST_PASSED;
else { printf ("Funzione tokenizzaEmail\nrisultato atteso: %s\nrisultato ottenuto: %s\nspiegazione: fallito il test del puntatore "
"nullo su tokenArray []\n", errori [tipo_di_test], errori [result]);
   return TEST_FAILED;  } }
else if ((argomento == 0) && (tipo_di_test == BODY_NOT_FOUND)) {
   email = "From: andrea@sterbini.org\nTo: babbo_natale@northpole.org\nSubject: Cosa vorrei per Natale\n\n";
   dimT = 300;
   tokenArray = calloc (dimT, sizeof (Token));
   result = tokenizzaEmail (email, tokenArray , dimT);
   if (result == tipo_di_test)
      return TEST_PASSED;
   else { printf ("Funzione tokenizzaEmail\nrisultato atteso: %srisultato ottenuto: %sspiegazione: fallito il test del corpo "
   "dell'email non trovato\n", errori [tipo_di_test], errori [result]);
      return TEST_FAILED; } }
else return NOT_IMPLEMENTED; }

int test_printTokens (int tipo_di_test, int argomento) {
char* errori [13] = {"RESULT_OK", "UNKNOWN_ERROR", "NULL_POINTER", "EMPTY_STRING", "FILE_MISSING", "FILE_UNREADABLE", 
"FILE_UNWRITABLE", "FILE_EMPTY", "BUFFER_TOO_SMALL", "HEADER_NOT_FOUND", "BODY_NOT_FOUND", "BAD_HEADER", "MEM_ALLOC_ERROR"};
int result;
Token* tokenArray;
int dimT;
if (argomento >= 2)
   return ARG_MISSING;
// tests insensati
// argomento 0, tabella dei tokens (puntatore)
if ((argomento == 0) && (tipo_di_test != NULL_POINTER))
   return NOT_VALID;
// argomento 1, lunghezza
if ((argomento == 1) && (tipo_di_test != BUFFER_TOO_SMALL))
   return NOT_VALID;
// tests veri e propri
if (tipo_di_test == RESULT_OK) {
   dimT = 300;
   tokenArray = calloc (dimT, sizeof (char));
result= printTokens (tokenArray, dimT);
if (result == tipo_di_test)
   return TEST_PASSED;
else { printf ("Funzione printTokens\nrisultato atteso: %s\nrisultato ottenuto: %s\nspiegazione: %s\n", errori [tipo_di_test], 
errori [result], errori [result]);
   return TEST_FAILED; } }
else if ((argomento == 0) && (tipo_di_test == NULL_POINTER)) {
   dimT = 300;
   tokenArray = NULL;
   result = printTokens (tokenArray, dimT);
   if (result == tipo_di_test)
      return TEST_PASSED;
   else { printf ("Funzione printTokens\nrisultato atteso: %s\nrisultato ottenuto: %s\n spiegazione: fallito il test del puntatore "
   "nullo su tokenArray []\n", errori [tipo_di_test], errori [result]);
      return TEST_FAILED; } } 
else if ((argomento == 1) && (tipo_di_test == BUFFER_TOO_SMALL)) {
   dimT = 2;
   tokenArray = calloc (dimT, sizeof (char));
result= printTokens (tokenArray, dimT);
if (result == tipo_di_test)
   return TEST_PASSED;
else { printf ("Funzione printTokens\nrisultato atteso: %s\nrisultato ottenuto: %s\nspiegazione: fallito il test del buffer "
"insufficiente\n", errori [tipo_di_test], errori [result]);
   return TEST_FAILED; } }
else return NOT_IMPLEMENTED; }

/* int result;
result = leggiFile(char * nomefile, int dimensione, char * testo);
result = estraiHeaders(char * email, char * headers, int dimh);
result = primoHeader(char * headers, char * primo_header, int dim);
result = parseHeader(char * header, char * tipo, int dimt, char * valore, int dimv);
result = primaParola(char * testo, char * parola, int dim);
result= tokenizzaEmail(char * email, Token tokenArray[], int dimT);
result= printTokens(Token tokenArray[], int dimT);
if (result == tipo_di_test)
   return TEST_PASSED;
else printf ("risultato atteso: %s\nrisultato ottenuto: %s\nspiegazione:\n", errori
[tipo_di_test], errori [result]);
   return TEST_FAILED;
if (argomento >= )
   return ARG_MISSING;
*/

