#include"modulo1.c"

int estraiHeaders(char* email, char* headers, int dimh){

	//Inizio: Controllo degli errori che potrebbero evitare la processazione della funzione.
	
	//Errore di empty_string: *email e' una stringa vuota
	if(email[0]=='\0') return(3);
	
	//Errore di email inesistente: *email e' un puntatore NULL
	if(email==NULL) return(2);

	//Errore di Headers: *headers e' un puntatore NULL
	if(headers==NULL) return(2);

	//Errore di dimensione BUFFER_TOO_SMALL: dimh e' zero
	if(dimh==0) return(8);

	//Errore di dimensione BUFFER_TOO_SMALL(2): dimh e' uno
	if(dimh==1) return(8);

	//Errore di headers inesistente: i primi due caratteri di e-mail sono \n e \n
	if ((email[0]=='\n')&&(email[1]=='\n')) return(9);

	//Prima fase: controllo delle dimensioni dell'header presente in email
	//Scansione di tutta l'e-mail fino a trovare la fine degli headers

	int x;				//Variabile di controllo dei cicli

	int dim_head=0;		//Variabile di controllo sulla dimensione corrente dell'header
	int dim_email=0;	//Variabile di controllo che indica la lunghezza della e-mail

	dim_email=strlen(email);	//Dimensione dell'array di caratteri e-mail
								//strlen() non conta il carattere di fine stringa

	//Ora so che in e-mail ci sono dim_email caratteri piu' il \0
	//Passo alla scansione di *email per trovare in che punto finiscono gli header

	for (x=0;x<dim_email;x++){

		if(email[x]=='\n'){
			if(email[x+1]=='\n'){			//Due Line Feed di seguito: Lo header termina qui
				
				dim_head=x;				//Questa e' la dimensione dello Header presente in *email
			
				x=dim_email+2;				//Condizione per forzare l'uscita dal ciclo for
			}

		}	//Chiusura secondo if

	}	//Chiusura ciclo for

	
	//Ora dim_head contiene la dimensione dello header dall'inizio fino ai due \n (compresi)

	//Primo controllo di errore: se la dimensione dello Header e' superiore a quella del 
	//vettore *headers (quindi a dimh-1)
	//esce restituendo il codice di errore appropriato

	if(dim_head+1>dimh){


		return(8);

		//Errore BUFFER_TOO_SMALL!!!!
		//Exit!!!

	}
	else
	{				//Il *headers e' in grado di contenere tutto lo header
					//Si passa quindi alla copia

		strncpy(headers,email,dim_head);	//Copia
		headers[dim_head]='\0';				//Aggiunta del carattere nullo di fine stringa
		return(0);							//Fine della Funzione



	}




}

int leggiFile(char* nomefile, int dimensione, char* testo){



	//nomefile e' il nome del file da aprire 
	//Dimensione il numero di byte che deve essere letto dal file ovverosia la dimensione del buffer *testo
	//testo puntatore ad una zona di memoria grande dimensione caratteri in cui copiare il testo letto dal file

	//La funzione deve aprire il file e copiarne il contenuto all'interno di testo.
	//La stringa che andra' all'interno di testo deve essere terminata dal carattere di fine stringa \0
	
	//Bisogna controllare la correttezza dei parametri


/* Apertura del file:*/

FILE* fp;			//Creazione di un puntatore a file

fp=fopen(nomefile,"r");			//Apertura del file. Modalita' lettura

int x=0;			//Variabile di controllo
int lung_file=0;	//Variabile che indica la dimensione del file in caratteri

if (fp==NULL){				//Gestione errori: chiamata fopen fallita

	/* Gli errori che si possono verificare sono i seguenti:

	-Il file non esiste  (cod. 4)
	-Il file non e' leggibile (cod. 5)
	-Il file e' vuoto	(cod. 7)

*/
return(4);

}



//Ora il file e' aperto e ad esso punta il *fp

lung_file=0;


while(!feof(fp)) {

testo[x++]=getc(fp);
lung_file++;
//lung_file++;			//In questo modo stabilisco la dimensione del file in caratteri
//fp++;
}
//printf("ste\n",lung_file);
testo[x]='\0';
if(lung_file==0) return(7);
/*
for (x=0;x<dimensione-1;x++){

	if (!feof(fp)){						//Se il carattere corrente non e' EOF
	testo[x]=getc(fp);					//Lo copia all'interno di testo[x]
	} else								//Altrimenti deve uscire dal for perche' ha copiato tutto quanto
										//Incrementa la variabile x ad un valora fittizio e inserisce '\0'
										//alla fine di testo
	{
		testo[x]='\0';
		x=dimensione;
	}

}

*/




fclose(fp);						//Chiusura del file
return(0);

}

int parseHeader(char* header, char* tipo, int dimt, char* valore, int dimv){

/*In Questa Funzione e' dato per scontato che la sintassi formale degli header sia corretta. Il controllo 
  va effettuato fuori di qui. Anche il \n finale si assume che non ci sia: la stringa header finisce con il \0.
  Si assume che header sara' sempre formato da una serie di
  caratteri piu' altri caratteri di cui si dovra' riconoscere la sequenza.
  Esistono tre tipi diversi di header e come tali vanno identificati from, to, subject.
  */

/*Gestione Errori */

	//Errore di Header inesistente: *header e' un puntatore NULL
	if(header==NULL) return(2);

	//Errore di empty_string: *header e' una stringa vuota
	if(header[0]=='\0') return(3);
	
	//Errore di Valore: *valore e' un puntatore NULL
	if(valore==NULL) return(2);

	//Errore di Tipo: *tipo e' un puntatore NULL
	if(tipo==NULL) return(2);


//Errore di dimensione per le parole troppo piccolo: BUFFER_TOO_SMALL
	if(dimv<2) return(8);

//Errore di dimensione per i tipi troppo piccolo: BUFFER_TOO_SMALL (al minimo deve essere di 3 caratteri)
	if(dimt<3) return(8);

/* Fase 1: definizione variabili temporanee.*/

	char from[]="from";					//Variabile per l'identificazione del tipo
	char to[]="to";
	char sub[]="subject";

	char temp[8]="\0";			//Variabile temporane
	int type=0;					//Questa variabile identifica il tipo dell'header: 5=from 3=to 8=Subject

	int lung_head=strlen(header);		//Variabile temporanea. Contiene la lunghezza dello header

/* Fase 2: Riconoscimento sequenza di intestazione header */

	temp[0]=(tolower(header[0]));
	temp[1]=(tolower(header[1]));
	temp[2]='\0';

	if (!strcmp(temp,to)){			//Il tipo e' TO
	type=3;
	}

	temp[2]=(tolower(header[2]));
	temp[3]=(tolower(header[3]));
	temp[4]='\0';

	if (!strcmp(temp,from)){			//Il tipo e' FROM
	type=5;	
	}

	temp[4]=(tolower(header[4]));
	temp[5]=(tolower(header[5]));
	temp[6]=(tolower(header[6]));
	temp[7]='\0';

	if (!strcmp(temp,sub)){			//Il tipo e' SUBJECT
	type=8;
	}

//Ora so che tipo di header abbiamo: 3, 5 o 8 per i riconosciuti, zero per quelli che non lo sono
//Basandomi su queste informazioni torno i valori appropriati.



	if(type==5){ 			//Processazione per il tipo from

	if(dimt<type+1) return(8);		//ERRORE di Buffer_TOO_SMALL (*tipo non puo' contenere il tipo)
	
	strcpy(tipo,"From:\0");			//Copia del tipo, in *tipo
    
	if(dimv<lung_head-type) return(8);			//ERRORE DI BUFFER_TOO_SMALL
	
	/*Elimazione due punti e spazio */

    if (header[type-1]==':') type++;            //Questa riga e la successiva eliminano lo spazio e i :
    while (header[type-1]==' ') type++;

	strcpy(valore,header+type-1);  //Copia del valore in *valore

	return(0);

	} else
	if(type==8){ 



	if(dimt<type+1) return(8);		//ERRORE di Buffer_TOO_SMALL (*tipo non puo' contenere il tipo)
	
	strcpy(tipo,"Subject:");			//Copia del tipo, in *tipo

	if(dimv<lung_head-type) return(8);			//ERRORE DI BUFFER_TOO_SMALL

    if (header[type-1]==':') type++;            //Questa riga e la successiva eliminano lo spazio e i :
    while (header[type-1]==' ') type++;

	strcpy(valore,header+type-1);  //Copia del valore in *valore

	return(0);
	
} else

	if(type==3){ 
	
	if(dimt<type+1) return(8);		//ERRORE di Buffer_TOO_SMALL (*tipo non puo' contenere il tipo)
	
	strcpy(tipo,"To:");			//Copia del tipo, in *tipo
    
	if(dimv<lung_head-type) return(8);			//ERRORE DI BUFFER_TOO_SMALL

    if (header[type-1]==':') type++;            //Questa riga e la successiva eliminano lo spazio e i :
    while (header[type-1]==' ') type++;

	strcpy(valore,header+type-1);   //Copia del valore in *valore

	return(0);
	
	
	}
	else {							//Non ha riconosciuto i ltipo di header, percio' esce tornando un errore
		return(11);

	}
}

int primaParola(char* testo, char* parola, int dim){

	//Testo non esite (e' NULL): errore di NULL_POINTER
	if (testo==NULL) return(2);

	//Parola e' NULL: errore di NULL_POINTER
	if (parola==NULL) return(2);

	//dim e' troppo piccolo (0 o 1 carattere): errore di BUFFER_TOO_SMALL
	if (dim<2) return(8);

	//L'headers e' una stringa vuota: errore di EMPTY_STRING
	if (testo[0]=='\0') return(3);

	//Funzionamento: La funzione riceve un array di caratteri. Inizia la scansione ed elimina TUTI I CARATTERI INIZIALI
	//NON ALFANUMERICI, memorizza poi gli alfanumerici in parola e all'arrivo di un altro carattere non alfanumerico
	//o del carattere di fine stringa, termina la memorizzazione e torna al chiamante

//Fase 1: verifico la lunghezza della prima parola e se necessario restituisco il codice di errore BUFFER_TOO_SMALL
//ad indicare che l'array parola e' troppo piccolo

	int x=0;				//Variabile di controllo
   	int lung=0;				//Variabile di controllo
	int lung_testo=0;		//Variabile di controllo
	int char_trash=0;		//Variabile di controllo che conta il numero dei caratteri da scartare

	lung_testo=strlen(testo);		//In questo modo so quanto e' lungo in *testo 

	for (x=0;x<lung_testo;x++){
		
		if ((isalnum(testo[x]))==0) char_trash++;		//Carattere non alfanumerico: si scarta
														//e si aggiorna il contatore di caratteri da scartare
		
		
		
		else{											//Il carattere e' alfanumerico: si inizia a contare

			do{
				lung++;
				x++;
			} while((isalnum(testo[x]))!=0);

		//Quando si e' qui si sono verificate due cose:
		//Il carattere corrente non e' alfanumerico
		//La parola e' stata scansita correttamente: si esce dal for. Si aggiorna percio' la variabile x
		//in maniera fittizia

		x=lung_testo+1;

		}//Else

	}//For


	//Prima Verifica di Errore: dim e' troppo piccolo per contenere parola: Errore di BUFFER_TOO_SMALL
	if (lung>dim-1) return(8);

	
	strncpy(parola,testo+char_trash,lung);		//Copia della prima parola presente in *testo e
	parola[lung]='\0';							//aggiunta del carattere fine stringa



	return(0);

}


int primoHeader(char* headers, char* primo_header, int dim){


//Fase 1: Allocazione dinamica di un array di caratteri temporaneo per contenere sicuramente gli header
	int lung=0;
	lung=strlen(headers);				//Lung contiene la lunghezza di tutto il blocco degli header

	char* temp;
	temp=malloc(lung);					//Temp diviene cosi' un array di caratteri grande sufficientemente per
										//Contenere tutto il blocco degli headers


	if(temp==NULL){						//Errore di allocazione del vettore temporaneo: ritorno un errore sconosciuto
										//causato dalla logica del programma (e del programmatore...)

		//printf("ERRORE DI ALLOCAZIONE VETTORE TEMPORANEO!!!!!");		//DA RIMUOVERE!!!!!!!!!

		return(1);

	}

	int x=0;							//Variabile di controllo dei cicli for
	int y=0;							//Variabile di appoggio

//GESTIONE ERRORI:

	//Headers non esite (e' NULL): errore di NULL_POINTER
	if (headers==NULL) return(2);

	//Primo Header e' NULL: errore di NULL_POINTER
	if (primo_header==NULL) return(2);

	//dim e' troppo piccolo (0 o 1 carattere): errore di BUFFER_TOO_SMALL
	if (dim<2) return(8);

	//L'headers e' una stringa vuota: errore di EMPTY_STRING
	if (headers[0]=='\0') return(3);

	//Errore di sintassi header, l'header non comincia con un carattere alfabetico: BAD_HEADER
	if ((isalpha(headers[0])==0)) return(11);

	//ATTENZIONE: controllare la fine della scansione dell'header
	//CONTROLLO EFFETTUATO DA TOKENIZZA EMAIL????


//Fase 2: Identificazione della prima riga degli header e successiva copia all'interno dell'array temporaneo
//		  Un Header si diversifica dal successivo per una successione acapo, carattere (\n+carattere)
//		  una volta identificata una sequenza del genere viene interrotta la scansione
//
//Le sequenze da riconoscere sono: \n+carattere (separazione); \n+spazio e \n+tab (prosecuzione su nuova riga)
//								   \0 (termine header e quindi separatore)

	for (x=0;x<lung;x++){				//Ciclo per la scansione di tutto l'header
										
		if(headers[x]=='\n'){			//Controllo iniziale: se il carattere corrente e' l'inizio di una sequenza di separazione, 
										//non fare niente ed esci dal ciclo for

		if(headers[x+1]==' ') temp[x]=headers[x];			//Il carattere successivo e' uno space: non e' un separatore copia il carattere corrente

		else if(headers[x+1]=='\t') temp[x]=headers[x]; 	//Il carattere successivo e' un tab: non e' un separatore non fare nulla

		else {							//Terzo caso, per esclusione: il carattere successivo e' un carattere
										//ed indica la fine della riga di un header: termina la scansione

			temp[x]='\0';				//Chiudo col carattere di fine stringa la copia della riga di header;

			x=lung+1;					//Altero volontariamente la variabile di controllo per uscire dal for

		}
		}								//Fine if
		
		else temp[x]=headers[x];		//Copia del carattere corrente nell'array temporaneo

	}									//Fine for



//Fase 3: Ora all'interno dell'array temporaneo temp si trova il primo header. Si passa alla verifica se
//esso puo' esserecontenuto da primo_header e in caso lo restituisce. In caso contrario si restituisce
//l'apposito messagio di errore

	y=strlen(temp);						//Controllo lunghezza del "primo header"

	if (y>dim) return(8);				//L'header e' piu' grande del vettore passato: Errore di BUFFER_TOO_SMALL

	strcpy(primo_header,temp);			//Copia del primo header nell'array di vettori primo_header

	//DeAllocazione Memoria:
	free(temp);

	return(0);


}



int printTokens(Token tokenArray[], int dimT){

int x;			//Variabile Temporanea di controllo del for
int numero_token=0;
	//GESTIONE ERRORI

	//Errore dimT e' uguale a zero: non ci sono elementi da stampare
	if (dimT==0) return(1);


while((tokenArray[numero_token].parola)!=NULL) numero_token++;
	
for(x=0;x<numero_token;x++){								//Ciclo tutto l'array

if(tokenArray[x].contesto==NULL) printf("%s\n",tokenArray[x].parola);		//Se trovo un contesto NULL e' una parola del corpo del messaggio e stampo solo la parola
else printf("%s*%s\n",tokenArray[x].contesto,tokenArray[x].parola);		//altrimenti stampo contesto * e parola
}



return(0);							//Tutto ok.

}


int tokenizzaEmail(char* email, Token tokenArray[], int dimT){

	//Dichiarazioni variabili
	//Allocazione dinamica stringhe di caratteri
	int dimensione_header=strlen(email);			//Allocazione dinamica blocco per contenere tutti gli header
	//char headers[1000];	
	char* headers=malloc(dimensione_header+1);		//creato come minimo sulla dimensione dell'email passata + 1 per il carattere di fine stringa
	if(!headers) return(12);					
	

	
	
	
//	char tipo[100];							//Blocco per il tipo dell'header
	char* tipo=malloc(20);						//Il tipo al massimo puo' essere di 8 caratteri. Per sicurezza ne alloco 20
	int dimtipo=20;
	if(!tipo) return(12);
	
	
	
//	char valore[100];						//Blocco per il valore dell'header
	char* valore=malloc(100);
	int dimvalore=100;
	if(!valore) return(12);

	char* parola=malloc(100);
	//char parola[50];						//Blocco per la parola
	int dimP=100;
if(!parola) return(12);
	
//Sia nel caso di parola, sia nel caso di valore, l'allocazione e' fatta sulla base di un numero fittizio minimo di caratteri per ogni
//parola ipotizzato di 100
	
	int dimP_Body=100;				//Dimensione di una parola del corpo del messaggio
	
	int token_disp=0;				//Numero di token disponibile 

	int error=0;					//Variabili che contengono l'eventuale numero di errore da restituire
	int error2=0;
	int error3=0;



	int y;							//Variabili di controllo temporanee
	int dim=0;						//Variabile di controllo temporanea
	int dim_headers=0;					//Variabile di controllo che contiene la dimensione del blocco headers

	//Fine dichiarazione

//Prima parte: Viene invocata la funzione estraiHeaders che estrae il blocco degli header e lo restituisce in
//headers

	if((error=estraiHeaders(email,headers,dimensione_header))!=0){ 
																		//Se la funzione restituisce un codice di errore
																		//la tokenizza lo ritorna immediatamente al main()
		return(error);
	}

	//Ora in headers c'e' tutto il blocco degli header

	//si passa alla suddivisione degli header in righe
	dim_headers=strlen(headers);
	
	//char headers[1000];	
	char* primo_header=malloc(dim_headers+1);		//Allocazione dello spazio per contenere al minimo una riga di header 
	int dim_first_header=dim_headers;						//creato come minimo sulla dimensione di tutto il blocco degli header
	if(!primo_header) return(12);
	
	
	
	
	
	do{

		if((error=primoHeader(headers,primo_header,dim_first_header))!=0){		//Questa riga trasferisce il primo_header trovato
			
			return(error);		//Se si verifica un errore questo lo torna immediatamente al main()
		
		}else{						//Nessun errore, si passa alla processazione della prima riga di header
		
									//Cioe' all'identificazione dell'header

			if((error2=parseHeader(primo_header,tipo,dimtipo,valore,dimvalore))!=0){			//Questo spezzetta la riga e ne identifica il tipo
																				//e trasferisce il valore in Valore
			return(error2);
			}
			//Ciclo che deve terminare nel momento in cui ha finito di processare la riga di header
			do{
			if((error3=primaParola(valore,parola,dimP))!=0){
				return(error3);
			}
			
tokenArray[token_disp].contesto=malloc(20);
if(!(tokenArray[token_disp].contesto)) return(12);

strcpy(tokenArray[token_disp].contesto,tipo);
int dimParola=strlen(parola);
tokenArray[token_disp].parola=malloc(dimParola);
if(!(tokenArray[token_disp].parola)) return(12);
strcpy(tokenArray[token_disp].parola,parola);
token_disp++;
			
			
			
			

//			tokenArray[token_disp].contesto=tipo;
//			tokenArray[token_disp++].parola=parola;

			
			
			if (token_disp==dimT)return(8);
			valore=strstr(valore,parola);
			y=strlen(parola);
			valore=valore+y;
			
			
int z;
for(z=0;z<10;){

if((*valore)=='\0') z=10;
else if((isalnum(*valore))!=0) z=10;
else valore++;
}
			
			
			
			
			
			}while((*valore)!='\0');

			//A questo punto ho la coppia tipo e valore per la riga corrente di header


		}

	dim=strlen(primo_header);
	

	headers=headers+dim;

	while((*headers)=='\n') headers++;
	
	}while((*headers)!='\0');				//Il carattere corrente degli headers e' la fine della stringa headers:	
										
										//Fine processazione headers
									
	email=email+dim_headers+2;
	
	if(*email=='\0') return(10);	//Il carattere subito dopo il blocco degli headers e' un fine stringa:
					//Il corpo del messaggio non esiste. Torno l'opportuno codice di errore
					//Errore: BODY_NOT_FOUND
					
	//Se sono qui vuol dire che il corpo esiste e mi trovo col puntatore all'inizio della parte del Body del messaggio
	/*
	do{
	*/
	do{
			if((error=primaParola(email,parola,dimP_Body))!=0){
				return(error);
			}
			int x=0;
			
			
tokenArray[token_disp].contesto=NULL;

int dimParola=strlen(parola);
tokenArray[token_disp].parola=malloc(dimParola);
if(!(tokenArray[token_disp].parola)) return(12);

strcpy(tokenArray[token_disp].parola,parola);
token_disp++;


			


			if (token_disp==dimT)return(8);
			email=strstr(email,parola);
			y=strlen(parola);
			email=email+y;
			
//			while((*email=='\0')||(isalnum(*email))) email++;



//while((*email)=='\n') email++;	//Finche' e' vera incrementa email

//while((isalnum(*email))==0)



//if((*email)=='\0'){}
//else while((isalnum(*email))==0) email++;
int w;
for(w=0;w<10;){

if((*email)=='\0') w=10;
else if((isalnum(*email))!=0) w=10;
else email++;
}


			
			}while((*email)!='\0');
	
	
//Deallocazione e restituzione memoria per tutte le variabili dinamiche.


							


return(0);
}

