#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <ctype.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <unistd.h>
#include <errno.h>

#include "modulo1.h"
int leggiFile(char *nomefile, int dimensione, char *testo){
   FILE *file;
   int cod_er, file_size;
   struct stat buf;
   if(nomefile==NULL) return NULL_POINTER;
   if(testo==NULL) return NULL_POINTER;
   if(strcmp(nomefile, "")==0) return EMPTY_STRING;
   /*Esistenza del file*/
   if(stat(nomefile, &buf) != 0){
      if(errno == ENOENT) return FILE_MISSING;
      else return UNKNOWN_ERROR;
   }
   file=fopen(nomefile, "r");
   if(file==NULL) return FILE_UNREADABLE;
   if(dimensione < 3) return BUFFER_TOO_SMALL;
   fseek(file, 0l*sizeof(char), SEEK_END);
   file_size=(int)ftell(file);
   rewind(file);
   if((dimensione-1) > file_size){
      fread(testo, file_size, 1, file);
      testo[file_size]='\0';
   }
   else{
      fread(testo, (dimensione-1), 1, file);
      testo[dimensione-1]='\0';
   }
   fclose(file);
   if(strcmp(testo, "")==0) return FILE_EMPTY;
   return RESULT_OK;
}/*47*/
int tokenizzaEmail(char *email, Token tokenArray[], int dimT){
   char *headers, *testo, *parola, *valore, *tipo, *primo_header;
   char *id=" @_!\"$%&/()=?^[]#*-+.,\n\t<>;`~";
   int len, dimh, dim, dimt=10, dimv=50, cod_er, pos, cicle;
   if(email == NULL || tokenArray == NULL) return NULL_POINTER;
   if(strcmp(email, "")==0) return EMPTY_STRING;
   if(dimT < 1) return BUFFER_TOO_SMALL;
   dimh=strlen(email)/3;
   headers=NULL;
   for(;;){
      if(headers!=NULL) free(headers);
      headers=(char *) malloc(dimh);
      if(headers==NULL) return MEM_ALLOC_ERROR;
      cod_er=estraiHeaders(email, headers, dimh);/*Cattura gli errori*/
      if(cod_er==RESULT_OK) break;
      else if(cod_er != BUFFER_TOO_SMALL) return cod_er;
      dimh+=20;
      headers=(char *) realloc(headers, dimh);
      if(headers==NULL) return MEM_ALLOC_ERROR;
      /*printf("realloc su estraiHeaders()\n");*/
   }
   /*PER TROVARE IL TESTO DELL'EMAIL*/
   len=strlen(email);
   dim=strlen(headers)+1;
   testo=NULL;
   for(;;){
      if(testo!=NULL) free(testo);
      testo=(char *) malloc(len);
      if(testo==NULL) return MEM_ALLOC_ERROR;
      cod_er=estraiTesto(email, dim, testo, len);
      if(cod_er==RESULT_OK) break;
      else if(cod_er != BUFFER_TOO_SMALL) return cod_er;
      len+=10;
   /*   printf("realloc su estraiTesto()\n");*/
   }
   dim=dim/2;
   valore=NULL;
   tipo=NULL;
   primo_header=NULL;
   for(cicle=0; cicle<dimT; cicle++){
      for(len=0;;){
         if(primo_header!=NULL) free(primo_header);
         primo_header=(char *) malloc(dim+len);
         if(primo_header==NULL) return MEM_ALLOC_ERROR;
         cod_er=primoHeader(headers, primo_header, dim+len);
         if(cod_er==RESULT_OK) break;
         else if(cod_er != BUFFER_TOO_SMALL) return cod_er;
         len+=10;
         /*  printf("realloc su primoHeader()\n");*/
      }
      for(len=0;;){
         if(tipo!=NULL) free(tipo);
         tipo=(char *) malloc(dimt+len);
         if(tipo==NULL) return MEM_ALLOC_ERROR;
         if(valore!=NULL) free(valore);
         valore=(char *) malloc(dimv+len);
         if(valore==NULL) return MEM_ALLOC_ERROR;
         cod_er=parseHeader(primo_header, tipo, dimt+len, valore, dimv+len);
         if(cod_er==RESULT_OK) break;
         else if(cod_er != BUFFER_TOO_SMALL) return cod_er;
         len+=10;
         len+=30;
         /*printf("realloc su parseHeader()\n");*/
      }
      /*RIEMPIE IL TOKENARRAY CON GLI HEADERS*/
      for(; ;cicle++){
         len=strcspn(valore, id);
         for(; len<=0; ){
            len=strspn(valore, id);
            valore+=len;/*Per spostare il puntatore della stringa*/
            len=strcspn(valore, id);
         }
         tokenArray[cicle].parola=(char *) malloc(len+1);
         if(tokenArray[cicle].parola==NULL) return MEM_ALLOC_ERROR;
         tokenArray[cicle].contesto=(char *) malloc(strlen(tipo)+1);
         if(tokenArray[cicle].contesto==NULL) return MEM_ALLOC_ERROR;
         strcpy(tokenArray[cicle].contesto, tipo);
         strncpy(tokenArray[cicle].parola, valore, len);		/*120*/
         tokenArray[cicle].parola[len]='\0';
         if(len==strlen(valore)) break;
         if(valore[len]!='\0') valore+=len+1;
         else valore+=len;
      }
      /*RIDIMENSIONA L'HEADERS TOGLIENDO IL PRIMO*/
    /*  printf("%s\n", headers);*/
      if(headers[strlen(primo_header)]=='\n') headers+=strlen(primo_header)+1;
      else headers+=strlen(primo_header);/*Per spostare il puntatore della stringa*/
      if(strcmp(headers, "\0")==0) break;
   }
   cicle++;
   /*RIEMPIE IL TOKENARRAY CON IL TESTO*/
   dim=20;
   id=" @_-!\"$%&/()=?^[]#*-+.,\n\t<>;`~";
   parola=NULL;
   for(dimh=cicle; cicle<dimT; cicle++){		/*140*/
      for(;;){
         if(parola!=NULL) free(parola);
         parola=(char *) malloc(dim);
         cod_er=primaParola(testo, parola, dim);
         if(cod_er==RESULT_OK) break;
         else{
            if(cod_er != BUFFER_TOO_SMALL && cod_er != BODY_NOT_FOUND) return cod_er;
            if(cod_er==BODY_NOT_FOUND){
               if(cicle==dimh) return BODY_NOT_FOUND;
               else break;
            }
         }
         dim+=5;
      }
      if(cod_er==BODY_NOT_FOUND) break;
      dim=20;
      tokenArray[cicle].parola=(char *) malloc(strlen(parola)+1);
      tokenArray[cicle].contesto=NULL;
      if(strcmp(parola, "")!=0) strcpy(tokenArray[cicle].parola, parola);
      else{
         cod_er=-1;
         break;
      }
      if(strcmp(testo, parola)==0){
         cod_er=-1;
         cicle++;                               /*ULTIMA MODIFICA*/
         break;    /*Condizione di uscita*/
      }
      testo+=strlen(parola)+1;/*Per spostare il puntatore della stringa*/
   }
   if(cod_er!=BODY_NOT_FOUND && cod_er!=-1) return BUFFER_TOO_SMALL;
	tokenArray[cicle].parola=NULL;
	tokenArray[cicle].contesto=NULL;
   return RESULT_OK;
}
int estraiHeaders(char *email, char *headers, int dimh){
   int i, c;
   char *is_ok;
   if(email==NULL || headers==NULL) return NULL_POINTER;
   if(strcmp(email, "")==0) return EMPTY_STRING;
   if(dimh<=1) return BUFFER_TOO_SMALL;
   i=strspn(email, "\n\t");
   if(i > 0) return HEADER_NOT_FOUND;
   else{
      c=strcspn(email, "\n\t :");
      if(c == 0){
         i=strspn(email, " ");
         c=strcspn(email+i, "\n\t :");
         is_ok=(char *) malloc(c+1);
         strncpy(is_ok, email+i, c);
         is_ok[c]='\0';
      }
      else{
         is_ok=(char *) malloc(c+1);
         strncpy(is_ok, email, c);
         is_ok[c]='\0';
      }
      if(strcmp(is_ok, "From")!=0 && strcmp(is_ok, "From:")!=0 && strcmp(is_ok, "Subject:")!=0 && strcmp(is_ok, "To:")!=0) return HEADER_NOT_FOUND;
      if(strcmp(is_ok, "From")!=0 && strcmp(is_ok, "From:")!=0) return BAD_HEADER;
   }
   if(email[0]==' ' || email[0]=='\t') return BAD_HEADER;
   is_ok=NULL;
   for(i=0; i<dimh; i++){
      headers[i]=email[i];
      if(email[i]=='\0') return BODY_NOT_FOUND;
      if(email[i]=='\n' && email[i+1]=='\n') break;
      if(i==0 || email[i]=='\n'){
         c=strspn(email+i, "\n\t ");
         if(c > 1) continue;
         if(i==0) c=strcspn(email+i+c, "\n\t ");
         else c=strcspn(email+i+c, "\n\t ");
         if(is_ok!=NULL) free(is_ok);
         is_ok=(char *) malloc(c+1);
         if(i==0) strncpy(is_ok, email+i, c);
         else strncpy(is_ok, email+i+1, c);
         is_ok[c]='\0';
         if(strcmp(is_ok, "From")!=0 && strcmp(is_ok, "From:")!=0 && strcmp(is_ok, "Subject:")!=0 && strcmp(is_ok, "To:")!=0) return BAD_HEADER;
      }
   }
   if(headers[i]!='\n' || email[i+1]!='\n') return BUFFER_TOO_SMALL;
   headers[i]='\0';
   return RESULT_OK;
}
int primoHeader(char *headers, char *primo_header, int dim){
   int i;
   if(headers==NULL || primo_header==NULL) return NULL_POINTER;
   if(strcmp(headers, "")==0) return EMPTY_STRING;
   if(dim<2) return BUFFER_TOO_SMALL;
   for(i=0; ; i++){
      if(i>=dim-1) return BUFFER_TOO_SMALL;
      if(headers[i]=='\n'){
         if(headers[i+1]!='\t' && headers[i+1]!=' ') break;
      }
      if(headers[i]=='\0') break;
      primo_header[i]=headers[i];
   }
   primo_header[i]='\0';
   return RESULT_OK;
}
int parseHeader(char *header, char *tipo, int dimt, char *valore, int dimv){
   int i, p, parola;
   char *id=" @_-!\"$%|{}&/()=?^'[]#*-+.,\n\t:;><`~";
   if(header==NULL || tipo==NULL || valore==NULL) return NULL_POINTER;
   if(strcmp(header, "")==0) return EMPTY_STRING;
   if(dimt<=1 || dimv<=2) return BUFFER_TOO_SMALL;
   for(i=0; i<dimt; i++){
      if(header[i]==' ' || header[i]=='\t') break;
      tipo[i]=header[i];
   }
   if(header[i]!=' ' && header[i]!='\t') return BUFFER_TOO_SMALL;
   tipo[i]='\0';
   if(dimv<=(strlen(header)-(i+1))) return BUFFER_TOO_SMALL;
   p=0;
   for(i=i+1; i<dimv; i++){
      valore[p]=header[i];
      if(valore[p]=='\0') break;
      if(header[p]=='\n'){
         if(header[p+1]!='\t' && header[p+1]!=' ') break;
      }
      p++;
   }
   if(valore[p]=='\n') valore[p]='\0';
   if(valore[p]!='\0') return BUFFER_TOO_SMALL;
   return RESULT_OK;
}
int estraiTesto(char *email, int dimh, char *testo, int dim){
   int i;
   for(i=0; i<dim; i++){
      testo[i]=email[dimh];
      if(testo[i]=='\0') break;
      dimh++;
   }
   if(email[dimh]!='\0') return BUFFER_TOO_SMALL;
   if(i==0) return BODY_NOT_FOUND;
   return RESULT_OK;
}
int primaParola(char *testo, char *parola, int dim){
   char *id=" @_-!\"$%|{}&/()=?^'[]#*-+.,\n\t:;><`~";
   int len, pos, flag;
   if(testo==NULL || parola==NULL) return NULL_POINTER;
   if(strcmp(testo, "")==0) return EMPTY_STRING;
   if(dim<3) return BUFFER_TOO_SMALL;
   for(flag=0; ; flag++){
      len=strspn(testo, id);
      if(len>0){
         for(pos=0; ; pos++){
            testo[pos]=testo[pos+len];
            if(testo[pos]=='\0') break;
         }
      }
      len=strcspn(testo, id);
      if(len >= dim) return BUFFER_TOO_SMALL;
      strncpy(parola, testo, len);
      parola[len]='\0';
      for(pos=0; ; pos++){
         if(!isalnum(parola[pos])) break;
         if(parola[pos]=='\0') break;
      }
      if(pos!=strlen(parola)){
         testo[pos]=' ';
         continue;
      }
      len=strlen(parola);
      if(len<2 && len>0){
         for(pos=0; ; pos++){
            testo[pos]=testo[pos+len];
            if(testo[pos]=='\0') break;
         }
         continue;
      }
      break;
   }
   if(strcmp(parola, "")==0 && flag == 0) return BODY_NOT_FOUND;
   return RESULT_OK;
}
int printTokens(Token tokenArray[], int dimT){
   int i;

   if(tokenArray==NULL) return NULL_POINTER;
   if(dimT<=0) return BUFFER_TOO_SMALL;
   for(i=0; i<dimT; i++){
      if(tokenArray[i].contesto!=NULL){
         printf("%s*%s\n", tokenArray[i].contesto, tokenArray[i].parola);
      }
      else{
         if(tokenArray[i].parola==NULL) break;
         printf("%s\n", tokenArray[i].parola);
      }
   }
   return RESULT_OK;
}
