#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include "testModulo1.h"
#include "modulo1.c"
int set_cmp_is_ok(Token *tokenArray, Token *is_ok, int mode);

int test_leggiFile(int tipo_di_test, int argomento){
   int cod_er;
   char *testo, *is_ok;
   FILE *file;
   if(tipo_di_test==NULL_POINTER){
      if(argomento < 0 || argomento > 2) return ARG_MISSING;
      if(argomento==0){
         testo=(char *) malloc(10);
         cod_er=leggiFile(NULL, 50, testo);
         if(cod_er==NULL_POINTER) return TEST_PASSED;
         else{
            printf("Test fallito: funzione testata: leggiFile(NULL, 50, testo);\n\t      risultato atteso: NULL_POINTER(2)\n\t      risultato ottenuto: %d\n\t      spiegazione: la tua funzione non controlla se l'argomento nomefile  NULL\n", cod_er);
            return TEST_FAILED;
         }
      }
      if(argomento==2){
         cod_er=leggiFile("email1.txt", 50, NULL);
         if(cod_er==NULL_POINTER) return TEST_PASSED;
         else{
            printf("Test fallito: funzione testata: leggiFile(\"email.txt\", 50, NULL);\n\t      risultato atteso: NULL_POINTER(2)\n\t      risultato ottenuto: %d\n\t      spiegazione: la tua funzione non controlla se l'argomento testo  NULL\n", cod_er);
            return TEST_FAILED;
         }
      }
      return NOT_VALID;
   }
   if(tipo_di_test==EMPTY_STRING){
      if(argomento < 0 || argomento > 2) return ARG_MISSING;
      if(argomento==0){
         testo=(char *) malloc(10);
         cod_er=leggiFile("\0", 100, testo);
         if(cod_er==EMPTY_STRING) return TEST_PASSED;
         else{
            printf("Test fallito: funzione testata: leggiFile(\"\0\", dimensione, testo);\n\t\trisultato atteso: EMPTY_STRING(3)\n\t      risultato ottenuto: %d\n\t      spiegazione: la tua funzione non controlla la stringa vuota del nomefile\n", cod_er);
            return TEST_FAILED;
         }
      }
      return NOT_VALID;
   }
   if(tipo_di_test==FILE_UNREADABLE){
      if(argomento < 0 || argomento > 2) return ARG_MISSING;
      if(argomento==0){
         testo=(char *) malloc(10);
         cod_er=leggiFile("File_unreadable.txt", 10, testo);
         if(cod_er==FILE_UNREADABLE) return TEST_PASSED;
         else{
            printf("Test fallito: funzione testata: leggiFile(\"file_unreadable.txt\", dimensione, testo);\n\t\trisultato atteso: FILE_UNREADABLE(5)\n\t      risultato ottenuto: %d\n\t      spiegazione: la tua funzione non controlla se il file e' leggibile\n", cod_er);
            return TEST_FAILED;
         }
      }
      return NOT_VALID;
   }
   if(tipo_di_test==FILE_EMPTY){
      if(argomento < 0 || argomento > 2) return ARG_MISSING;
      if(argomento==0){
         testo=(char *) malloc(10);
         cod_er=leggiFile("File_empty.txt", 10, testo);
         if(cod_er==FILE_EMPTY) return TEST_PASSED;
         else{
            printf("Test fallito: funzione testata: leggiFile(\"file_empty.txt\", dimensione, testo);\n\t\trisultato atteso: FILE_UNREADABLE(5)\n\t      risultato ottenuto: %d\n\t      spiegazione: la tua funzione non controlla se il file e' leggibile\n", cod_er);
            return TEST_FAILED;
         }
      }
      return NOT_VALID;
   }
   if(tipo_di_test==BUFFER_TOO_SMALL){
      if(argomento < 0 || argomento > 2) return ARG_MISSING;
      if(argomento==1){
         testo=(char *) malloc(10);
         cod_er=leggiFile("email1.txt", 0, testo);
         if(cod_er==BUFFER_TOO_SMALL) return TEST_PASSED;
         else{
            printf("Test fallito: funzione testata: leggiFile(\"email1.txt\", 0, testo);\n\t\trisultato atteso: BUFFER_TOO_SMALL(8)\n\t      risultato ottenuto: %d\n\t      spiegazione: la tua funzione non controlla la dimensione del buffer testo\n", cod_er);
            return TEST_FAILED;
         }
      }
      return NOT_VALID;
   }
   if(tipo_di_test==FILE_MISSING){
      if(argomento < 0 || argomento > 2) return ARG_MISSING;
      if(argomento == 0){
         testo=(char *) malloc(10);
         cod_er=leggiFile("pippoKighygd", 10, testo);
         if(cod_er==FILE_MISSING) return TEST_PASSED;
         else{
            printf("Test fallito: funzione testata: leggiFile(\"pippoKighygd\", 10, testo);\n\t      risultato atteso: FILE_MISSING(4)\n\t      risultato ottenuto: %d\n\t      spiegazione: la tua funzione non controlla se il file esiste\n", cod_er);
            return TEST_FAILED;
         }
      }
      return NOT_VALID;
   }
   if(tipo_di_test==RESULT_OK){
      if(argomento < 0 || argomento > 2) return ARG_MISSING;
      if(argomento == 0){
         testo=(char *) malloc(1000);
         strcpy(testo, "From sterbini.di.uniroma1.it\nFrom: andrea@sterbini.org\nTo: babbo_natale@northpole.org\nSubject: Cosa vorrei per Natale\n\nCaro Babbo %$%&%$&%&Natale%$%$!\"!{,\nquest'anno ho cercato di essere molto\"$\"%$%&$&\"$\"%$&% buono[ e di non bocciare nessuno, ma talvolta ho dovuto farlo.\n\nTi prego di portarmi in regalo un Lego Mindstorms per poter insegnare ai ragazzi del corso a programmare in microcodice Lego.\n\nCiao\nAndrea\n");
         is_ok=(char *) malloc(strlen(testo)+1);
         strcpy(is_ok, testo);
         file=fopen("MIO_file_TEST.txt", "w+");
         fwrite(testo, strlen(testo), 1, file);
         fseek(file, 0l*sizeof(char), SEEK_END);
         cod_er=ftell(file);
         fclose(file);
         cod_er=leggiFile("MIO_file_TEST.txt", cod_er, testo);
         if(cod_er==RESULT_OK){
            if(strcmp(testo, is_ok)==0) return TEST_PASSED;
            else{
               printf("Test fallito: funzione testata: leggiFile(\"MIO_file_TEST.txt\", file_size, testo);\n\t      risultato atteso: RESULT_OK(0)\n\t      risultato ottenuto: %d\nspiegazione: Anche se ha ritornato il valore corretto il testo letto\ne' diverso da quello del file\n", cod_er);
               return TEST_FAILED;
            }
         }
         else{
            printf("Test fallito: funzione testata: leggiFile(\"MIO_file_TEST.txt\", file_size, testo);\n\t      risultato atteso: RESULT_OK(0)\n\t      risultato ottenuto: %d\n\t      spiegazione: nessuna\n", cod_er);
            return TEST_FAILED;
         }
      }
      return NOT_IMPLEMENTED;
   }
   return NOT_IMPLEMENTED;
}
int test_estraiHeaders(int tipo_di_test, int argomento){
   int cod_er;
   char *email, *headers, *is_ok;
   if(tipo_di_test == NULL_POINTER){
      if(argomento < 0 || argomento > 2) return ARG_MISSING;
      if(argomento == 0){
         headers=(char *) malloc(500);
         cod_er=estraiHeaders(NULL, headers, 500);
         if(cod_er == NULL_POINTER) return TEST_PASSED;
         else{
            printf("Test fallito: funzione testata: estraiHeaders(NULL, headers, dimh);\n\t      risultato atteso: NULL_POINTER(2)\n\t      risultato ottenuto: %d\n\t      spiegazione: la funzione non controlla il NULL pointer su email\n", cod_er);
            return TEST_FAILED;
         }
      }
      if(argomento == 1){
         email=(char *) malloc(10);
         cod_er=estraiHeaders(email, NULL, 50);
         if(cod_er == NULL_POINTER) return TEST_PASSED;
         else{
            printf("Test fallito: funzione testata: estraiHeaders(email, NULL, dimh);\n\t      risultato atteso: NULL_POINTER(2)\n\t      risultato ottenuto: %d\n\t      spiegazione: la funzione non controlla il NULL pointer su headers\n", cod_er);
            return TEST_FAILED;
         }
      }
      return NOT_VALID;
   }
   if(tipo_di_test==EMPTY_STRING){
      if(argomento < 0 || argomento > 2) return ARG_MISSING;
      if(argomento==0){
         headers=(char *) malloc(10);
         cod_er=estraiHeaders("\0", headers, 10);
         if(cod_er==EMPTY_STRING) return TEST_PASSED;
         else{
            printf("Test fallito: funzione testata: estraiHeaders(\"\0\", headers, dimh);\n\t\trisultato atteso: EMPTY_STRING(3)\n\t      risultato ottenuto: %d\n\t      spiegazione: la tua funzione non controlla la stringa vuota del email\n", cod_er);
            return TEST_FAILED;
         }
      }
      return NOT_VALID;
   }
   if(tipo_di_test == BUFFER_TOO_SMALL){
      if(argomento < 0 || argomento > 2) return ARG_MISSING;
      if(argomento == 2){
         cod_er=estraiHeaders("pippo", "pluto", 0);
         if(cod_er == BUFFER_TOO_SMALL) return TEST_PASSED;
         else{
            printf("Test fallito: funzione testata: estraiHeaders(email, headers, 0);\n\t      risultato atteso: BUFFER_TOO_SMALL(8)\n\t      risultato ottenuto: %d\n\t      spiegazione: la funzione non controlla se il buffer headers  troppo piccolo\n", cod_er);
            return TEST_FAILED;
         }
      }
      return NOT_VALID;
   }
   if(tipo_di_test == BODY_NOT_FOUND){
      if(argomento < 0 || argomento > 2) return ARG_MISSING;
      if(argomento == 0){
         email=(char *) malloc(1000);
         strcpy(email, "From andrea@sterbini.org\n		151.100.17.XXX\n		ghgfhgfhgfhhjhgfdhgfhf\nFrom titti@paperino.org\n		321.001.98.RRR\n		itirewyturwtd\nFrom: andrea@sterbini.org\nTo: babbo_natale@northpole.org\nSubject: Cosa vorrei per Natale");
         headers=(char *) malloc(500);
         cod_er=estraiHeaders(email, headers, 500);
         if(cod_er == BODY_NOT_FOUND) return TEST_PASSED;
         else{
            if(cod_er == RESULT_OK) printf("Test fallito: funzione testata: estraiHeaders(email(senza Body), headers, dimh);\n\t      risultato atteso: BODY_NOT_FOUND(10)\n\t      risultato ottenuto: %d\n\t      spiegazione: la funzione non controlla se gli headers sono presenti, di conseguenza prende il testo come headers\n", cod_er);
            if(cod_er == BAD_HEADER) printf("Test fallito: funzione testata: estraiHeaders(email(senza Body), headers, dimh);\n\t      risultato atteso: BODY_NOT_FOUND(10)\n\t      risultato ottenuto: %d\n\t      spiegazione: la funzione non controlla se il corpo dell'email e' presente, e restituisce un BAD_HEADER\n", cod_er);
            return TEST_FAILED;
         }
      }
      return NOT_VALID;
   }
   if(tipo_di_test == HEADER_NOT_FOUND){
      if(argomento < 0 || argomento > 2) return ARG_MISSING;
      if(argomento == 0){
         email=(char *) malloc(1000);
         strcpy(email, " Caro Babbo Natale,\nquest'anno ho cercato di essere molto buono e di non bocciare nessuno, ma talvolta ho dovuto farlo.\n\nTi prego di portarmi in regalo un Lego Mindstorms per poter insegnare ai ragazzi del corso a programmare in microcodice Lego\n");
         headers=(char *) malloc(500);
         cod_er=estraiHeaders(email, headers, 500);
         if(cod_er == HEADER_NOT_FOUND) return TEST_PASSED;
         else{
            if(cod_er == RESULT_OK) printf("Test fallito: funzione testata: estraiHeaders(email(senza headers), headers, 500);\n\t      risultato atteso: HEADER_NOT_FOUND(9)\n\t      risultato ottenuto: %d\n\t      spiegazione: la funzione non controlla se gli headers sono presenti, di conseguenza prende il testo come headers\n", cod_er);
            if(cod_er == BAD_HEADER) printf("Test fallito: funzione testata: estraiHeaders(email(senza headers), headers, 500);\n\t      risultato atteso: HEADER_NOT_FOUND(9)\n\t      risultato ottenuto: %d\n\t      spiegazione: la funzione non controlla se gli headers sono presenti, e restituisce un BAD_HEADER\n", cod_er);
            return TEST_FAILED;
         }
      }
      return NOT_VALID;
   }
   if(tipo_di_test == BAD_HEADER){
      if(argomento < 0 || argomento > 2) return ARG_MISSING;
      if(argomento == 0){
         email=(char *) malloc(1000);
         strcpy(email, "From: andrea@sterbini.org\nTo babbo_natale@northpole.org\nSubject: Cosa vorrei per Natale\n\nCaro Babbo Natale,\nquest'anno ho cercato di essere molto buono e di non bocciare nessuno, ma talvolta ho dovuto farlo.\n\nTi prego di portarmi in regalo un Lego Mindstorms per poter insegnare ai ragazzi del corso a programmare in microcodice Lego.\n\nCiao\nAndrea\n");
         headers=(char *) malloc(500);
         cod_er=estraiHeaders(email, headers, 500);
         if(cod_er == BAD_HEADER) return TEST_PASSED;
         else{
            printf("Test fallito: funzione testata: estraiHeaders(email(headers errato), headers, 500);\n\t      risultato atteso: BAD_HEADER(11)\n\t      risultato ottenuto: %d\n\t      spiegazione: la funzione non controlla se gli headers sono corretti\n", cod_er);
            return TEST_FAILED;
         }
      }
      return NOT_VALID;
   }
   if(tipo_di_test == RESULT_OK){
      if(argomento < 0 || argomento > 2) return ARG_MISSING;
      if(argomento == 0){
         is_ok="From: andrea@sterbini.org\nTo: babbo_natale@northpole.org\nSubject: Cosa vorrei per Natale";
         email=(char *) malloc(1000);
         strcpy(email, "From: andrea@sterbini.org\nTo: babbo_natale@northpole.org\nSubject: Cosa vorrei per Natale\n\nCaro Babbo Natale,\nquest'anno ho cercato di essere molto buono e di non bocciare nessuno, ma talvolta ho dovuto farlo.\n\nTi prego di portarmi in regalo un Lego Mindstorms per poter insegnare ai ragazzi del corso a programmare in microcodice Lego.\n\nCiao\nAndrea\n");
         headers=(char *) malloc(500);
         cod_er=estraiHeaders(email, headers, 500);
         if(cod_er == RESULT_OK){
            if(strcmp(headers, is_ok)==0) return TEST_PASSED;
            else{
               printf("Test fallito: funzione testata: estraiHeaders(email, headers, 500);\n\t      risultato atteso: RESULT_OK(0)\n\t      risultato ottenuto: %d\n\t      spiegazione: la funzione non calcola gli headers in modo corretti\n", cod_er);
               return TEST_FAILED;
            }
         }
         else{
            printf("Test fallito: funzione testata: estraiHeaders(email(headers errato), headers, 500);\n\t      risultato atteso: RESULT_OK(0)\n\t      risultato ottenuto: %d\n\t      spiegazione: la funzione non calcola gli headers\n", cod_er);
            return TEST_FAILED;
         }
      }
      return NOT_IMPLEMENTED;
   }
   return NOT_IMPLEMENTED;
}
int test_primoHeader(int tipo_di_test, int argomento){
   int cod_er;
   char *headers, *primo_header;
   char *is_ok;
   if(tipo_di_test == NULL_POINTER){
      if(argomento < 0 || argomento > 2) return ARG_MISSING;
      if(argomento == 0){
         primo_header=(char *) malloc(500);
         cod_er=primoHeader(NULL, primo_header, 500);
         if(cod_er == NULL_POINTER) return TEST_PASSED;
         else{
            printf("Test fallito: funzione testata: primoHeaders(NULL, primo_header, dim);\n\t      risultato atteso: NULL_POINTER(2)\n\t      risultato ottenuto: %d\n\t      spiegazione: la funzione non controlla il NULL pointer sul headers\n", cod_er);
            return TEST_FAILED;
         }
      }
      if(argomento == 1){
         headers=(char *) malloc(500);
         cod_er=primoHeader(headers, NULL, 500);
         if(cod_er == NULL_POINTER) return TEST_PASSED;
         else{
            printf("Test fallito: funzione testata: primoHeaders(headers, NULL, dim);\n\t      risultato atteso: NULL_POINTER(2)\n\t      risultato ottenuto: %d\n\t      spiegazione: la funzione non controlla il NULL pointer su primo_header\n", cod_er);
            return TEST_FAILED;
         }
      }
      return NOT_VALID;
   }
   if(tipo_di_test==EMPTY_STRING){
      if(argomento < 0 || argomento > 2) return ARG_MISSING;
      if(argomento==0){
         primo_header=(char *) malloc(10);
         cod_er=primoHeader("\0", primo_header, 10);
         if(cod_er==EMPTY_STRING) return TEST_PASSED;
         else{
            printf("Test fallito: funzione testata: primoHeader(\"\0\", header, dim);\n\t\trisultato atteso: EMPTY_STRING(3)\n\t      risultato ottenuto: %d\n\t      spiegazione: la tua funzione non controlla la stringa vuota del headers\n", cod_er);
            return TEST_FAILED;
         }
      }
      return NOT_VALID;
   }
   if(tipo_di_test == BUFFER_TOO_SMALL){
      if(argomento < 0 || argomento > 2) return ARG_MISSING;
      if(argomento == 2){
         cod_er=primoHeader("headers", "primo_header", 0);
         if(cod_er == BUFFER_TOO_SMALL) return TEST_PASSED;
         else{
            printf("Test fallito: funzione testata: primoHeader(headers, primo_header, 0);\n\t      risultato atteso: BUFFER_TOO_SMALL(8)\n\t      risultato ottenuto: %d\n\t      spiegazione: la funzione non controlla la dimensione di dim\n", cod_er);
            return TEST_FAILED;
         }
      }
      return NOT_VALID;
   }
   if(tipo_di_test == RESULT_OK){
      if(argomento < 0 || argomento > 2) return ARG_MISSING;
      if(argomento == 0){
         headers="From andrea@sterbini.org\n		151.100.17.XXX\n		ghgfhgfhgfhhjhgfdhgfhf\nFrom titti@paperino.org\n		321.001.98.RRR\n		itirewyturwtd\nFrom: andrea@sterbini.org\nTo: babbo_natale@northpole.org\nSubject: Cosa vorrei per Natale";
         is_ok="From andrea@sterbini.org\n		151.100.17.XXX\n		ghgfhgfhgfhhjhgfdhgfhf";
         primo_header=(char *) malloc(100);
         cod_er=primoHeader(headers, primo_header, 100);
         if(cod_er == RESULT_OK){
            if(strcmp(primo_header, is_ok)==0) return TEST_PASSED;
            else{
               printf("Test fallito: funzione testata: primoHeader(headers, primo_header, dim);\n\t      risultato atteso: RESULT_OK(0)\n\t      risultato ottenuto: %d\n\t      spiegazione: il primo_header restituito dalla funzione non e' corretto\n", cod_er);
               return TEST_FAILED;
            }
         }
      }
      return NOT_IMPLEMENTED;
   }
   return NOT_IMPLEMENTED;
}
int test_parseHeader(int tipo_di_test, int argomento){
   int cod_er;
   char *header, *tipo, *valore;
   if(tipo_di_test == NULL_POINTER){
      if(argomento < 0 || argomento > 4) return ARG_MISSING;
      if(argomento == 0){
         header=NULL;
         tipo=(char *) malloc(10);
         valore=(char *) malloc(10);
         cod_er=parseHeader(NULL, tipo, 10, valore, 10);
         if(cod_er == NULL_POINTER) return TEST_PASSED;
         else{
            printf("Test fallito: funzione testata: parseHeaders(NULL, tipo, dimt, valore, dimv);\n\t      risultato atteso: NULL_POINTER(2)\n\t      risultato ottenuto: %d\n\t      spiegazione: la funzione non controlla il NULL pointer sul header\n", cod_er);
            return TEST_FAILED;
         }
      }
      if(argomento == 1){
         header=(char *) malloc(10);
         valore=(char *) malloc(10);
         cod_er=parseHeader(header, NULL, 10, valore, 10);
         if(cod_er == NULL_POINTER) return TEST_PASSED;
         else{
            printf("Test fallito: funzione testata: parseHeaders(header, NULL, dimt, valore, dimv);\n\t      risultato atteso: NULL_POINTER(2)\n\t      risultato ottenuto: %d\n\t      spiegazione: la funzione non controlla il NULL pointer su tipo\n", cod_er);
            return TEST_FAILED;
         }
      }
      if(argomento == 3){
         header=(char *) malloc(10);
         tipo=(char *) malloc(10);
         cod_er=parseHeader(header, tipo, 10, NULL, 10);
         if(cod_er == NULL_POINTER) return TEST_PASSED;
         else{
            printf("Test fallito: funzione testata: parseHeaders(header, tipo, dimt, NULL, dimv);\n\t      risultato atteso: NULL_POINTER(2)\n\t      risultato ottenuto: %d\n\t      spiegazione: la funzione non controlla il NULL pointer su valore\n", cod_er);
            return TEST_FAILED;
         }
      }
      return NOT_VALID;
   }
   if(tipo_di_test==EMPTY_STRING){
      if(argomento < 0 || argomento > 4) return ARG_MISSING;
      if(argomento==0){
         tipo=(char *) malloc(10);
         valore=(char *) malloc(10);
         cod_er=parseHeader("\0", tipo, 10, valore, 10);
         if(cod_er==EMPTY_STRING) return TEST_PASSED;
         else{
            printf("Test fallito: funzione testata: parseHeader(\"\0\", tipo, dimt, valore, dimv);\n\t\trisultato atteso: EMPTY_STRING(3)\n\t      risultato ottenuto: %d\n\t      spiegazione: la tua funzione non controlla la stringa vuota del header\n", cod_er);
            return TEST_FAILED;
         }
      }
      return NOT_VALID;
   }
   if(tipo_di_test == BUFFER_TOO_SMALL){
      if(argomento < 0 || argomento > 4) return ARG_MISSING;
      if(argomento == 2){
         cod_er=parseHeader("header", "tipo", 0, "valore", 10);
         if(cod_er == BUFFER_TOO_SMALL) return TEST_PASSED;
         else{
            printf("Test fallito: funzione testata: parseHeaders(header, tipo, 0, valore, dimv);\n\t      risultato atteso: NULL_POINTER(2)\n\t      risultato ottenuto: %d\n\t      spiegazione: la funzione non controlla il buffer tipo\n", cod_er);
            return TEST_FAILED;
         }
      }
      if(argomento == 4){
         cod_er=parseHeader("header", "tipo", 10, "valore", 0);
         if(cod_er == BUFFER_TOO_SMALL) return TEST_PASSED;
         else{
            printf("Test fallito: funzione testata: parseHeaders(header, tipo, dimt, valore, 0);\n\t      risultato atteso: NULL_POINTER(2)\n\t      risultato ottenuto: %d\n\t      spiegazione: la funzione non controlla il buffer valore\n", cod_er);
            return TEST_FAILED;
         }
      }
      return NOT_VALID;
   }
   if(tipo_di_test == RESULT_OK){
      if(argomento < 0 || argomento > 4) return ARG_MISSING;
      if(argomento == 0){
         header="Subject: Cosa vorrei per Natale";
         tipo=(char *) malloc(20);
         valore=(char *) malloc(50);
         cod_er=parseHeader(header, tipo, 20, valore, 50);
         if(cod_er == RESULT_OK){
            if(strcmp(tipo, "Subject:")==0 && strcmp(valore, "Cosa vorrei per Natale")==0) return TEST_PASSED;
            else{
               printf("Test fallito: funzione testata: parseHeaders(header, tipo, dimt, valore, dimv);\n\t      risultato atteso: RESULT_OK(0)\n\t      risultato ottenuto: %d\n\t      spiegazione: la funzione non restituisci i stessi valori di tipo e valore\n", cod_er);
               return TEST_FAILED;
            }
         }
         else printf("Test fallito: funzione testata: parseHeaders(header, tipo, dimt, valore, dimv);\n\t      risultato atteso: RESULT_OK(0)\n\t      risultato ottenuto: %d\n\t      spiegazione: la funzione non restituisci il codice giusto\n", cod_er);
      }
      return NOT_IMPLEMENTED;
   }
   return NOT_IMPLEMENTED;
}
int test_primaParola(int tipo_di_test, int argomento){
   int cod_er;
   char *testo, *parola, *is_ok;
   if(tipo_di_test == NULL_POINTER){
      if(argomento < 0 || argomento > 2) return ARG_MISSING;
      if(argomento == 0){
         parola=(char *) malloc(10);
         cod_er=primaParola(NULL, parola, 10);
         if(cod_er == NULL_POINTER) return TEST_PASSED;
         else{
            printf("Test fallito: funzione testata: primaParola(NULL, parola, dim);\n\t      risultato atteso: NULL_POINTER(2)\n\t      risultato ottenuto: %d\n\t      spiegazione: la funzione non controlla il NULL pointer sul testo\n", cod_er);
            return TEST_FAILED;
         }
      }
      if(argomento == 1){
         testo=(char *) malloc(10);
         cod_er=primaParola(testo, NULL, 10);
         if(cod_er == NULL_POINTER) return TEST_PASSED;
         else{
            printf("Test fallito: funzione testata: primaParola(testo, NULL, dim);\n\t      risultato atteso: NULL_POINTER(2)\n\t      risultato ottenuto: %d\n\t      spiegazione: la funzione non controlla il NULL pointer su parola\n", cod_er);
            return TEST_FAILED;
         }
      }
      return NOT_VALID;
   }
   if(tipo_di_test==EMPTY_STRING){
      if(argomento < 0 || argomento > 2) return ARG_MISSING;
      if(argomento==0){
         parola=(char *) malloc(10);
         cod_er=primaParola("\0", parola, 10);
         if(cod_er==EMPTY_STRING) return TEST_PASSED;
         else{
            printf("Test fallito: funzione testata: primaParola(\"\0\", parola, dim);\n\t\trisultato atteso: EMPTY_STRING(3)\n\t      risultato ottenuto: %d\n\t      spiegazione: la tua funzione non controlla la stringa vuota del testo\n", cod_er);
            return TEST_FAILED;
         }
      }
      return NOT_VALID;
   }
   if(tipo_di_test == BODY_NOT_FOUND){
      if(argomento < 0 || argomento > 2) return ARG_MISSING;
      if(argomento == 0){
         parola=(char *) malloc(30);
         testo=(char *) malloc(100);
         strcpy(testo, "\n");
         is_ok="";
         cod_er=primaParola(testo, parola, 30);
         if(cod_er == BODY_NOT_FOUND) return TEST_PASSED;
         else{
            printf("Test fallito: funzione testata: primaParola(testo, parola, dim);\n\t      risultato atteso: BODY_NOT_FOUND(10)\n\t      risultato ottenuto: %d\n\t      spiegazione: la funzione non controlla se il corpo dell'email manca\n", cod_er);
            return TEST_FAILED;
         }
      }
      return NOT_VALID;
   }
   if(tipo_di_test == BUFFER_TOO_SMALL){
      if(argomento < 0 || argomento > 2) return ARG_MISSING;
      if(argomento == 2){
         cod_er=primaParola("testo", "parola", 0);
         if(cod_er == BUFFER_TOO_SMALL) return TEST_PASSED;
         else{
            printf("Test fallito: funzione testata: primaParola(testo, parola, 0);\n\t      risultato atteso: BUFFER_TOO_SMALL(8)\n\t      risultato ottenuto: %d\n\t      spiegazione: la funzione non controlla se la dimensione del buffer  troppo piccola\n", cod_er);
            return TEST_FAILED;
         }
      }
      return NOT_VALID;
   }
   if(tipo_di_test == RESULT_OK){
      if(argomento < 0 || argomento > 2) return ARG_MISSING;
      if(argomento == 0){
         testo=(char *) malloc(50);
         parola=(char *) malloc(20);
         strcpy(testo, "a e r t y u i o o p p  d f g h j f x c v b Bomba_Sexy f d\n");
         cod_er=primaParola(testo, parola, 20);
         is_ok="Bomba";
         if(cod_er == RESULT_OK){
            if(strcmp(parola, is_ok)==0) return TEST_PASSED;
            else{
               printf("Test fallito: funzione testata: primaParola(testo, parola, dim);\n\t      risultato atteso: RESULT_OK(0)\n\t      risultato ottenuto: %d\n\t      spiegazione: il valore e' RESUL_OK, pero' la parola restituita non e' esatta\n", cod_er);
               return TEST_FAILED;
            }
         }
         else{
            printf("Test fallito: funzione testata: primaParola(testo, parola, dim);\n\t      risultato atteso: BUFFER_TOO_SMALL(8)\n\t      risultato ottenuto: %d\n\t      spiegazione: la funzione non restituisce il giusto codice\n", cod_er);
            return TEST_FAILED;
         }
      }
      return NOT_IMPLEMENTED;
   }
   return NOT_IMPLEMENTED;
}
int test_tokenizzaEmail(int tipo_di_test, int argomento){
   int cod_er;
   char *email;
   Token *tokenArray, *is_ok;
   struct full_memo* full, *pre;
   if(tipo_di_test == NULL_POINTER){
      if(argomento < 0 || argomento > 2) return ARG_MISSING;
      if(argomento == 0){
         tokenArray=(Token *) malloc(sizeof(Token)*10);
         cod_er=tokenizzaEmail(NULL, tokenArray, 10);
         if(cod_er == NULL_POINTER) return TEST_PASSED;
         else{
            printf("Test fallito: funzione testata: tokenizzaEmail(NULL, tokenArray, dimT);\n\t      risultato atteso: NULL_POINTER(2)\n\t      risultato ottenuto: %d\n\t      spiegazione: la funzione non controlla il NULL pointer sull'email\n", cod_er);
            return TEST_FAILED;
         }
      }
      if(argomento == 1){
         email=(char *) malloc(10);
         cod_er=primaParola(email, NULL, 0);
         if(cod_er == NULL_POINTER) return TEST_PASSED;
         else{
            if(cod_er == BUFFER_TOO_SMALL) printf("Test fallito: funzione testata: tokenizzaEmail(email, NULL, 0);\n\t      risultato atteso: NULL_POINTER(2)\n\t      risultato ottenuto: %d\n\t      spiegazione: la funzione non controlla il NULL pointer su parola, o meglio non lo controlla prima della dimensione dimT\n", cod_er);
            else printf("Test fallito: funzione testata: tokenizzaEamil(email, NULL, 0);\n\t      risultato atteso: NULL_POINTER(2)\n\t      risultato ottenuto: %d\n\t      spiegazione: la funzione non controlla il NULL pointer su parola\n", cod_er);
            return TEST_FAILED;
         }
      }
      return NOT_VALID;
   }
   if(tipo_di_test==EMPTY_STRING){
      if(argomento < 0 || argomento > 2) return ARG_MISSING;
      if(argomento==0){
         tokenArray=(Token *) malloc(80);
         cod_er=tokenizzaEmail("\0", tokenArray, 10);
         if(cod_er==EMPTY_STRING) return TEST_PASSED;
         else{
            printf("Test fallito: funzione testata: tokenizzaEmail(\"\0\", tokenArray, dimT);\n\t\trisultato atteso: EMPTY_STRING(3)\n\t      risultato ottenuto: %d\n\t      spiegazione: la tua funzione non controlla la stringa vuota dell'email\n", cod_er);
            return TEST_FAILED;
         }
      }
      return NOT_VALID;
   }
   if(tipo_di_test == BODY_NOT_FOUND){
      if(argomento < 0 || argomento > 2) return ARG_MISSING;
      if(argomento == 0){
         email=(char *) malloc(500);
         strcpy(email, "From sterbini.di.uniroma1.it\nFrom: andrea@sterbini.org\nTo: babbo_natale@northpole.org\nSubject: Cosa vorrei per Natale\n\n");
         tokenArray=(Token *) malloc(sizeof(Token)*100);
         cod_er=tokenizzaEmail(email, tokenArray, 100);
         if(cod_er == BODY_NOT_FOUND) return TEST_PASSED;
         else{
            printf("Test fallito: funzione testata: tokenizzaEmail(email, tokenArray, dimT);\n\t      risultato atteso: BODY_NOT_FOUND(10)\n\t      risultato ottenuto: %d\n\t      spiegazione: la funzione non controlla se il corpo dell'email manca\n", cod_er);
            return TEST_FAILED;
         }
      }
      return NOT_VALID;
   }
   if(tipo_di_test == BUFFER_TOO_SMALL){
      if(argomento < 0 || argomento > 2) return ARG_MISSING;
      if(argomento == 2){
         tokenArray=(Token *) malloc(sizeof(Token)*100);
         cod_er=tokenizzaEmail("email", tokenArray, 0);
         if(cod_er == BUFFER_TOO_SMALL) return TEST_PASSED;
         else{
            printf("Test fallito: funzione testata: tokenizzaEmail(email, tokenArray, 0);\n\t      risultato atteso: BUFFER_TOO_SMALL(8)\n\t      risultato ottenuto: %d\n\t      spiegazione: la funzione non controlla se la dimensione del buffer  troppo piccola\n", cod_er);
            return TEST_FAILED;
         }
      }
      return NOT_VALID;
   }/**/
   if(tipo_di_test == HEADER_NOT_FOUND){
      if(argomento < 0 || argomento > 2) return ARG_MISSING;
      if(argomento == 0){
         email=(char *) malloc(1000);
         tokenArray=(Token *) malloc(sizeof(Token)*100);
         strcpy(email, " Caro Babbo Natale,\nquest'anno ho cercato di essere molto buono e di non bocciare nessuno, ma talvolta ho dovuto farlo.\n\nTi prego di portarmi in regalo un Lego Mindstorms per poter insegnare ai ragazzi del corso a programmare in microcodice Lego\n");
         cod_er=tokenizzaEmail(email, tokenArray, 100);
         if(cod_er == HEADER_NOT_FOUND) return TEST_PASSED;
         else{
            if(cod_er == RESULT_OK) printf("Test fallito: funzione testata: tokenizzaEmail(email(senza headers), tokenArray, dimT);\n\t      risultato atteso: HEADER_NOT_FOUND(9)\n\t      risultato ottenuto: %d\n\t      spiegazione: la funzione non controlla se gli headers sono presenti, di conseguenza prende il testo come headers\n", cod_er);
            if(cod_er == BAD_HEADER) printf("Test fallito: funzione testata: estraiHeaders(email(senza headers), headers, 500);\n\t      risultato atteso: HEADER_NOT_FOUND(9)\n\t      risultato ottenuto: %d\n\t      spiegazione: la funzione non controlla se gli headers sono presenti, e restituisce un BAD_HEADER\n", cod_er);
            return TEST_FAILED;
         }
      }
      return NOT_VALID;
   }
   if(tipo_di_test == BAD_HEADER){
      if(argomento < 0 || argomento > 2) return ARG_MISSING;
      if(argomento == 0){
         email=(char *) malloc(1000);
         tokenArray=(Token *) malloc(sizeof(Token)*100);
         strcpy(email, "From: andrea@sterbini.org\nTo: babbo_natale@northpole.org\nSubject: Cosa vorrei per Natale\nCaro Babbo Natale,\nquest'anno ho cercato di essere molto buono e di non bocciare nessuno, ma talvolta ho dovuto farlo.\n\nTi prego di portarmi in regalo un Lego Mindstorms per poter insegnare ai ragazzi del corso a programmare in microcodice Lego.\n\nCiao\nAndrea\n");
         cod_er=tokenizzaEmail(email, tokenArray, 100);
         if(cod_er == BAD_HEADER) return TEST_PASSED;
         else{
            printf("Test fallito: funzione testata: tokenizzaEmail(email(headers errato), tokenArray, dimT);\n\t      risultato atteso: BAD_HEADER(11)\n\t      risultato ottenuto: %d\n\t      spiegazione: la funzione non controlla se gli headers sono corretti\n", cod_er);
            return TEST_FAILED;
         }
      }
      return NOT_VALID;
   }/**/
   if(tipo_di_test==RESULT_OK){
      if(argomento < 0 || argomento > 2) return ARG_MISSING;
      if(argomento==0){
         tokenArray=(Token *) malloc(sizeof(Token)*100);
         is_ok=(Token *) malloc(sizeof(Token)*100);
         email=(char *) malloc(1000);
         strcpy(email, "From andrea@sterbini.org\nTo: babbo_natale@northpole.org\nSubject: Cosa vorrei per Natale\n\nCaro Babbo Natale,\nquest'anno ho cercato di essere molto buono e di non bocciare nessuno, ma talvolta ho dovuto farlo");
         cod_er=tokenizzaEmail(email, tokenArray, 100);
         if(cod_er==RESULT_OK){
            if(set_cmp_is_ok(tokenArray, is_ok, 0)==TEST_PASSED) return TEST_PASSED;
            else{
               printf("Test fallito: funzione testata: tokenizzaEmail(email, tokenArray, dimT);\n\t\trisultato atteso: RESULT_OK(0)\n\t      risultato ottenuto: %d\n\t      spiegazione: la tua funzione pur restituendo RESULT_OK non ha messo in tokenArray l'output atteso\n", cod_er);
               return TEST_FAILED;
            }
         }
         else{
            printf("Test fallito: funzione testata: tokenizzaEmail(email, tokenArray, dimT);\n\t\trisultato atteso: RESULT_OK(0)\n\t      risultato ottenuto: %d\n\t      spiegazione: la tua funzione non restituisce RESULT_OK come dovrebbe\n", cod_er);
            return TEST_FAILED;
         }
      }
      return NOT_IMPLEMENTED;
   }
   return NOT_IMPLEMENTED;
}
int set_cmp_is_ok(Token *tokenArray, Token *is_ok, int mode){
   int i;
   /*RIEMPIMENTO DEI DATI PER IL CONFRONTO*/
   is_ok[0].parola="andrea";     is_ok[1].parola="sterbini";      is_ok[2].parola="org";
   is_ok[0].contesto="From";     is_ok[1].contesto="From";        is_ok[2].contesto="From";
   is_ok[3].parola="babbo";      is_ok[4].parola="natale";        is_ok[5].parola="northpole";
   is_ok[3].contesto="To:";      is_ok[4].contesto="To:";         is_ok[5].contesto="To:";
   is_ok[6].parola="org";        is_ok[7].parola="Cosa";          is_ok[8].parola="vorrei";
   is_ok[6].contesto="To:";      is_ok[7].contesto="Subject:";    is_ok[8].contesto="Subject:";
   is_ok[9].parola="per";        is_ok[10].parola="Natale";       is_ok[11].parola="Caro";
   is_ok[9].contesto="Subject:"; is_ok[10].contesto="Subject:";
   is_ok[12].parola="Babbo";     is_ok[13].parola="Natale";       is_ok[14].parola="quest";
   is_ok[15].parola="anno";      is_ok[16].parola="ho";           is_ok[17].parola="cercato";
   is_ok[18].parola="di";        is_ok[19].parola="essere";       is_ok[20].parola="molto";
   is_ok[21].parola="buono";     is_ok[22].parola="di";           is_ok[23].parola="non";
   is_ok[24].parola="bocciare";  is_ok[25].parola="nessuno";      is_ok[26].parola="ma";
   is_ok[27].parola="talvolta";  is_ok[28].parola="ho";             is_ok[29].parola="dovuto";
   is_ok[30].parola="farlo";
   /*SETTAGGIO A NULL DEL CONTESTO PER IL BODY*/
   if(mode == 0){
      for(i=11; i<=30; i++){
         is_ok[i].contesto=NULL;
      }
      /*VERIFICA DEI DATI OTTENUTI*/
      for(i=0; i<=30; i++){
         /*printf("PAROLA: %s-%s\n", tokenArray[i].parola, is_ok[i].parola);
         printf("CONTESTO: %s-%s\n", tokenArray[i].contesto, is_ok[i].contesto);*/
         if(strcmp(tokenArray[i].parola, is_ok[i].parola)!=0) return TEST_FAILED;
         if(is_ok[i].contesto!=NULL){
            if(strcmp(tokenArray[i].contesto, is_ok[i].contesto)!=0) return TEST_FAILED;
         }
         else if(tokenArray[i].contesto!=NULL) return TEST_FAILED;
      }
      return TEST_PASSED;
   }
   return 0;
}
int test_printTokens(int tipo_di_test, int argomento){
   int cod_er;
   Token *token;
   if(tipo_di_test == NULL_POINTER){
      if(argomento < 0 || argomento > 1) return ARG_MISSING;
      if(argomento == 0){
         cod_er=printTokens(NULL, 50);
         if(cod_er == NULL_POINTER) return TEST_PASSED;
         else{
            printf("Test fallito: funzione testata: printTokens(NULL, dimT);\n\t      risultato atteso: NULL_POINTER(2)\n\t      risultato ottenuto: %d\n\t      spiegazione: la funzione non controlla il NULL_POINTER in input su tokenArray\n", cod_er);
            return TEST_FAILED;
         }
      }
      return NOT_VALID;
   }
   if(tipo_di_test == BUFFER_TOO_SMALL){
      if(argomento < 0 || argomento > 1) return ARG_MISSING;
      if(argomento == 1){
         token=(Token *) malloc(80);
         cod_er=printTokens(token, 0);
         if(cod_er == BUFFER_TOO_SMALL) return TEST_PASSED;
         else{
            printf("Test fallito: funzione testata: printTokens(tokenArray, 0);\n\t      risultato atteso: BUFFER_TOO_SMALL(8)\n\t      risultato ottenuto: %d\n\t      spiegazione: la funzione non controlla la dimensione minima di dimT\n", cod_er);
            return TEST_FAILED;
         }
      }
      return NOT_VALID;
   }
   return NOT_IMPLEMENTED;
}
