#include"modulo1.h"
#include<stdio.h>
#include<stdlib.h>

int leggiFile(char* nomefile, int dimensione, char* testo)
{
 FILE *fd;
 int count;

 if(nomefile == NULL) return NULL_POINTER;
 if(testo == NULL) return NULL_POINTER;

 if((fd=fopen(nomefile, "rb")) == NULL)
 	return FILE_MISSING;

 if((count=fread(testo, sizeof(char),dimensione-1, fd))==0)
	 return FILE_UNREADABLE;

 testo[dimensione-1]='\0';
 fclose(fd);

 return RESULT_OK;
}

int estraiHeaders(char* email, char* headers, int dimh)
{
 char *f, *t; int l=0;

 if(email ==NULL) return NULL_POINTER;
 if(headers == NULL) return NULL_POINTER;

 t=email;

 while(t)
 {
	 f=strstr(t,"\n");
	 if(f-t == 1) t=0;
	 else t= ++f;
 }
 
 if(f) l=f-email;

 if(l+1 <= dimh)
 {
	strncpy(headers, email, l+1);
	headers[l]='\0';
 }
 else
 {
	strncpy(headers, email, dimh);
	headers[dimh -1]='\0';
	return BUFFER_TOO_SMALL;
 }

 return RESULT_OK;
}

int primoHeader(char* header, char* primo_header, int dim)
{
 char *f, *t, *c;
 int l=0;

 if(header == NULL) return NULL_POINTER;
 if(primo_header == NULL) return NULL_POINTER;

 l=strlen(header);

 if(( c=(char*)malloc(sizeof(char)*l)) == NULL) return MEM_ALLOC_ERROR;
 
 f=strstr(header, "\n");	 

 if(f) l=f-header;
 strncpy(c, header, l+1);
 c[l]='\0';

 while(f)
 {
	 t=strchr(f, '\t');
	 if(!t) t=strchr(f,' ');
	 if(t && (t-f) == 1)
	 {
		f=strchr(t, '\n');
		if(f)
		{
			strcat(c,"\n");
			strncat(c, t, f-t);
		}
	 }else f=0;
	 if(t) l+= strlen(t);
 }
 c[l]='\0';

 if(l <= dim) strcpy(primo_header, c);
 else 
 {
	strncpy(primo_header, c, dim);
	primo_header[dim-1]='\0';
	free(c);
	return BUFFER_TOO_SMALL;
 }

 free(c);
 return RESULT_OK;
}

int parseHeader(char* header, char* tipo, int dimt, char* valore, int dimv)
{
 char *tempt, *tempv;
 int l;
 if(header == NULL) return NULL_POINTER;
 
 l=strlen(header);
 if((tempv=(char*)malloc(sizeof(char)*l)) == NULL) 
	 return MEM_ALLOC_ERROR;
 if((tempt=(char*)malloc(sizeof(char)*l)) == NULL)
	 return MEM_ALLOC_ERROR;

 tempv=strchr(header, ' '); 
 if(tempv)
 {
	strncpy(tempt, header, tempv-header +1);
 	tempt[tempv-header]='\0';
 }

 if(tempv && strlen(tempv)<=dimv)
	 strcpy(valore, tempv);
 else if(tempv)
 {
	strncpy(valore, tempv, dimv);
	valore[dimv-1]='\0';
 }
		 
 if(tempt && strlen(tempt) <= dimt)
 	strcpy(tipo, tempt);
 else if(tempt)
 {
	strncpy(tipo, tempt, dimt);
	tipo[dimt-1]='\0';
 }
  
 return RESULT_OK;
}

int primaParola(char *testo, char *parola, int dim)
{
 char *temp_parola, *temp_testo;
 int i=0;

 if(testo == NULL) return NULL_POINTER;
 if(parola == NULL) return NULL_POINTER;

 if((temp_parola=(char*)malloc(sizeof(char)*strlen(testo)))== NULL)
	 return MEM_ALLOC_ERROR;

 temp_testo=testo;

 while(temp_testo && *temp_testo != '\0')
 {
	if(!isalnum(*temp_testo))
		temp_testo++;
	else
	{
		while(temp_testo && *temp_testo != '\0' && isalnum(*temp_testo))
		{
			temp_parola[i]=*temp_testo;
			i++;
			temp_testo++;
		}
		strcpy(testo, temp_testo);
		temp_testo=0;
		temp_parola[i]='\0';
	}
 }

 if(temp_parola[0] == '\0') *testo='\0';

 if(strlen(temp_parola) >= dim)
 {
	strncpy(parola, temp_parola, dim);
	parola[dim-1]='\0';
	return BUFFER_TOO_SMALL;
 }
 else
 {
	 strcpy(parola, temp_parola);
	 parola[strlen(temp_parola)]='\0';
 }
 free(temp_parola);
 return RESULT_OK;
}

int tokenizzaEmail(char*email, Token tokenArray[], int dimT)
{
 char *headers, *primo_header, *next_header, *contesto, *parola, *testo;
 int count=0, i=0;
 
 if(email == NULL) return NULL_POINTER;
 if(tokenArray == NULL) return NULL_POINTER;
 
 if((headers=(char*)malloc(sizeof(char)*200))==NULL) return MEM_ALLOC_ERROR;
 if((primo_header=(char*)malloc(sizeof(char)*100))==NULL) return MEM_ALLOC_ERROR;
 if((next_header=(char*)malloc(sizeof(char)*200))==NULL) return MEM_ALLOC_ERROR;
 if((contesto=(char*)malloc(sizeof(char)*50))==NULL) return MEM_ALLOC_ERROR;
 if((parola=(char*)malloc(sizeof(char)*150))==NULL) return MEM_ALLOC_ERROR;
 if((testo=(char*)malloc(sizeof(char)*500))==NULL) return MEM_ALLOC_ERROR;

 estraiHeaders(email, headers, 200);
 
 if(headers == NULL) return HEADER_NOT_FOUND;
 
 while(count < strlen(headers))
 {
	strcpy(next_header, &headers[count]);
	primoHeader(next_header, primo_header, 100);
	if(primo_header)
	 	parseHeader(primo_header, contesto, 50, parola, 150);

	 while(parola && *parola !='\0' && i<dimT)
	 {
		tokenArray->contesto=(char*)malloc(sizeof(char)*50);
		tokenArray->parola=(char*)malloc(sizeof(char)*150);
		primaParola(parola, tokenArray->parola, 150);
		strcpy(tokenArray->contesto, contesto);
		
		tokenArray++;
		i++;
	 }
 	 count = count + 1 + strlen(primo_header);
	
 }
 strcpy(testo,&email[strlen(headers)]);  
 count = strlen(testo);

 while(testo && *testo!='\0' && i<dimT && strlen(testo)>0 )
 {

	tokenArray->contesto=(char*)malloc(sizeof(char)*50);
	tokenArray->parola=(char*)malloc(sizeof(char)*150);
	primaParola(testo, tokenArray->parola, 150);
	tokenArray->contesto=NULL;

	tokenArray++;
	i++;
 }
 
 if(strlen(testo)>1) return BUFFER_TOO_SMALL;
 return RESULT_OK;
}

int printTokens(Token tokenArray[], int dimT)
{
 int i;
 
 if(tokenArray == NULL) return NULL_POINTER;
 
 for(i=0; i<dimT; i++)
 {
 	if(tokenArray->contesto!=NULL)
		printf("%s*",tokenArray->contesto);
	if(tokenArray->parola != NULL)
		printf("%s\n",tokenArray->parola);

	tokenArray++;
 }

 return RESULT_OK;
}

