#include<stdio.h>
#include"testModulo1.h"
#include"modulo1.c"

int test_leggiFile(int tipo_di_test, int n_argomento)
{
 char*testo=(char*)malloc(sizeof(char)*1000);
 int ctrl;
 
 switch(tipo_di_test)
 {
	case 2: //NULL_POINTER
		switch(n_argomento)
		{
			case 0:
				ctrl=leggiFile(NULL,1000, testo);
				if(ctrl==2)  return TEST_PASSED;
				else 
				{
					printf("Test Fallito: funzione testata leggiFile(null,1000,testo)\n");
					printf("risultato atteso: NULL_POINTER\n");
					printf("risultato ottenuto: RESULT_OK\n");
					printf("spiegazione: la funzione leggiFile non controlla che");
					printf("il primo argomento e\' un puntatore nullo.");
					return TEST_FAILED;
				}
			break;
			case 1: case 2: return NOT_VALID;
			break;

			default: return ARG_MISSING;
		}
 	break;
	
	case 4: //FILE_MISSING
		ctrl=leggiFile("email_test.txt",1000, testo);
		if(ctrl == 4) return TEST_PASSED;
		else 
		{
		  printf("Test Fallito: funzione testata leggiFile(\"email_test.txt\",1000,testo)\n");
		  printf("	risultato atteso: FILE_MISSING\n");
		  printf("	risultato ottenuto: RESULT_OK\n");
		  printf("	spiegazione: la funzione leggiFile non controlla che");
						       printf("il FILE contenente la mail esista.");
					return TEST_FAILED;

		}	
	break;

	case 5: //FILE_UNREADABLE
		ctrl=leggiFile("email1.txt",1000, testo);
		if(ctrl == 5) return TEST_PASSED;
		else 
		{
		  printf("Test Fallito: funzione testata leggiFile(\"email_test.txt\",1000,testo)\n");
						printf("	risultato atteso: FILE_UNREADABLE\n");
						printf("	risultato ottenuto: RESULT_OK\n");
						printf("	spiegazione: la funzione leggiFile non controlla che");
						printf("	il FILE contenente la mail sia leggibile.");
					return TEST_FAILED;

		}	
	break;

 default: return NOT_IMPLEMENTED;

 }
	
}


int test_estraiHeaders(int tipo_di_test, int n_argomento)
{
 char *header=(char*)malloc(sizeof(char)*500);
 char *mail=(char*)malloc(sizeof(char)*1000);
 int ctrl;
 leggiFile("email1.txt",1000,mail);

 switch(tipo_di_test)
 {
	case 2://NULL_POINTER
		switch(n_argomento)
		{
		  case 0: ctrl=estraiHeaders(NULL, header, 500);
		    	if(ctrl==2)  return TEST_PASSED;
				else 
				{
					printf("Test Fallito: funzione testata estraiHeaders(null, header, 500)\n");
					printf("risultato atteso: NULL_POINTER\n");
					printf("risultato ottenuto: RESULT_OK\n");
					printf("spiegazione: la funzione estraiHeaders non controlla che");
					printf("il primo argomento e\' un puntatore nullo.");
					return TEST_FAILED;
				}
		    
		    break;

	          case 1: ctrl=estraiHeaders(mail,NULL,500);

		    	if(ctrl==2)  return TEST_PASSED;
				else 
				{
					printf("Test Fallito: funzione testata estraiHeaders(mail, null, 500)\n");
					printf("risultato atteso: NULL_POINTER\n");
					printf("risultato ottenuto: RESULT_OK\n");
					printf("spiegazione: la funzione estraiHeaders non controlla che");
					printf("il secondo argomento e\' un puntatore nullo.");
					return TEST_FAILED;
				}
	          break;

		  case 2: return NOT_VALID;
		  break;

		  default: return ARG_MISSING;
		}
	break;

	case 8://BUFFER_TOO_SMALL
		ctrl=estraiHeaders(mail, header, 4);
		if(ctrl==8) return TEST_PASSED;
		else 
		{
		 printf("Test Fallito: funzione testata estraiHeaders(mail, header, 4)\n");
					printf("risultato atteso: BUFFER_TOO_SMALL\n");
					printf("risultato ottenuto: RESULT_OK\n");
					printf("spiegazione: la funzione estraiHeaders non controlla che");
					printf("la dimensione di header e' piccola.");
				
		  return TEST_FAILED;
		}
	break;

	default: return NOT_IMPLEMENTED;
 }
 
}


int test_primoHeader(int tipo_di_test, int n_argomento)
{
 char *header=(char*)malloc(sizeof(char)*500);
 char *mail=(char*)malloc(sizeof(char)*1000);
 char *primo_header=(char*)malloc(sizeof(char)*300);
 int ctrl;
 leggiFile("email1.txt",1000,mail);
 estraiHeaders(mail, header, 500);

 switch(tipo_di_test)
 {
	case 2://NULL_POINTER
		switch(n_argomento)
		{
		  case 0: ctrl=primoHeader(NULL,primo_header, 300);
		    	if(ctrl==2)  return TEST_PASSED;
				else 
				{
					printf("Test Fallito: funzione testata primoHeader(null, primo_header, 300)\n");
					printf("risultato atteso: NULL_POINTER\n");
					printf("risultato ottenuto: RESULT_OK\n");
					printf("spiegazione: la funzione primoHeader non controlla che");
					printf("il primo argomento e\' un puntatore nullo.");
					return TEST_FAILED;
				}
		    
		    break;

	          case 1: ctrl=primoHeader(header,NULL,300);

		    	if(ctrl==2)  return TEST_PASSED;
				else 
				{
					printf("Test Fallito: funzione testata primoHeader(header, null, 300)\n");
					printf("risultato atteso: NULL_POINTER\n");
					printf("risultato ottenuto: RESULT_OK\n");
					printf("spiegazione: la funzione primoHeader non controlla che");
					printf("il secondo argomento e\' un puntatore nullo.");
					return TEST_FAILED;
				}
	          break;

		  case 2: return NOT_VALID;
		  break;

		  default: return ARG_MISSING;
		}
	break;

	case 8://BUFFER_TOO_SMALL
		ctrl=primoHeader(header, primo_header, 4);
		if(ctrl==8) return TEST_PASSED;
		else 
		{
		 printf("Test Fallito: funzione testata primoHeaders(header,primo_header, 4)\n");
					printf("risultato atteso: BUFFER_TOO_SMALL\n");
					printf("risultato ottenuto: RESULT_OK\n");
					printf("spiegazione: la funzione primoHeader non controlla che");
					printf("la dimensione di primo_header e' piccola.");
				
		  return TEST_FAILED;
		}
	break;

	default: return NOT_IMPLEMENTED;
 }

	
}


int test_parseHeader(int tipo_di_test, int n_argomento)
{
 char *header=(char*)malloc(sizeof(char)*500);
 char *mail=(char*)malloc(sizeof(char)*1000);
 char *primo_header=(char*)malloc(sizeof(char)*300);
 char *tipo=(char*)malloc(sizeof(char)*50);
 char *valore=(char*)malloc(sizeof(char)*150);
 int ctrl;
 leggiFile("email1.txt",1000,mail);
 estraiHeaders(mail, header, 500);
 primoHeader(header, primo_header, 300);

 switch(tipo_di_test)
 {
	case 2://NULL_POINTER
		switch(n_argomento)
		{
		  case 0: ctrl=parseHeader(NULL,tipo, 50, valore, 150);
		    	if(ctrl==2)  return TEST_PASSED;
				else 
				{
					printf("Test Fallito: funzione testata parseHeader(null,tipo, 50, valore, 150)\n");
					printf("risultato atteso: NULL_POINTER\n");
					printf("risultato ottenuto: RESULT_OK\n");
					printf("spiegazione: la funzione parseHeader non controlla che");
					printf("il primo argomento e\' un puntatore nullo.");
					return TEST_FAILED;
				}
		    
		    break;

	          case 1: case 2: case 3: case 4:  return NOT_VALID;
		  break;

		  default: return ARG_MISSING;
		}
	break;

	
	default: return NOT_IMPLEMENTED;
 }


}


int test_primaParola(int tipo_di_test, int n_argomento)
{
 char *header=(char*)malloc(sizeof(char)*500);
 char *mail=(char*)malloc(sizeof(char)*1000);
 char *testo=(char*)malloc(sizeof(char)*500);
 char *parola=(char*)malloc(sizeof(char)*150);
 int ctrl;

 leggiFile("email1.txt",1000,mail);
 estraiHeaders(mail, header, 500);
 strcpy(testo,&mail[strlen(header)]);
 
switch(tipo_di_test)
 {
	case 2://NULL_POINTER
		switch(n_argomento)
		{
		  case 0: ctrl=primaParola(NULL,parola, 150);
		    	if(ctrl==2)  return TEST_PASSED;
				else 
				{
					printf("Test Fallito: funzione testata primaParola(null, parola, 150)\n");
					printf("risultato atteso: NULL_POINTER\n");
					printf("risultato ottenuto: RESULT_OK\n");
					printf("spiegazione: la funzione primaparola non controlla che");
					printf("il primo argomento e\' un puntatore nullo.");
					return TEST_FAILED;
				}
		    
		    break;

	          case 1: ctrl=primaParola(testo,NULL,150);

		    	if(ctrl==2)  return TEST_PASSED;
				else 
				{
					printf("Test Fallito: funzione testata primaParola(testo, null, 150)\n");
					printf("risultato atteso: NULL_POINTER\n");
					printf("risultato ottenuto: RESULT_OK\n");
					printf("spiegazione: la funzione primaParola non controlla che");
					printf("il secondo argomento e\' un puntatore nullo.");
					return TEST_FAILED;
				}
	          break;

		  case 2: return NOT_VALID;
		  break;

		  default: return ARG_MISSING;
		}
	break;

	case 8://BUFFER_TOO_SMALL
		ctrl=primaParola(testo, parola, 4);
		if(ctrl==8) return TEST_PASSED;
		else 
		{
		 printf("Test Fallito: funzione testata primaParola(testo,parola, 4)\n");
					printf("risultato atteso: BUFFER_TOO_SMALL\n");
					printf("risultato ottenuto: RESULT_OK\n");
					printf("spiegazione: la funzione primaParola non controlla che");
					printf("la dimensione di parola e' piccola.");
				
		  return TEST_FAILED;
		}
	break;

	default: return NOT_IMPLEMENTED;
 }

	
}


int test_tokenizzaEmail(int tipo_di_test, int n_argomento)
{
  char *testo=(char*)malloc(sizeof(char)*700);
  Token *tokenArray=(Token*)malloc(sizeof(Token)*1000);
  
  int ctrl;

  leggiFile("email1.txt",700, testo);

  
switch(tipo_di_test)
 {
	case 2://NULL_POINTER
		switch(n_argomento)
		{
		  case 0: ctrl=tokenizzaEmail(NULL,tokenArray, 1000);
		    	if(ctrl==2)  return TEST_PASSED;
				else 
				{
					printf("Test Fallito: funzione testata tokenizzaEmail(null, tokenArray, 1000)\n");
					printf("risultato atteso: NULL_POINTER\n");
					printf("risultato ottenuto: RESULT_OK\n");
					printf("spiegazione: la funzione tokenizzaEmail non controlla che");
					printf("il primo argomento e\' un puntatore nullo.");
					return TEST_FAILED;
				}
		    
		    break;

	          case 1: ctrl=tokenizzaEmail(testo,NULL,1000);

		    	if(ctrl==2)  return TEST_PASSED;
				else 
				{
					printf("Test Fallito: funzione testata tokenizzaEmail(testo, null, 1000)\n");
					printf("risultato atteso: NULL_POINTER\n");
					printf("risultato ottenuto: RESULT_OK\n");
					printf("spiegazione: la funzione tokenizzaEmail non controlla che");
					printf("il secondo argomento e\' un puntatore nullo.");
					return TEST_FAILED;
				}
	          break;

		  case 2: return NOT_VALID;
		  break;

		  default: return ARG_MISSING;
		}
	break;

	case 8://BUFFER_TOO_SMALL
		ctrl=tokenizzaEmail(testo, tokenArray, 4);
		if(ctrl==8) return TEST_PASSED;
		else 
		{
		 printf("Test Fallito: funzione testata tokenizzaEmail(testo,tokenArray, 4)\n");
					printf("risultato atteso: BUFFER_TOO_SMALL\n");
					printf("risultato ottenuto: RESULT_OK\n");
					printf("spiegazione: la funzione tokenizzaEmail non controlla che");
					printf("la dimensione di tokenArray e' piccola.");
				
		  return TEST_FAILED;
		}
	break;

	default: return NOT_IMPLEMENTED;
 }

	

  
}


int test_printTokens(int tipo_di_test, int n_argomento)
{

  char *testo=(char*)malloc(sizeof(char)*700);
  Token *tokenArray=(Token*)malloc(sizeof(Token)*1000);
  
  int ctrl;

  leggiFile("email1.txt",700, testo);
  tokenizzaEmail(testo, tokenArray, 1000);

switch(tipo_di_test)
 {
	case 2://NULL_POINTER
		switch(n_argomento)
		{
		  case 0: ctrl=printTokens(NULL,1000);
		    	if(ctrl==2)  return TEST_PASSED;
				else 
				{
					printf("Test Fallito: funzione testata printTokens(null, 1000)\n");
					printf("risultato atteso: NULL_POINTER\n");
					printf("risultato ottenuto: RESULT_OK\n");
					printf("spiegazione: la funzione printTokens non controlla che");
					printf("il primo argomento e\' un puntatore nullo.");
					return TEST_FAILED;
				}
		    
		    break;

	          case 1:  return NOT_VALID;
		  break;

		  default: return ARG_MISSING;
		}
	break;

	
	default: return NOT_IMPLEMENTED;
 }

	
}

